DROP TABLE IF EXISTS `etcitem`;
CREATE TABLE `etcitem` (
  `item_id` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
  `name` VARCHAR(100) NOT NULL DEFAULT '',
  `crystallizable` VARCHAR(5) NOT NULL DEFAULT 'false',
  `item_type` VARCHAR(14) NOT NULL DEFAULT 'none',
  `weight` MEDIUMINT(5) NOT NULL DEFAULT 0,
  `consume_type` VARCHAR(9) NOT NULL DEFAULT 'normal',
  `material` VARCHAR(15) NOT NULL DEFAULT 'wood',
  `crystal_type` VARCHAR(4) NOT NULL DEFAULT 'none',
  `duration` SMALLINT(3) NOT NULL DEFAULT -1,           -- duration in minutes for shadow items
  `time` MEDIUMINT(6) NOT NULL DEFAULT -1,              -- duration in minutes for time limited items
  `price` INT UNSIGNED NOT NULL DEFAULT 0,
  `crystal_count` SMALLINT(4) UNSIGNED NOT NULL DEFAULT 0,
  `sellable` VARCHAR(5) NOT NULL DEFAULT 'false',
  `dropable` VARCHAR(5) NOT NULL DEFAULT 'false',
  `destroyable` VARCHAR(5) NOT NULL DEFAULT 'true',
  `tradeable` VARCHAR(5) NOT NULL DEFAULT 'false',
  `depositable` VARCHAR(5) NOT NULL DEFAULT 'false',
  `handler` VARCHAR(70) NOT NULL DEFAULT 'none',
  `skills_item` VARCHAR(70) NOT NULL DEFAULT '',
  PRIMARY KEY (`item_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO `etcitem` VALUES
(17,'Wooden Arrow','false','arrow',6,'stackable','wood','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(53,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(54,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(55,'Shiny Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(56,'Sobbing Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(57,'Adena','false','none',0,'asset','gold','none',-1,-1,1,0,'false','true','true','true','true','none',''),
(65,'Red Potion','false','potion',80,'stackable','liquid','none',-1,-1,40,0,'true','true','true','true','true','ItemSkills','2001-1'),
(136,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(137,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(138,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(139,'Sudden Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(140,'Shiny Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(141,'Sobbing Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(163,'(Not In Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(170,'Sudden Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(686,'Chair','false','none',100,'normal','wood','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(687,'Darin\'s Letter','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(688,'Roxxy\'s Kerchief','false','quest',0,'normal','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(689,'Poetry Book','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(690,'Lyrics Book','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(691,'Romance Novel','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(692,'Arujien\'s Letter','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(693,'Greenis\'s Letter','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(694,'Ingredient List','false','quest',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(695,'Omen Beast\'s Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(696,'Mana Seeker\'s Husk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(697,'Gargoyle\'s Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(698,'Gilbert\'s List','false','quest',0,'normal','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(699,'Orc\'s Nose','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(700,'Hobgoblin Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(701,'Fungus Juice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(702,'Wolf Pelt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(703,'Poison Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(704,'Fever Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(705,'Orc\'s Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(706,'Basilisk\'s Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(707,'Spore Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(708,'Sylph Headband','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(709,'Leather Shirt','false','none',400,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(710,'Hard Leather Shirt','false','none',400,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(711,'Piece Bone Breastplate','false','none',800,'normal','bone','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(712,'Half Plate Armor','false','none',1200,'normal','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(713,'Leather Pants','false','none',250,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(714,'Hard Leather Pants','false','none',300,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(715,'Piece Bone Gaiters','false','none',500,'normal','bone','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(716,'Plate Gaiters','false','none',800,'normal','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(717,'Leather Gloves','false','none',100,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(718,'Hard Leather Gloves','false','none',150,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(719,'Crafted Leather Gloves','false','none',150,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(720,'Reinforced Gloves','false','none',200,'normal','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(721,'Leather Boots','false','none',150,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(722,'Hard Leather Boots','false','none',150,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(723,'Crafted Leather Boots','false','none',200,'normal','leather','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(724,'Reinforced Boots','false','none',250,'normal','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(725,'Healing Drug','false','potion',180,'stackable','liquid','none',-1,-1,50,0,'true','true','true','true','true','ItemSkills','2002-1'),
(726,'Mana Drug','false','potion',180,'stackable','liquid','none',-1,-1,80,0,'true','true','true','true','true','Potions',''),
(727,'Healing Potion','false','potion',180,'stackable','liquid','none',-1,-1,80,0,'true','true','true','true','true','Potions',''),
(728,'Mana Potion','false','potion',180,'stackable','liquid','none',-1,-1,2000,0,'true','true','true','true','true','Potions',''),
(729,'Scroll: Enchant Weapon (A)','false','scroll',120,'stackable','paper','none',-1,-1,1800000,0,'true','true','true','true','true','EnchantScrolls','2006-1'),
(730,'Scroll: Enchant Armor (A)','false','scroll',120,'stackable','paper','none',-1,-1,240000,0,'true','true','true','true','true','EnchantScrolls','2007-1'),
(731,'Crystal Scroll: Enchant Weapon (A)','false','scroll',120,'stackable','paper','none',-1,-1,240000,0,'true','true','true','true','true','EnchantScrolls',''),
(732,'Crystal Scroll: Enchant Armor (A)','false','scroll',120,'stackable','paper','none',-1,-1,240000,0,'true','true','true','true','true','EnchantScrolls',''),
(733,'Endeavor Potion','false','potion',180,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','ItemSkills','2010-1'),
(734,'Haste Potion','false','potion',20,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','ItemSkills','2011-1'),
(735,'Potion of Alacrity','false','potion',20,'stackable','liquid','none',-1,-1,2400,0,'true','true','true','true','true','ItemSkills','2012-1'),
(736,'Scroll of Escape','false','scroll',120,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2013-1'),
(737,'Scroll of Resurrection','false','scroll',120,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','ScrollOfResurrection','2014-1'),
(739,'Broken Sword Handle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(740,'Broken Blade Bottom','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(741,'Broken Blade Top','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(742,'Altran\'s Note','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(745,'Cobendell Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(746,'Alberius\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(750,'Kinship Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(751,'Cracked Kinship Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(752,'Orc Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(753,'Silverleaf Brooch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(755,'Colleen\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(756,'Mandragora Root','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(757,'Mandragora Essence','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(758,'Colleen\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(759,'Etched Rune Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(760,'Macabre Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(761,'Thanatos Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(762,'Gray Bone Chip','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(763,'Esther\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(764,'Arbon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(765,'Conspirator List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(766,'Sabrin\'s Signet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(767,'Sealed Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(768,'Oyen\'s Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(769,'Ricardo\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(770,'Shield of Honor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(771,'Saythus\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(772,'Trayer\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(773,'Falimar\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(774,'Fallen Sword of Honor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(775,'Sword of Honor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(776,'Nameless Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(777,'Sword of Black Ice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(778,'Arodin\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(779,'Sabrin\'s Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(780,'Arbon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(781,'Madclaw\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(782,'Alex\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(783,'Alex\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(784,'Glass Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(785,'Broken Glass Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(786,'Shadowguard Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(787,'Coroli\'s Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(788,'Midnight Onyx Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(789,'Song: Moonlight Whisper','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(790,'Bloodsteel Kris','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(791,'Karlun\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(792,'Karlun\'s Rib Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(793,'Karlun\'s Thigh Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(794,'Saint\'s Ash Urn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(795,'Mace of Athebaldt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(796,'Roien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(797,'Manuel\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(798,'Varan\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(799,'Groot\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(800,'Tome of Nassen','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(801,'Cursed Tome of Nassen','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(802,'Bloodthirsty Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(803,'Bloody Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(804,'Staff of Shane','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(805,'Pinter\'s Bill','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(806,'Drake\'s Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(807,'Flawless Drake\'s Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(808,'Pushkin\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(809,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(810,'Altran\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(811,'Oil Paper','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(812,'Adamantium Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(813,'Heart Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(814,'Pushkin\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(815,'Leather Strap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(816,'Widow Maker','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(817,'Mithril Bottle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(818,'Grace Unicorn\'s Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(819,'Drake\'s Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(820,'Zahak Fluids','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(821,'Bone Knife','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(822,'Drake Knife','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(823,'Dull Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(824,'Siriel\'s Note','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(825,'Raien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(826,'Silver Spores','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(827,'Star Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(828,'Song of Awakening','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(829,'Spirit Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(830,'Medallion of Kwyllinas','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(831,'Echo Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(832,'Green Echo Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(833,'Red Echo Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(834,'Aquamarine Echo Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(835,'Blue Echo Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(836,'Book of Kwyllinas','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(837,'Fairy Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(838,'Vellior\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(839,'Icarus\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(840,'Drevanul Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(841,'Icarus\'s Order Form','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(842,'Basilisk Ink','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(843,'Book of Aklantoth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(844,'Book of Aklantoth P1 ~ P10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(937,'Directions to Ruins','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(938,'Deck','false','none',0,'normal','silver','none',-1,-1,0,0,'false','true','true','false','true','none',''),
(939,'Gara\'s Quest Item #11','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(940,'Gara\'s Quest Item #12','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(941,'Gara\'s Proof of Bravery','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(942,'Gara\'s Proof of Justice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(943,'Gara\'s Proof of Despair','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(944,'Deathknight Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(947,'Scroll: Enchant Weapon (B)','false','scroll',120,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','EnchantScrolls','2015-1'),
(948,'Scroll: Enchant Armor (B)','false','scroll',120,'stackable','paper','none',-1,-1,80000,0,'true','true','true','true','true','EnchantScrolls','2016-1'),
(949,'Crystal Scroll: Enchant Weapon (B)','false','scroll',120,'stackable','paper','none',-1,-1,80000,0,'true','true','true','true','true','EnchantScrolls',''),
(950,'Crystal Scroll: Enchant Armor (B)','false','scroll',120,'stackable','paper','none',-1,-1,80000,0,'true','true','true','true','true','EnchantScrolls',''),
(951,'Scroll: Enchant Weapon (C)','false','scroll',120,'stackable','paper','none',-1,-1,110000,0,'true','true','true','true','true','EnchantScrolls','2017-1'),
(952,'Scroll: Enchant Armor (C)','false','scroll',120,'stackable','paper','none',-1,-1,15000,0,'true','true','true','true','true','EnchantScrolls','2018-1'),
(953,'Crystal Scroll: Enchant Weapon (C)','false','scroll',120,'stackable','paper','none',-1,-1,15000,0,'true','true','true','true','true','EnchantScrolls',''),
(954,'Crystal Scroll: Enchant Armor (C)','false','scroll',120,'stackable','paper','none',-1,-1,15000,0,'true','true','true','true','true','EnchantScrolls',''),
(955,'Scroll: Enchant Weapon (D)','false','scroll',120,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','EnchantScrolls','2019-1'),
(956,'Scroll: Enchant Armor (D)','false','scroll',120,'stackable','paper','none',-1,-1,6000,0,'true','true','true','true','true','EnchantScrolls','2020-1'),
(957,'Crystal Scroll: Enchant Weapon (D)','false','scroll',120,'stackable','paper','none',-1,-1,6000,0,'true','true','true','true','true','EnchantScrolls',''),
(958,'Crystal Scroll: Enchant Armor (D)','false','scroll',120,'stackable','paper','none',-1,-1,6000,0,'true','true','true','true','true','EnchantScrolls',''),
(959,'Scroll: Enchant Weapon (S)','false','scroll',120,'stackable','paper','none',-1,-1,5000000,0,'true','true','true','true','true','EnchantScrolls','2021-1'),
(960,'Scroll: Enchant Armor (S)','false','scroll',120,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','EnchantScrolls','2022-1'),
(961,'Crystal Scroll: Enchant Weapon (S)','false','scroll',120,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','EnchantScrolls',''),
(962,'Crystal Scroll: Enchant Armor (S)','false','scroll',120,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','EnchantScrolls',''),
(963,'Orcish Arrowhead','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(964,'Alberius\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(965,'Evergreen Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(966,'Dryad\'s Tears','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(967,'Cobendell Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(968,'Karrod\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(969,'Cecktinon\'s First Voucher','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(970,'Cecktinon\'s Second Voucher','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(971,'Soul Catcher','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(972,'Preserving Oil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(973,'Zombie Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(974,'Steelbender Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(976,'1st Mark of Sentinel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(977,'2nd Mark of Sentinel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(978,'Skullcrusher Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(979,'Bloodspear Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(980,'0','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(982,'Esrandell\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(983,'Kendell\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(984,'1st Onyx Talisman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(985,'2nd Onyx Talisman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(986,'Ancient Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(987,'Ancient Clay Tablet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(988,'Kartia\'s Translation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1001,'Book of Aklantoth - Part 4','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1002,'Book of Aklantoth - Part 5','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1003,'Book of Aklantoth - Part 6','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1004,'Book of Aklantoth - Part 7','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1005,'Book of Aklantoth - Part 8','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1006,'Book of Aklantoth - Part 9','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1007,'Book of Aklantoth - Part 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1008,'Harrys\'s 1st Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1009,'Harrys\'s 2nd Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1010,'Golem Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1011,'Tool Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1012,'Delivery List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1013,'Heavy Wood Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1014,'Cloth Bundle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1015,'Clay Pot','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1016,'Jackson\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1017,'Silvia\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1018,'Rant\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1019,'official Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1020,'Flame Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1021,'Ice Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1022,'Lilith\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1023,'Theon\'s Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1024,'Adamantite Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1025,'Clay Tablet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1026,'Silvery Spidersilk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1027,'Unoren\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1028,'Creamees\'s Ticket','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1029,'Nightshade Leaf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1030,'Cracked Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1031,'Perfect Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1032,'Fox Fur','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1033,'Fox Fur Yarn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1034,'Maiden Doll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1035,'Plague Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1036,'Andellia\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1037,'Fruit of The Mother Tree','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1038,'Rumiel\'s 1st Poem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1039,'Rumiel\'s 2nd Poem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1040,'Rumiel\'s 3rd Poem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1041,'Rumiel\'s 4th Poem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1042,'Wererat\'s Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1043,'Varool Foulclaw\'s Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1044,'Kirunak Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1045,'Zombie\'s Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1046,'Nightmare Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1047,'Spellbook: Light','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1048,'Spellbook: Might','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1049,'Spellbook: Ice Bolt','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1050,'Spellbook: Battle Heal','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1051,'Spellbook: Vampiric Touch','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1052,'Spellbook: Flame Strike','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1053,'Spellbook: Cure Poison','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1054,'Spellbook: Group Heal','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1055,'Spellbook: Curse: Poison','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1056,'Spellbook: Curse: Weakness','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1057,'Spellbook: Summon Meal','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1058,'Spellbook: Shield','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1059,'Spellbook: Know Enemy','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1060,'Lesser Healing Potion','false','potion',5,'stackable','liquid','none',-1,-1,90,0,'true','true','true','true','true','Potions',''),
(1061,'Healing Potion','false','potion',5,'stackable','liquid','none',-1,-1,330,0,'true','true','true','true','true','Potions',''),
(1062,'Haste Potion','false','potion',180,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(1063,'Tutorial Parchment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1064,'Tutorial Parchment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1065,'Tutorial Parchment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1066,'Tutorial Parchment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1067,'Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1068,'Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1069,'Leaf of the Mother Tree','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1070,'Blood of Mitraell','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1071,'Hyacinth Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1072,'Hyacinth Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1073,'Beginner\'s Potion','false','potion',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Potions',''),
(1074,'Boat Ticket: Talking Island to Gludin','false','none',20,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1075,'Boat Ticket: Gludin to Talking Island','false','none',20,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1076,'Carlon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1077,'Venom Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1078,'Wind Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1079,'Darin\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1080,'Baulro\'s Potion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1081,'Omen Beast\'s Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1082,'Taint Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1083,'Succubus Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1084,'Gludio Lord\'s Mark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1085,'Orc\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1086,'Werewolf\'s Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1087,'Giant Spider Leg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1088,'Undrias\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1089,'Ceremonial Dagger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1090,'Dreviant Wine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1091,'Garmiel\'s Scripture','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1092,'Arujien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1093,'Arujien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1094,'Arujien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1095,'Spellbook: Attack Aura','false','spellbook',120,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','none',''),
(1096,'Spellbook: Elemental Heal','false','spellbook',120,'stackable','paper','none',-1,-1,550,0,'true','true','true','true','true','none',''),
(1097,'Spellbook: Drain Health','false','spellbook',120,'stackable','paper','none',-1,-1,550,0,'true','true','true','true','true','none',''),
(1098,'Spellbook: Wind Walk','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1099,'Spellbook: Wind Shackle','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1106,'Norman\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1107,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1108,'Arbon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1109,'Roien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1110,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1111,'Adamantite Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1112,'Leaf of the Mother Tree','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1113,'Blood of Mitraell','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1114,'Orc Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1115,'Orc\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1116,'Orc Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1117,'Orc\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1118,'Spore Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1130,'Cobendell\'s Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1131,'Cobendell\'s Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1132,'Cobendell\'s Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1133,'Cobendell\'s Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1134,'Cobendell\'s Medicine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1135,'Spiritbound Wand','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1136,'Spiritbound Wand','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1137,'Spiritbound Wand','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1138,'Auron\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1139,'Warrior Guild Mark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1140,'Rusted Bronze Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1141,'Rusted Bronze Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(1143,'Simplon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1144,'Venomous Spider Leg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1145,'Medallion of Warrior','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1150,'Spellbook: Wind Strike','false','spellbook',120,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(1151,'Spellbook: Self Heal','false','spellbook',120,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(1152,'Spellbook: Heal','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1153,'Jenna\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1154,'Sentry Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1155,'Sentry Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1156,'Sentry Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1157,'Old Bronze Sword','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1158,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1159,'Elf Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1160,'Dark Bezoar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1161,'Sword of Ritual','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1162,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1163,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1164,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1165,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1166,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1167,'Coin of Lords','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1168,'Gludio Guard\'s 1st Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1169,'Bugbear Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1170,'Einhasad\'s 1st Temple Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1171,'Einhasad\'s Crucifix','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1172,'Gludio Guard\'s 2nd Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1173,'Venomous Spider Leg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1174,'Einhasad\'s 2nd Temple Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1175,'Lizardman\'s Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1176,'Gludio Guard\'s 3rd Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1177,'Giant Spider\'s Husk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1178,'Einhasad\'s 3rd Temple Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1179,'Skull of Silent Horror','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1180,'Bezique\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1183,'Spartoi\'s Bones','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1184,'Horseshoe of Light','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1185,'Most Wanted List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1186,'Stolen Jewelry','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1187,'Stolen Tomes','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1188,'Stolen Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1189,'Stolen Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1190,'Bezique\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1191,'1st Letter of Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1192,'2nd Letter of Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1193,'Lionel\'s Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1194,'Book of Vivyan','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1195,'Book of Simplon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1196,'Book of Praga','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1197,'Certificate of Gallint','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1198,'Pendant of Mother','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1199,'Necklace of Mother','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1200,'Lionel\'s Covenant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1201,'Mark of Faith','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1202,'Sorius\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1203,'Kluto Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1204,'Elven Knight Brooch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1205,'Topaz Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1206,'Emerald Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1207,'Reisa\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1208,'Prias\'s 1st Torn Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1209,'Prias\'s 2nd Torn Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1210,'Prias\'s 3rd Torn Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1211,'Prias\'s 4th Torn Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1212,'Moretti\'s Herb','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1214,'Moretti\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1215,'Prias\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1216,'Honorary Guard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1217,'Reisa\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1218,'Rosella\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1219,'Red Down','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1220,'Magical Powers Ruby','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1221,'Pure Aquamarine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1222,'Appetizing Apple','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1223,'Gold Leaves','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1224,'Immortal Love','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1225,'Amethyst','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1226,'Nobility Amethyst','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1227,'Rosella\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1228,'Peridot','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1229,'Fertility Peridot','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1230,'Eternity Diamond','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1231,'Crystal Medallion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1232,'Swindler\'s Money','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1233,'Allana\'s Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1234,'Lizard Captain Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1235,'Leaf of Oracle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1236,'Half of Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1237,'Palus Talisman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1238,'Lycanthrope Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1239,'Virgil\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1240,'Morte Talisman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1241,'Predator\'s Carapace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1242,'Arachnid Tracker Silk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1243,'Coffin of Eternal Rest','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1244,'Gaze of Abyss','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1245,'Shilen\'s Call','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1246,'Arkenia\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1247,'Leikan\'s Note','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1248,'Moonstone Beast\'s Molar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1249,'Leikan\'s Knife','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1250,'Shilen\'s Tears','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1251,'Arkenia\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1252,'Iron Heart','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1253,'Seed of Anger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1254,'Seed of Despair','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1255,'Seed of Horror','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1256,'Seed of Lunacy','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1257,'Family\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1258,'Varika\'s Liquor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1259,'Knee Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1260,'Heart of Lunacy','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1261,'Dark Jewel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1262,'Sidra\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1263,'Blank Sheet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1264,'Bloody Rune','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1265,'Garmiel Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1266,'Prayer of Adonius','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1267,'Penitent\'s Mark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1268,'Ashen Bones','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1269,'Andariel Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1270,'Orb of Abyss','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1271,'Mark of Esquire','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1272,'Charm of Grain','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1273,'Sap of the Mother Tree','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1274,'Lucky Potpourri','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1275,'Tamil\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1276,'Kluto\'s Memo','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1277,'Lucky Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1278,'Candle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1279,'Hub Scent','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1280,'Map of Luster','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1281,'Key of Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1282,'Flame Earring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1283,'Broken Bronze Mirror','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1284,'Wind Feather','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1285,'Wind Bangle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1286,'Rama\'s Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1287,'Sparkle Pebble','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1288,'Water Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1289,'Rust Gold Coin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1290,'Red Soil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1291,'Earth Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1292,'Bead of Season','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1293,'Rusted Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1294,'Spellbook: Defense Aura','false','spellbook',120,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','none',''),
(1334,'Predator\'s Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(1335,'Goblin Club','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(1336,'Glass Shard','false','none',80,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1337,'Emerald','false','none',80,'stackable','liquid','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(1338,'Blue Onyx','false','none',80,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1339,'Onyx','false','none',80,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','none',''),
(1340,'Silvery Leaf','false','none',3,'stackable','liquid','none',-1,-1,20,0,'true','true','true','true','true','none',''),
(1341,'Bone Arrow','false','arrow',5,'stackable','bone','d',-1,-1,2,0,'true','true','true','true','true','none',''),
(1342,'Iron Arrow','false','arrow',4,'stackable','fine_steel','c',-1,-1,5,0,'true','true','true','true','true','none',''),
(1343,'Silver Arrow','false','arrow',4,'stackable','silver','b',-1,-1,7,0,'true','true','true','true','true','none',''),
(1344,'Mithril Arrow','false','arrow',3,'stackable','mithril','a',-1,-1,8,0,'true','true','true','true','true','none',''),
(1345,'Shining Arrow','false','arrow',3,'stackable','adamantaite','s',-1,-1,10,0,'true','true','true','true','true','none',''),
(1346,'Golem\'s Stoneheart','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1347,'Monster Eye Carcass','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1348,'Basilisk\'s Gizzard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1349,'Anatomy Diagram','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1350,'Zombie Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1351,'Zombie Heart','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1352,'Zombie Liver','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1353,'Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1354,'Rib Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1355,'Spine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1356,'Arm Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1357,'Thigh Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1358,'Complete Skeleton','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1359,'Red Cross Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1360,'Blue Cross Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1361,'Black Cross Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1362,'Spider\'s Carapace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1363,'Spider Silk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1364,'Spider Venom Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1365,'Broken Stoneheart','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1366,'Monster Eye\'s Lens','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1367,'Wolf Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1368,'Imp Shackles','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1369,'Black Lion Mark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1370,'Spellbook: Aqua Swirl','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1371,'Spellbook: Twister','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1372,'Spellbook: Blaze','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1373,'Magic Gem','false','none',80,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','none',''),
(1374,'Greater Haste Potion','false','potion',20,'stackable','liquid','none',-1,-1,3600,0,'true','true','true','true','true','ItemSkills','2034-1'),
(1375,'Greater Swift Attack Potion','false','potion',20,'stackable','liquid','none',-1,-1,7200,0,'true','true','true','true','true','ItemSkills','2035-1'),
(1377,'Spellbook: Poison Recovery','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1378,'Spellbook: Divine Heal','false','spellbook',120,'stackable','paper','none',-1,-1,1550,0,'true','true','true','true','true','none',''),
(1379,'Spellbook: Cure Bleeding','false','spellbook',120,'stackable','paper','none',-1,-1,1150,0,'true','true','true','true','true','none',''),
(1380,'Spellbook: Entangle','false','spellbook',120,'stackable','paper','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(1381,'Spellbook: Freezing Strike','false','spellbook',120,'stackable','paper','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(1382,'Spellbook: Power Break','false','spellbook',120,'stackable','paper','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(1383,'Spellbook: Poison','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1384,'Spellbook: Sprint','false','spellbook',120,'stackable','paper','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(1385,'Spellbook: Recharge','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1386,'Spellbook: Disrupt Undead','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1387,'Spellbook: Resist Poison','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1388,'Spellbook: Mental Shield','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1389,'Spellbook: Holy Weapon','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1390,'Spellbook: Regeneration','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1391,'Spellbook: Empower','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1392,'Spellbook: Berserker Spirit','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1393,'Spellbook: Quickness','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1394,'Spellbook: Sleep','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1395,'Spellbook: Surrender to Water','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1396,'Spellbook: Surrender to Wind','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1397,'Spellbook: Peace','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1398,'Spellbook: Focus','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1399,'Spellbook: Concentration','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1400,'Spellbook: Surrender To Fire','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1401,'Spellbook: Acumen','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1402,'Spellbook: Agility','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1403,'Spellbook: Summon Kat the Cat','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1404,'Spellbook: Servitor Recharge','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1405,'Spellbook: Servitor Heal','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1406,'Spellbook: Servitor Wind Walk','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1407,'Spellbook: Servitor Magic Boost','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1408,'Spellbook: Mighty Servitor','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1409,'Spellbook: Slow','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1410,'Spellbook: Poisonous Cloud','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1411,'Spellbook: Aura Burn','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1412,'Spellbook: Resist Aqua','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1413,'Spellbook: Resist Wind','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1414,'Spellbook: Resist Fire','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1415,'Spellbook: Dryad Root','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1416,'Spellbook: Curse of Chaos','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1417,'Spellbook: Surrender To Earth','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1418,'Spellbook: Surrender To Poison','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1419,'Blood Mark','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(1420,'Ingredient List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1421,'Sonia\'s Botany Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1422,'Red Mandragora Root','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1423,'White Mandragora Root','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1424,'Red Mandragora Sap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1425,'White Mandragora Sap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1426,'Jacob\'s Insect Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1427,'Nectar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1428,'Royal Jelly','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1429,'Honey','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1430,'Golden Honey','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1431,'Pano\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1432,'Hobgoblin Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1433,'Dionian Potato','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1434,'Glyvka\'s Botany Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1435,'Green Marsh Moss','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1436,'Brown Marsh Moss','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1437,'Green Moss Bundle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1438,'Brown Moss Bundle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1439,'Rollant\'s Creature Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1440,'Body of Monster Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1441,'Meat of Monster Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1442,'Jonas\'s 1st Steak Dish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1443,'Jonas\'s 2nd Steak Dish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1444,'Jonas\'s 3rd Steak Dish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1445,'Jonas\'s 4th Steak Dish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1446,'Jonas\'s 5th Steak Dish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1447,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1448,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1449,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1450,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1451,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1452,'Harpy Feather','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1453,'Medusa Venom','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1454,'Wyrm\'s Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1455,'Jonas\'s Salad Recipe','false','quest',0,'stackable','paper','none',-1,-1,9000,0,'false','false','true','false','false','none',''),
(1456,'Jonas\'s Sauce Recipe','false','quest',0,'stackable','paper','none',-1,-1,11250,0,'false','false','true','false','false','none',''),
(1457,'Jonas\'s Steak Recipe','false','quest',0,'stackable','paper','none',-1,-1,13500,0,'false','false','true','false','false','none',''),
(1458,'Crystal: D-Grade','false','none',0,'stackable','paper','d',-1,-1,650,0,'true','true','true','true','true','none',''),
(1459,'Crystal: C-Grade','false','none',0,'stackable','paper','c',-1,-1,3000,0,'true','true','true','true','true','none',''),
(1460,'Crystal: B-Grade','false','none',0,'stackable','paper','b',-1,-1,9000,0,'true','true','true','true','true','none',''),
(1461,'Crystal: A-Grade','false','none',0,'stackable','paper','a',-1,-1,15000,0,'true','true','true','true','true','none',''),
(1462,'Crystal: S Grade','false','none',0,'stackable','paper','s',-1,-1,25000,0,'true','true','true','true','true','none',''),
(1463,'Soulshot: D-grade','false','shot',3,'stackable','paper','d',-1,-1,10,0,'true','true','true','true','true','SoulShots','2150-1'),
(1464,'Soulshot: C-grade','false','shot',3,'stackable','paper','c',-1,-1,15,0,'true','true','true','true','true','SoulShots','2151-1'),
(1465,'Soulshot: B-grade','false','shot',2,'stackable','paper','b',-1,-1,50,0,'true','true','true','true','true','SoulShots','2152-1'),
(1466,'Soulshot: A-grade','false','shot',2,'stackable','paper','a',-1,-1,80,0,'true','true','true','true','true','SoulShots','2153-1'),
(1467,'Soulshot: S-grade','false','shot',2,'stackable','paper','s',-1,-1,100,0,'true','true','true','true','true','SoulShots','2154-1'),
(1468,'Gludin Panacen','false','quest',0,'stackable','paper','s',-1,-1,0,0,'true','true','true','true','true','none',''),
(1469,'Gludin Vermouth','false','quest',0,'stackable','paper','s',-1,-1,0,0,'true','true','true','true','true','none',''),
(1470,'Artemeter','false','quest',0,'stackable','paper','s',-1,-1,0,0,'true','true','true','true','true','none',''),
(1473,'Kasha Wolf Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1474,'Grave Robber\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1475,'Black Soulstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none','');

INSERT INTO `etcitem` VALUES
(1476,'Red Soulstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1477,'Maraku Werewolf Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1478,'Darkwing Bat Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1479,'Varangka\'s Parasite','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1480,'Kasha Parasite','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1481,'Kasha Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1482,'Black Wolf Pelt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1483,'Goblin Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1484,'Goblin Pendant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1485,'Goblin Lord Pendant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1486,'Suspicious Memo','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1487,'Suspicious Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1488,'Chrysolite Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1489,'Torn Map Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1490,'Hidden Ore Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1491,'Bat Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1492,'Floating Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1493,'Tarantula Spider Silk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1494,'Tarantula Spinnerette','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1495,'Giant Spider Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1496,'Voucher of Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1497,'Necklace of Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1498,'License of Miner','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1499,'Laferon\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1500,'Totem of Hestui','false','none',10,'stackable','liquid','none',-1,-1,11000,0,'true','true','true','true','true','none',''),
(1501,'Maraku Werewolf Totem','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(1502,'Grandma\'s Pearl','false','none',10,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(1503,'Grandma\'s Mirror','false','none',10,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1504,'Grandma\'s Necklace','false','none',10,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(1505,'Grandma\'s Hairpin','false','none',10,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1512,'Spellbook: Confusion','false','spellbook',120,'stackable','paper','none',-1,-1,1150,0,'true','true','true','true','true','none',''),
(1513,'Spellbook: Charm','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1514,'Spellbook: Resurrection','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1515,'Spellbook: Kiss of Eva','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1516,'Spellbook: Corpse Life Drain','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1517,'Spellbook: Body To Mind','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1518,'Amulet: Flame Chant','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1519,'Amulet: Pa\'agrio\'s Gift','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1520,'Amulet: Pa\'agrio\'s Blessing','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1521,'Amulet: Chant of Fire','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1522,'Amulet: Chant of Battle','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1523,'Amulet: Chant of Shielding','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1524,'Amulet: Soul Shield','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1525,'Amulet: Life Drain','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1526,'Amulet: Fear','false','spellbook',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1527,'Amulet: Venom','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1528,'Amulet: Seal of Chaos','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(1529,'Amulet: Dreaming Spirit','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1530,'Amulet: Seal of Slow','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(1531,'Amulet: Chill Flame','false','spellbook',120,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1532,'Amulet: Blaze Quake','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1533,'Amulet: Aura Sink','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1534,'Amulet: Madness','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1535,'Amulet: Frost Flame','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1536,'Amulet: Seal of Binding','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1537,'Amulet: Seal of Poison','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1538,'Blessed Scroll of Escape','false','scroll',120,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','ItemSkills','2036-1'),
(1539,'Greater Healing Potion','false','potion',5,'stackable','liquid','none',-1,-1,1080,0,'true','true','true','true','true','ItemSkills','2037-1'),
(1540,'Quick Healing Potion','false','potion',180,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','ItemSkills','2038-1'),
(1541,'Honey Khandar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1542,'Bear Fur Cloak','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1543,'Bloody Axe','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1544,'Ancestor Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1545,'Spider Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1546,'Deep Sea Orb','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1547,'Bolter\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1548,'Mining Boots','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1549,'Miner\'s Pick','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1550,'Boomboom Powder','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1551,'Redstone Beer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1552,'Bolter\'s Smelly Socks','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1553,'Hatos\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1554,'Hatos\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1555,'Hatos\'s 3rd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1556,'Letter to Dark Elf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1557,'Letter to Human','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1558,'Letter to Elf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1559,'Gouph\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1560,'Reep\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1561,'Elven Wine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1562,'Brunon\'s Dice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1563,'Brunon\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1564,'Aquamarine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1565,'Chrysoberyl','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1566,'Gem Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1567,'Coal Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1568,'Brunon\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1569,'Berry Tart','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1570,'Bat Diagram','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1571,'Star Diamond','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1572,'Starstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1573,'Starstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1574,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1575,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1576,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1577,'Mirien\'s Review','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1578,'Green Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1579,'Goblin Dwelling Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1580,'Kuruka Ratman Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1581,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1582,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1583,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1584,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1585,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1586,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1587,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1588,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1589,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1590,'Betrayer\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1591,'Head of Betrayer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1592,'Mark of Raider','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1593,'Pomegranate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1594,'1st Leather Pouch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1595,'2nd Leather Pouch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1596,'3rd Leather Pouch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1597,'1st Leather Pouch (Full)','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1598,'2nd Leather Pouch (Full)','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1599,'3rd Leather Pouch (Full)','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1600,'Kasha Bear Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1601,'Kasha Blade Spider Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1602,'Scarlet Salamander Scale','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1603,'Fiery Spirit Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1604,'Rosheek\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1605,'Gantaki\'s Letter of Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1606,'Fig','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1607,'4th Leather Pouch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1608,'4th Leather Pouch (Full)','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1609,'Vuku Orc Tusk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1610,'Ratman Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1611,'Langk Lizardman Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1612,'Felim Lizardman Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1613,'Iron Will Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1614,'Toruku\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1615,'Khavatari Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1616,'Fire Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1617,'Kasha Bear Pelt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1618,'Kasha Blade Spider Husk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1619,'1st Fiery Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1620,'Hestui Mask','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1621,'2nd Fiery Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1622,'Totem Spirit Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1623,'Tataru\'s Letter of Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1624,'Flame Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1625,'Grizzly Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1626,'Blood Cauldron','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1627,'Spirit Net','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1628,'Bound Durka Spirit','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1629,'Durka Parasite','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1630,'Totem Spirit Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1631,'Mask of Medium','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1632,'Silvera\'s Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1633,'1st Pass Certificate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1634,'2nd Pass Certificate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1635,'Final Pass Certificate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1636,'Boogle Ratman Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1637,'Boogle Ratman Leader\'s Tooth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1638,'Kluto\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1639,'Footprint of Thief','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1640,'Stolen Secret Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1641,'Secret Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1642,'Ring of Raven','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1643,'Pippi\'s Letter of Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1644,'Raut\'s Teleport Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1645,'Succubus Undies','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1646,'Mion\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1647,'Bronk\'s Ingot','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1648,'Shari\'s Axe','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1649,'Zimenf\'s Potion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1650,'Bronk\'s Pay','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1651,'Shari\'s Pay','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1652,'Zimenf\'s Pay','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1653,'Bear Picture','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1654,'Tarantula Picture','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1655,'Honey Jar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1656,'Bead','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1657,'Bead Parcel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1658,'Gatekeeper Charm','false','none',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(1659,'Gatekeeper Token','false','none',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(1661,'Thief Key','false','none',10,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1662,'Wood','false','none',2,'stackable','liquid','none',-1,-1,20,0,'true','true','true','true','true','none',''),
(1663,'(Not used) Trunk','false','none',2,'stackable','liquid','none',-1,-1,20,0,'true','true','true','true','true','none',''),
(1664,'Steel Powder','false','none',2,'stackable','liquid','none',-1,-1,80,0,'true','true','true','true','true','none',''),
(1665,'World Map','false','none',0,'normal','liquid','none',-1,-1,500,0,'true','true','true','true','true','Maps',''),
(1666,'Recipe: Wooden Arrow','false','recipe',30,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','Recipes',''),
(1667,'Spellbook: Summon Shadow','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1668,'Spellbook: Summon Mew the Cat','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1669,'Spellbook: Summon Boxer the Unicorn','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1670,'Spellbook: Summon Mirage the Unicorn','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1671,'Spellbook: Summon Silhouette','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1672,'__','false','none',40,'normal','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1673,'__','false','none',40,'normal','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1674,'Twig of Treant','false','material',2,'stackable','liquid','none',-1,-1,80,0,'true','true','true','true','true','none',''),
(1675,'Beast Blood','false','material',2,'stackable','liquid','none',-1,-1,40,0,'true','true','true','true','true','none',''),
(1676,'Beast Bone','false','material',2,'stackable','liquid','none',-1,-1,20,0,'true','true','true','true','true','none',''),
(1677,'Hot Oil','false','material',2,'stackable','liquid','none',-1,-1,40,0,'true','true','true','true','true','none',''),
(1678,'(Not used) Thread','false','material',2,'stackable','liquid','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(1679,'Bronze','false','material',2,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(1680,'Fur','false','material',2,'stackable','liquid','none',-1,-1,40,0,'true','true','true','true','true','none',''),
(1681,'Elf Stone','false','material',2,'stackable','liquid','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(1682,'Tear of Holy Spirit','false','material',2,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1683,'Mithril','false','material',2,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(1684,'Durable Stem','false','material',2,'stackable','liquid','none',-1,-1,220,0,'true','true','true','true','true','none',''),
(1685,'Wooden Frame','false','material',2,'stackable','liquid','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(1686,'Bark of Treant','false','material',2,'stackable','liquid','none',-1,-1,480,0,'true','true','true','true','true','none',''),
(1687,'(Not used) Coarse Bone Powder','false','material',2,'stackable','liquid','none',-1,-1,80,0,'true','true','true','true','true','none',''),
(1688,'Refined Steel','false','material',2,'stackable','liquid','none',-1,-1,480,0,'true','true','true','true','true','none',''),
(1689,'(Not used) Leather','false','material',2,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(1690,'Bowstring','false','material',2,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(1691,'Steel Frame','false','material',2,'stackable','liquid','none',-1,-1,4400,0,'true','true','true','true','true','none',''),
(1692,'(Not used) Cord','false','material',2,'stackable','liquid','none',-1,-1,45,0,'true','true','true','true','true','none',''),
(1693,'Refined Bronze','false','material',2,'stackable','liquid','none',-1,-1,890,0,'true','true','true','true','true','none',''),
(1694,'Treant Potion','false','material',2,'stackable','liquid','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1695,'Spell Paper','false','material',2,'stackable','liquid','none',-1,-1,580,0,'true','true','true','true','true','none',''),
(1696,'Flaming Oil','false','material',2,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1697,'Magic Powder','false','material',2,'stackable','liquid','none',-1,-1,3080,0,'true','true','true','true','true','none',''),
(1698,'Refined Mithril','false','material',2,'stackable','liquid','none',-1,-1,2100,0,'true','true','true','true','true','none',''),
(1699,'Fortified Steel','false','material',2,'stackable','liquid','none',-1,-1,1860,0,'true','true','true','true','true','none',''),
(1700,'(Not used) Oriharukon','false','material',2,'stackable','liquid','none',-1,-1,6300,0,'true','true','true','true','true','none',''),
(1701,'Spell Solution','false','material',2,'stackable','liquid','none',-1,-1,8160,0,'true','true','true','true','true','none',''),
(1702,'Metal Frame','false','material',2,'stackable','liquid','none',-1,-1,12500,0,'true','true','true','true','true','none',''),
(1703,'Steel of The Highest Grade','false','material',2,'stackable','liquid','none',-1,-1,3720,0,'true','true','true','true','true','none',''),
(1704,'Stone of Anguish','false','material',60,'stackable','liquid','none',-1,-1,157,0,'true','true','true','true','true','none',''),
(1705,'Sprig of Wisdom','false','material',60,'stackable','liquid','none',-1,-1,258,0,'true','true','true','true','true','none',''),
(1706,'Blue Diamond Fragment','false','material',60,'stackable','liquid','none',-1,-1,471,0,'true','true','true','true','true','none',''),
(1707,'Saint\'s Molar','false','material',60,'stackable','liquid','none',-1,-1,568,0,'true','true','true','true','true','none',''),
(1708,'Smoky Quartz','false','material',60,'stackable','liquid','none',-1,-1,1136,0,'true','true','true','true','true','none',''),
(1709,'Blood of Manticore','false','material',60,'stackable','liquid','none',-1,-1,568,0,'true','true','true','true','true','none',''),
(1710,'Tiger\'s Eye Crystal','false','material',60,'stackable','liquid','none',-1,-1,3215,0,'true','true','true','true','true','none',''),
(1711,'Claw of Leopard','false','material',60,'stackable','liquid','none',-1,-1,402,0,'true','true','true','true','true','none',''),
(1712,'Leather Shoes Material','false','material',60,'stackable','liquid','none',-1,-1,87,0,'true','true','true','true','true','none',''),
(1713,'Leather Tunic Material','false','material',60,'stackable','liquid','none',-1,-1,261,0,'true','true','true','true','true','none',''),
(1714,'Leather Stockings Material','false','material',60,'stackable','liquid','none',-1,-1,129,0,'true','true','true','true','true','none',''),
(1715,'Leather Helmet Material','false','material',60,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','none',''),
(1716,'Leather Gloves Texture','false','material',60,'stackable','liquid','none',-1,-1,226,0,'true','true','true','true','true','none',''),
(1717,'Leather Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,113,0,'true','true','true','true','true','none',''),
(1718,'Black Bone Fragment','false','material',60,'stackable','liquid','none',-1,-1,693,0,'true','true','true','true','true','none',''),
(1719,'Hard Leather Shirt Material','false','material',60,'stackable','liquid','none',-1,-1,963,0,'true','true','true','true','true','none',''),
(1720,'Blue-Black Bone Fragment','false','material',60,'stackable','liquid','none',-1,-1,1493,0,'true','true','true','true','true','none',''),
(1721,'Hard Leather Gaiter Material','false','material',60,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1722,'Boots Material','false','material',60,'stackable','liquid','none',-1,-1,271,0,'true','true','true','true','true','none',''),
(1723,'Leather Boots Material','false','material',60,'stackable','liquid','none',-1,-1,364,0,'true','true','true','true','true','none',''),
(1724,'Skull Fragment','false','material',60,'stackable','liquid','none',-1,-1,512,0,'true','true','true','true','true','none',''),
(1725,'Dark Stockings Material','false','material',60,'stackable','liquid','none',-1,-1,632,0,'true','true','true','true','true','none',''),
(1726,'Crafted Leather Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,523,0,'true','true','true','true','true','none',''),
(1727,'Crafted Leather Gloves Texture','false','material',60,'stackable','liquid','none',-1,-1,261,0,'true','true','true','true','true','none',''),
(1728,'Steel Scale','false','material',60,'stackable','liquid','none',-1,-1,1790,0,'true','true','true','true','true','none',''),
(1729,'Pure White Cloth','false','material',60,'stackable','liquid','none',-1,-1,833,0,'true','true','true','true','true','none',''),
(1730,'Purifying Potion','false','material',60,'stackable','liquid','none',-1,-1,3330,0,'true','true','true','true','true','none',''),
(1731,'Steel Scale Gaiters','false','material',60,'stackable','liquid','none',-1,-1,1148,0,'true','true','true','true','true','none',''),
(1732,'Leather Fittings','false','material',60,'stackable','liquid','none',-1,-1,1520,0,'true','true','true','true','true','none',''),
(1733,'Large Sheet Iron','false','material',60,'stackable','liquid','none',-1,-1,1900,0,'true','true','true','true','true','none',''),
(1734,'Small Leather Fittings','false','material',60,'stackable','liquid','none',-1,-1,952,0,'true','true','true','true','true','none',''),
(1735,'Small Sheet Iron','false','material',60,'stackable','liquid','none',-1,-1,1190,0,'true','true','true','true','true','none',''),
(1736,'Iron Boots Binding','false','material',60,'stackable','liquid','none',-1,-1,635,0,'true','true','true','true','true','none',''),
(1737,'Iron Boots Frame','false','material',60,'stackable','liquid','none',-1,-1,508,0,'true','true','true','true','true','none',''),
(1738,'Wide Blade','false','material',60,'stackable','liquid','none',-1,-1,625,0,'true','true','true','true','true','none',''),
(1739,'Broadsword Mold','false','material',60,'stackable','liquid','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(1740,'Crafted Willow Branch','false','material',60,'stackable','liquid','none',-1,-1,833,0,'true','true','true','true','true','none',''),
(1741,'Stave','false','material',60,'stackable','liquid','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(1742,'Red Cedar Branch','false','material',60,'stackable','liquid','none',-1,-1,1797,0,'true','true','true','true','true','none',''),
(1743,'Dirk Blade','false','material',60,'stackable','liquid','none',-1,-1,1082,0,'true','true','true','true','true','none',''),
(1744,'Dirk Mold','false','material',60,'stackable','liquid','none',-1,-1,5410,0,'true','true','true','true','true','none',''),
(1745,'Brandish Blade','false','material',60,'stackable','liquid','none',-1,-1,1880,0,'true','true','true','true','true','none',''),
(1746,'Short Spear Blade','false','material',60,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(1747,'Shining Blade','false','material',60,'stackable','liquid','none',-1,-1,1700,0,'true','true','true','true','true','none',''),
(1748,'Sword of Reflection Mold','false','material',60,'stackable','liquid','none',-1,-1,13600,0,'true','true','true','true','true','none',''),
(1749,'Branch of The Mother Tree','false','material',60,'stackable','liquid','none',-1,-1,4533,0,'true','true','true','true','true','none',''),
(1750,'Dark Forest Leaf','false','material',60,'stackable','liquid','none',-1,-1,2267,0,'true','true','true','true','true','none',''),
(1751,'Lump of Iron','false','material',60,'stackable','liquid','none',-1,-1,5278,0,'true','true','true','true','true','none',''),
(1752,'Piece of Sword Breaker','false','material',60,'stackable','liquid','none',-1,-1,3050,0,'true','true','true','true','true','none',''),
(1753,'Sword Breaker Mold','false','material',60,'stackable','liquid','none',-1,-1,24400,0,'true','true','true','true','true','none',''),
(1754,'Steel Bow Mold','false','material',60,'stackable','liquid','none',-1,-1,4067,0,'true','true','true','true','true','none',''),
(1755,'Metal Stave','false','material',60,'stackable','liquid','none',-1,-1,8133,0,'true','true','true','true','true','none',''),
(1756,'Spirit of The Saber Smith','false','material',60,'stackable','liquid','none',-1,-1,4544,0,'true','true','true','true','true','none',''),
(1757,'Saber Blade','false','material',60,'stackable','liquid','none',-1,-1,5453,0,'true','true','true','true','true','none',''),
(1758,'Saber Mold','false','material',60,'stackable','liquid','none',-1,-1,13633,0,'true','true','true','true','true','none',''),
(1759,'Blood of Assassin','false','material',60,'stackable','liquid','none',-1,-1,4544,0,'true','true','true','true','true','none',''),
(1760,'Assassin Blade','false','material',60,'stackable','liquid','none',-1,-1,5453,0,'true','true','true','true','true','none',''),
(1761,'Assassin Mold','false','material',60,'stackable','liquid','none',-1,-1,27267,0,'true','true','true','true','true','none',''),
(1762,'Piece of Trident','false','material',60,'stackable','liquid','none',-1,-1,6850,0,'true','true','true','true','true','none',''),
(1763,'Ruby Fragment','false','material',60,'stackable','liquid','none',-1,-1,5113,0,'true','true','true','true','true','none',''),
(1764,'Deep Sea Water','false','material',60,'stackable','liquid','none',-1,-1,10225,0,'true','true','true','true','true','none',''),
(1765,'Spinebone Fragment','false','material',60,'stackable','liquid','none',-1,-1,6440,0,'true','true','true','true','true','none',''),
(1766,'Spinebone Pattern','false','material',60,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','none',''),
(1767,'Piece of Mace of Judgment','false','material',60,'stackable','liquid','none',-1,-1,7156,0,'true','true','true','true','true','none',''),
(1768,'Pattern of Judgment','false','material',60,'stackable','liquid','none',-1,-1,10733,0,'true','true','true','true','true','none',''),
(1769,'Piece of Conjuror\'s Staff','false','material',60,'stackable','liquid','none',-1,-1,6440,0,'true','true','true','true','true','none',''),
(1770,'Magic Flute','false','material',60,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','none',''),
(1771,'Elven Stave','false','material',60,'stackable','liquid','none',-1,-1,21467,0,'true','true','true','true','true','none',''),
(1772,'Leaf of the Mother Tree','false','material',60,'stackable','liquid','none',-1,-1,5367,0,'true','true','true','true','true','none',''),
(1773,'Piece of Dwarven Trident','false','material',60,'stackable','liquid','none',-1,-1,8613,0,'true','true','true','true','true','none',''),
(1774,'Piece of Two-Handed Sword','false','material',60,'stackable','liquid','none',-1,-1,5688,0,'true','true','true','true','true','none',''),
(1775,'Two-Handed Sword Mold','false','material',60,'stackable','liquid','none',-1,-1,96700,0,'true','true','true','true','true','none',''),
(1776,'Piece of Spiked Club','false','material',60,'stackable','liquid','none',-1,-1,32233,0,'true','true','true','true','true','none',''),
(1777,'Steel Piece of Club','false','material',60,'stackable','liquid','none',-1,-1,6447,0,'true','true','true','true','true','none',''),
(1778,'Shilen Bone','false','material',60,'stackable','liquid','none',-1,-1,6447,0,'true','true','true','true','true','none',''),
(1779,'Shilen Mane','false','material',60,'stackable','liquid','none',-1,-1,64467,0,'true','true','true','true','true','none',''),
(1780,'Purity Bronze','false','material',60,'stackable','liquid','none',-1,-1,9210,0,'true','true','true','true','true','none',''),
(1781,'Gastraphetes Stave','false','material',60,'stackable','liquid','none',-1,-1,32233,0,'true','true','true','true','true','none',''),
(1782,'Gastraphetes Addendum','false','material',60,'stackable','liquid','none',-1,-1,6447,0,'true','true','true','true','true','none',''),
(1783,'Blood of Fiend','false','material',60,'stackable','liquid','none',-1,-1,10744,0,'true','true','true','true','true','none',''),
(1784,'Cursed Leather','false','material',60,'stackable','liquid','none',-1,-1,10744,0,'true','true','true','true','true','none',''),
(1785,'Soul Ore','false','material',10,'stackable','liquid','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(1786,'Recipe: Broad Sword','false','recipe',30,'stackable','liquid','none',-1,-1,250,0,'true','true','true','true','true','Recipes',''),
(1787,'Recipe: Willow Staff','false','recipe',30,'stackable','liquid','none',-1,-1,250,0,'true','true','true','true','true','Recipes',''),
(1788,'Recipe: Bow','false','recipe',30,'stackable','liquid','none',-1,-1,250,0,'true','true','true','true','true','Recipes',''),
(1789,'Recipe: Cedar Staff','false','recipe',30,'stackable','liquid','none',-1,-1,1082,0,'true','true','true','true','true','Recipes',''),
(1790,'Recipe: Dirk','false','recipe',30,'stackable','liquid','none',-1,-1,1082,0,'true','true','true','true','true','Recipes',''),
(1791,'Recipe: Brandish','false','recipe',30,'stackable','liquid','none',-1,-1,1082,0,'true','true','true','true','true','Recipes',''),
(1792,'Recipe: Short Spear','false','recipe',30,'stackable','liquid','none',-1,-1,2720,0,'true','true','true','true','true','Recipes',''),
(1793,'Recipe: Sword of Reflection','false','recipe',30,'stackable','liquid','none',-1,-1,2720,0,'true','true','true','true','true','Recipes',''),
(1794,'Recipe: Forest Bow','false','recipe',30,'stackable','liquid','none',-1,-1,2720,0,'true','true','true','true','true','Recipes',''),
(1795,'Recipe:Leather Shoes','false','recipe',30,'stackable','liquid','none',-1,-1,53,0,'true','true','true','true','true','Recipes',''),
(1796,'Recipe: Leather Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,159,0,'true','true','true','true','true','Recipes',''),
(1797,'Recipe: Leather Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,99,0,'true','true','true','true','true','Recipes',''),
(1798,'Recipe: Leather Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,204,0,'true','true','true','true','true','Recipes',''),
(1799,'Recipe: Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,135,0,'true','true','true','true','true','Recipes',''),
(1800,'Recipe: Piece Bone Breastplate','false','recipe',30,'stackable','liquid','none',-1,-1,636,0,'true','true','true','true','true','Recipes',''),
(1801,'Recipe: Piece Bone Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,397,0,'true','true','true','true','true','Recipes',''),
(1802,'Recipe: Necklace of Anguish','false','recipe',30,'stackable','liquid','none',-1,-1,93,0,'true','true','true','true','true','Recipes',''),
(1803,'Recipe: Necklace of Wisdom','false','recipe',30,'stackable','liquid','none',-1,-1,238,0,'true','true','true','true','true','Recipes',''),
(1804,'Recipe: Soulshot: D-Grade','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(1805,'Recipe: Soulshot: C-Grade','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(1806,'Recipe: Soulshot: B-Grade','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(1807,'Recipe: Soulshot: A-Grade','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(1808,'Recipe: Soulshot: S Grade','false','recipe',30,'stackable','liquid','none',-1,-1,450000,0,'true','true','true','true','true','Recipes',''),
(1809,'Recipe: Durable Stem','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1810,'Recipe: Wooden Frame','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1811,'Recipe: Bark of Treant','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1812,'Recipe: Coarse Bone Powder','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1813,'Recipe: Refined Steel','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1814,'Recipe: Leather','false','recipe',30,'stackable','liquid','none',-1,-1,380,0,'true','true','true','true','true','Recipes',''),
(1815,'Recipe: Bowstring','false','recipe',30,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1816,'Recipe: Steel Frame','false','recipe',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1817,'Recipe: Cord','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(1818,'Recipe: Refined Bronze','false','recipe',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1819,'Recipe: Treant Potion','false','recipe',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1820,'Recipe: Spell Paper','false','recipe',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1821,'Recipe: Flaming Oil','false','recipe',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1822,'Recipe: Magic Powder','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1823,'Recipe: Refined Mythril','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1824,'Recipe: Fortified Steel','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1825,'Recipe: Oriharukon','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(1826,'Recipe: Spell Solution','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1827,'Recipe: Metal Frame','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1828,'Recipe: Steel of Highest Grade','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1829,'Scroll of Escape: Clan Hall','false','scroll',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','ItemSkills','2040-1'),
(1830,'Scroll of Escape: Castle','false','scroll',120,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','ItemSkills','2041-1'),
(1831,'Antidote','false','potion',20,'stackable','liquid','none',-1,-1,75,0,'true','true','true','true','true','ItemSkills','2042-1'),
(1832,'Greater Antidote','false','potion',20,'stackable','liquid','none',-1,-1,180,0,'true','true','true','true','true','ItemSkills','2043-1'),
(1833,'Bandage','false','potion',20,'stackable','liquid','none',-1,-1,75,0,'true','true','true','true','true','ItemSkills','2044-1'),
(1834,'Emergency Dressing','false','potion',20,'stackable','liquid','none',-1,-1,180,0,'true','true','true','true','true','ItemSkills','2045-1'),
(1835,'Soulshot: No Grade','false','shot',4,'stackable','paper','none',-1,-1,6,0,'true','true','true','true','true','SoulShots',''),
(1836,'Kendell\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1837,'Kendell\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1838,'Kendell\'s 3rd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1839,'Kendell\'s 4th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1840,'Kendell\'s 5th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1841,'Kendell\'s 6th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1842,'Kendell\'s 7th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1843,'Kendell\'s 8th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1844,'Kaboo Chief\'s 1st Torque','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1845,'Kaboo Chief\'s 2nd Torque','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1846,'Turek Dog Tag','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1847,'Turek Medallion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1848,'Clay Urn Fragment','false','none',10,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1849,'Brass Trinket Piece','false','none',10,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','none',''),
(1850,'Bronze Mirror Piece','false','none',10,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','none',''),
(1851,'Jade Necklace Bead','false','none',10,'stackable','liquid','none',-1,-1,280,0,'true','true','true','true','true','none',''),
(1852,'Ancient Clay Urn','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(1853,'Ancient Brass Tiara','false','none',10,'stackable','liquid','none',-1,-1,1400,0,'true','true','true','true','true','none',''),
(1854,'Ancient Bronze Mirror','false','none',10,'stackable','liquid','none',-1,-1,1400,0,'true','true','true','true','true','none',''),
(1855,'Ancient Jade Necklace','false','none',10,'stackable','liquid','none',-1,-1,1700,0,'true','true','true','true','true','none',''),
(1856,'Amulet: Chant of Life','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(1857,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1858,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1859,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1860,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1861,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1862,'Keltir Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(1863,'Map: Elmore','false','none',0,'normal','liquid','none',-1,-1,500,0,'true','true','true','true','true','Maps',''),
(1864,'Stem','false','material',2,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1865,'Varnish','false','material',2,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1866,'Suede','false','material',2,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(1867,'Animal Skin','false','material',2,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(1868,'Thread','false','material',2,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(1869,'Iron Ore','false','material',2,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1870,'Coal','false','material',2,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1871,'Charcoal','false','material',2,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(1872,'Animal Bone','false','material',2,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(1873,'Silver Nugget','false','material',2,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1874,'Oriharukon Ore','false','material',2,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(1875,'Stone of Purity','false','material',2,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(1876,'Mithril Ore','false','material',2,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(1877,'Adamantite Nugget','false','material',2,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(1878,'Braided Hemp','false','material',2,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(1879,'Cokes','false','material',2,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(1880,'Steel','false','material',2,'stackable','liquid','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(1881,'Coarse Bone Powder','false','material',2,'stackable','liquid','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(1882,'Leather','false','material',2,'stackable','liquid','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(1883,'Steel Mold','false','material',2,'stackable','liquid','none',-1,-1,4500,0,'true','true','true','true','true','none',''),
(1884,'Cord','false','material',2,'stackable','liquid','none',-1,-1,325,0,'true','true','true','true','true','none',''),
(1885,'High Grade Suede','false','material',2,'stackable','liquid','none',-1,-1,2400,0,'true','true','true','true','true','none',''),
(1886,'Silver Mold','false','material',2,'stackable','liquid','none',-1,-1,13500,0,'true','true','true','true','true','none',''),
(1887,'Varnish of Purity','false','material',2,'stackable','liquid','none',-1,-1,8100,0,'true','true','true','true','true','none',''),
(1888,'Synthetic Cokes','false','material',2,'stackable','liquid','none',-1,-1,6600,0,'true','true','true','true','true','none',''),
(1889,'Compound Braid','false','material',2,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(1890,'Mithril Alloy','false','material',2,'stackable','liquid','none',-1,-1,13100,0,'true','true','true','true','true','none',''),
(1891,'Artisan\'s Frame','false','material',2,'stackable','liquid','none',-1,-1,95000,0,'true','true','true','true','true','none',''),
(1892,'Blacksmith\'s Frame','false','material',2,'stackable','liquid','none',-1,-1,64000,0,'true','true','true','true','true','none',''),
(1893,'Oriharukon','false','material',2,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(1894,'Crafted Leather','false','material',2,'stackable','liquid','none',-1,-1,5700,0,'true','true','true','true','true','none',''),
(1895,'Metallic Fiber','false','material',2,'stackable','liquid','none',-1,-1,700,0,'true','true','true','true','true','none',''),
(1896,'Necklace of Anguish Chain','false','material',60,'stackable','liquid','none',-1,-1,472,0,'true','true','true','true','true','none',''),
(1897,'Necklace of Wisdom Chain','false','material',60,'stackable','liquid','none',-1,-1,840,0,'true','true','true','true','true','none',''),
(1898,'Blue Diamond Necklace Gem','false','material',60,'stackable','liquid','none',-1,-1,1947,0,'true','true','true','true','true','none',''),
(1899,'Necklace of Devotion Chain','false','material',60,'stackable','liquid','none',-1,-1,1280,0,'true','true','true','true','true','none',''),
(1900,'Enchanted Necklace Chain','false','material',60,'stackable','liquid','none',-1,-1,1828,0,'true','true','true','true','true','none',''),
(1901,'Tiger\'s Eye Earring Stone','false','material',60,'stackable','liquid','none',-1,-1,1448,0,'true','true','true','true','true','none',''),
(1902,'Elven Earring Beads','false','material',60,'stackable','liquid','none',-1,-1,1974,0,'true','true','true','true','true','none',''),
(1903,'Elven Ring Piece','false','material',60,'stackable','liquid','none',-1,-1,1199,0,'true','true','true','true','true','none',''),
(1904,'Elven Necklace Beads','false','material',60,'stackable','liquid','none',-1,-1,2143,0,'true','true','true','true','true','none',''),
(1905,'Omen Beast\'s Eye Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,2056,0,'true','true','true','true','true','none',''),
(1906,'Mithril Ring Wire','false','material',60,'stackable','liquid','none',-1,-1,1455,0,'true','true','true','true','true','none',''),
(1907,'Necklace of Darkness Gem','false','material',60,'stackable','liquid','none',-1,-1,2875,0,'true','true','true','true','true','none',''),
(1908,'Moonstone Earring Wire','false','material',60,'stackable','liquid','none',-1,-1,2112,0,'true','true','true','true','true','none',''),
(1909,'Aquastone Ring Wire','false','material',60,'stackable','liquid','none',-1,-1,1481,0,'true','true','true','true','true','none',''),
(1910,'Aquastone Necklace Chain','false','material',60,'stackable','liquid','none',-1,-1,2656,0,'true','true','true','true','true','none',''),
(1911,'Earring of Protection Gemstone','false','material',60,'stackable','liquid','none',-1,-1,2689,0,'true','true','true','true','true','none',''),
(1912,'Ring of Protection Gemstone','false','material',60,'stackable','liquid','none',-1,-1,1856,0,'true','true','true','true','true','none',''),
(1913,'Necklace of Protection Gemstone','false','material',60,'stackable','liquid','none',-1,-1,3289,0,'true','true','true','true','true','none',''),
(1914,'Earring of Binding Gemstone','false','material',60,'stackable','liquid','none',-1,-1,3560,0,'true','true','true','true','true','none',''),
(1915,'Ring of Ages Gemstone','false','material',60,'stackable','liquid','none',-1,-1,2270,0,'true','true','true','true','true','none',''),
(1916,'Necklace of Mermaid Teardrop','false','material',60,'stackable','liquid','none',-1,-1,4700,0,'true','true','true','true','true','none',''),
(1917,'Sage\'s Necklace Chain','false','material',60,'stackable','liquid','none',-1,-1,5845,0,'true','true','true','true','true','none',''),
(1918,'Nassen\'s Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,4618,0,'true','true','true','true','true','none',''),
(1919,'Ring of Sage Gemstone','false','material',60,'stackable','liquid','none',-1,-1,3482,0,'true','true','true','true','true','none',''),
(1920,'Necklace of Binding Chain','false','material',60,'stackable','liquid','none',-1,-1,5845,0,'true','true','true','true','true','none',''),
(1921,'Leather Shoes Texture','false','material',60,'stackable','liquid','none',-1,-1,310,0,'true','true','true','true','true','none',''),
(1922,'Leather Tunic Pattern','false','material',60,'stackable','liquid','none',-1,-1,784,0,'true','true','true','true','true','none',''),
(1923,'Leather Stocking Pattern','false','material',60,'stackable','liquid','none',-1,-1,488,0,'true','true','true','true','true','none',''),
(1924,'Leather Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,620,0,'true','true','true','true','true','none',''),
(1925,'Leather Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,305,0,'true','true','true','true','true','none',''),
(1926,'Piece Bone Breastplate Fragment','false','material',60,'stackable','liquid','none',-1,-1,1980,0,'true','true','true','true','true','none',''),
(1927,'Hard Leather Shirt Pattern','false','material',60,'stackable','liquid','none',-1,-1,2507,0,'true','true','true','true','true','none',''),
(1928,'Piece Bone Gaiters Fragment','false','material',60,'stackable','liquid','none',-1,-1,1373,0,'true','true','true','true','true','none',''),
(1929,'Hard Leather Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,1550,0,'true','true','true','true','true','none',''),
(1930,'Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,780,0,'true','true','true','true','true','none',''),
(1931,'Leather Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,1530,0,'true','true','true','true','true','none',''),
(1932,'Bone Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,1260,0,'true','true','true','true','true','none',''),
(1933,'Dark Stocking Fabric','false','material',60,'stackable','liquid','none',-1,-1,1700,0,'true','true','true','true','true','none',''),
(1934,'Crafted Leather Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,1530,0,'true','true','true','true','true','none',''),
(1935,'Scale Mail Fragment','false','material',60,'stackable','liquid','none',-1,-1,3580,0,'true','true','true','true','true','none',''),
(1936,'White Tunic Pattern','false','material',60,'stackable','liquid','none',-1,-1,2444,0,'true','true','true','true','true','none',''),
(1937,'Scale Gaiters Fragment','false','material',60,'stackable','liquid','none',-1,-1,2328,0,'true','true','true','true','true','none',''),
(1938,'Mithril Banded Mail Material','false','material',60,'stackable','liquid','none',-1,-1,2975,0,'true','true','true','true','true','none',''),
(1939,'Mithril Banded Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,2277,0,'true','true','true','true','true','none',''),
(1940,'Iron Boots Design','false','material',60,'stackable','liquid','none',-1,-1,1340,0,'true','true','true','true','true','none',''),
(1941,'Brigandine Temper','false','material',60,'stackable','liquid','none',-1,-1,5029,0,'true','true','true','true','true','none',''),
(1942,'Manticore Skin Shirt Texture','false','material',60,'stackable','liquid','none',-1,-1,3921,0,'true','true','true','true','true','none',''),
(1943,'Manticore Skin Gaiters Pattern','false','material',60,'stackable','liquid','none',-1,-1,2518,0,'true','true','true','true','true','none',''),
(1944,'Mithril Tunic Fabric','false','material',60,'stackable','liquid','none',-1,-1,3921,0,'true','true','true','true','true','none',''),
(1945,'Mithril Stocking Design','false','material',60,'stackable','liquid','none',-1,-1,2518,0,'true','true','true','true','true','none',''),
(1946,'Rip Gauntlets Pattern','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(1947,'Kite Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,1389,0,'true','true','true','true','true','none',''),
(1948,'Boots of Power Pattern','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(1949,'Mithril Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(1950,'Half Plate Temper','false','material',60,'stackable','liquid','none',-1,-1,6162,0,'true','true','true','true','true','none',''),
(1951,'Plate Gaiters Part','false','material',60,'stackable','liquid','none',-1,-1,3962,0,'true','true','true','true','true','none',''),
(1952,'Salamander Skin Mail Texture','false','material',60,'stackable','liquid','none',-1,-1,6244,0,'true','true','true','true','true','none',''),
(1953,'Sage\'s Rag Lining','false','material',60,'stackable','liquid','none',-1,-1,6244,0,'true','true','true','true','true','none',''),
(1954,'Karmian Stocking Design','false','material',60,'stackable','liquid','none',-1,-1,3762,0,'true','true','true','true','true','none',''),
(1955,'Chain Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,2481,0,'true','true','true','true','true','none',''),
(1956,'Square Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,1762,0,'true','true','true','true','true','none',''),
(1957,'Assault Boots Part','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(1958,'Mithril Boots Design','false','material',60,'stackable','liquid','none',-1,-1,1120,0,'true','true','true','true','true','none',''),
(1959,'Chain Mail Shirt Material','false','material',60,'stackable','liquid','none',-1,-1,7425,0,'true','true','true','true','true','none',''),
(1960,'Chain Gaiters Part','false','material',60,'stackable','liquid','none',-1,-1,3650,0,'true','true','true','true','true','none',''),
(1961,'Mithril Shirt Fabric','false','material',60,'stackable','liquid','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(1962,'Karmian Tunic Pattern','false','material',60,'stackable','liquid','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(1963,'Ogre Power Gauntlets Part','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(1964,'Eldarake Temper','false','material',60,'stackable','liquid','none',-1,-1,2475,0,'true','true','true','true','true','none',''),
(1965,'Metal Plate Helmet Material','false','material',60,'stackable','liquid','none',-1,-1,2967,0,'true','true','true','true','true','none',''),
(1966,'Plated Leather Fragment','false','material',60,'stackable','liquid','none',-1,-1,5478,0,'true','true','true','true','true','none',''),
(1967,'Plated Leather Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,3667,0,'true','true','true','true','true','none',''),
(1968,'Dwarven Chain Mail Shirt Material','false','material',60,'stackable','liquid','none',-1,-1,8300,0,'true','true','true','true','true','none',''),
(1969,'Dwarven Chain Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,5233,0,'true','true','true','true','true','none',''),
(1970,'Robe of Seal Fabric','false','material',60,'stackable','liquid','none',-1,-1,8956,0,'true','true','true','true','true','none',''),
(1971,'Great Helmet Material','false','material',60,'stackable','liquid','none',-1,-1,3267,0,'true','true','true','true','true','none',''),
(1972,'Knight\'s Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(1973,'Pa\'agrian Hand Design','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(1974,'Crimson Boot Fabric','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(1975,'Rind Leather Armor Design','false','material',60,'stackable','liquid','none',-1,-1,6089,0,'true','true','true','true','true','none',''),
(1976,'Rind Leather Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,3289,0,'true','true','true','true','true','none',''),
(1977,'Composite Armor Temper','false','material',60,'stackable','liquid','none',-1,-1,13520,0,'true','true','true','true','true','none',''),
(1978,'Tower Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,3120,0,'true','true','true','true','true','none',''),
(1979,'Demon\'s Tunic Fabric','false','material',60,'stackable','liquid','none',-1,-1,8240,0,'true','true','true','true','true','none',''),
(1980,'Demon\'s Stocking Pattern','false','material',60,'stackable','liquid','none',-1,-1,4700,0,'true','true','true','true','true','none',''),
(1981,'Mithril Gauntlets Design','false','material',60,'stackable','liquid','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(1982,'Forgotten Boots Pattern','false','material',60,'stackable','liquid','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(1983,'Shining Circlet Pattern','false','material',60,'stackable','liquid','none',-1,-1,4560,0,'true','true','true','true','true','none',''),
(1984,'Theca Leather Armor Pattern','false','material',60,'stackable','liquid','none',-1,-1,9330,0,'true','true','true','true','true','none',''),
(1985,'Theca Leather Gaiters Pattern','false','material',60,'stackable','liquid','none',-1,-1,5800,0,'true','true','true','true','true','none',''),
(1986,'Full Plate Armor Temper','false','material',60,'stackable','liquid','none',-1,-1,18927,0,'true','true','true','true','true','none',''),
(1987,'Drake Leather Armor Texture','false','material',60,'stackable','liquid','none',-1,-1,13109,0,'true','true','true','true','true','none',''),
(1988,'Divine Tunic Fabric','false','material',60,'stackable','liquid','none',-1,-1,10409,0,'true','true','true','true','true','none',''),
(1989,'Divine Stocking Pattern','false','material',60,'stackable','liquid','none',-1,-1,6636,0,'true','true','true','true','true','none',''),
(1990,'Mithril Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1991,'Cap of Mana Pattern','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1992,'Paradia Hood Material','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1993,'Hood of Solar Eclipse Texture','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1994,'Hood of Summoning Texture','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1995,'Elemental Hood Material','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1996,'Hood of Grace Texture','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1997,'Phoenix Hood Material','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1998,'Hood of Aid Material','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(1999,'Flame Helm Design','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(2000,'Tallum Helm Design','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(2001,'Helm of Avadon Design','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(2002,'Helmet of Pledge Pattern','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(2003,'Gauntlets of Ghost Pattern','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2004,'Adamantite Boots Design','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2005,'Broadsword Blade','false','material',60,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','none',''),
(2006,'Willow Staff Head','false','material',60,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','none',''),
(2007,'Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','none',''),
(2008,'Cedar Staff Head','false','material',60,'stackable','liquid','none',-1,-1,5140,0,'true','true','true','true','true','none',''),
(2009,'Dirk Blade','false','material',60,'stackable','liquid','none',-1,-1,5640,0,'true','true','true','true','true','none',''),
(2010,'Brandish Blade','false','material',60,'stackable','liquid','none',-1,-1,5140,0,'true','true','true','true','true','none',''),
(2011,'Short Spear Edge','false','material',60,'stackable','liquid','none',-1,-1,8767,0,'true','true','true','true','true','none',''),
(2012,'Sword of Reflection Blade','false','material',60,'stackable','liquid','none',-1,-1,9600,0,'true','true','true','true','true','none',''),
(2013,'Forest Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,9267,0,'true','true','true','true','true','none',''),
(2014,'Iron Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,17400,0,'true','true','true','true','true','none',''),
(2015,'Sword Breaker Edge','false','material',60,'stackable','liquid','none',-1,-1,16400,0,'true','true','true','true','true','none',''),
(2016,'Composite Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,17067,0,'true','true','true','true','true','none',''),
(2017,'Saber Blade','false','material',60,'stackable','liquid','none',-1,-1,15050,0,'true','true','true','true','true','none',''),
(2018,'Assassin Knife Edge','false','material',60,'stackable','liquid','none',-1,-1,15050,0,'true','true','true','true','true','none',''),
(2019,'Trident Edge','false','material',60,'stackable','liquid','none',-1,-1,9300,0,'true','true','true','true','true','none',''),
(2020,'Temptation of Abyss Piece','false','material',60,'stackable','liquid','none',-1,-1,11425,0,'true','true','true','true','true','none',''),
(2021,'Spinebone Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,15840,0,'true','true','true','true','true','none',''),
(2022,'Mace of Judgment Head','false','material',60,'stackable','liquid','none',-1,-1,12840,0,'true','true','true','true','true','none',''),
(2023,'Conjuror\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,16140,0,'true','true','true','true','true','none',''),
(2024,'Elven Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,14040,0,'true','true','true','true','true','none',''),
(2025,'Dwarven Trident Edge','false','material',60,'stackable','liquid','none',-1,-1,14440,0,'true','true','true','true','true','none',''),
(2026,'Two-Handed Sword Edge','false','material',60,'stackable','liquid','none',-1,-1,16617,0,'true','true','true','true','true','none',''),
(2027,'Spiked Club Head','false','material',60,'stackable','liquid','none',-1,-1,15267,0,'true','true','true','true','true','none',''),
(2028,'Shilen Knife Edge','false','material',60,'stackable','liquid','none',-1,-1,16833,0,'true','true','true','true','true','none',''),
(2029,'Gastraphetes Shaft','false','material',60,'stackable','liquid','none',-1,-1,16767,0,'true','true','true','true','true','none',''),
(2030,'Tome of Blood Page','false','material',60,'stackable','liquid','none',-1,-1,17100,0,'true','true','true','true','true','none',''),
(2031,'Morning Star Head','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(2032,'Goat Head Staff Head','false','material',60,'stackable','liquid','none',-1,-1,21643,0,'true','true','true','true','true','none',''),
(2033,'Winged Spear Blade','false','material',60,'stackable','liquid','none',-1,-1,17929,0,'true','true','true','true','true','none',''),
(2034,'Sword of Revolution Blade','false','material',60,'stackable','liquid','none',-1,-1,18929,0,'true','true','true','true','true','none',''),
(2035,'Tarbar Head','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(2036,'Skull Breaker Head','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(2037,'Heavy Bone Club Head','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(2038,'Maingauche Edge','false','material',60,'stackable','liquid','none',-1,-1,18929,0,'true','true','true','true','true','none',''),
(2039,'Bich\'Hwa Edge','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(2040,'Strengthened Long Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,17286,0,'true','true','true','true','true','none',''),
(2041,'War Pick Head','false','material',60,'stackable','liquid','none',-1,-1,17929,0,'true','true','true','true','true','none',''),
(2042,'Crucifix of Blood Piece','false','material',60,'stackable','liquid','none',-1,-1,21643,0,'true','true','true','true','true','none',''),
(2043,'Eye of Infinity Stone','false','material',60,'stackable','liquid','none',-1,-1,21643,0,'true','true','true','true','true','none',''),
(2044,'Cursed Maingauche Edge','false','material',60,'stackable','liquid','none',-1,-1,18929,0,'true','true','true','true','true','none',''),
(2045,'Blue Crystal Skull Part','false','material',60,'stackable','liquid','none',-1,-1,21786,0,'true','true','true','true','true','none',''),
(2046,'Demon Fangs Part','false','material',60,'stackable','liquid','none',-1,-1,21786,0,'true','true','true','true','true','none',''),
(2047,'Claymore Blade','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2048,'Bonebreaker Head','false','material',60,'stackable','liquid','none',-1,-1,24188,0,'true','true','true','true','true','none',''),
(2049,'Atuba Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,24188,0,'true','true','true','true','true','none',''),
(2050,'Ghost Staff Head','false','material',60,'stackable','liquid','none',-1,-1,22812,0,'true','true','true','true','true','none',''),
(2051,'Staff of Life Shaft','false','material',60,'stackable','liquid','none',-1,-1,22812,0,'true','true','true','true','true','none',''),
(2052,'Mithril Dagger Blade','false','material',60,'stackable','liquid','none',-1,-1,23062,0,'true','true','true','true','true','none',''),
(2053,'Scallop Jamadhr Edge','false','material',60,'stackable','liquid','none',-1,-1,24188,0,'true','true','true','true','true','none',''),
(2054,'Light Crossbow Shaft','false','material',60,'stackable','liquid','none',-1,-1,23500,0,'true','true','true','true','true','none',''),
(2055,'Glaive Edge','false','material',60,'stackable','liquid','none',-1,-1,24188,0,'true','true','true','true','true','none',''),
(2056,'Vajra Wand Frame','false','material',60,'stackable','liquid','none',-1,-1,22812,0,'true','true','true','true','true','none',''),
(2057,'Ancient Reagent Remnant','false','material',60,'stackable','liquid','none',-1,-1,22812,0,'true','true','true','true','true','none',''),
(2058,'Atuba Mace Head','false','material',60,'stackable','liquid','none',-1,-1,24188,0,'true','true','true','true','true','none',''),
(2059,'Flamberge Blade','false','material',60,'stackable','liquid','none',-1,-1,24125,0,'true','true','true','true','true','none',''),
(2060,'Stormbringer Blade','false','material',60,'stackable','liquid','none',-1,-1,24425,0,'true','true','true','true','true','none',''),
(2061,'Big Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,26800,0,'true','true','true','true','true','none',''),
(2062,'Scythe Edge','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2063,'Battle Axe Head','false','material',60,'stackable','liquid','none',-1,-1,26800,0,'true','true','true','true','true','none',''),
(2064,'Silver Axe Head','false','material',60,'stackable','liquid','none',-1,-1,26800,0,'true','true','true','true','true','none',''),
(2065,'Skull Graver Head','false','material',60,'stackable','liquid','none',-1,-1,26800,0,'true','true','true','true','true','none',''),
(2066,'Heavy Doom Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2067,'Crystal Staff Head','false','material',60,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(2068,'Stick of Faith Shaft','false','material',60,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(2069,'Heavy Doom Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2070,'Cursed Dagger Blade','false','material',60,'stackable','liquid','none',-1,-1,24425,0,'true','true','true','true','true','none',''),
(2071,'Wolverine Needle Edge','false','material',60,'stackable','liquid','none',-1,-1,24425,0,'true','true','true','true','true','none',''),
(2072,'Dark Elven Dagger Edge','false','material',60,'stackable','liquid','none',-1,-1,24425,0,'true','true','true','true','true','none',''),
(2073,'Chakram Edge','false','material',60,'stackable','liquid','none',-1,-1,26800,0,'true','true','true','true','true','none',''),
(2074,'Crystallized Ice Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,26538,0,'true','true','true','true','true','none',''),
(2075,'Orcish Glaive Blade','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2076,'Body Slasher Blade','false','material',60,'stackable','liquid','none',-1,-1,22750,0,'true','true','true','true','true','none',''),
(2077,'Shamshir Blade','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2078,'Katana Blade','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2079,'Bec De Corbin Blade','false','material',60,'stackable','liquid','none',-1,-1,31667,0,'true','true','true','true','true','none',''),
(2080,'Spirit Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2081,'Raid Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2082,'Cursed Staff Head','false','material',60,'stackable','liquid','none',-1,-1,30911,0,'true','true','true','true','true','none',''),
(2083,'Stiletto Edge','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2084,'Soulfire Dirk Blade','false','material',60,'stackable','liquid','none',-1,-1,29556,0,'true','true','true','true','true','none',''),
(2085,'Crossbow Shaft','false','material',60,'stackable','liquid','none',-1,-1,26189,0,'true','true','true','true','true','none',''),
(2086,'Elven Bow of Nobility Shaft','false','material',60,'stackable','liquid','none',-1,-1,26189,0,'true','true','true','true','true','none',''),
(2087,'Tears of Fairy Drop','false','material',60,'stackable','liquid','none',-1,-1,30911,0,'true','true','true','true','true','none',''),
(2088,'Horn of Glory Fragment','false','material',60,'stackable','liquid','none',-1,-1,30911,0,'true','true','true','true','true','none',''),
(2089,'Caliburs Edge','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2090,'Delusional Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2091,'Tsurugi Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2092,'Homunkulus\'s Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2093,'Poleaxe Blade','false','material',60,'stackable','liquid','none',-1,-1,34200,0,'true','true','true','true','true','none',''),
(2094,'Sword of Limit Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2095,'Sword of Nightmare Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2096,'Sword of Whispering Death Blade','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2097,'War Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,37000,0,'true','true','true','true','true','none',''),
(2098,'Nirvana Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,37000,0,'true','true','true','true','true','none',''),
(2099,'Stick of Eternity Shaft','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2100,'Paradia Staff Head','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2101,'Inferno Staff Head','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2102,'Pa\'agrian Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,34200,0,'true','true','true','true','true','none',''),
(2103,'Sage\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2104,'Club of Nature Head','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2105,'Mace of The Underworld Head','false','material',60,'stackable','liquid','none',-1,-1,37000,0,'true','true','true','true','true','none',''),
(2106,'Grace Dagger Edge','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2107,'Dark Screamer Edge','false','material',60,'stackable','liquid','none',-1,-1,37450,0,'true','true','true','true','true','none',''),
(2108,'Fisted Blade Piece','false','material',60,'stackable','liquid','none',-1,-1,37000,0,'true','true','true','true','true','none',''),
(2109,'Akat Longbow Shaft','false','material',60,'stackable','liquid','none',-1,-1,41130,0,'true','true','true','true','true','none',''),
(2110,'Heathen\'s Book Page','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2111,'Hex Doll Fragment','false','material',60,'stackable','liquid','none',-1,-1,35900,0,'true','true','true','true','true','none',''),
(2112,'Pa\'agrian Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,39900,0,'true','true','true','true','true','none',''),
(2113,'Scorpion Blade','false','material',60,'stackable','liquid','none',-1,-1,39900,0,'true','true','true','true','true','none',''),
(2114,'Widowmaker Head','false','material',60,'stackable','liquid','none',-1,-1,39900,0,'true','true','true','true','true','none',''),
(2115,'Samurai Longsword Blade','false','material',60,'stackable','liquid','none',-1,-1,46636,0,'true','true','true','true','true','none',''),
(2116,'Deadman\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2117,'Ghoul\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2118,'Demon\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2119,'Crystal Dagger Blade','false','material',60,'stackable','liquid','none',-1,-1,43136,0,'true','true','true','true','true','none',''),
(2120,'Great Pata Blade','false','material',60,'stackable','liquid','none',-1,-1,45964,0,'true','true','true','true','true','none',''),
(2121,'Eminence Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,47218,0,'true','true','true','true','true','none',''),
(2122,'Orcish Poleaxe Blade','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2123,'Candle of Wisdom Model','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2124,'Blessed Branch Splinter','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2125,'Phoenix Feather Piece','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2126,'Cerberus Eye Fragment','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2127,'Scroll of Destruction Page','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2128,'Claws of Black Dragon Piece','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2129,'Three Eyed Crow\'s Feather Piece','false','material',60,'stackable','liquid','none',-1,-1,43818,0,'true','true','true','true','true','none',''),
(2130,'Gemstone D','false','material',2,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(2131,'Gemstone C','false','material',2,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(2132,'Gemstone B','false','material',2,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(2133,'Gemstone A','false','material',2,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(2134,'Gemstone S','false','material',2,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','none',''),
(2135,'Recipe: Braided Hemp','false','recipe',30,'stackable','liquid','none',-1,-1,680,0,'true','true','true','true','true','Recipes',''),
(2136,'Recipe: Cokes','false','recipe',30,'stackable','liquid','none',-1,-1,680,0,'true','true','true','true','true','Recipes',''),
(2137,'Recipe: Steel','false','recipe',30,'stackable','liquid','none',-1,-1,680,0,'true','true','true','true','true','Recipes',''),
(2138,'Recipe: Coarse Bone Powder (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,680,0,'true','true','true','true','true','Recipes',''),
(2139,'Recipe: Steel Mold','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2140,'Recipe: High Grade Suede','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2141,'Recipe: Silver Mold','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2142,'Recipe: Varnish of Purity','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2143,'Recipe: Synthetic Cokes','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2144,'Recipe: Compound Braid','false','recipe',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','Recipes',''),
(2145,'Recipe: Mithril Alloy','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2146,'Recipe: Artisan\'s frame','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2147,'Recipe: Blacksmith\'s frame','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2148,'Recipe: Crafted Leather','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2149,'Recipe: Metallic Fiber','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2150,'Recipe: Blue Diamond Necklace','false','recipe',30,'stackable','liquid','none',-1,-1,426,0,'true','true','true','true','true','Recipes',''),
(2151,'Recipe: Necklace of Devotion','false','recipe',30,'stackable','liquid','none',-1,-1,718,0,'true','true','true','true','true','Recipes',''),
(2152,'Recipe: Enchanted Necklace','false','recipe',30,'stackable','liquid','none',-1,-1,1136,0,'true','true','true','true','true','Recipes',''),
(2153,'Recipe: Tiger\'s Eye Earring','false','recipe',30,'stackable','liquid','none',-1,-1,1286,0,'true','true','true','true','true','Recipes',''),
(2154,'Recipe: Elven Earring','false','recipe',30,'stackable','liquid','none',-1,-1,1868,0,'true','true','true','true','true','Recipes',''),
(2155,'Recipe: Elven Ring','false','recipe',30,'stackable','liquid','none',-1,-1,1246,0,'true','true','true','true','true','Recipes',''),
(2156,'Recipe: Elven Necklace','false','recipe',30,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','Recipes',''),
(2157,'Recipe: Omen Beast\'s Eye Earring','false','recipe',30,'stackable','liquid','none',-1,-1,2420,0,'true','true','true','true','true','Recipes',''),
(2158,'Recipe: Mithril Ring','false','recipe',30,'stackable','liquid','none',-1,-1,1616,0,'true','true','true','true','true','Recipes',''),
(2159,'Recipe: Necklace of Darkness','false','recipe',30,'stackable','liquid','none',-1,-1,3240,0,'true','true','true','true','true','Recipes',''),
(2160,'Recipe: Moonstone Earring','false','recipe',30,'stackable','liquid','none',-1,-1,3100,0,'true','true','true','true','true','Recipes',''),
(2161,'Recipe: Aquastone Ring','false','recipe',30,'stackable','liquid','none',-1,-1,2060,0,'true','true','true','true','true','Recipes',''),
(2162,'Recipe: Aquastone Necklace','false','recipe',30,'stackable','liquid','none',-1,-1,4140,0,'true','true','true','true','true','Recipes',''),
(2163,'Recipe: Earring of Protection','false','recipe',30,'stackable','liquid','none',-1,-1,3920,0,'true','true','true','true','true','Recipes',''),
(2164,'Recipe: Ring of Protection','false','recipe',30,'stackable','liquid','none',-1,-1,2600,0,'true','true','true','true','true','Recipes',''),
(2165,'Recipe: Necklace of Protection','false','recipe',30,'stackable','liquid','none',-1,-1,5220,0,'true','true','true','true','true','Recipes',''),
(2166,'Recipe: Earrings of Binding (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5900,0,'true','true','true','true','true','Recipes',''),
(2167,'Recipe: Ring of Ages','false','recipe',30,'stackable','liquid','none',-1,-1,3920,0,'true','true','true','true','true','Recipes',''),
(2168,'Recipe: Necklace of Mermaid','false','recipe',30,'stackable','liquid','none',-1,-1,7860,0,'true','true','true','true','true','Recipes',''),
(2169,'Recipe: Necklace of Binding','false','recipe',30,'stackable','liquid','none',-1,-1,11300,0,'true','true','true','true','true','Recipes',''),
(2170,'Recipe: Nassen\'s Earring','false','recipe',30,'stackable','liquid','none',-1,-1,8480,0,'true','true','true','true','true','Recipes',''),
(2171,'Recipe: Sage\'s Ring','false','recipe',30,'stackable','liquid','none',-1,-1,5640,0,'true','true','true','true','true','Recipes',''),
(2172,'Recipe: Sage\'s Necklace','false','recipe',30,'stackable','liquid','none',-1,-1,11300,0,'true','true','true','true','true','Recipes',''),
(2173,'Recipe: Hard Leather Shirt','false','recipe',30,'stackable','liquid','none',-1,-1,738,0,'true','true','true','true','true','Recipes',''),
(2174,'Recipe: Hard Leather Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,460,0,'true','true','true','true','true','Recipes',''),
(2175,'Recipe: Boots','false','recipe',30,'stackable','liquid','none',-1,-1,246,0,'true','true','true','true','true','Recipes',''),
(2176,'Recipe: Leather Boots','false','recipe',30,'stackable','liquid','none',-1,-1,418,0,'true','true','true','true','true','Recipes',''),
(2177,'Recipe: Bone Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,626,0,'true','true','true','true','true','Recipes',''),
(2178,'Recipe: Dark Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,1250,0,'true','true','true','true','true','Recipes',''),
(2179,'Recipe: Crafted Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,418,0,'true','true','true','true','true','Recipes',''),
(2180,'Recipe: Scale Mail','false','recipe',30,'stackable','liquid','none',-1,-1,2660,0,'true','true','true','true','true','Recipes',''),
(2181,'Recipe: White Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,1998,0,'true','true','true','true','true','Recipes',''),
(2182,'Recipe: Scale Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,1666,0,'true','true','true','true','true','Recipes',''),
(2183,'Recipe: Mithril Banded Mail','false','recipe',30,'stackable','liquid','none',-1,-1,3040,0,'true','true','true','true','true','Recipes',''),
(2184,'Recipe: Mithril Banded Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,1904,0,'true','true','true','true','true','Recipes',''),
(2185,'Recipe: Iron Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1016,0,'true','true','true','true','true','Recipes',''),
(2186,'Recipe: Brigandine Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,5980,0,'true','true','true','true','true','Recipes',''),
(2187,'Recipe: Manticore Skin Shirt','false','recipe',30,'stackable','liquid','none',-1,-1,4480,0,'true','true','true','true','true','Recipes',''),
(2188,'Recipe: Manticore Skin Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2189,'Recipe: Mithril Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,4480,0,'true','true','true','true','true','Recipes',''),
(2190,'Recipe: Mithril Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2191,'Recipe: RIP Gauntlets','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2192,'Recipe: Kite Shield','false','recipe',30,'stackable','liquid','none',-1,-1,1568,0,'true','true','true','true','true','Recipes',''),
(2193,'Recipe: Boots of Power','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2194,'Recipe: Mithril Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2195,'Recipe: Half Plate Armor','false','recipe',30,'stackable','liquid','none',-1,-1,7820,0,'true','true','true','true','true','Recipes',''),
(2196,'Recipe: Plate Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,4880,0,'true','true','true','true','true','Recipes',''),
(2197,'Recipe: Salamander Skin Mail','false','recipe',30,'stackable','liquid','none',-1,-1,9540,0,'true','true','true','true','true','Recipes',''),
(2198,'Recipe: Sage\'s Rag','false','recipe',30,'stackable','liquid','none',-1,-1,9540,0,'true','true','true','true','true','Recipes',''),
(2199,'Recipe: Karmian Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,4740,0,'true','true','true','true','true','Recipes',''),
(2200,'Recipe: Chain Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,2940,0,'true','true','true','true','true','Recipes',''),
(2201,'Recipe: Square Shield','false','recipe',30,'stackable','liquid','none',-1,-1,2060,0,'true','true','true','true','true','Recipes',''),
(2202,'Recipe: Assault Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2203,'Recipe: Mithril Boots','false','recipe',30,'stackable','liquid','none',-1,-1,918,0,'true','true','true','true','true','Recipes',''),
(2204,'Recipe: Chain Mail Shirt','false','recipe',30,'stackable','liquid','none',-1,-1,10100,0,'true','true','true','true','true','Recipes',''),
(2205,'Recipe: Chain Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,6320,0,'true','true','true','true','true','Recipes',''),
(2206,'Recipe: Mithril Shirt','false','recipe',30,'stackable','liquid','none',-1,-1,7580,0,'true','true','true','true','true','Recipes',''),
(2207,'Recipe: Karmian Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,7580,0,'true','true','true','true','true','Recipes',''),
(2208,'Recipe: Ogre Power Gauntlets','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2209,'Recipe: Eldarake','false','recipe',30,'stackable','liquid','none',-1,-1,2660,0,'true','true','true','true','true','Recipes',''),
(2210,'Recipe: Steel Plate Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,4120,0,'true','true','true','true','true','Recipes',''),
(2211,'Recipe: Plated Leather Armor','false','recipe',30,'stackable','liquid','none',-1,-1,8920,0,'true','true','true','true','true','Recipes',''),
(2212,'Recipe: Plated Leather Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,5580,0,'true','true','true','true','true','Recipes',''),
(2213,'Recipe: Dwarven Chain Mail Shirt','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2214,'Recipe: Dwarven Chain Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,8060,0,'true','true','true','true','true','Recipes',''),
(2215,'Recipe: Robe of Seal','false','recipe',30,'stackable','liquid','none',-1,-1,15700,0,'true','true','true','true','true','Recipes',''),
(2216,'Recipe: Great Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,4840,0,'true','true','true','true','true','Recipes',''),
(2217,'Recipe: Knight\'s Shield','false','recipe',30,'stackable','liquid','none',-1,-1,3380,0,'true','true','true','true','true','Recipes',''),
(2218,'Recipe: Pa\'agrian Hand','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(2219,'Recipe: Crimson Boots','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(2220,'Recipe: Rind Leather Armor','false','recipe',30,'stackable','liquid','none',-1,-1,9660,0,'true','true','true','true','true','Recipes',''),
(2221,'Recipe: Rind Leather Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,6040,0,'true','true','true','true','true','Recipes',''),
(2222,'Recipe: Composite Armor','false','recipe',30,'stackable','liquid','none',-1,-1,32000,0,'true','true','true','true','true','Recipes',''),
(2223,'Recipe: Tower Shield','false','recipe',30,'stackable','liquid','none',-1,-1,5160,0,'true','true','true','true','true','Recipes',''),
(2224,'Recipe: Demon\'s Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,14720,0,'true','true','true','true','true','Recipes',''),
(2225,'Recipe: Demon\'s Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,9200,0,'true','true','true','true','true','Recipes',''),
(2226,'Recipe: Mithril Gauntlets','false','recipe',30,'stackable','liquid','none',-1,-1,4900,0,'true','true','true','true','true','Recipes',''),
(2227,'Recipe: Forgotten Boots','false','recipe',30,'stackable','liquid','none',-1,-1,4900,0,'true','true','true','true','true','Recipes',''),
(2228,'Recipe: Shining Circlet','false','recipe',30,'stackable','liquid','none',-1,-1,7360,0,'true','true','true','true','true','Recipes',''),
(2229,'Recipe: Theca Leather Armor','false','recipe',30,'stackable','liquid','none',-1,-1,16500,0,'true','true','true','true','true','Recipes',''),
(2230,'Recipe: Theca Leather Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,10320,0,'true','true','true','true','true','Recipes',''),
(2231,'Recipe: Full Plate Armor','false','recipe',30,'stackable','liquid','none',-1,-1,46400,0,'true','true','true','true','true','Recipes',''),
(2232,'Recipe: Drake Leather Armor','false','recipe',30,'stackable','liquid','none',-1,-1,34800,0,'true','true','true','true','true','Recipes',''),
(2233,'Recipe: Divine Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,21400,0,'true','true','true','true','true','Recipes',''),
(2234,'Recipe: Divine Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,13420,0,'true','true','true','true','true','Recipes',''),
(2235,'Recipe: Mithril Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2236,'Recipe: Cap of Mana','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2237,'Recipe: Paradia Hood','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2238,'Recipe: Hood of Solar Eclipse','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2239,'Recipe: Hood of Summoning','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2240,'Recipe: Elemental Hood','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2241,'Recipe: Hood of Grace','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2242,'Recipe: Phoenix Hood','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2243,'Recipe: Hood of Aid','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2244,'Recipe: Flame Helm','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2245,'Recipe: Tallum Helm','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','none',''),
(2246,'Recipe: Helm of Avadon','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2247,'Recipe: Helmet of Pledge','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(2248,'Recipe: Gauntlets of Ghost','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(2249,'Recipe: Adamantite Boots','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(2250,'Recipe: Bone Arrow','false','recipe',30,'stackable','liquid','none',-1,-1,800,0,'true','true','true','true','true','Recipes',''),
(2251,'Recipe: Steel Arrow','false','recipe',30,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','Recipes',''),
(2252,'Recipe: Iron Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,4880,0,'true','true','true','true','true','Recipes',''),
(2253,'Recipe: Sword Breaker','false','recipe',30,'stackable','liquid','none',-1,-1,4880,0,'true','true','true','true','true','Recipes',''),
(2254,'Recipe: Composite Bow','false','recipe',30,'stackable','liquid','none',-1,-1,4880,0,'true','true','true','true','true','Recipes',''),
(2255,'Recipe: Saber','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(2256,'Recipe: Assassin Knife','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(2257,'Recipe: Trident','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(2258,'Recipe: Temptation of Abyss','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(2259,'Recipe: Spinebone Sword','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2260,'Recipe: Mace of Judgment','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2261,'Recipe: Conjuror\'s Staff','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2262,'Recipe: Elven Bow','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2263,'Recipe: Dwarven Trident','false','recipe',30,'stackable','liquid','none',-1,-1,12880,0,'true','true','true','true','true','Recipes',''),
(2264,'Recipe: Two-handed Sword','false','recipe',30,'stackable','liquid','none',-1,-1,19340,0,'true','true','true','true','true','Recipes',''),
(2265,'Recipe: Spiked Club','false','recipe',30,'stackable','liquid','none',-1,-1,19340,0,'true','true','true','true','true','Recipes',''),
(2266,'Recipe: Shilen Knife','false','recipe',30,'stackable','liquid','none',-1,-1,19340,0,'true','true','true','true','true','Recipes',''),
(2267,'Recipe: Gastraphetes','false','recipe',30,'stackable','liquid','none',-1,-1,19340,0,'true','true','true','true','true','Recipes',''),
(2268,'Recipe: Tome of Blood','false','recipe',30,'stackable','liquid','none',-1,-1,19340,0,'true','true','true','true','true','Recipes',''),
(2269,'Recipe: Morning Star','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2270,'Recipe: Goat Head Staff','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2271,'Recipe: Winged Spear','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2272,'Recipe: Sword of Revolution','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2273,'Recipe: Tarbar','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2274,'Recipe: Skull Breaker','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2275,'Recipe: Heavy Bone Club','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2276,'Recipe: Maingauche','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2277,'Recipe: Bich\'hwa','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2278,'Recipe: Strengthened Long Bow','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2279,'Recipe: War Pick','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2280,'Recipe: Crucifix of Blood','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2281,'Recipe: Eye of Infinity','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2282,'Recipe: Cursed Maingauche','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(2283,'Recipe: Blue Crystal Skull','false','recipe',30,'stackable','liquid','none',-1,-1,30400,0,'true','true','true','true','true','Recipes',''),
(2284,'Recipe: Demon Fangs','false','recipe',30,'stackable','liquid','none',-1,-1,30400,0,'true','true','true','true','true','Recipes',''),
(2285,'Recipe: Claymore','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2286,'Recipe: Bonebreaker','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2287,'Recipe: Atuba Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2288,'Recipe: Ghost Staff','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2289,'Recipe: Staff of Life','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2290,'Recipe: Mithril Dagger','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2291,'Recipe: Scallop Jamadhr','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2292,'Recipe: Light Crossbow','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2293,'Recipe: Glaive','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2294,'Recipe: Vajra Wands','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2295,'Recipe: Ancient Reagent','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2296,'Recipe: Atuba Mace','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(2297,'Recipe: Flamberge','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2298,'Recipe: Stormbringer','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2299,'Recipe: Big Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2300,'Recipe: Scythe','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2301,'Recipe: Battle Axe','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2302,'Recipe: Silver Axe','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2303,'Recipe: Skull Graver','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2304,'Recipe: Heavy Doom Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2305,'Recipe: Crystal Staff','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2306,'Recipe: Stick of Faith','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2307,'Recipe: Heavy Doom Axe','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2308,'Recipe: Cursed Dagger','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2309,'Recipe: Wolverine Needle','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2310,'Recipe: Dark Elven Dagger','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2311,'Recipe: Chakram','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2312,'Recipe: Crystallized Ice Bow','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2313,'Recipe: Orcish Glaive','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2314,'Recipe: Body Slasher','false','recipe',30,'stackable','liquid','none',-1,-1,45800,0,'true','true','true','true','true','Recipes',''),
(2315,'Recipe: Shamshir','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2316,'Recipe: Katana','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2317,'Recipe: Bec de Corbin','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2318,'Recipe: Spirit Sword','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2319,'Recipe: Raid Sword','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2320,'Recipe: Cursed Staff','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2321,'Recipe: Stiletto','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2322,'Recipe: Soulfire Dirk','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2323,'Recipe: Elemental Bow','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2324,'Recipe: Elven Bow of Nobility','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2325,'Recipe: Tears of Fairy','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2326,'Recipe: Horn of Glory','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(2327,'Recipe: Caliburs','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2328,'Recipe: Sword of Delusion','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2329,'Recipe: Tsurugi','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2330,'Recipe: Homunkulus\'s Sword','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2331,'Recipe: Poleaxe','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2332,'Recipe: Sword of Limit','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2333,'Recipe: Sword of Nightmare','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2334,'Recipe: Sword of Whispering Death','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2335,'Recipe: War Axe','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2336,'Recipe: Nirvana Axe','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2337,'Recipe: Stick of Eternity','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2338,'Recipe: Paradia Staff','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2339,'Recipe: Inferno Staff','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2340,'Recipe: Pa\'agrian Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2341,'Recipe: Sage\'s Staff','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2342,'Recipe: Club of Nature','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2343,'Recipe: Mace of the Underworld','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2344,'Recipe: Grace Dagger','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2345,'Recipe: Dark Screamer','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2346,'Recipe: Fisted Blade','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2347,'Recipe: Akat Long Bow','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2348,'Recipe: Heathen\'s Book','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2349,'Recipe: Hex Doll','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(2350,'Recipe: Pa\'agrian Axe','false','recipe',30,'stackable','liquid','none',-1,-1,95600,0,'true','true','true','true','true','Recipes',''),
(2351,'Recipe: Scorpion','false','recipe',30,'stackable','liquid','none',-1,-1,95600,0,'true','true','true','true','true','Recipes',''),
(2352,'Recipe: Widow Maker','false','recipe',30,'stackable','liquid','none',-1,-1,95600,0,'true','true','true','true','true','Recipes',''),
(2353,'Recipe: Samurai Longsword','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2354,'Recipe: Deadman\'s Staff','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2355,'Recipe: Ghoul\'s Staff','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2356,'Recipe: Demon\'s Staff','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2357,'Recipe: Crystal Dagger','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2358,'Recipe: Great Pata','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2359,'Recipe: Eminence Bow','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2360,'Recipe: Orcish Poleaxe','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2361,'Recipe: Candle of Wisdom','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2362,'Recipe: Blessed Branch','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2363,'Recipe: Phoenix Feather','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2364,'Recipe: Cerberus Eye','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2365,'Recipe: Scroll of Destruction','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2366,'Recipe: Claws of Black Dragon','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2367,'Recipe: Three Eyed Crow\'s Feather','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(2375,'Wolf Collar','false','pet_collar',10,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(2508,'Cursed Bone','false','material',3,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(2509,'Spiritshot: No Grade','false','shot',5,'stackable','paper','none',-1,-1,15,0,'true','true','true','true','true','SpiritShot','2061-1'),
(2510,'Spiritshot: D-grade','false','shot',5,'stackable','paper','d',-1,-1,18,0,'true','true','true','true','true','SpiritShot','2155-1'),
(2511,'Spiritshot: C-grade','false','shot',3,'stackable','paper','c',-1,-1,35,0,'true','true','true','true','true','SpiritShot','2156-1'),
(2512,'Spiritshot: B-grade','false','shot',3,'stackable','paper','b',-1,-1,100,0,'true','true','true','true','true','SpiritShot','2157-1'),
(2513,'Spiritshot: A-grade','false','shot',2,'stackable','paper','a',-1,-1,120,0,'true','true','true','true','true','SpiritShot','2158-1'),
(2514,'Spiritshot: S-grade','false','shot',2,'stackable','paper','s',-1,-1,150,0,'true','true','true','true','true','SpiritShot','2159-1'),
(2515,'Food For Wolves','false','none',10,'stackable','liquid','none',-1,-1,108,0,'true','true','true','true','true','PetFood','2048-1'),
(2627,'Mark of Challenger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2628,'Letter of Kash','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2629,'Watcher\'s 1st Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2630,'Watcher\'s 2nd Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2631,'Scroll of Shyslassys','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2632,'Broken Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2633,'Mark of Duty','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2634,'Letter of Dustin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2635,'Knights Tear','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2636,'Mirror of Orpic','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2637,'Tear of Confession','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2638,'Report Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2639,'Report Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2640,'Tear of Loyalty','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2641,'Militas Article','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2642,'Saints Ashes Urn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2643,'Athebaldt\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2644,'Athebaldt\'s Ribs','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2645,'Athebaldt\'s Shin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2646,'Letter of Windawood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2647,'Dufners Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2648,'Terry\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2649,'Terry\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2650,'Terry\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2651,'Viktor\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2652,'Hawkeye\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2653,'Mysterious Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2654,'Ol Mahum Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2655,'Turek Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2656,'Ant Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2657,'Turak Bugbear Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2658,'Terry\'s Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2659,'Viktor\'s Request','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2660,'Medusa Scales','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2661,'Shilen\'s Runestone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2662,'Analysis Request','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2663,'Marina\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2664,'Experiment Tools','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2665,'Analysis Result','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2666,'Terry\'s 3rd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2667,'List of Host','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2668,'Abyss Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2669,'Abyss Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2670,'Abyss Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2671,'Abyss Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2672,'Terry\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2673,'Mark of Seeker','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2674,'Mark of Scholar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2675,'Mirien\'s 1st Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2676,'Mirien\'s 2nd Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2677,'Mirien\'s 3rd Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2678,'Mirien\'s Instruction','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2679,'Maria\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2680,'Maria\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2681,'Lucas\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2682,'Lucilla\'s Handbag','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2683,'Creta\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2684,'Creta\'s Painting1','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2685,'Creta\'s Painting2','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2686,'Creta\'s Painting3','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2687,'Brown Scroll Scrap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2688,'Crystal of Purity','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2689,'High Priest\'s Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2690,'Grand Magister\'s Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2691,'Crono\'s Sigil','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2692,'Sylvain\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2693,'Symbol of Sylvain','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2694,'Jurek\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2695,'Monster Eye Destroyer Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2696,'Shaman\'s Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2697,'Shackle\'s Scalp','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2698,'Symbol of Jurek','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none','');

INSERT INTO `etcitem` VALUES
(2699,'Cronos Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2700,'Dieter\'s Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2701,'Creta\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2702,'Dieter\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2703,'Dieter\'s Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2704,'Raut\'s Letter Envelope','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2705,'Triff\'s Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2706,'Scripture Chapter 1','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2707,'Scripture Chapter 2','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2708,'Scripture Chapter 3','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2709,'Scripture Chapter 4','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2710,'Valkon\'s Request','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2711,'Poitan\'s Notes','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2712,'Scriptures of Knowledge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2713,'Strong Liquor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2714,'Crystal of Purity','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2715,'Casian\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2716,'Ghoul\'s Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2717,'Medusa\'s Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2718,'Fettered Soul\'s Ichor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2719,'Enchanted Gargoyle\'s Nail','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2720,'Symbol of Cronos','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2721,'Mark of Pilgrim','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2722,'Book of Sage','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2723,'Voucher of Trial','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2724,'Spirit of Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2725,'Essence of Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2726,'Book of Gerald','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2727,'Gray Badge','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2728,'Picture of Nahir','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2729,'Hair of Nahir','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2730,'Statue of Einhasad','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2731,'Book of Darkness','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2732,'Debris of Willow','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2733,'Tag of Rumor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2734,'Mark of Trust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2735,'Letter to Elf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2736,'Letter to Darkelf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2737,'Letter to Dwarf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2738,'Letter to Orc','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2739,'Letter to Seresin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2740,'Scroll of Dark Elf Trust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2741,'Scroll of Elf Trust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2742,'Scroll of Dwarf Trust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2743,'Scroll of Orc Trust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2744,'Recommendation of Hollint','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2745,'Order of Asterios','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2746,'Breath of Winds','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2747,'Seed of Verdure','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2748,'Letter from Thifiell','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2749,'Blood of Guardian Basilisk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2750,'Giant Aphid','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2751,'Stakatos Fluids','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2752,'Basilisk Plasma','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2753,'Honey Dew','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2754,'Stakato Ichor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2755,'Order of Clayton','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2756,'Parasite of Lota','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2757,'Letter to Manakia','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2758,'Letter of Manakia','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2759,'Letter to Nikola','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2760,'Order of Nikola','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2761,'Heartstone of Porta','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2762,'Mark of Duelist','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2763,'Order Gludio','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2764,'Order Dion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2765,'Order Giran','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2766,'Order Oren','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2767,'Order Aden','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2768,'Puncher\'s Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2769,'Noble Ant\'s Feeler','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2770,'Drone\'s Chitin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2771,'Dead Seeker Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2772,'Overlord Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2773,'Fettered Soul\'s Chain','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2774,'Chief\'s Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2775,'Enchanted Eye Meat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2776,'Tamrin Orc\'s Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2777,'Tamrin Orc\'s Arrow','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2778,'Final Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2779,'Excuro\'s Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2780,'Krator\'s Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2781,'Grandi\'s Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2782,'Timak Orc\'s Belt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2783,'Lakin\'s Mace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2784,'Luther\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2785,'Alex\'s Warrant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2786,'Leirynn\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2787,'Delu Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2788,'Leirynn\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2789,'Chief Kalki\'s Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2790,'Leirynn\'s Report','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2791,'Strange Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2792,'Lambert\'s Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2793,'Alex\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2794,'Alex\'s Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2795,'Wine Catalog','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2796,'Tyra\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2797,'Red Spore Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2798,'Malrukian Wine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2799,'Old Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2800,'Jax\'s Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2801,'1st Torn Map Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2802,'2nd Torn Map Piece','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2803,'Solt\'s Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2804,'Makel\'s Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2805,'Combined Map','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2806,'Rusted Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2807,'Gold Bar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2808,'Alex\'s Recommend','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2809,'Mark of Searcher','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2810,'Report of Perrin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2811,'Kristina\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2812,'Picture of Windy','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2813,'Golden Statue','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2814,'Windy\'s Pebbles','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2815,'Order of Sorius','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2816,'1st Secret Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2817,'2nd Secret Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2818,'3rd Secret Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2819,'4th Secret Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2820,'Mark of Healer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2821,'Mark of Reformer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2822,'Book of Reform','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2823,'Letter of Introduction','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2824,'Sla\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2825,'Greetings','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2826,'Ol Mahum\'s Money','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2827,'Katari\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2828,'Nyakuri\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2829,'Undead List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2830,'Ramus\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2831,'Ripped Diary','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2832,'Huge Nail','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2833,'Letter of Betrayer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2834,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2835,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2836,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2837,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2838,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2839,'Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2840,'Mark of Magus','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2841,'Rukal\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2842,'Parina\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2843,'Lilac Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2844,'1st Golden Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2845,'2nd Golden Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2846,'3rd Golden Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2847,'Score of Elements','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2848,'Dazzling Drop','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2849,'Flame Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2850,'Harpy\'s Feather','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2851,'Wyrm\'s Wingbone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2852,'Windsus Mane','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2853,'Enchanted Monster Eye Shell','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2854,'Enchanted Stone Golem Powder','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2855,'Enchanted Iron Golem Scrap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2856,'Tone of Water','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2857,'Tone of Fire','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2858,'Tone of Wind','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2859,'Tone of Earth','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2860,'Salamander Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2861,'Sylph Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2862,'Undine Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2863,'Serpent Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2864,'Recommendation of Balanki','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2865,'Recommendation of Filaur','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2866,'Recommendation of Arin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2867,'Mark of Maestro','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2868,'Letter of Solder Detachment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2869,'Paint of Kamuru','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2870,'Necklace of Kamuru','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2871,'Paint of Teleport Device','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2872,'Teleport Device','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(2873,'Architecture of Cruma','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2874,'Report of Cruma','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2875,'Ingredients of Antidote','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2876,'Stinger Wasp Needle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2877,'Marsh Spider\'s Web','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2878,'Blood of Leech','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2879,'Mark of Warspirit','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2880,'Vendetta Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2881,'Tamlin Orc Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2882,'Warspirit Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2883,'Orim\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2884,'Porta\'s Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2885,'Excuro\'s Scale','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2886,'Mordeos Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2887,'Braki\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2888,'Pekiron\'s Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2889,'Tonar\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2890,'Tonar\'s Rib Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2891,'Tonar\'s Spine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2892,'Tonar\'s Arm Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2893,'Tonar\'s Thigh Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2894,'Tonar\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2895,'Manakia\'s Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2896,'Hermodt\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2897,'Hermodt\'s Rib Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2898,'Hermodt\'s Spine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2899,'Hermodt\'s Arm Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2900,'Hermodt\'s Thigh Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2901,'Hermodt\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2902,'Racoy\'s Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2903,'Vivyan\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2904,'Insect Diagram Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2905,'Kiruna\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2906,'Kiruna\'s Rib Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2907,'Kiruna\'s Spine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2908,'Kiruna\'s Arm Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2909,'Kiruna\'s Thigh Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2910,'Kiruna\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2911,'Braki\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2912,'Tonar\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2913,'Hermodt\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2914,'Kiruna\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2916,'Broken Teleport Device','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(2917,'Ring of Binding Gemstone','false','material',60,'stackable','liquid','none',-1,-1,3482,0,'true','true','true','true','true','none',''),
(2918,'Mithril Scale Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,3371,0,'true','true','true','true','true','none',''),
(2919,'Brigandine Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,3371,0,'true','true','true','true','true','none',''),
(2920,'Elven Mithril Tunic Pattern','false','material',60,'stackable','liquid','none',-1,-1,3921,0,'true','true','true','true','true','none',''),
(2921,'Elven Mithril Stockings Pattern','false','material',60,'stackable','liquid','none',-1,-1,2518,0,'true','true','true','true','true','none',''),
(2922,'Brigandine Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,5193,0,'true','true','true','true','true','none',''),
(2923,'Manticore Skin Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2924,'Brigandine Boots Design','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2925,'Elven Mithril Boots Design','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2926,'Manticore Skin Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2927,'Brigandine Gauntlets Pattern','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2928,'Mithril Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,1480,0,'true','true','true','true','true','none',''),
(2929,'Brigandine Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,1389,0,'true','true','true','true','true','none',''),
(2930,'Plate Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,2481,0,'true','true','true','true','true','none',''),
(2931,'Salamander Skin Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(2932,'Plate Boots Design','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(2933,'Sage\'s Worn Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,1792,0,'true','true','true','true','true','none',''),
(2934,'Plate Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,1762,0,'true','true','true','true','true','none',''),
(2935,'Tempered Mithril Gaiters Fragment','false','material',60,'stackable','liquid','none',-1,-1,3763,0,'true','true','true','true','true','none',''),
(2936,'Chain Hood Pattern','false','material',60,'stackable','liquid','none',-1,-1,2725,0,'true','true','true','true','true','none',''),
(2937,'Chain Boots Part','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2938,'Karmian Boots Fabric','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2939,'Plate Leather Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2940,'Dwarven Chain Boots Part','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2941,'Boots of Seal Pattern','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2942,'Reinforced Mithril Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2943,'Chain Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2944,'Karmian Gloves Fabric','false','material',60,'stackable','liquid','none',-1,-1,2225,0,'true','true','true','true','true','none',''),
(2945,'Chain Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,2475,0,'true','true','true','true','true','none',''),
(2946,'Plate Leather Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,3578,0,'true','true','true','true','true','none',''),
(2947,'Dwarven Chain Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','none',''),
(2948,'Rind Leather Boot Lining','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(2949,'Dwarven Chain Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(2950,'Gloves of Seal Pattern','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(2951,'Rind Leather Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,2378,0,'true','true','true','true','true','none',''),
(2952,'Demon\'s Boots Fabric','false','material',60,'stackable','liquid','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(2953,'Demon\'s Gloves Fabric','false','material',60,'stackable','liquid','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(2954,'Theca Leather Boots Texture','false','material',60,'stackable','liquid','none',-1,-1,3160,0,'true','true','true','true','true','none',''),
(2955,'Theca Leather Gloves Texture','false','material',60,'stackable','liquid','none',-1,-1,3160,0,'true','true','true','true','true','none',''),
(2956,'Composite Boots Part','false','material',60,'stackable','liquid','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(2957,'Composite Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,4560,0,'true','true','true','true','true','none',''),
(2958,'Divine Boots Fabric','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2959,'Full Plate Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,5782,0,'true','true','true','true','true','none',''),
(2960,'Drake Leather Boots Design','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2961,'Full Plate Boots Part','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2962,'Drake Leather Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2963,'Full Plate Gauntlets Part','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2964,'Divine Gloves Pattern','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2965,'Blessed Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,3673,0,'true','true','true','true','true','none',''),
(2966,'Full Plate Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,3655,0,'true','true','true','true','true','none',''),
(2967,'Elven Long Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,23062,0,'true','true','true','true','true','none',''),
(2968,'Dwarven Warhammer Head','false','material',60,'stackable','liquid','none',-1,-1,30067,0,'true','true','true','true','true','none',''),
(2969,'Yaksa Mace Head','false','material',60,'stackable','liquid','none',-1,-1,38364,0,'true','true','true','true','true','none',''),
(2970,'Recipe: Ring of Binding','false','recipe',30,'stackable','liquid','none',-1,-1,5640,0,'true','true','true','true','true','Recipes',''),
(2971,'Recipe: Mithril Scale Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,3740,0,'true','true','true','true','true','Recipes',''),
(2972,'Recipe: Brigandine Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,3740,0,'true','true','true','true','true','Recipes',''),
(2973,'Recipe: Elven Mithril Tunic','false','recipe',30,'stackable','liquid','none',-1,-1,4480,0,'true','true','true','true','true','Recipes',''),
(2974,'Recipe: Elven Mithril Stockings','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(2975,'Recipe: Brigandine Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,2240,0,'true','true','true','true','true','Recipes',''),
(2976,'Recipe: Manticore Skin Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2977,'Recipe: Brigandine Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2978,'Recipe: Elven Mithril Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2979,'Recipe: Manticore Skin Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2980,'Recipe: Brigandine Gauntlets','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2981,'Recipe: Mithril Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,1494,0,'true','true','true','true','true','Recipes',''),
(2982,'Recipe: Brigandine Shield','false','recipe',30,'stackable','liquid','none',-1,-1,1568,0,'true','true','true','true','true','Recipes',''),
(2983,'Recipe: Plate Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,2940,0,'true','true','true','true','true','Recipes',''),
(2984,'Recipe: Salamander Skin Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2985,'Recipe: Plate Boots','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2986,'Recipe: Sage\'s Worn Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,1956,0,'true','true','true','true','true','Recipes',''),
(2987,'Recipe: Plate Shield','false','recipe',30,'stackable','liquid','none',-1,-1,2060,0,'true','true','true','true','true','Recipes',''),
(2988,'Recipe: Tempered Mithril Gaiters','false','recipe',30,'stackable','liquid','none',-1,-1,4740,0,'true','true','true','true','true','Recipes',''),
(2989,'Recipe: Chain Hood','false','recipe',30,'stackable','liquid','none',-1,-1,3780,0,'true','true','true','true','true','Recipes',''),
(2990,'Recipe: Chain Boots','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2991,'Recipe: Karmian Boots','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2992,'Recipe: Plated Leather Boots','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2993,'Recipe: Dwarven Chain Boots','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2994,'Recipe: Boots of Seal','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2995,'Recipe: Reinforced Mithril Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2996,'Recipe: Chain Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2997,'Recipe: Karmian Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,2520,0,'true','true','true','true','true','Recipes',''),
(2998,'Recipe: Chain Shield','false','recipe',30,'stackable','liquid','none',-1,-1,2660,0,'true','true','true','true','true','Recipes',''),
(2999,'Recipe: Plated Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,2980,0,'true','true','true','true','true','Recipes',''),
(3000,'Recipe: Dwarven Chain Shield','false','recipe',30,'stackable','liquid','none',-1,-1,3120,0,'true','true','true','true','true','Recipes',''),
(3001,'Recipe: Rind Leather Boots','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(3002,'Recipe: Dwarven Chain Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(3003,'Recipe: Gloves of Seal','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(3004,'Recipe: Rind Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,3220,0,'true','true','true','true','true','Recipes',''),
(3005,'Recipe: Demon\'s Boots','false','recipe',30,'stackable','liquid','none',-1,-1,4900,0,'true','true','true','true','true','Recipes',''),
(3006,'Recipe: Demon\'s Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,4900,0,'true','true','true','true','true','Recipes',''),
(3007,'Recipe: Theca Leather Boots','false','recipe',30,'stackable','liquid','none',-1,-1,5500,0,'true','true','true','true','true','Recipes',''),
(3008,'Recipe: Theca Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,5500,0,'true','true','true','true','true','Recipes',''),
(3009,'Recipe: Composite Boots','false','recipe',30,'stackable','liquid','none',-1,-1,4900,0,'true','true','true','true','true','Recipes',''),
(3010,'Recipe: Composite Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,7360,0,'true','true','true','true','true','Recipes',''),
(3011,'Recipe: Divine Boots','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3012,'Recipe: Full Plate Helmet','false','recipe',30,'stackable','liquid','none',-1,-1,10720,0,'true','true','true','true','true','Recipes',''),
(3013,'Recipe: Drake Leather Boots','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3014,'Recipe: Full Plate Boots','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3015,'Recipe: Drake Leather Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3016,'Recipe: Full Plate Gauntlets','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3017,'Recipe: Divine Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3018,'Recipe: Blessed Gloves','false','recipe',30,'stackable','liquid','none',-1,-1,7160,0,'true','true','true','true','true','Recipes',''),
(3019,'Recipe: Full Plate Shield','false','recipe',30,'stackable','liquid','none',-1,-1,7500,0,'true','true','true','true','true','Recipes',''),
(3020,'Recipe: Elven Long Sword','false','recipe',30,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','Recipes',''),
(3021,'Recipe: Dwarven War Hammer','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(3022,'Recipe: Yaksa Mace','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(3023,'Recipe: Titan Key','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'false','false','false','false','false','Recipes',''),
(3024,'Recipe: Journeyman Ring','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'false','false','false','false','false','Recipes',''),
(3025,'Recipe: Amber Bead','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'false','false','false','false','false','Recipes',''),
(3030,'Key of Titan','false','none',10,'stackable','bronze','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3031,'Spirit Ore','false','material',5,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(3032,'Recipe: Spiritshot D','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(3033,'Recipe: Spiritshot C','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(3034,'Recipe: Spiritshot B','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(3035,'Recipe: Spiritshot A','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(3036,'Recipe: Spiritshot S','false','recipe',30,'stackable','liquid','none',-1,-1,450000,0,'true','true','true','true','true','Recipes',''),
(3037,'Kakan\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3038,'Blueprint: Summon Mechanic Golem','false','spellbook',120,'stackable','paper','none',-1,-1,1550,0,'true','true','true','true','true','Recipes',''),
(3039,'Spellbook: Summon Storm Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3040,'Spellbook: Summon Vampiric Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(3041,'Spellbook: Summon Phantom Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3042,'Spellbook: Life Scavenge','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3043,'Spellbook: Holy Strike','false','spellbook',120,'stackable','paper','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(3044,'Spellbook: Horror','false','spellbook',120,'stackable','paper','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(3045,'Spellbook: Summon Life Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(3046,'Spellbook: Sacrifice','false','spellbook',120,'stackable','paper','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(3047,'Spellbook: Iron Will','false','spellbook',120,'stackable','paper','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(3048,'Spellbook: Reflect Damage','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3049,'Spellbook: Corpse Plague','false','spellbook',120,'stackable','paper','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(3050,'Spellbook: Hex','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3051,'Spellbook: Spirit Barrier','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3052,'Spellbook: Hamstring','false','spellbook',120,'stackable','paper','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(3053,'Spellbook: Holy Blessing','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3054,'Spellbook: Summon Viper Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(3055,'Spellbook: Lightning Strike','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(3056,'Spellbook: Summon Dark Panther','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3057,'Spellbook: Summon Reanimated Man','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3058,'Spellbook: Summon Corrupted Man','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3059,'Spellbook: Corpse Burst','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3060,'Spellbook: Forget','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3061,'Spellbook: Curse Discord','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3062,'Spellbook: Curse Fear','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3063,'Spellbook: Anchor','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3064,'Spellbook: Silence','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3065,'Spellbook: Death Spike','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3066,'Spellbook: Curse Death Link','false','spellbook',120,'stackable','paper','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(3067,'Spellbook: Vampiric Claw','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3068,'Spellbook: Vitalize','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3069,'Spellbook: Repose','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3070,'Spellbook: Hold Undead','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3071,'Spellbook: Requiem','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3072,'Spellbook: Purify','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3073,'Spellbook: Might of Heaven','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3074,'Spellbook: Surrender to Wind','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3075,'Spellbook: Blazing Circle','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3076,'Spellbook: Prominence','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3077,'Spellbook: Blazing Skin','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3078,'Spellbook: Decay','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3079,'Spellbook: Cancel','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3080,'Spellbook: Sleeping Cloud','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3081,'Spellbook: Aura Flare','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3082,'Spellbook: Surrender to Water','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3083,'Spellbook: Frost Wall','false','spellbook',120,'stackable','paper','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(3084,'Spellbook: Freezing Shackle','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3085,'Spellbook: Hydro Blast','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3086,'Spellbook: Frost Bolt','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3087,'Spellbook: Ice Dagger','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3088,'Spellbook: Freezing Skin','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3089,'Spellbook: Tempest','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3090,'Spellbook: Hurricane','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3091,'Spellbook: Servitor Magic Shield','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3092,'Spellbook: Servitor Physical Shield','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3093,'Spellbook: Servitor Haste','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3094,'Spellbook: Invigor','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3095,'Spellbook: Magic Barrier','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3096,'Spellbook: Blessed Body','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3097,'Spellbook: Blessed Soul','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3098,'Spellbook: Return','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3099,'Spellbook: Haste','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3100,'Spellbook: Guidance','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3101,'Spellbook: Death Whisper','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3102,'Spellbook: Bless Shield','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3103,'Amulet: Pa\'agrio\'s Wisdom','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3104,'Amulet: Pa\'agrio\'s Glory','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3105,'Amulet: Seal of Winter','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3106,'Amulet: Seal of Flame','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3107,'Amulet: Seal of Gloom','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3108,'Amulet: Seal of Mirage','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3109,'Amulet: Seal of Silence','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3110,'Amulet: Seal of Scourge','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3111,'Amulet: Seal of Suspension','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3112,'Amulet: Pa\'agrio\'s Vision','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3113,'Amulet: Pa\'agrio\'s Protection','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3114,'Amulet: Steal Essence','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3115,'Amulet: Freezing Flame','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3116,'Amulet: Chant of Fury','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3117,'Amulet: Chant of Evasion','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3118,'Amulet: Chant of Rage','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3119,'Mark of Guildsman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3120,'Valkon\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3121,'Mandragora Berry','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3122,'Altran\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3123,'Altran\'s 1st Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3124,'Altran\'s 2nd Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3125,'Norman\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3126,'Norman\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3127,'Duning\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3128,'Duning\'s Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3129,'Norman\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3130,'Gray Bone Powder','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3131,'Granite Whetstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3132,'Red Pigment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3133,'Braided Yarn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3134,'Journeyman Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3135,'Pinter\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3136,'Amber Bead','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3137,'Amber Lump','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3138,'Journeyman Deco Beads','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3139,'Journeyman Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3140,'Mark of Life','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3141,'Cardien\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3142,'Camomile Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3143,'Hierarch\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3144,'Moonflower Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3145,'Grail Diagram','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3146,'Thalia\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3147,'Thalia\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3148,'Thalia\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3149,'Pushkin\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3150,'Pure Mithril Cup','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3151,'Arkenia\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3152,'Arkenia\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3153,'Adonius\'s list','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3154,'Andariel Scripture Copy','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3155,'Stardust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3156,'Isael\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3157,'Isael\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3158,'Grail of Purity','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3159,'Tears of Unicorn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3160,'Water of Life','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3161,'Pure Mithril Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3162,'Ant Soldier Acid','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3163,'Wyrm\'s Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3164,'Spider Ichor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3165,'Harpy\'s Down','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3166,'Talin\'s Spear Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3167,'Talin\'s Spear Shaft','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3168,'Talin\'s Ruby','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3169,'Talin\'s Aquamarine','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3170,'Talin\'s Amethyst','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3171,'Talin\'s Peridot','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3172,'Mark of Fate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3173,'Kaira\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3174,'Metheus\'s Funeral Jar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3175,'Kasandra\'s Remains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3176,'Herbalism Textbook','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3177,'Ixia\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3178,'Medusa\'s Ichor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3179,'Marsh Spider Fluids','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3180,'Dead Seeker Dung','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3181,'Tyrant\'s Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3182,'Nightshade Root','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3183,'Belladonna','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3184,'Alder\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3185,'Alders Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3186,'Alder\'s Receipt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3187,'Revelations Manuscript','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3188,'Kaira\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3189,'Kaira\'s Recommendation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3190,'Palus Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3191,'Thifiell\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3192,'Arkenia\'s Note','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3193,'Pixy Garnet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3194,'Grandis\'s Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3195,'Karul Bugbear Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3196,'Breka Overlord Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3197,'Leto Overlord Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3198,'Red Fairy Dust','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3199,'Blight Treant Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3200,'Black Willow Leaf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3201,'Blight Treant Sap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3202,'Arkenia\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3203,'Mark of Glory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3204,'Vokian\'s Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3205,'Manashen Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3206,'Tyrant Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3207,'Guardian Basilisk Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3208,'Vokian\'s Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3209,'Necklace of Authority','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3210,'Chianta\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3211,'Scepter of Breka','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3212,'Scepter of Enku','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3213,'Scepter of Vuku','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3214,'Scepter of Turek','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3215,'Scepter of Tunath','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3216,'Chianta\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3217,'Chianta\'s 3rd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3218,'Tamlin Orc Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3219,'Timak Orc Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3220,'Scepter Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3221,'Pashika\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3222,'Vultus\' Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3223,'Glove of Voltar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3224,'Enku Overlord Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3225,'Glove of Kepra','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3226,'Makum Bugbear Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3227,'Glove of Burai','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3228,'Manakia\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3229,'Manakia\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3230,'Kasman\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3231,'Kasman\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3232,'Kasman\'s 3rd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3233,'Driko\'s Contract','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3234,'Stakato Drone Husk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3235,'Tanapi\'s Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3236,'Scepter of Tantos','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3237,'Ritual Box','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3238,'Mark of Prosperity','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3239,'1st Ring of Testimony','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3240,'2nd Ring of Testimony','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3241,'Old Account Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3242,'Blessed Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3243,'Emily\'s Recipe','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3244,'Lilith\'s Elven Wafer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3245,'Maphr Tablet Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3246,'Collection License','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3247,'Lockirin\'s 1st Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3248,'Lockirin\'s 2nd Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3249,'Lockirin\'s 3rd Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3250,'Lockirin\'s 4th Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3251,'Lockirin\'s 5th Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3252,'Contribution of Shari','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3253,'Contribution of Mion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3254,'Contribution of Maryse','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3255,'Maryse\'s Request','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3256,'Contribution of Toma','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3257,'Receipt of Bolter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3258,'1st Receipt of Contribution','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3259,'2nd Receipt of Contribution','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3260,'3rd Receipt of Contribution','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3261,'4th Receipt of Contribution','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3262,'5th Receipt of Contribution','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3263,'Procuration of Torocco','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3264,'Bright\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3265,'Mandragora Petal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3266,'Crimson Moss','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3267,'Mandragora Bouquet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3268,'Parman\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3269,'Parman\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3270,'Clay Dough','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3271,'Pattern of Keyhole','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3272,'Nikolas\' List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3273,'Stakato Shell','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3274,'Toad Lord Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3275,'Spider Thorn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3276,'Mark of Champion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3277,'Ascalon\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3278,'Mason\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3279,'Iron Rose Ring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3280,'Ascalon\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3281,'White Rose Insignia','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3282,'Groot\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3283,'Ascalon\'s 3rd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3284,'Mouen\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3285,'Mouen\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3286,'Mouen\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3287,'Harpy\'s Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3288,'Medusa\'s Venom','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3289,'Windsus Bile','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3290,'Bloody Axe Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3291,'Road Ratman Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3292,'Leto Lizardman Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3293,'Mark of Sagittarius','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3294,'Bernard\'s Introduction','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3295,'Hamil\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3296,'Hamil\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3297,'Hamil\'s 3rd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3298,'Hunter\'s 1st Rune','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3299,'Hunter\'s 2nd Rune','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3300,'Talisman of Kadesh','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3301,'Talisman of Snake','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3302,'Mithril Clip','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3303,'Stakato Chitin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3304,'Reinforced Bowstring','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3305,'Manashen\'s Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3306,'Blood of Lizardman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3307,'Mark of Witchcraft','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3308,'Orim\'s Diagram','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3309,'Alexandria\'s Book','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3310,'Iker\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3311,'Dire Wyrm Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3312,'Leto Lizardman Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3313,'Enchanted Golem Heartstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3314,'Lara\'s Memo','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3315,'Nestle\'s Memo','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3316,'Leopold\'s Journal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3317,'Aklantoth 1st Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3318,'Aklantoth 2nd Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3319,'Aklantoth 3rd Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3320,'Aklantoth 4th Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3321,'Aklantoth 5th Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3322,'Aklantoth 6th Gem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3323,'1st Brimstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3324,'Orim\'s Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3325,'Orim\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3326,'Orim\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3327,'Sir Vasper\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3328,'Vadin\'s Crucifix','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3329,'Tamlin Orc Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3330,'Vadin\'s Sanctions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3331,'Iker\'s Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3332,'Soultrap Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3333,'Purgatory Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3334,'Zeruel Bind Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3335,'2nd Brimstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3336,'Mark of Summoner','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3337,'Leto Lizardman Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3338,'Sac of Redspores','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3339,'Karul Bugbear Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3340,'Shards of Manashen','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3341,'Breka Orc Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3342,'Crimson Bloodstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3343,'Talons of Tyrant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3344,'Wings of Droneant','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3345,'Tusk of Windsus','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3346,'Fangs of Wyrm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3347,'Lara\'s 1st List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3348,'Lara\'s 2nd List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3349,'Lara\'s 3rd List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3350,'Lara\'s 4th List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3351,'Lara\'s 5th List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3352,'Galatea\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3353,'Beginner\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3354,'Almors\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3355,'Camoniell\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3356,'Belthus\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3357,'Basillia\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3358,'Celestiel\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3359,'Brynthea\'s Arcana','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3360,'1st Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3361,'1st Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3362,'1st Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3363,'1st Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3364,'1st Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3365,'2nd Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3366,'2nd Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3367,'2nd Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3368,'2nd Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3369,'2nd Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3370,'3rd Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3371,'3rd Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3372,'3rd Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3373,'3rd Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3374,'3rd Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3375,'4th Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3376,'4th Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3377,'4th Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3378,'4th Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3379,'4th Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3380,'5th Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3381,'5th Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3382,'5th Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3383,'5th Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3384,'5th Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3385,'6th Crystal of Starting','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3386,'6th Crystal of Inprogress','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3387,'6th Crystal of Foul','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3388,'6th Crystal of Defeat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3389,'6th Crystal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3390,'Mark of Lord','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3391,'Ordeal Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3392,'Varkee\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3393,'Tantus\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3394,'Hatos\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3395,'Takuna\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3396,'Chianta\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3397,'Manakia\'s Orders','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3398,'Breka Orc Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3399,'Manakia\'s Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3400,'Huge Orc Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3401,'Sumari\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3402,'Urutu Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3403,'Timak Orc Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3404,'Sword Into Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3405,'Neruga Axe Blade','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3406,'Axe of Ceremony','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3407,'Marsh Spider Feeler','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3408,'Marsh Spider Feet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3409,'Handiwork Spider Brooch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3410,'Cornea of Enchanted Monster Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3411,'Monster Eye Woodcarving','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3412,'Bear Fang Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3413,'Martankus\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3414,'Ragna Orc Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3415,'Ragna Chief Notice','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3416,'Immortal Flame','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3417,'Animal Lover\'s List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3418,'Animal Slayer\'s 1st List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3419,'Animal Slayer\'s 2nd List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3420,'Animal Slayer\'s 3rd List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3421,'Animal Slayer\'s 4th List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3422,'Animal Slayer\'s 5th List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3423,'Bloody Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3424,'Bloody Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3425,'Bloody Nail','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3426,'Bloody Kasha Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3427,'Bloody Tarantula Nail','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3428,'Crystal Brooch','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3429,'Spellbook: Greater Heal','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3430,'Spellbook: Greater Battle Heal','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3431,'Spellbook: Greater Group Heal','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3432,'Spellbook: Remedy','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(3433,'Elf Figure','false','none',0,'normal','steel','none',-1,-1,0,0,'false','true','false','false','false','none',''),
(3434,'Coke','false','none',0,'normal','steel','none',-1,-1,0,0,'false','true','false','false','false','none',''),
(3435,'Nvidia','false','none',0,'normal','steel','none',-1,-1,0,0,'false','true','false','false','false','none',''),
(3436,'Mouse','false','none',0,'normal','steel','none',-1,-1,0,0,'false','true','false','false','false','none',''),
(3437,'Trade Book of Merchant','false','none',120,'normal','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3438,'Trade Book of Great Merchant','false','none',120,'normal','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3440,'Cargo Box','false','none',20,'stackable','steel','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3441,'Cargo Box','false','none',20,'stackable','steel','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3442,'Cargo Box','false','none',20,'stackable','steel','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3443,'Cargo Box','false','none',20,'stackable','steel','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3444,'Gludio Apples','false','none',20,'stackable','steel','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(3445,'Dion Corn Meal','false','none',20,'stackable','steel','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(3446,'Dire Wolf Pelts','false','none',20,'stackable','steel','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(3447,'Moonstone','false','none',20,'stackable','steel','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(3448,'Gludio Wheat Flour','false','none',20,'stackable','steel','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(3449,'Spidersilk Rope','false','none',20,'stackable','steel','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(3450,'Alexandrite','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3451,'Silver Tea Service','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3452,'Mechanic Golem Spare Parts','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3453,'Fire Emerald','false','none',20,'stackable','steel','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(3454,'Avellan Silk Frock','false','none',20,'stackable','steel','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(3455,'Feriotic Porcelain Urn','false','none',20,'stackable','steel','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3456,'Imperial Diamond','false','none',20,'stackable','steel','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3457,'Statue of Shilen - Head','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3458,'Statue of Shilen - Torso','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3459,'Statue of Shilen - Arm','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3460,'Statue of Shilen - Leg','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3461,'Complete Statue of Shilen','false','none',20,'stackable','steel','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3462,'Fragment of Ancient Tablet - 1st Piece','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3463,'Fragment of Ancient Tablet - 2nd Piece','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3464,'Fragment of Ancient Tablet - 3rd Piece','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3465,'Fragment of Ancient Tablet - 4th Piece','false','none',20,'stackable','steel','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(3466,'Complete Ancient Tablet','false','none',20,'stackable','steel','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(3467,'Wish Potion','false','none',60,'normal','paper','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3468,'Ancient Crown','false','none',0,'normal','paper','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(3469,'Certificate of Royalty','false','none',0,'normal','paper','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(3470,'Gold Bar','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(3472,'Blood Medusa','false','none',0,'stackable','steel','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(3473,'Blood Werewolf','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3474,'Blood Basilisk','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3475,'Blood Drevanul','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3476,'Blood Succubus','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3477,'Blood Dragon','false','none',0,'stackable','steel','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(3478,'Beleth\'s Blood Dragon','false','none',0,'stackable','steel','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(3479,'Manak\'s Blood Werewolf','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3480,'Nia\'s Blood Medusa','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3481,'Gold Dragon','false','none',0,'stackable','steel','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(3482,'Gold Wyvern','false','none',0,'stackable','steel','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(3483,'Gold Knight','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3484,'Gold Giant','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3485,'Gold Drake','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3486,'Gold Wyrm','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3487,'Beleth\'s Gold Dragon','false','none',0,'stackable','steel','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(3488,'Manak\'s Gold Giant','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3489,'Nia\'s Gold Wyvern','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3490,'Silver Unicorn','false','none',0,'stackable','steel','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(3491,'Silver Fairy','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3492,'Silver Dryad','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3493,'Silver Dragon','false','none',0,'stackable','steel','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(3494,'Silver Golem','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3495,'Silver Undine','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3496,'Beleth\'s Silver Dragon','false','none',0,'stackable','steel','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(3497,'Manak\'s Silver Dryad','false','none',0,'stackable','steel','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(3498,'Nia\'s Silver Fairy','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(3499,'Fairy Dust','false','quest',0,'normal','steel','none',-1,-1,10000,0,'true','false','true','true','false','none',''),
(3500,'Dragonflute of Wind','false','pet_collar',20,'normal','steel','none',-1,-1,1000,0,'true','true','true','true','true','SummonItems',''),
(3501,'Dragonflute of Star','false','pet_collar',20,'normal','steel','none',-1,-1,1000,0,'true','true','true','true','true','SummonItems',''),
(3502,'Dragonflute of Twilight','false','pet_collar',20,'normal','steel','none',-1,-1,1000,0,'true','true','true','true','true','SummonItems',''),
(3503,'Deliverymen Decertificate','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3504,'Kirunas Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3505,'Mithril Mold','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3506,'Bloody Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3507,'Supplies to Alex','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3508,'Supplies to Endrigo','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3509,'Alex\'s Coins','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3510,'Wardens Appreciation','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3511,'Blackbox to Orim','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3512,'Deluxe Windsus Ham','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3513,'Heart of Silenos','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3514,'Request Giran','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3515,'Request Gludin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3516,'Request Hunters','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3517,'Delivery Score Red','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3518,'Delivery Score Blue','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3519,'Deliverymen Advanced Certificate Super','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3520,'1st Confirmation Document','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3521,'2nd Confirmation Document','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3522,'Delivery Goods 01','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3523,'Delivery Goods 02','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3524,'Delivery Goods 03','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3525,'Delivery Goods 04','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3526,'Delivery Goods 05','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3527,'Delivery Goods 06','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3528,'Delivery Goods 07','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3529,'Delivery Goods 08','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3530,'Delivery Goods 09','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3531,'Delivery Goods 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3532,'Delivery Goods 11','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3533,'Delivery Goods 12','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3534,'Delivery Goods 13','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3535,'Delivery Goods 14','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3536,'Delivery Goods 15','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3537,'Delivery Goods 16','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3538,'Delivery Goods 17','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3539,'Delivery Goods 18','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3540,'Delivery Goods 19','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3541,'Delivery Goods 20','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3542,'Delivery Goods 21','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3543,'Delivery Goods 22','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3544,'Delivery Goods 23','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3545,'Delivery Goods 24','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3546,'Delivery Goods 25','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3547,'Delivery Goods 26','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3548,'Delivery Goods 27','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3549,'Delivery Goods 28','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3550,'Delivery Goods 29','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3551,'Delivery Goods 30','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3552,'Delivery Goods 31','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3553,'Delivery Goods 32','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3554,'Delivery Goods 33','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3555,'Delivery Goods 34','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3556,'Delivery Goods 35','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3557,'Delivery Goods 36','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3558,'Delivery Goods 37','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3559,'Delivery Goods 38','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3560,'Delivery Goods 39','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3561,'Delivery Goods 40','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3562,'Delivery Goods 41','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3563,'Delivery Goods 42','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3564,'Delivery Goods 43','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3565,'Delivery Goods 44','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3566,'Delivery Goods 45','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3567,'Delivery Goods 46','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3568,'Delivery Goods 47','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3569,'Delivery Goods 48','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3570,'Delivery Goods 49','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3571,'Delivery Goods 50','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3572,'Delivery Goods 51','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3573,'Delivery Goods 52','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3574,'Delivery Goods 53','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3575,'Delivery Goods 54','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3576,'Delivery Goods 55','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3577,'Delivery Goods 56','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3578,'Delivery Goods 57','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3579,'Delivery Goods 58','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3580,'Delivery Goods 59','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3581,'Delivery Goods 60','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3582,'Delivery Goods 61','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3583,'Delivery Goods 62','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3584,'Delivery Goods 63','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3585,'Delivery Goods 64','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3586,'Delivery Goods 65','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3587,'Delivery Goods 66','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3588,'Delivery Goods 67','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3589,'Confirmation Document 01','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3590,'Confirmation Document 02','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3591,'Confirmation Document 03','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3592,'Confirmation Document 04','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3593,'Confirmation Document 05','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3594,'Confirmation Document 06','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3595,'Confirmation Document 07','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3596,'Confirmation Document 08','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3597,'Confirmation Document 09','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3598,'Confirmation Document 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3599,'Confirmation Document 11','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3600,'Confirmation Document 12','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3601,'Confirmation Document 13','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3602,'Confirmation Document 14','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3603,'Confirmation Document 15','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3604,'Confirmation Document 16','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3605,'Confirmation Document 17','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3606,'Confirmation Document 18','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3607,'Confirmation Document 19','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3608,'Confirmation Document 20','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3609,'Confirmation Document 21','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3610,'Confirmation Document 22','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3611,'Confirmation Document 23','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3612,'Confirmation Document 24','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3613,'Confirmation Document 25','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3614,'Confirmation Document 26','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3615,'Confirmation Document 27','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3616,'Confirmation Document 28','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3617,'Confirmation Document 29','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3618,'Confirmation Document 30','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3619,'Confirmation Document 31','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3620,'Confirmation Document 32','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3621,'Confirmation Document 33','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3622,'Confirmation Document 34','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3623,'Confirmation Document 35','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3624,'Confirmation Document 36','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3625,'Confirmation Document 37','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3626,'Confirmation Document 38','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3627,'Confirmation Document 39','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3628,'Confirmation Document 40','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3629,'Confirmation Document 41','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3630,'Confirmation Document 42','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3631,'Confirmation Document 43','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3632,'Confirmation Document 44','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3633,'Confirmation Document 45','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3634,'Confirmation Document 46','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3635,'Confirmation Document 47','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3636,'Confirmation Document 48','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3637,'Confirmation Document 49','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3638,'Confirmation Document 50','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3639,'Confirmation Document 51','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3640,'Confirmation Document 52','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3641,'Confirmation Document 53','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3642,'Confirmation Document 54','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3643,'Confirmation Document 55','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3644,'Confirmation Document 56','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3645,'Confirmation Document 57','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3646,'Confirmation Document 58','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3647,'Confirmation Document 59','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3648,'Confirmation Document 60','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3649,'Confirmation Document 61','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3650,'Confirmation Document 62','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3651,'Confirmation Document 63','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3652,'Confirmation Document 64','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3653,'Confirmation Document 65','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3654,'Confirmation Document 66','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3655,'Confirmation Document 67','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3656,'Eye of Seer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3657,'Pincher Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3658,'Ol Mahum Uniform','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3659,'Enku Orc Champion\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3660,'Bloody Bee Stinger','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3661,'Ignition of Ghost Fire','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3662,'Ethereal Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3663,'Returned Delivery Goods 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3664,'Returned Delivery Goods 15','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3665,'Returned Delivery Goods 30','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3666,'Returned Delivery Goods 33','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3667,'Returned Delivery Goods 37','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3668,'Returned Delivery Goods 45','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3669,'Returned Delivery Goods 55','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3670,'Returned Delivery Goods 60','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3671,'Sophya\'s 1st Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3672,'Sophya\'s 2nd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3673,'Sophya\'s 3rd Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3674,'Sophya\'s 4th Order','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3675,'Lion\'s Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3676,'Lion\'s Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3677,'Guild Coin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3678,'Alchemy Text','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3679,'Secret Book of Potion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3680,'1st Potion Recipe','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3681,'2nd Potion Recipe','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3682,'Matild\'s Orb','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3683,'Forbidden Love Scroll','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3684,'Amber Scale','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3685,'Wind Soulstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3686,'Glass Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3687,'Horror Ectoplasm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3688,'Silenos Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3689,'Ant Soldier Aphid','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3690,'Tyrant\'s Chitin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3691,'Bugbear Blood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3692,'1st Circle Hunter License','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3693,'2nd Circle Hunter License','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3694,'Laurel Leaf Pin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3695,'1st Test Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3696,'2nd Test Instructions','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3697,'Cybellin\'s Request','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3698,'Blood Crystal: Purity 1','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3699,'Blood Crystal: Purity 2','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3700,'Blood Crystal: Purity 3','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3701,'Blood Crystal: Purity 4','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3702,'Blood Crystal: Purity 5','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3703,'Blood Crystal: Purity 6','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3704,'Blood Crystal: Purity 7','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3705,'Blood Crystal: Purity 8','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3706,'Blood Crystal: Purity 9','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3707,'Blood Crystal: Purity 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3708,'Blood Crystal: Broken','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3709,'Guardian Basilisk Scale','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3710,'Karut Weed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3711,'Haka\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3712,'Jakas\' Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3713,'Marka\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3714,'Windsus Aleph Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3715,'Indigo Spirit Ore','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3716,'Sporesea Seed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3717,'Timak Orc Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3718,'Trisalim Silk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3719,'Ambrosius Fruit','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3720,'Balefire Crystal','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3721,'Imperial Arrowhead','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3722,'Athu\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3723,'Lanka\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3724,'Triska\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3725,'Motura\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3726,'Kalath\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3727,'1st Circle Request: 1C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3728,'1st Circle Request: 2C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3729,'1st Circle Request: 3C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3730,'1st Circle Request: 4C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3731,'1st Circle Request: 5C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3732,'1st Circle Request: 6C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3733,'1st Circle Request: 7C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3734,'1st Circle Request: 8C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3735,'1st Circle Request: 9C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3736,'1st Circle Request: 10C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3737,'1st Circle Request: 11C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3738,'1st Circle Request: 12C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3739,'1st Circle Request: 1B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3740,'1st Circle Request: 2B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3741,'1st Circle Request: 3B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3742,'1st Circle Request: 4B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none','');

INSERT INTO `etcitem` VALUES
(3743,'1st Circle Request: 5B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3744,'1st Circle Request: 6B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3745,'1st Circle Request: 1A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3746,'1st Circle Request: 2A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3747,'1st Circle Request: 3A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3748,'2nd Circle Request: 1C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3749,'2nd Circle Request 2C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3750,'2nd Circle Request 3C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3751,'2nd Circle Request: 4C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3752,'2nd Circle Request: 5C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3753,'2nd Circle Request: 6C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3754,'2nd Circle Request: 7C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3755,'2nd Circle Request: 8C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3756,'2nd Circle Request: 9C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3757,'2nd Circle Request: 10C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3758,'2nd Circle Request: 11C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3759,'2nd Circle Request: 12C','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3760,'2nd Circle Request: 1B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3761,'2nd Circle Request: 2B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3762,'2nd Circle Request: 3B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3763,'2nd Circle Request: 4B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3764,'2nd Circle Request: 5B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3765,'2nd Circle Request: 6B','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3766,'2nd Circle Request: 1A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3767,'2nd Circle Request: 2A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3768,'2nd Circle Request: 3A','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3769,'Charm of Kadesh','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3770,'Timak Jade Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3771,'Enchanted Golem Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3772,'Giant Monster Eye Meat','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3773,'Dire Wyrm Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3774,'Grd Basilisk Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3775,'Revenant\'s Chains','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3776,'Windsus Tusk','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3777,'Grandis Skull','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3778,'Taik Obsidian Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3779,'Karul Bugbear Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3780,'Tamlin Ivory Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3781,'Fang of Narak','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3782,'Enchanted Gargoyle Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3783,'Coiled Serpent Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3784,'Totem of Kadesh','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3785,'Kaiki\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3786,'Kronbe Venom Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3787,'Eva\'s Charm','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3788,'Titan\'s Tablet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3789,'Book of Shunaiman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3790,'Rotting Tree Spores','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3791,'Trisalim Venom Sac','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3792,'Taik Orc Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3793,'Harit Barbed Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3794,'Coin of Old Empire','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3795,'Skin of Farcran','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3796,'Tempest Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3797,'Tsunami Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3798,'Satyr Mane','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3799,'Hamadryad Shard','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3800,'Vanor Silenos Mane','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3801,'Talk Bugbear Totem','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3802,'Okun\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3803,'Kakran\'s Head','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3804,'Narcissus\'s Soulstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3805,'Deprive Eye','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3806,'Unicorn\'s Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3807,'Kerunos\'s Gold Mane','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3808,'Skull of Executed','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3809,'Bust of Travis','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3810,'Sword of Cadmus','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3811,'Coin Diagram','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3812,'Kaldis Gold Dragon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3813,'Coin Collector Membership 1','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3814,'Coin Collector Membership 2','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3815,'Coin Collector Membership 3','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3816,'Fairy Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3817,'Deluxe Fairy Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3818,'Fairy Stone List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3819,'Deluxe Fairy Stone List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3820,'Toad Lord Back Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3821,'Juice of Monkshood','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3822,'Scale of Drake Exarion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3823,'Egg of Drake Exarion','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3824,'Scale of Drake Zwov','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3825,'Egg of Drake Zwov','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3826,'Scale of Drake Kalibran','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3827,'Egg of Drake Kalibran','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3828,'Scale of Wyvern Suzet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3829,'Egg of Wyvern Suzet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3830,'Scale of Wyvern Shamhai','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3831,'Egg of Wyvern Shamhai','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3832,'Herb of Harit','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3833,'Herb of Vanor','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3834,'Herb of Oel Mahum','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3835,'Blood of Eva','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3836,'Athrea\'s Coin','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3837,'Symbol of Loyalty','false','none',0,'normal','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3838,'Recipe: Titan\'s Powerstone','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','false','true','true','false','Recipes',''),
(3839,'Mist Drake Egg','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3840,'Blitz Wyrm Egg','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3841,'Drake Egg','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3842,'Thunder Wyrm Egg','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3843,'Brooch of the Magpie','false','none',0,'normal','steel','none',-1,-1,1000,0,'true','false','true','true','false','none',''),
(3844,'Nebulite Crystals','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3845,'Broken Titan\'s Powerstone','false','none',0,'stackable','steel','none',-1,-1,500,0,'true','false','true','true','false','none',''),
(3846,'Titan\'s Powerstone','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3847,'Imperial Key','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','false','true','true','false','none',''),
(3848,'Undead Ash','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3849,'Bloody Axe Insignia','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3850,'Delu Lizardman Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3851,'Stakato Talon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3852,'Feather of Gabrielle','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3853,'Marsh Stalker Horn','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3854,'Marsh Drake Talons','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3855,'Kranrot Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3856,'Hamrut Leg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3857,'Remains of Sacrified','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3858,'Totem of Land Dragon','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3859,'1st Fragment of Abyss Jewel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3860,'2nd Fragment of Abyss Jewel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3861,'3rd Fragment of Abyss Jewel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3862,'Mara Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3863,'Musfel Fang','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3864,'Mark of Watchman','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3865,'Portal Stone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3866,'Gustav\'s 1st Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3867,'Gustav\'s 2nd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3868,'Gustav\'s 3rd Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3869,'Scepter of Judgment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3870,'Seal of Aspiration','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(3871,'Black Anvil Coin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3872,'Antidote Recipe List','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3873,'Voucher of Faith','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3874,'Alliance Manifesto','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(3875,'L2Day - A','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3876,'L2Day - C','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3877,'L2Day - E','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3878,'L2Day - F','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3879,'L2Day - G','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3880,'L2Day - H','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3881,'L2Day - I','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3882,'L2Day - L','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3883,'L2Day - N','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3884,'L2Day - O','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3885,'L2Day - R','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3886,'L2Day - S','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3887,'L2Day - T','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3888,'L2Day - II','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(3889,'Potion of Recovery','false','potion',180,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2060-1'),
(3890,'Herald of Slayer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(3926,'L2Day - Scroll of Guidance','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2050-1'),
(3927,'L2Day - Scroll of Death Whisper','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2051-1'),
(3928,'L2Day - Scroll of Focus','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2052-1'),
(3929,'L2Day - Scroll of Greater Acumen','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2053-1'),
(3930,'L2Day - Scroll of Haste','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2054-1'),
(3931,'L2Day - Scroll of Agility','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2055-1'),
(3932,'L2Day - Scroll of Mystic Empower','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2056-1'),
(3933,'L2Day - Scroll of Might','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2057-1'),
(3934,'L2Day - Scroll of Windwalk','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2058-1'),
(3935,'L2Day - Scroll of Shield','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2059-1'),
(3936,'Blessed Scroll of Resurrection','false','scroll',120,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','ScrollOfResurrection','2049-1'),
(3940,'Blueprint: Summon Siege Golem','false','spellbook',120,'stackable','paper','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(3941,'Spellbook: Mass Resurrection','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3942,'Spellbook: Party Return','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(3943,'Amulet: Pa\'agrio\'s Heart','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(3944,'Spellbook: Decrease Weight','false','spellbook',120,'stackable','paper','none',-1,-1,2450,0,'true','true','true','true','true','none',''),
(3945,'Boat Ticket: Talking Island to Giran','false','none',20,'stackable','paper','none',-1,-1,8000,0,'true','true','true','true','true','none',''),
(3946,'Boat Ticket: Giran to Talking Island','false','none',20,'stackable','paper','none',-1,-1,8000,0,'true','true','true','true','true','none',''),
(3947,'Blessed Spiritshot: No Grade','false','shot',5,'stackable','paper','none',-1,-1,35,0,'true','true','true','true','true','BlessedSpiritShot','2061-1'),
(3948,'Blessed Spiritshot: D-Grade','false','shot',5,'stackable','paper','d',-1,-1,45,0,'true','true','true','true','true','BlessedSpiritShot','2160-1'),
(3949,'Blessed Spiritshot: C-Grade','false','shot',3,'stackable','paper','c',-1,-1,90,0,'true','true','true','true','true','BlessedSpiritShot','2161-1'),
(3950,'Blessed Spiritshot: B-Grade','false','shot',3,'stackable','paper','b',-1,-1,245,0,'true','true','true','true','true','BlessedSpiritShot','2162-1'),
(3951,'Blessed Spiritshot: A-Grade','false','shot',2,'stackable','paper','a',-1,-1,290,0,'true','true','true','true','true','BlessedSpiritShot','2163-1'),
(3952,'Blessed Spiritshot: S Grade','false','shot',2,'stackable','paper','s',-1,-1,350,0,'true','true','true','true','true','BlessedSpiritShot','2164-1'),
(3953,'Recipe: Blessed Spiritshot D','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(3954,'Recipe: Blessed Spiritshot C','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(3955,'Recipe: Blessed Spiritshot B','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(3956,'Recipe: Blessed Spiritshot A','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(3957,'Recipe: Blessed Spiritshot S','false','recipe',30,'stackable','liquid','none',-1,-1,450000,0,'true','true','true','true','true','Recipes',''),
(3958,'L2Day - Blessed Escape Scroll','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2036-2'),
(3959,'L2Day - Blessed Resurrection Scroll','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ScrollOfResurrection','2062-1'),
(3960,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3961,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3962,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3963,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3964,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3965,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3966,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3967,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3968,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3969,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3970,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3971,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3972,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3973,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3974,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3975,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3976,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3977,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3978,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3979,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3980,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3981,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3982,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3983,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3984,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3985,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3986,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3987,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3988,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3989,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3990,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3991,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(3992,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(3993,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(3994,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3995,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(3996,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3997,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3998,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(3999,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(4000,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(4001,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(4002,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4003,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4004,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(4005,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(4006,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(4007,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4008,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4009,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4010,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4011,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4012,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(4013,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(4014,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(4015,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4016,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4017,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,30000,0,'true','true','true','true','true','MercTicket',''),
(4018,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','MercTicket',''),
(4019,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','MercTicket',''),
(4020,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4021,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','MercTicket',''),
(4022,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4023,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4024,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4025,'Mercenary Posting Ticket (Teleporter4)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4026,'Mercenary Posting Ticket (Teleporter5)','false','castle_guard',0,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','MercTicket',''),
(4029,'Red Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4030,'Orange Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4031,'Yellow Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4032,'Green Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4033,'Blue Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4034,'Purple Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4035,'White Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4036,'Black Paper','false','none',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(4037,'Coin of Luck','false','none',0,'stackable','paper','none',-1,-1,1,0,'false','false','true','false','false','none',''),
(4038,'Food For Hatchling','false','none',10,'stackable','liquid','none',-1,-1,162,0,'true','true','true','true','true','PetFood','2063-1'),
(4039,'Mold Glue','false','material',2,'stackable','liquid','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(4040,'Mold Lubricant','false','material',2,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(4041,'Mold Hardener','false','material',2,'stackable','liquid','none',-1,-1,23000,0,'true','true','true','true','true','none',''),
(4042,'Enria','false','material',2,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4043,'Asofe','false','material',2,'stackable','liquid','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(4044,'Thons','false','material',2,'stackable','liquid','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(4045,'Maestro Holder','false','material',2,'stackable','liquid','none',-1,-1,411000,0,'true','true','true','true','true','none',''),
(4046,'Maestro Anvil Lock','false','material',2,'stackable','liquid','none',-1,-1,90400,0,'true','true','true','true','true','none',''),
(4047,'Craftsman Mold','false','material',2,'stackable','liquid','none',-1,-1,710000,0,'true','true','true','true','true','none',''),
(4048,'Maestro Mold','false','material',2,'stackable','liquid','none',-1,-1,154000,0,'true','true','true','true','true','none',''),
(4049,'Adamantite Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,3813,0,'true','true','true','true','true','none',''),
(4050,'Adamantite Ring Wire','false','material',60,'stackable','liquid','none',-1,-1,3228,0,'true','true','true','true','true','none',''),
(4051,'Adamantite Necklace Chain','false','material',60,'stackable','liquid','none',-1,-1,5157,0,'true','true','true','true','true','none',''),
(4052,'Earring of Black Ore Piece','false','material',60,'stackable','liquid','none',-1,-1,5649,0,'true','true','true','true','true','none',''),
(4053,'Ring of Black Ore Gemstone','false','material',60,'stackable','liquid','none',-1,-1,4666,0,'true','true','true','true','true','none',''),
(4054,'Necklace of Black Ore Beads','false','material',60,'stackable','liquid','none',-1,-1,10154,0,'true','true','true','true','true','none',''),
(4055,'Composite Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,3120,0,'true','true','true','true','true','none',''),
(4056,'Zubei\'s Breastplate Part','false','material',60,'stackable','liquid','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(4057,'Zubei\'s Gaiter Material','false','material',60,'stackable','liquid','none',-1,-1,7150,0,'true','true','true','true','true','none',''),
(4058,'Implosion Boots Part','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4059,'Boots of Silence Fabric','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4060,'Guardian\'s Boots Fabric','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4061,'Paradia Boots Pattern','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4062,'Elemental Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4063,'Boots of Grace Lining','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4064,'Avadon Breastplate Part','false','material',60,'stackable','liquid','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(4065,'Avadon Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,7150,0,'true','true','true','true','true','none',''),
(4066,'Zubei\'s Leather Shirt Fabric','false','material',60,'stackable','liquid','none',-1,-1,8483,0,'true','true','true','true','true','none',''),
(4067,'Zubei\'s Leather Gaiter Texture','false','material',60,'stackable','liquid','none',-1,-1,5587,0,'true','true','true','true','true','none',''),
(4068,'Avadon Leather Armor Lining','false','material',60,'stackable','liquid','none',-1,-1,11042,0,'true','true','true','true','true','none',''),
(4069,'Tunic of Zubei Fabric','false','material',60,'stackable','liquid','none',-1,-1,8483,0,'true','true','true','true','true','none',''),
(4070,'Stockings of Zubei Fabric','false','material',60,'stackable','liquid','none',-1,-1,5587,0,'true','true','true','true','true','none',''),
(4071,'Avadon Robe Fabric','false','material',60,'stackable','liquid','none',-1,-1,11042,0,'true','true','true','true','true','none',''),
(4072,'Avadon Circlet Pattern','false','material',60,'stackable','liquid','none',-1,-1,4453,0,'true','true','true','true','true','none',''),
(4073,'Avadon Gloves Part','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4074,'Chain Gloves of Silence Design','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4075,'Guardian\'s Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4076,'Gloves of Blessing Pattern','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4077,'Doom Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,4446,0,'true','true','true','true','true','none',''),
(4078,'Blue Wolf Breastplate Part','false','material',60,'stackable','liquid','none',-1,-1,13692,0,'true','true','true','true','true','none',''),
(4079,'Boots of Blessing Design','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4080,'Blue Wolf Gaiters Material','false','material',60,'stackable','liquid','none',-1,-1,9723,0,'true','true','true','true','true','none',''),
(4081,'Doom Plate Armor Temper','false','material',60,'stackable','liquid','none',-1,-1,20292,0,'true','true','true','true','true','none',''),
(4082,'Blue Wolf Leather Armor Texture','false','material',60,'stackable','liquid','none',-1,-1,17700,0,'true','true','true','true','true','none',''),
(4083,'Leather Armor of Doom Design','false','material',60,'stackable','liquid','none',-1,-1,17700,0,'true','true','true','true','true','none',''),
(4084,'Blue Wolf Tunic Fabric','false','material',60,'stackable','liquid','none',-1,-1,11508,0,'true','true','true','true','true','none',''),
(4085,'Tunic of Doom Pattern','false','material',60,'stackable','liquid','none',-1,-1,11508,0,'true','true','true','true','true','none',''),
(4086,'Blue Wolf Stockings Pattern','false','material',60,'stackable','liquid','none',-1,-1,8523,0,'true','true','true','true','true','none',''),
(4087,'Stockings of Doom Pattern','false','material',60,'stackable','liquid','none',-1,-1,8523,0,'true','true','true','true','true','none',''),
(4088,'Blue Wolf Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,5292,0,'true','true','true','true','true','none',''),
(4089,'Doom Helmet Pattern','false','material',60,'stackable','liquid','none',-1,-1,5292,0,'true','true','true','true','true','none',''),
(4090,'Blue Wolf Boots Design','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4091,'Doom Gloves Part','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4092,'Elemental Gloves Lining','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4093,'Gloves of Grace Lining','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4094,'Implosion Gauntlet Fabric','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4095,'Paradia Gloves Pattern','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4096,'Blue Wolf Gloves Fabric','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4097,'Zubei\'s Boots Design','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4098,'Avadon Boots Design','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4099,'Doom Boots Part','false','material',60,'stackable','liquid','none',-1,-1,4455,0,'true','true','true','true','true','none',''),
(4100,'Zubei\'s Gauntlets Part','false','material',60,'stackable','liquid','none',-1,-1,3843,0,'true','true','true','true','true','none',''),
(4101,'Zubei\'s Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,3450,0,'true','true','true','true','true','none',''),
(4102,'Zubei\'s Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,4453,0,'true','true','true','true','true','none',''),
(4103,'Pata Blade','false','material',60,'stackable','liquid','none',-1,-1,32950,0,'true','true','true','true','true','none',''),
(4104,'Great Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,34950,0,'true','true','true','true','true','none',''),
(4105,'Heavy War Axe Head','false','material',60,'stackable','liquid','none',-1,-1,34950,0,'true','true','true','true','true','none',''),
(4106,'Sprite\'s Staff Head','false','material',60,'stackable','liquid','none',-1,-1,35533,0,'true','true','true','true','true','none',''),
(4107,'Keshanberk Blade','false','material',60,'stackable','liquid','none',-1,-1,35500,0,'true','true','true','true','true','none',''),
(4108,'Sword of Valhalla Blade','false','material',60,'stackable','liquid','none',-1,-1,35500,0,'true','true','true','true','true','none',''),
(4109,'Kris Edge','false','material',60,'stackable','liquid','none',-1,-1,35500,0,'true','true','true','true','true','none',''),
(4110,'Hell Knife Edge','false','material',60,'stackable','liquid','none',-1,-1,35500,0,'true','true','true','true','true','none',''),
(4111,'Arthro Nail Blade','false','material',60,'stackable','liquid','none',-1,-1,34950,0,'true','true','true','true','true','none',''),
(4112,'Dark Elven Longbow Shaft','false','material',60,'stackable','liquid','none',-1,-1,35325,0,'true','true','true','true','true','none',''),
(4113,'Great Axe Head','false','material',60,'stackable','liquid','none',-1,-1,38867,0,'true','true','true','true','true','none',''),
(4114,'Sword of Damascus Blade','false','material',60,'stackable','liquid','none',-1,-1,45692,0,'true','true','true','true','true','none',''),
(4115,'Lance Blade','false','material',60,'stackable','liquid','none',-1,-1,45846,0,'true','true','true','true','true','none',''),
(4116,'Deadman\'s Glory Stone','false','material',60,'stackable','liquid','none',-1,-1,45769,0,'true','true','true','true','true','none',''),
(4117,'Art of Battle Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,45769,0,'true','true','true','true','true','none',''),
(4118,'Evil Spirit Head','false','material',60,'stackable','liquid','none',-1,-1,48308,0,'true','true','true','true','true','none',''),
(4119,'Demon Dagger Edge','false','material',60,'stackable','liquid','none',-1,-1,45692,0,'true','true','true','true','true','none',''),
(4120,'Bellion Cestus Edge','false','material',60,'stackable','liquid','none',-1,-1,45769,0,'true','true','true','true','true','none',''),
(4121,'Bow of Peril Shaft','false','material',60,'stackable','liquid','none',-1,-1,45923,0,'true','true','true','true','true','none',''),
(4122,'Recipe: Maestro Holder (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,4500,0,'true','true','true','true','true','Recipes',''),
(4123,'Recipe: Maestro Anvil Lock (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,4500,0,'true','true','true','true','true','Recipes',''),
(4124,'Recipe: Craftsman Mold (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,4500,0,'true','true','true','true','true','Recipes',''),
(4125,'Recipe: Maestro Mold (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,4500,0,'true','true','true','true','true','Recipes',''),
(4126,'Recipe: Adamantite Earrings (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,12120,0,'true','true','true','true','true','Recipes',''),
(4127,'Recipe: Adamantite Ring (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,8080,0,'true','true','true','true','true','Recipes',''),
(4128,'Recipe: Adamantite Necklace (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16160,0,'true','true','true','true','true','Recipes',''),
(4129,'Recipe: Earrings of Black Ore (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,18480,0,'true','true','true','true','true','Recipes',''),
(4130,'Recipe: Ring of Black Ore (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,12320,0,'true','true','true','true','true','Recipes',''),
(4131,'Recipe: Necklace of Black Ore (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','Recipes',''),
(4132,'Recipe: Composite Shield (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5160,0,'true','true','true','true','true','Recipes',''),
(4133,'Recipe: Zubei\'s Breastplate (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,41600,0,'true','true','true','true','true','Recipes',''),
(4134,'Recipe: Zubei\'s Gaiters (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,26000,0,'true','true','true','true','true','Recipes',''),
(4135,'Recipe: Implosion Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4136,'Recipe: Boots of Silence (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4137,'Recipe: Guardian\'s Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4138,'Recipe: Paradia Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4139,'Recipe: Elemental Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4140,'Recipe: Boots of Grace (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4141,'Recipe: Avadon Breastplate (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,41600,0,'true','true','true','true','true','Recipes',''),
(4142,'Recipe: Avadon Gaiters (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,26000,0,'true','true','true','true','true','Recipes',''),
(4143,'Recipe: Zubei\'s Leather Shirt (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,31200,0,'true','true','true','true','true','Recipes',''),
(4144,'Recipe: Zubei\'s Leather Gaiters (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,19460,0,'true','true','true','true','true','Recipes',''),
(4145,'Recipe: Avadon Leather Armor (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,45600,0,'true','true','true','true','true','Recipes',''),
(4146,'Recipe: Tunic of Zubei (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,31200,0,'true','true','true','true','true','Recipes',''),
(4147,'Recipe: Stockings of Zubei (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,19460,0,'true','true','true','true','true','Recipes',''),
(4148,'Recipe: Avadon Robe (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,45600,0,'true','true','true','true','true','Recipes',''),
(4149,'Recipe: Avadon Circlet (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,15560,0,'true','true','true','true','true','Recipes',''),
(4150,'Recipe: Avadon Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4151,'Recipe: Chain Gloves of Silence (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4152,'Recipe: Guardian\'s Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4153,'Recipe: Gloves of Blessing (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4154,'Recipe: Doom Shield (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16900,0,'true','true','true','true','true','Recipes',''),
(4155,'Recipe: Blue Wolf Breastplate (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,64400,0,'true','true','true','true','true','Recipes',''),
(4156,'Recipe: Boots of Blessing (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4157,'Recipe: Blue Wolf Gaiters (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,40200,0,'true','true','true','true','true','Recipes',''),
(4158,'Recipe: Doom Plate Armor (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,94200,0,'true','true','true','true','true','Recipes',''),
(4159,'Recipe: Blue Wolf Leather Armor (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,70600,0,'true','true','true','true','true','Recipes',''),
(4160,'Recipe: Leather Armor of Doom (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,70600,0,'true','true','true','true','true','Recipes',''),
(4161,'Recipe: Blue Wolf Tunic (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,48200,0,'true','true','true','true','true','Recipes',''),
(4162,'Recipe: Tunic of Doom (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,48200,0,'true','true','true','true','true','Recipes',''),
(4163,'Recipe: Blue Wolf Stockings (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,30200,0,'true','true','true','true','true','Recipes',''),
(4164,'Recipe: Stockings of Doom (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,30200,0,'true','true','true','true','true','Recipes',''),
(4165,'Recipe: Blue Wolf Helmet (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,24200,0,'true','true','true','true','true','Recipes',''),
(4166,'Recipe: Doom Helmet (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,24200,0,'true','true','true','true','true','Recipes',''),
(4167,'Recipe: Blue Wolf Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4168,'Recipe: Doom Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4169,'Recipe: Elemental Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4170,'Recipe: Gloves of Grace (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4171,'Recipe: Implosion Gauntlets (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4172,'Recipe: Paradia Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4173,'Recipe: Blue Wolf Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4174,'Recipe: Zubei\'s Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4175,'Recipe: Avadon Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4176,'Recipe: Doom Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4177,'Recipe: Zubei\'s Gauntlets (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4178,'Recipe: Zubei\'s Shield (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,10900,0,'true','true','true','true','true','Recipes',''),
(4179,'Recipe: Zubei\'s Helmet (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,15560,0,'true','true','true','true','true','Recipes',''),
(4180,'Recipe: Silver Arrow (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,1800,0,'true','true','true','true','true','Recipes',''),
(4181,'Recipe: Pata (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,156600,0,'true','true','true','true','true','Recipes',''),
(4182,'Recipe: Great Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4183,'Recipe: Heavy War Axe (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4184,'Recipe: Sprite\'s Staff (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4185,'Recipe: Keshanberk (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4186,'Recipe: Sword of Valhalla (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4187,'Recipe: Kris (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4188,'Recipe: Hell Knife (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4189,'Recipe: Arthro Nail (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4190,'Recipe: Dark Elven Long Bow (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4191,'Recipe: Great Axe (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4192,'Recipe: Sword of Damascus (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4193,'Recipe: Lance (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4194,'Recipe: Deadman\'s Glory (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4195,'Recipe: Art of Battle Axe (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4196,'Recipe: Staff of Evil Spirits (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4197,'Recipe: Demon Dagger (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4198,'Recipe: Bellion Cestus (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4199,'Recipe: Bow of Peril (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(4200,'Spellbook: Restore Life','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4201,'Spellbook: Resist Shock','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4203,'Spellbook: Life Leech','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4204,'Amulet: Pa\'agrio\'s Tact','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4205,'Amulet: Pa\'agrio\'s Rage','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4206,'Spellbook: Transfer Pain','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4207,'Spellbook: Mana Regeneration','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4208,'Spellbook: Curse Gloom','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4209,'Change of Heart - Piece 1','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4210,'Change of Heart - Piece 2','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4211,'Change of Heart - Piece 3','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4212,'Change of Heart - Piece 4','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4213,'Change of Heart - Piece 5','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4214,'Change of Heart - Piece 6','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4215,'Change of Heart - Piece 7','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4216,'Change of Heart - Piece 8','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4217,'Change of Heart - Piece 9','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4218,'L2 Day - Scroll of Mana Regeneration','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2064-1'),
(4232,'Dice','false','none',0,'normal','steel','none',-1,-1,0,0,'true','true','false','true','true','none',''),
(4239,'Blade Mold','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4240,'Tyra\'s Bill','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4241,'Ranger\'s Report - Part 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4242,'Ranger\'s Report - Part 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4243,'Ranger\'s Report - Part 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4244,'Ranger\'s Report - Part 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4245,'Weapons Trade Contract','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4246,'Attack Directives','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4247,'Certificate of the Silver Scale Guild','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4248,'Rolento\'s Cargobox','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4249,'Ol Mahum Captain\'s Head','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4250,'Jade Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4251,'Ancient Statue of Goddess','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4252,'GalfRedo Romer\'s Bust','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4253,'Eye of the Shadow','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4254,'Certificate of Participation: Battle Royal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4255,'Trade Cargo','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4256,'Agnes\'s Holy Symbol','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4257,'Agnes\'s Rosary','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4258,'Sinister Totem','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4259,'Bear Skin','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4260,'Enku Orc\'s Head','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4261,'Orc Heads Bouquet -1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4262,'Orc Heads Bouquet -2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4263,'Orc Heads Bouquet -3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4264,'Orc Heads Bouquet -4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4265,'Orc Heads Bouquet -5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4266,'Orc Heads Bouquet -6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4267,'Orc Heads Bouquet -7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4268,'Jennifer\'s Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4269,'Articles of Dead Heroes','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4270,'Old Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4271,'Old Hilt','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4272,'Totem Necklace','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4273,'Einhasad Crucifix','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4274,'Victim\'s Arm Bone','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4275,'Victim\'s Thigh Bone','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4276,'Victim\'s Skull','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4277,'Victim\'s Rib Bone','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4278,'Victim\'s Spine','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4279,'Jar of Bones','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4280,'Useless Bone Pieces','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4281,'Powder to Summon Dead Souls','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4282,'Sack of the Dead','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4283,'Frog Prince','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4284,'Fly Powder','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4285,'Calculator','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4286,'Gemstone Beast\'s Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4287,'Titan\'s Powerstone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4288,'Hanellin\'s 1st Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4289,'Hanellin\'s 2nd Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4290,'Hanellin\'s 3rd Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4291,'1st Key of Ark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4292,'2nd Key of Ark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4293,'3rd Key of Ark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4294,'White Fabric','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4295,'Blooded Fabric','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4296,'Order of Gosta','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4297,'Lizard Fang','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4298,'Barrel of League','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4299,'Operation Document - 1/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4300,'Operation Document - 2/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4301,'Operation Document - 3/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4302,'Operation Document - 4/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4303,'Operation Document - 5/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4304,'Operation Document - 6/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4305,'Operation Document - 7/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4306,'Operation Document - 8/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4307,'Operation Document - 9/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4308,'Operation Document - 10/10','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4309,'Completed Operation Order','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4310,'Iason Heines Bill','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4311,'Gillian\'s Diary','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4312,'Gillian\'s Notes','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4313,'Unfinished Music','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4314,'Gillian\'s Heart','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4315,'Gandi Tribe\'s Relic','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4316,'Swan\'s Flute','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4317,'Swan\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4318,'Event Clothes','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4319,'Nanarin\'s Flute','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4320,'Sabrin\'s Black Beer','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4321,'Stolen Black Beer','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4322,'Stolen Event Clothes','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4323,'Clothes Chest Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4324,'Beer Chest Key','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4325,'Fairy Leaf','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4326,'Ratman Scavenger\'s Skull','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4327,'Turek War Hound\'s Tail','false','quest',0,'stackable','bone','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4328,'Tyrant Kingpin\'s Heart','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4329,'Trisalim Tarantula\'s Venom Sac','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4330,'Penitent\'s Manacles','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4331,'Manual of Manacles','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4332,'Tarlk Amulet','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4333,'Contest Certificate','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4334,'Ant\'s Ichor','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4335,'Noble Ant\'s Nerve Tissue','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4336,'Casian\'s Enzyme','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4337,'Alligator Leather','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4338,'Blue Back Alligator Leather','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4339,'Jewel Studded Alligator Leather','false','quest',0,'stackable','leather','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4340,'Certificate of Approval to Create a Belt','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4341,'Certificate of Approval to Create a Purse','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4342,'Water Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4343,'Fire Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4344,'Wind Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4345,'Earth Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4346,'Dark Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4347,'Crystal of Light','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4348,'Jade Crystal','false','none',1,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4349,'Bust of Ancient Goddess','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4350,'The Work of the ancient sculptor Berona','false','none',5,'stackable','wood','none',-1,-1,3400,0,'true','true','true','true','true','none',''),
(4351,'Ancient Statue of Goddess - Prototype','false','none',5,'stackable','wood','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(4352,'Ancient Statue of Goddess - Original','false','none',5,'stackable','wood','none',-1,-1,6800,0,'true','true','true','true','true','none',''),
(4353,'Ancient Statue of Goddess - Replica','false','none',5,'stackable','wood','none',-1,-1,850,0,'true','true','true','true','true','none',''),
(4354,'Ancient Statue of Goddess - Forgery','false','none',5,'stackable','wood','none',-1,-1,850,0,'true','true','true','true','true','none',''),
(4355,'Blue Eva','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4356,'Gold Einhasad','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4357,'Silver Shilen','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4358,'Bloody Pa\'agrio','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4359,'Barrel of Liquor','false','none',2000,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4360,'Precious Scarab','false','none',0,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4361,'Simbelmyne','false','none',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4362,'Odd (looking) Doll','false','none',500,'normal','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4363,'Scarlet Dress','false','none',20,'normal','cloth','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4364,'Nebulite Orb','false','none',2,'stackable','crystal','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(4365,'Ectoplasm Liqueur','false','none',10,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4366,'Prince\'s Trophy','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4367,'Prince\'s Autobiography','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4368,'Prince\'s Bust','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4369,'Silk Handkerchief','false','none',5,'stackable','cloth','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4370,'Luxurious Goblet','false','none',10,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4371,'Scepter of Darkness','false','none',10,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4372,'Succubus Perfume','false','none',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4373,'Succubus Mirror','false','none',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4374,'Heart of Darkness','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4375,'Royal Orc Totem','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4376,'Pearl Trodden/Trampled By A Wild Hog','false','none',5,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4377,'Boar\'s Tusk','false','none',10,'stackable','bone','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4378,'Sweet Potato','false','none',5,'stackable','bone','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4379,'Beast\'s Claws','false','none',5,'stackable','bone','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4380,'Beast\'s Mane','false','none',10,'stackable','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4381,'Ginseng Root','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4382,'Honey Jar','false','none',10,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4383,'Bear\'s Gall','false','none',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4384,'Fresh Samon','false','none',5,'stackable','bone','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4385,'Sushi Riceball','false','none',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4386,'Avellan Spice','false','none',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4387,'Lucky Rabbit Weed','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4388,'Malcom\'s Check','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4389,'Deposit Box Key','false','none',10,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4390,'Dwarven Royal Seal','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4391,'Dwarven Royal Crown','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4392,'Dwarven Dance Manual','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4393,'Calculator','false','none',20,'normal','steel','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(4394,'Hanellin\'s White Flower','false','none',0,'normal','wood','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4395,'Hanellin\'s Red Flower','false','none',0,'normal','wood','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4396,'Hanellin\'s Yellow Flower','false','none',0,'normal','wood','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4397,'Book of Saint','false','none',20,'normal','paper','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4398,'Blood of Saint','false','none',20,'normal','liquid','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4399,'Bough of Saint','false','none',20,'normal','wood','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4400,'White Fabric','false','none',0,'stackable','cloth','none',-1,-1,0,0,'true','false','false','true','false','none',''),
(4401,'Green Dimensional Stone','false','none',10,'stackable','crystal','none',-1,-1,100000,0,'true','true','true','true','true','none',''),
(4402,'Blue Dimensional Stone','false','none',10,'stackable','crystal','none',-1,-1,100000,0,'true','true','true','true','true','none',''),
(4403,'Red Dimensional Stone','false','none',10,'stackable','crystal','none',-1,-1,100000,0,'true','true','true','true','true','none',''),
(4404,'Green Dimensional Stone - Shard','false','none',10,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4405,'Blue Dimensional Stone - Shard','false','none',10,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4406,'Red Dimensional Stone - Shard','false','none',10,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4407,'Bill of Iason Heine','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4408,'Musical Score - Theme of Love','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4409,'Musical Score - Theme of Battle','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4410,'Musical Score - Theme of Journey','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4411,'Echo Crystal - Theme of Journey','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2069-1'),
(4412,'Echo Crystal - Theme of Battle','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2068-1'),
(4413,'Echo Crystal - Theme of Love','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2070-1'),
(4414,'Echo Crystal - Theme of Solitude','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2072-1'),
(4415,'Echo Crystal - Theme of the Feast','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2071-1'),
(4416,'Echo Crystal - Theme of Celebration','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Potions','2073-1'),
(4417,'Echo Crystal - Theme of Comedy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2067-1'),
(4418,'Musical Score - Theme of Celebration','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4419,'Musical Score - Theme of Comedy','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4420,'Musical Score - Theme of Solitude','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4421,'Musical Score - Theme of the Feast','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4422,'Dragon Bugle of Wind','false','pet_collar',20,'normal','steel','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(4423,'Dragon Bugle of Star','false','pet_collar',20,'normal','steel','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(4424,'Dragon Bugle of Dusk','false','pet_collar',20,'normal','steel','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(4425,'Penitent\'s Manacles','false','pet_collar',800,'normal','steel','none',-1,-1,0,0,'false','false','false','false','false','SummonItems',''),
(4426,'Manacles of Penitent','false','none',50,'normal','steel','none',-1,-1,22000,0,'true','false','true','true','false','none',''),
(4427,'Alligator Leather Belt','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4428,'Blue Alligator Leather Belt','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4429,'Bejeweled Leather Belt','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4430,'Alligator Leather Purse','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4431,'Blue Alligator Leather Purse','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4432,'Bejeweled Purse','false','none',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4433,'Elemental Stone Powder','false','none',10,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4434,'Elemental Stone Shards','false','none',100,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4435,'Elemental Stone Lump','false','none',1000,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4436,'Bentley\'s Request','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4437,'Carson\'s Request','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4438,'Knuckle Duster Edge','false','material',60,'stackable','liquid','none',-1,-1,28044,0,'true','true','true','true','true','none',''),
(4439,'Avadon Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,2900,0,'true','true','true','true','true','none',''),
(4440,'Recipe: Knuckle Duster','false','recipe',30,'stackable','liquid','none',-1,-1,57400,0,'true','true','true','true','true','Recipes',''),
(4441,'Recipe: Avadon Shield','false','recipe',30,'stackable','liquid','none',-1,-1,10900,0,'true','true','true','true','true','Recipes',''),
(4442,'Lottery Ticket','false','lotto',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4443,'Monster Race Ticket - Single','false','race_ticket',20,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4444,'Monster Race Ticket - Double','false','race_ticket',20,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4445,'Dye of STR <Str+1 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4446,'Dye of STR <Str+1 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4447,'Dye of CON <Con+1 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4448,'Dye of CON <Con+1 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4449,'Dye of DEX <Dex+1 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4450,'Dye of DEX <Dex+1 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4451,'Dye of INT <Int+1 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4452,'Dye of INT <Int+1 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4453,'Dye of MEN <Men+1 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4454,'Dye of MEN <Men+1 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4455,'Dye of WIT <Wit+1 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4456,'Dye of WIT <Wit+1 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,5100,0,'true','true','true','true','true','none',''),
(4457,'Dye of STR <Str+1 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4458,'Dye of STR <Str+1 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4459,'Dye of CON <Con+1 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4460,'Dye of CON <Con+1 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4461,'Dye of DEX <Dex+1 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4462,'Dye of DEX <Dex+1 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4463,'Dye of INT <Int+1 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4464,'Dye of INT <Int+1 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4465,'Dye of MEN <Men+1 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4466,'Dye of MEN <Men+1 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4467,'Dye of WIT <Wit+1 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4468,'Dye of WIT <Wit+1 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4469,'Dye of STR <Str+1 Con-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4470,'Dye of STR <Str+1 Dex-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4471,'Dye of CON <Con+1 Str-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4472,'Dye of CON <Con+1 Dex-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4473,'Dye of DEX <Dex+1 Str-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4474,'Dye of DEX <Dex+1 Con-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4475,'Dye of INT <Int+1 Men-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4476,'Dye of INT <Int+1 Wit-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4477,'Dye of MEN <Men+1 Int-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4478,'Dye of MEN <Men+1 Wit-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4479,'Dye of WIT <Wit+1 Int-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4480,'Dye of WIT <Wit+1 Men-1>','false','dye',150,'stackable','liquid','none',-1,-1,42000,0,'true','true','true','true','true','none',''),
(4481,'Greater Dye of STR <Str+1 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4482,'Greater Dye of STR <Str+1 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4483,'Greater Dye of CON<Con+1 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4484,'Greater Dye of CON<Con+1 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4485,'Greater Dye of DEX <Dex+1 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4486,'Greater Dye of DEX <Dex+1 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4487,'Greater Dye of INT <Int+1 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4488,'Greater Dye of INT <Int+1 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4489,'Greater Dye of MEN <Men+1 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4490,'Greater Dye of MEN <Men+1 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4491,'Greater Dye of WIT <Wit+1 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4492,'Greater Dye of WIT <Wit+1 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(4493,'Greater Dye of STR <Str+1 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4494,'Greater Dye of STR <Str+1 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4495,'Greater Dye of CON <Con+1 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4496,'Greater Dye of CON <Con+1 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4497,'Greater Dye of DEX <Dex+1 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4498,'Greater Dye of DEX <Dex+1 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4499,'Greater Dye of INT <Int+1 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4500,'Greater Dye of INT <Int+1 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4501,'Greater Dye of MEN <Men+1 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4502,'Greater Dye of MEN <Men+1 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4503,'Greater Dye of WIT <Wit+1 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4504,'Greater Dye of WIT <Wit+1 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,21000,0,'true','true','true','true','true','none',''),
(4505,'Greater Dye of STR <Str+2 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4506,'Greater Dye of STR <Str+2 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4507,'Greater Dye of CON <Con+2 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4508,'Greater Dye of CON <Con+2 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4509,'Greater Dye of DEX <Dex+2 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4510,'Greater Dye of DEX <Dex+2 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4511,'Greater Dye of INT <Int+2 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4512,'Greater Dye of INT <Int+2 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4513,'Greater Dye of MEN <Men+2 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4514,'Greater Dye of MEN <Men+2 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4515,'Greater Dye of WIT <Wit+2 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4516,'Greater Dye of WIT <Wit+2 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','none',''),
(4517,'Greater Dye of STR <Str+2 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4518,'Greater Dye of STR <Str+2 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4519,'Greater Dye of CON <Con+2 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4520,'Greater Dye of CON <Con+2 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4521,'Greater Dye of DEX <Dex+2 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4522,'Greater Dye of DEX <Dex+2 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4523,'Greater Dye of INT <Int+2 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4524,'Greater Dye of INT <Int+2 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4525,'Greater Dye of MEN <Men+2 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4526,'Greater Dye of MEN <Men+2 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4527,'Greater Dye of WIT <Wit+2 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4528,'Greater Dye of WIT <Wit+2 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,27000,0,'true','true','true','true','true','none',''),
(4529,'Greater Dye of STR <Str+3 Con-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4530,'Greater Dye of STR <Str+3 Dex-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4531,'Greater Dye of CON <Con+3 Str-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4532,'Greater Dye of CON <Con+3 Dex-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4533,'Greater Dye of DEX <Dex+3 Str-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4534,'Greater Dye of DEX <Dex+3 Con-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4535,'Greater Dye of INT <Int+3 Men-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4536,'Greater Dye of INT <Int+3 Wit-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4537,'Greater Dye of MEN <Men+3 Int-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4538,'Greater Dye of MEN <Men+3 Wit-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4539,'Greater Dye of WIT <Wit+3 Int-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4540,'Greater Dye of WIT <Wit+3 Men-5>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4541,'Greater Dye of STR <Str+3 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4542,'Greater Dye of STR <Str+3 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4543,'Greater Dye of CON <Con+3 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4544,'Greater Dye of CON <Con+3 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4545,'Greater Dye of DEX <Dex+3 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4546,'Greater Dye of DEX <Dex+3 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4547,'Greater Dye of INT <Int+3 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4548,'Greater Dye of INT <Int+3 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4549,'Greater Dye of MEN <Men+3 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4550,'Greater Dye of MEN <Men+3 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4551,'Greater Dye of WIT <Wit+3 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4552,'Greater Dye of WIT <Wit+3 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','none',''),
(4553,'Greater Dye of STR <Str+1 Con-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4554,'Greater Dye of STR <Str+1 Dex-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4555,'Greater Dye of CON <Con+1 Str-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4556,'Greater Dye of CON <Con+1 Dex-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4557,'Greater Dye of DEX <Dex+1 Str-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4558,'Greater Dye of DEX <Dex+1 Con-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4559,'Greater Dye of INT <Int+1 Men-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4560,'Greater Dye of INT <Int+1 Wit-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4561,'Greater Dye of MEN <Men+1 Int-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4562,'Greater Dye of MEN <Men+1 Wit-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4563,'Greater Dye of WIT <Wit+1 Int-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4564,'Greater Dye of WIT <Wit+1 Men-1>','false','dye',150,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(4565,'Greater Dye of STR <Str+4 Con-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4566,'Greater Dye of STR <Str+4 Dex-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4567,'Greater Dye of CON <Con+4 Str-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4568,'Greater Dye of CON <Con+4 Dex-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4569,'Greater Dye of DEX <Dex+4 Str-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4570,'Greater Dye of DEX <Dex+4 Con-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4571,'Greater Dye of INT <Int+4 Men-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4572,'Greater Dye of INT <Int+4 Wit-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4573,'Greater Dye of MEN <Men+4 Int-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4574,'Greater Dye of MEN <Men+4 Wit-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4575,'Greater Dye of WIT <Wit+4 Int-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4576,'Greater Dye of WIT <Wit+4 Men-6>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4577,'Greater Dye of STR <Str+4 Con-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4578,'Greater Dye of STR <Str+4 Dex-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4579,'Greater Dye of CON <Con+4 Str-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4580,'Greater Dye of CON <Con+4 Dex-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4581,'Greater Dye of DEX <Dex+4 Str-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4582,'Greater Dye of DEX <Dex+4 Con-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4583,'Greater Dye of INT <Int+4 Men-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4584,'Greater Dye of INT <Int+4 Wit-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4585,'Greater Dye of MEN <Men+4 Int-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4586,'Greater Dye of MEN <Men+4 Wit-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4587,'Greater Dye of WIT <Wit+4 Int-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4588,'Greater Dye of WIT <Wit+4 Men-5>','false','dye',150,'stackable','liquid','none',-1,-1,36000,0,'true','true','true','true','true','none',''),
(4589,'Greater Dye of STR <Str+2 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4590,'Greater Dye of STR <Str+2 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4591,'Greater Dye of CON <Con+2 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4592,'Greater Dye of CON <Con+2 Dex-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4593,'Greater Dye of DEX <Dex+2 Str-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4594,'Greater Dye of DEX <Dex+2 Con-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4595,'Greater Dye of INT <Int+2 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4596,'Greater Dye of INT <Int+2 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4597,'Greater Dye of MEN <Men+2 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4598,'Greater Dye of MEN <Men+2 Wit-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4599,'Greater Dye of WIT <Wit+2 Int-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4600,'Greater Dye of WIT <Wit+2 Men-2>','false','dye',150,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(4601,'Greater Dye of STR <Str+3 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4602,'Greater Dye of STR <Str+3 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4603,'Greater Dye of CON <Con+3 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4604,'Greater Dye of CON <Con+3 Dex-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4605,'Greater Dye of DEX <Dex+3 Str-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4606,'Greater Dye of DEX <Dex+3 Con-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4607,'Greater Dye of INT <Int+3 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4608,'Greater Dye of INT <Int+3 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4609,'Greater Dye of MEN <Men+3 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4610,'Greater Dye of MEN <Men+3 Wit-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4611,'Greater Dye of WIT <Wit+3 Int-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4612,'Greater Dye of WIT <Wit+3 Men-3>','false','dye',150,'stackable','liquid','none',-1,-1,108000,0,'true','true','true','true','true','none',''),
(4613,'Greater Dye of STR <Str+4 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4614,'Greater Dye of STR <Str+4 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4615,'Greater Dye of CON <Con+4 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4616,'Greater Dye of CON <Con+4 Dex-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4617,'Greater Dye of DEX <Dex+4 Str-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4618,'Greater Dye of DEX <Dex+4 Con-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4619,'Greater Dye of INT <Int+4 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4620,'Greater Dye of INT <Int+4 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4621,'Greater Dye of MEN <Men+4 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4622,'Greater Dye of MEN <Men+4 Wit-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4623,'Greater Dye of WIT <Wit+4 Int-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4624,'Greater Dye of WIT <Wit+4 Men-4>','false','dye',150,'stackable','liquid','none',-1,-1,174000,0,'true','true','true','true','true','none',''),
(4625,'Dice (Heart)','false','none',0,'normal','steel','none',-1,-1,500,0,'true','false','true','true','true','RollingDice',''),
(4626,'Dice (Spade)','false','none',0,'normal','steel','none',-1,-1,500,0,'true','false','true','true','true','RollingDice',''),
(4627,'Dice (Clover)','false','none',0,'normal','steel','none',-1,-1,500,0,'true','false','true','true','true','RollingDice',''),
(4628,'Dice (Diamond)','false','none',0,'normal','steel','none',-1,-1,500,0,'true','false','true','true','true','RollingDice',''),
(4629,'Red Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4630,'Red Soul Crystal - Stage 1','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4631,'Red Soul Crystal - Stage 2','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4632,'Red Soul Crystal - Stage 3','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4633,'Red Soul Crystal - Stage 4','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4634,'Red Soul Crystal - Stage 5','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4635,'Red Soul Crystal - Stage 6','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4636,'Red Soul Crystal - Stage 7','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4637,'Red Soul Crystal - Stage 8','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4638,'Red Soul Crystal - Stage 9','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4639,'Red Soul Crystal - Stage 10','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4640,'Green Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4641,'Green Soul Crystal - Stage 1','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4642,'Green Soul Crystal - Stage 2','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4643,'Green Soul Crystal - Stage 3','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4644,'Green Soul Crystal - Stage 4','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4645,'Green Soul Crystal - Stage 5','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4646,'Green Soul Crystal - Stage 6','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4647,'Green Soul Crystal - Stage 7','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4648,'Green Soul Crystal - Stage 8','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4649,'Green Soul Crystal - Stage 9','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4650,'Green Soul Crystal - Stage 10','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4651,'Blue Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4652,'Blue Soul Crystal - Stage 1','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4653,'Blue Soul Crystal - Stage 2','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4654,'Blue Soul Crystal - Stage 3','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4655,'Blue Soul Crystal - Stage 4','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4656,'Blue Soul Crystal - Stage 5','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4657,'Blue Soul Crystal - Stage 6','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4658,'Blue Soul Crystal - Stage 7','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4659,'Blue Soul Crystal - Stage 8','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4660,'Blue Soul Crystal - Stage 9','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4661,'Blue Soul Crystal - Stage 10','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(4662,'Broken Red Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4663,'Broken Green Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4664,'Broken Blue Soul Crystal','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4666,'Reiria\'s Soul Orb','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4667,'Kernon\'s Infernium Scepter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4668,'Golkonda\'s Infernium Scepter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4669,'Hallate\'s Infernium Scepter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4670,'Maestro Reorin\'s Hammer','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4671,'Maestro Reorin\'s Mold','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4672,'Infernium Varnish','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4673,'Red Pipette Knife','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4674,'Medal of Honor','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4675,'Medal of Friendship','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4676,'Medal of Victory','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(4677,'Potion of Critical Escape','false','potion',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2074-1'),
(4678,'Decrease Haste Potion','false','potion',180,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2075-1'),
(4679,'Bless of Eva','false','potion',180,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','ItemSkills','2076-1'),
(4680,'Potion of Revenge','false','potion',180,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4906,'Spellbook: Solar Spark','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(4907,'Spellbook: Solar Flare','false','spellbook',120,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(4908,'Spellbook: Shadow Spark','false','spellbook',120,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(4909,'Spellbook: Shadow Flare','false','spellbook',120,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(4910,'Spellbook: Vampiric Rage','false','spellbook',120,'stackable','paper','none',-1,-1,1800,0,'true','true','true','true','true','none',''),
(4911,'Spellbook: Curse Disease','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(4912,'Spellbook: Benediction','false','spellbook',120,'stackable','paper','none',-1,-1,8200,0,'true','true','true','true','true','none',''),
(4913,'Spellbook: Word of Fear','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4914,'Spellbook: Serenade of Eva','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4915,'Blueprint: Summon Wild Hog Cannon','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(4916,'Spellbook: Energy Bolt','false','spellbook',120,'stackable','paper','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(4917,'Spellbook: Aura Bolt','false','spellbook',120,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(4918,'Spellbook: Summon Kai the Cat','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4919,'Spellbook: Summon Merrow the Unicorn','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4920,'Spellbook: Summon Soulless','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4921,'Blueprint: Summon Big Boom','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(4922,'Spellbook: Summon Binding Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4923,'Spellbook: Summon Aqua Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4924,'Spellbook: Summon Spark Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(4925,'Amulet: Pa\'agrio\'s Haste','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(4926,'Amulet: Soul Guard','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(4927,'Amulet: Chant of Revenge','false','spellbook',120,'stackable','paper','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(4928,'Spellbook: Seed of Fire','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4929,'Spellbook: Seed of Water','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4930,'Spellbook: Seed of Wind','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4931,'Spellbook: Aura Symphony','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4932,'Spellbook: Inferno','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4933,'Spellbook: Blizzard','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4934,'Spellbook: Demon Wind','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(4935,'Spellbook: Elemental Symphony','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(4936,'Recipe: Avadon Shield (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10900,0,'true','true','true','true','true','Recipes',''),
(4937,'Recipe: Adamantite Earrings (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,12120,0,'true','true','true','true','true','Recipes',''),
(4938,'Recipe: Adamantite Ring (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,8080,0,'true','true','true','true','true','Recipes',''),
(4939,'Recipe: Adamantite Necklace (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,16160,0,'true','true','true','true','true','Recipes',''),
(4940,'Recipe: Zubei\'s Breastplate (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,41600,0,'true','true','true','true','true','Recipes',''),
(4941,'Recipe: Zubei\'s Gaiters (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,26000,0,'true','true','true','true','true','Recipes',''),
(4942,'Recipe: Boots of Silence (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4943,'Recipe: Guardian\'s Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4944,'Recipe: Avadon Breastplate (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,41600,0,'true','true','true','true','true','Recipes',''),
(4945,'Recipe: Avadon Gaiters (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,26000,0,'true','true','true','true','true','Recipes',''),
(4946,'Recipe: Zubei\'s Leather Shirt (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,31200,0,'true','true','true','true','true','Recipes',''),
(4947,'Recipe: Zubei\'s Leather Gaiters (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,19460,0,'true','true','true','true','true','Recipes',''),
(4948,'Recipe: Avadon Leather Armor (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,45600,0,'true','true','true','true','true','Recipes',''),
(4949,'Recipe: Tunic of Zubei (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,31200,0,'true','true','true','true','true','Recipes',''),
(4950,'Recipe: Stockings of Zubei (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,19460,0,'true','true','true','true','true','Recipes',''),
(4951,'Recipe: Avadon Robe (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,45600,0,'true','true','true','true','true','Recipes',''),
(4952,'Recipe: Avadon Circlet (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,15560,0,'true','true','true','true','true','Recipes',''),
(4953,'Recipe: Avadon Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4954,'Recipe: Chain Gloves of Silence (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4955,'Recipe: Guardian\'s Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4956,'Recipe: Gloves of Blessing (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4957,'Recipe: Boots of Blessing (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4958,'Recipe: Zubei\'s Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4959,'Recipe: Avadon Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4960,'Recipe: Zubei\'s Gauntlets (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10380,0,'true','true','true','true','true','Recipes',''),
(4961,'Recipe: Zubei\'s Shield (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,10900,0,'true','true','true','true','true','Recipes',''),
(4962,'Recipe: Zubei\'s Helmet (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,15560,0,'true','true','true','true','true','Recipes',''),
(4963,'Recipe: Great Sword (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4964,'Recipe: Heavy War Axe (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4965,'Recipe: Sprite\'s Staff (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4966,'Recipe: Keshanberk (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4967,'Recipe: Sword of Valhalla (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4968,'Recipe: Kris (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4969,'Recipe: Hell Knife (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4970,'Recipe: Arthro Nail (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4971,'Recipe: Dark Elven Long Bow (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(4972,'Recipe: Great Axe (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4973,'Recipe: Earring of Black Ore (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,18480,0,'true','true','true','true','true','Recipes',''),
(4974,'Recipe: Ring of Black Ore (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,12320,0,'true','true','true','true','true','Recipes',''),
(4975,'Recipe: Necklace of Black Ore (70%)','false','recipe',30,'stackable','liquid','none',-1,-1,24600,0,'true','true','true','true','true','Recipes',''),
(4976,'Recipe: Implosion Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4977,'Recipe: Paradia Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4978,'Recipe: Elemental Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4979,'Recipe: Boots of Grace (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4980,'Recipe: Doom Shield (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16900,0,'true','true','true','true','true','Recipes',''),
(4981,'Recipe: Blue Wolf Breastplate (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,64400,0,'true','true','true','true','true','Recipes',''),
(4982,'Recipe: Blue Wolf Gaiters (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,40200,0,'true','true','true','true','true','Recipes',''),
(4983,'Recipe: Doom Plate Armor (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,94200,0,'true','true','true','true','true','Recipes',''),
(4984,'Recipe: Blue Wolf Leather Armor (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,70600,0,'true','true','true','true','true','Recipes',''),
(4985,'Recipe: Leather Armor of Doom (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,70600,0,'true','true','true','true','true','Recipes',''),
(4986,'Recipe: Blue Wolf Tunic (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,48200,0,'true','true','true','true','true','Recipes',''),
(4987,'Recipe: Tunic of Doom (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,48200,0,'true','true','true','true','true','Recipes',''),
(4988,'Recipe: Blue Wolf Stockings (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,30200,0,'true','true','true','true','true','Recipes',''),
(4989,'Recipe: Stockings of Doom (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,30200,0,'true','true','true','true','true','Recipes',''),
(4990,'Recipe: Blue Wolf Helmet (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,24200,0,'true','true','true','true','true','Recipes',''),
(4991,'Recipe: Doom Helmet (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,24200,0,'true','true','true','true','true','Recipes',''),
(4992,'Recipe: Blue Wolf Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4993,'Recipe: Doom Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4994,'Recipe: Elemental Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4995,'Recipe: Gloves of Grace (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4996,'Recipe: Implosion Gauntlets (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4997,'Recipe: Paradia Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(4998,'Recipe: Blue Wolf Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(4999,'Recipe: Doom Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,16080,0,'true','true','true','true','true','Recipes',''),
(5000,'Recipe: Sword of Damascus (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5001,'Recipe: Lance (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5002,'Recipe: Deadman\'s Glory (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5003,'Recipe: Art of Battle Axe (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5004,'Recipe: Staff of Evil Spirits (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5005,'Recipe: Demon Dagger (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5006,'Recipe: Bellion Cestus (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5007,'Recipe: Bow of Peril (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(5008,'Recipe: Pata (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5009,'Trophy of Alliance','false','none',0,'normal','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5010,'Echo Crystal - Theme of Victory','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2066-1'),
(5011,'Star of Destiny','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(5012,'Leikan\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5013,'Spellbook: Elemental Assault','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(5014,'Spellbook: Elemental Symphony','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(5015,'Spellbook: Elemental Storm','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(5016,'Seed: Dark Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5017,'Seed: Red Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5018,'Seed: Chilly Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5019,'Seed: Blue Coda','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5020,'Seed: Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5021,'Seed: Lute Coda','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(5022,'Seed: Desert Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5023,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5024,'Seed: Blue Coda','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5025,'Seed: Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5026,'Seed: Lute Coda','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(5027,'Seed: Desert Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5028,'Seed: Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5029,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5030,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5031,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5032,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5033,'Seed: Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5034,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5035,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5036,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5037,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5038,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5039,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5040,'Seed: Twin Codra','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5041,'Seed: Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(5042,'Seed: Dark Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5043,'Seed: Red Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5044,'Seed: Blue Coda','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5045,'Seed: Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5046,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5047,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5048,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5049,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5050,'Seed: Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5051,'Seed: Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5052,'Seed: Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5053,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5054,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5055,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5056,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5057,'Seed: Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5058,'Seed: Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5059,'Seed: Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5060,'Seed: Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(5061,'Seed: Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(5062,'Trash','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5063,'Trash','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5064,'Trash','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5065,'Chilly Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none','');

INSERT INTO `etcitem` VALUES
(5066,'Burning Coda','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5067,'Blue Coda','false','none',2,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5068,'Red Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(5069,'Golden Coda','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5070,'Desert Coda','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5071,'Lute Coda','false','none',2,'stackable','paper','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(5072,'Twin Coda','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5073,'Dark Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(5074,'Shining Coda','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5075,'Chilly Cobol','false','none',2,'stackable','paper','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(5076,'Burning Cobol','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5077,'Blue Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5078,'Red Cobol','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5079,'Golden Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5080,'Desert Cobol','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5081,'Sea Cobol','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5082,'Thorn Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5083,'Dapple Cobol','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5084,'Great Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5085,'Chilly Codran','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5086,'Burning Codran','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5087,'Blue Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5088,'Red Codran','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5089,'Dapple Codran','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5090,'Desert Codran','false','none',2,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(5091,'Sea Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5092,'Twin Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5093,'Thorn Codran','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5094,'Great Codran','false','none',2,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','none',''),
(5095,'Mature Chilly Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5096,'Mature Burning Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5097,'Mature Blue Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5098,'Mature Red Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5099,'Mature Golden Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5100,'Mature Desert Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5101,'Mature Lute Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5102,'Mature Twin Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5103,'Mature Dark Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5104,'Mature Shining Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5105,'Mature Chilly Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5106,'Mature Burning Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5107,'Mature Blue Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5108,'Mature Red Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5109,'Mature Golden Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5110,'Mature Desert Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5111,'Mature Sea Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5112,'Mature Thorn Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5113,'Mature Dapple Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5114,'Mature Great Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5115,'Mature Chilly Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5116,'Mature Burning Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5117,'Mature Blue Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5118,'Mature Red Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5119,'Mature Dapple Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5120,'Mature Desert Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5121,'Mature Sea Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5122,'Mature Twin Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5123,'Mature Thorn Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5124,'Mature Great Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5125,'Harvester','false','harvest',20,'normal','steel','none',-1,-1,500,0,'true','true','true','true','true','Harvester','2098-1'),
(5126,'Dualsword Craft Stamp','false','none',20,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(5134,'Compressed Package of Soulshots: No Grade','false','shot',600,'normal','steel','none',-1,-1,2300,0,'true','true','true','true','true','ItemSkills','2078-1'),
(5135,'Compressed Package of Soulshots: D-grade','false','shot',450,'normal','steel','none',-1,-1,3300,0,'true','true','true','true','true','ItemSkills','2079-1'),
(5136,'Compressed Package of Soulshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,4950,0,'true','true','true','true','true','ItemSkills','2080-1'),
(5137,'Compressed Package of Soulshots: B-grade','false','shot',300,'normal','steel','none',-1,-1,16500,0,'true','true','true','true','true','ItemSkills','2081-1'),
(5138,'Compressed Package of Soulshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,26400,0,'true','true','true','true','true','ItemSkills','2082-1'),
(5139,'Compressed Package of Soulshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,33000,0,'true','true','true','true','true','ItemSkills','2083-1'),
(5140,'Compressed Package of Spiritshots: No Grade','false','shot',750,'normal','steel','none',-1,-1,4950,0,'true','true','true','true','true','ItemSkills','2084-1'),
(5141,'Compressed Package of Spiritshots: D-grade','false','shot',750,'normal','steel','none',-1,-1,5940,0,'true','true','true','true','true','ItemSkills','2085-1'),
(5142,'Compressed Package of Spiritshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,11550,0,'true','true','true','true','true','ItemSkills','2086-1'),
(5143,'Compressed Package of Spiritshots: B-grade','false','shot',450,'normal','steel','none',-1,-1,33000,0,'true','true','true','true','true','ItemSkills','2087-1'),
(5144,'Compressed Package of Spiritshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,39600,0,'true','true','true','true','true','ItemSkills','2088-1'),
(5145,'Compressed Package of Spiritshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,49500,0,'true','true','true','true','true','ItemSkills','2089-1'),
(5146,'Compressed Package of Blessed Spiritshots: No Grade','false','shot',750,'normal','steel','none',-1,-1,11550,0,'true','true','true','true','true','ItemSkills','2090-1'),
(5147,'Compressed Package of Blessed Spiritshots: D-grade','false','shot',750,'normal','steel','none',-1,-1,14850,0,'true','true','true','true','true','ItemSkills','2091-1'),
(5148,'Compressed Package of Blessed Spiritshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,29700,0,'true','true','true','true','true','ItemSkills','2092-1'),
(5149,'Compressed Package of Blessed Spiritshots: B-grade','false','shot',450,'normal','steel','none',-1,-1,80850,0,'true','true','true','true','true','ItemSkills','2093-1'),
(5150,'Compressed Package of Blessed Spiritshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,95700,0,'true','true','true','true','true','ItemSkills','2094-1'),
(5151,'Compressed Package of Blessed Spiritshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,115500,0,'true','true','true','true','true','ItemSkills','2095-1'),
(5152,'Magic Compressor','false','none',10,'normal','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5153,'Recipe: Soulshot (D) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(5154,'Recipe: Soulshot (C) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,25000,0,'true','true','true','true','true','Recipes',''),
(5155,'Recipe: Soulshot (B) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(5156,'Recipe: Soulshot (A) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(5157,'Recipe: Soulshot (S) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,250000,0,'true','true','true','true','true','Recipes',''),
(5158,'Recipe: Spiritshot (D) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(5159,'Recipe: Spiritshot (C) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,25000,0,'true','true','true','true','true','Recipes',''),
(5160,'Recipe: Spiritshot (B) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(5161,'Recipe: Spiritshot (A) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(5162,'Recipe: Spiritshot (S) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,250000,0,'true','true','true','true','true','Recipes',''),
(5163,'Recipe: Blessed Spiritshot (D) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,30000,0,'true','true','true','true','true','Recipes',''),
(5164,'Recipe: Blessed Spiritshot (C) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(5165,'Recipe: Blessed Spiritshot (B) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(5166,'Recipe: Blessed Spiritshot (A) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,180000,0,'true','true','true','true','true','Recipes',''),
(5167,'Recipe: Blessed Spiritshot (S) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,290000,0,'true','true','true','true','true','Recipes',''),
(5168,'Food for Strider','false','none',10,'stackable','liquid','none',-1,-1,216,0,'true','true','true','true','true','PetFood','2101-1'),
(5169,'Deluxe Food for Strider','false','none',10,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','PetFood','2102-1'),
(5192,'Rope of Magic: D-Grade','false','none',2,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5193,'Rope of Magic: C-Grade','false','none',2,'stackable','paper','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(5194,'Rope of Magic: B-Grade','false','none',2,'stackable','paper','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(5195,'Rope of Magic: A-Grade','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5196,'Rope of Magic: S Grade','false','none',2,'stackable','paper','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(5197,'Chest Key - Grade 8','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5198,'Chest Key - Grade 7','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5199,'Chest Key - Grade 6','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5200,'Chest Key - Grade 5','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5201,'Chest Key - Grade 4','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5202,'Chest Key - Grade 3','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5203,'Chest Key - Grade 2','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5204,'Chest Key - Grade 1','false','none',10,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','none',''),
(5205,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5206,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5207,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5208,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5209,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5210,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5211,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5212,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5213,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5214,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5215,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5218,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5219,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(5220,'Metal Hardener','false','material',2,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(5221,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5222,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5223,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5224,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5225,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5226,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5227,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5228,'Trash','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5229,'Trash','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5230,'Recipe: Mithril Arrow (100%)','false','recipe',30,'stackable','paper','none',-1,-1,80000,0,'true','true','true','true','true','Recipes',''),
(5231,'Recipe: Metal Hardener (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(5232,'White Fabric','false','quest',0,'stackable','cloth','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5234,'Mystery Potion','false','potion',50,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','ItemSkills','2103-1'),
(5235,'Facelifting Potion - A','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2122-1'),
(5236,'Facelifting Potion - B','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2123-1'),
(5237,'Facelifting Potion - C','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2124-1'),
(5238,'Dye Potion - A','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2125-1'),
(5239,'Dye Potion - B','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2126-1'),
(5240,'Dye Potion - C','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2127-1'),
(5241,'Dye Potion - D','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2128-1'),
(5242,'Hair Style Change Potion - A','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2129-1'),
(5243,'Hair Style Change Potion - B','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2130-1'),
(5244,'Hair Style Change Potion - C','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2131-1'),
(5245,'Hair Style Change Potion - D','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2132-1'),
(5246,'Hair Style Change Potion - E','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2133-1'),
(5247,'Hair Style Change Potion - F','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2134-1'),
(5248,'Hair Style Change Potion - G','false','potion',50,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2135-1'),
(5249,'Commemorative Item: First Anniversary of Lineage II Service','false','none',0,'normal','cloth','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(5250,'Greater Compressed Package of Soulshots: No-grade','false','shot',600,'normal','steel','none',-1,-1,7700,0,'true','true','true','true','true','ItemSkills','2104-1'),
(5251,'Greater Compressed Package of Soulshots: D-grade','false','shot',450,'normal','steel','none',-1,-1,11000,0,'true','true','true','true','true','ItemSkills','2105-1'),
(5252,'Greater Compressed Package of Soulshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,16500,0,'true','true','true','true','true','ItemSkills','2106-1'),
(5253,'Greater Compressed Package of Soulshots: B-grade','false','shot',300,'normal','steel','none',-1,-1,55000,0,'true','true','true','true','true','ItemSkills','2107-1'),
(5254,'Greater Compressed Package of Soulshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,88000,0,'true','true','true','true','true','ItemSkills','2108-1'),
(5255,'Greater Compressed Package of Soulshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,120000,0,'true','true','true','true','true','ItemSkills','2109-1'),
(5256,'Greater Compressed Package of Spiritshots: No-grade','false','shot',750,'normal','steel','none',-1,-1,16500,0,'true','true','true','true','true','ItemSkills','2110-1'),
(5257,'Greater Compressed Package of Spiritshots: D-grade','false','shot',750,'normal','steel','none',-1,-1,19800,0,'true','true','true','true','true','ItemSkills','2111-1'),
(5258,'Greater Compressed Package of Spiritshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,38500,0,'true','true','true','true','true','ItemSkills','2112-1'),
(5259,'Greater Compressed Package of Spiritshots: B-grade','false','shot',450,'normal','steel','none',-1,-1,110000,0,'true','true','true','true','true','ItemSkills','2113-1'),
(5260,'Greater Compressed Package of Spiritshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,132000,0,'true','true','true','true','true','ItemSkills','2114-1'),
(5261,'Greater Compressed Package of Spiritshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,180000,0,'true','true','true','true','true','ItemSkills','2115-1'),
(5262,'Greater Compressed Package of Blessed Spiritshots: No-grade','false','shot',750,'normal','steel','none',-1,-1,38500,0,'true','true','true','true','true','ItemSkills','2116-1'),
(5263,'Greater Compressed Package of Blessed Spiritshots: D-grade','false','shot',750,'normal','steel','none',-1,-1,49500,0,'true','true','true','true','true','ItemSkills','2117-1'),
(5264,'Greater Compressed Package of Blessed Spiritshots: C-grade','false','shot',450,'normal','steel','none',-1,-1,99000,0,'true','true','true','true','true','ItemSkills','2118-1'),
(5265,'Greater Compressed Package of Blessed Spiritshots: B-grade','false','shot',450,'normal','steel','none',-1,-1,269500,0,'true','true','true','true','true','ItemSkills','2119-1'),
(5266,'Greater Compressed Package of Blessed Spiritshots: A-grade','false','shot',300,'normal','steel','none',-1,-1,319000,0,'true','true','true','true','true','ItemSkills','2120-1'),
(5267,'Greater Compressed Package of Blessed Spiritshots: S-grade','false','shot',300,'normal','steel','none',-1,-1,419000,0,'true','true','true','true','true','ItemSkills','2121-1'),
(5268,'Recipe: Greater Soulshot (D) Compressed Package (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(5269,'Recipe: Greater Soulshot (C) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(5270,'Recipe: Greater Soulshot (B) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(5271,'Recipe: Greater Soulshot (A) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(5272,'Recipe: Greater Soulshot (S) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,250000,0,'true','true','true','true','true','Recipes',''),
(5273,'Recipe: Greater Spiritshot (D) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','Recipes',''),
(5274,'Recipe: Greater Spiritshot (C) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','Recipes',''),
(5275,'Recipe: Greater Spiritshot (B) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(5276,'Recipe: Greater Spiritshot (A) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,150000,0,'true','true','true','true','true','Recipes',''),
(5277,'Recipe: Greater Spiritshot (S) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,250000,0,'true','true','true','true','true','Recipes',''),
(5278,'Recipe: Greater Blessed Spiritshot (D) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,8000,0,'true','true','true','true','true','Recipes',''),
(5279,'Recipe: Greater Blessed Spiritshot (C) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,80000,0,'true','true','true','true','true','Recipes',''),
(5280,'Recipe: Greater Blessed Spiritshot (B) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,130000,0,'true','true','true','true','true','Recipes',''),
(5281,'Recipe: Greater Blessed Spiritshot (A) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,170000,0,'true','true','true','true','true','Recipes',''),
(5282,'Recipe: Greater Blessed Spiritshot (S) Compressed Package(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,285000,0,'true','true','true','true','true','Recipes',''),
(5283,'Rice Cake','false','potion',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5332,'Recipe: Sealed Dark Crystal Leather Armor(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,69400,0,'true','true','true','true','true','Recipes',''),
(5333,'Recipe: Sealed Dark Crystal Leather Armor(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5334,'Recipe: Sealed Tallum Leather Armor(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,101600,0,'true','true','true','true','true','Recipes',''),
(5335,'Recipe: Sealed Tallum Leather Armor(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5336,'Recipe: Sealed Leather Armor of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,154600,0,'true','true','true','true','true','Recipes',''),
(5337,'Recipe: Sealed Leather Armor of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5338,'Recipe: Sealed Majestic Leather Armor(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,154600,0,'true','true','true','true','true','Recipes',''),
(5339,'Recipe: Sealed Majestic Leather Armor(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5340,'Recipe: Sealed Dark Crystal Leggings(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,43400,0,'true','true','true','true','true','Recipes',''),
(5341,'Recipe: Sealed Dark Crystal Leggings(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5342,'Echo Crystal - Sad Song','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5343,'Echo Crystal - Holy Song','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5344,'Recipe: Inferno Earring(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5345,'Recipe: Inferno Earring(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5346,'Recipe: Sealed Tallum Tunic(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,69400,0,'true','true','true','true','true','Recipes',''),
(5347,'Recipe: Sealed Tallum Tunic(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5348,'Recipe: Sealed Dark Crystal Robe(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,101600,0,'true','true','true','true','true','Recipes',''),
(5349,'Recipe: Sealed Dark Crystal Robe(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5350,'Recipe: Sealed Nightmare Robe(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,154600,0,'true','true','true','true','true','Recipes',''),
(5351,'Recipe: Sealed Nightmare Robe(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5352,'Recipe: Sealed Majestic Robe(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,154600,0,'true','true','true','true','true','Recipes',''),
(5353,'Recipe: Sealed Majestic Robe(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5354,'Recipe: Sealed Tallum Stockings(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,43400,0,'true','true','true','true','true','Recipes',''),
(5355,'Recipe: Sealed Tallum Stockings(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5356,'Recipe: Phoenix Necklace(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5357,'Recipe: Phoenix Necklace(100%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5358,'Recipe: Inferno Necklace(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5359,'Recipe: Inferno Necklace(100%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5360,'Recipe: Phoenix Ring(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5361,'Recipe: Phoenix Ring(100%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5362,'Recipe: Inferno Ring(70%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5363,'Recipe: Inferno Ring(100%)','false','recipe',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5364,'Recipe: Sealed Dark Crystal Shield(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,24400,0,'true','true','true','true','true','Recipes',''),
(5365,'Recipe: Sealed Dark Crystal Shield(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5366,'Recipe: Sealed Shield of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,37000,0,'true','true','true','true','true','Recipes',''),
(5367,'Recipe: Sealed Shield of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5368,'Recipe: Sealed Dark Crystal Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,23200,0,'true','true','true','true','true','Recipes',''),
(5369,'Recipe: Sealed Dark Crystal Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5370,'Recipe: Sealed Tallum Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,23200,0,'true','true','true','true','true','Recipes',''),
(5371,'Recipe: Sealed Tallum Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5372,'Recipe: Sealed Boots of The Underworld(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5373,'Recipe: Sealed Boots of The Underworld(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5374,'Recipe: Sealed Gust Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5375,'Recipe: Sealed Gust Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5376,'Recipe: Sealed Red Flame Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5377,'Recipe: Sealed Red Flame Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5378,'Recipe: Sealed Phoenix Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5379,'Recipe: Sealed Phoenix Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5380,'Recipe: Sealed Boots of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,35200,0,'true','true','true','true','true','Recipes',''),
(5381,'Recipe: Sealed Boots of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5382,'Recipe: Sealed Majestic Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,35200,0,'true','true','true','true','true','Recipes',''),
(5383,'Recipe: Sealed Majestic Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5384,'Recipe: Sealed Dark Legion Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5385,'Recipe: Sealed Dark Legion Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5386,'Recipe: Sealed Boots of Phantom(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5387,'Recipe: Sealed Boots of Phantom(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5388,'Recipe: Sealed Cerberus Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5389,'Recipe: Sealed Cerberus Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5390,'Recipe: Sealed Dasparion\'s Boots Boots(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5391,'Recipe: Sealed Dasparion\'s Boots Boots(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5392,'Recipe: Sealed Dark Crystal Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,23200,0,'true','true','true','true','true','Recipes',''),
(5393,'Recipe: Sealed Dark Crystal Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5394,'Recipe: Sealed Tallum Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,23200,0,'true','true','true','true','true','Recipes',''),
(5395,'Recipe: Sealed Tallum Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5396,'Recipe: Sealed Gloves of The Underworld(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5397,'Recipe: Sealed Gloves of The Underworld(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5398,'Recipe: Sealed Gust Bracer(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5399,'Recipe: Sealed Gust Bracer(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5400,'Recipe: Sealed Gloves of Black Ore(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5401,'Recipe: Sealed Gloves of Black Ore(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5402,'Recipe: Sealed Phoenix Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5403,'Recipe: Sealed Phoenix Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5404,'Recipe: Sealed Gauntlets of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,35200,0,'true','true','true','true','true','Recipes',''),
(5405,'Recipe: Sealed Gauntlets of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5406,'Recipe: Sealed Majestic Gauntlets(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,35200,0,'true','true','true','true','true','Recipes',''),
(5407,'Recipe: Sealed Majestic Gauntlets(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5408,'Recipe: Sealed Dark Legion Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5409,'Recipe: Sealed Dark Legion Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5410,'Recipe: Sealed Gloves of Phantom(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5411,'Recipe: Sealed Gloves of Phantom(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5412,'Recipe: Sealed Cerberus Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5413,'Recipe: Sealed Cerberus Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5414,'Recipe: Sealed Dasparion\'s Gloves(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5415,'Recipe: Sealed Dasparion\'s Gloves(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5416,'Recipe: Sealed Dark Crystal Breastplate(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,92600,0,'true','true','true','true','true','Recipes',''),
(5417,'Recipe: Sealed Dark Crystal Breastplate(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5418,'Recipe: Sealed Tallum Plate Armor(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,135400,0,'true','true','true','true','true','Recipes',''),
(5419,'Recipe: Sealed Tallum Plate Armor(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5420,'Recipe: Sealed Armor of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,206000,0,'true','true','true','true','true','Recipes',''),
(5421,'Recipe: Sealed Armor of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5422,'Recipe: Sealed Majestic Plate Armor(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,206000,0,'true','true','true','true','true','Recipes',''),
(5423,'Recipe: Sealed Majestic Plate Armor(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5424,'Recipe: Sealed Dark Crystal Gaiters(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,57800,0,'true','true','true','true','true','Recipes',''),
(5425,'Recipe: Sealed Dark Crystal Gaiters(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5426,'Recipe: Sealed Dark Crystal Helmet(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,34800,0,'true','true','true','true','true','Recipes',''),
(5427,'Recipe: Sealed Dark Crystal Helmet(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5428,'Recipe: Sealed Tallum Helmet(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,34800,0,'true','true','true','true','true','Recipes',''),
(5429,'Recipe: Sealed Tallum Helmet(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5430,'Recipe: Sealed Helm of Nightmare(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,52800,0,'true','true','true','true','true','Recipes',''),
(5431,'Recipe: Sealed Helm of Nightmare(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5432,'Recipe: Sealed Majestic Circlet (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,52800,0,'true','true','true','true','true','Recipes',''),
(5433,'Recipe: Sealed Majestic Circlet (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5434,'Recipe: Dragon Slayer(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5435,'Recipe: Dragon Slayer(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5436,'Recipe: Berserker Blade(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(5437,'Recipe: Heavy Sword(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(5438,'Recipe: Meteor Shower(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5439,'Recipe: Meteor Shower(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5440,'Recipe: Elysian(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5441,'Recipe: Elysian(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5442,'Recipe: Soul Bow(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5443,'Recipe: Soul Bow(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5444,'Recipe: Carnage Bow(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5445,'Recipe: Carnage Bow(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5446,'Recipe: Bloody Orchid(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5447,'Recipe: Bloody Orchid(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5448,'Recipe: Soul Separator(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5449,'Recipe: Soul Separator(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5450,'Recipe: Dragon Grinder(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5451,'Recipe: Dragon Grinder(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5452,'Recipe: Blood Tornado(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5453,'Recipe: Blood Tornado(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5454,'Recipe: Orcish Halberd(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5455,'Recipe: Orcish Halberd(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5456,'Recipe: Tallum Glaive(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5457,'Recipe: Tallum Glaive(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5458,'Recipe: Halberd(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5459,'Recipe: Halberd(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5460,'Recipe: Dasparion\'s Staff(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5461,'Recipe: Dasparion\'s Staff(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5462,'Recipe: Branch of The Mother Tree(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5463,'Recipe: Branch of The Mother Tree(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5464,'Recipe: Dark Legion\'s Edge(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5465,'Recipe: Dark Legion\'s Edge(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5466,'Recipe: Sword of Miracles(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(5467,'Recipe: Sword of Miracles(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5468,'Recipe: Elemental Sword(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5469,'Recipe: Elemental Sword(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5470,'Recipe: Tallum Blade(60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(5471,'Recipe: Tallum Blade(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5472,'Recipe: Metallic Thread(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(5473,'Recipe: Durable Metal Plate(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,2800,0,'true','true','true','true','true','Recipes',''),
(5474,'Recipe: Reorin\'s Mold(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5475,'Recipe: Warsmith\'s Mold(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5476,'Recipe: Arcsmith\'s Anvil(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5477,'Recipe: Warsmith\'s Holder(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(5478,'Sealed Dark Crystal Leather Armor Pattern','false','material',60,'stackable','liquid','none',-1,-1,23784,0,'true','true','true','true','true','none',''),
(5479,'Sealed Tallum Leather Armor Pattern','false','material',60,'stackable','liquid','none',-1,-1,33800,0,'true','true','true','true','true','none',''),
(5480,'Sealed Leather Armor of Nightmare Fabric','false','material',60,'stackable','liquid','none',-1,-1,44571,0,'true','true','true','true','true','none',''),
(5481,'Sealed Majestic Leather Armor Fabric','false','material',60,'stackable','liquid','none',-1,-1,44571,0,'true','true','true','true','true','none',''),
(5482,'Sealed Dark Crystal Leggings Design','false','material',60,'stackable','liquid','none',-1,-1,15153,0,'true','true','true','true','true','none',''),
(5483,'Phoenix Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5484,'Inferno Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5485,'Sealed Tallum Tunic Texture','false','material',60,'stackable','liquid','none',-1,-1,23784,0,'true','true','true','true','true','none',''),
(5486,'Sealed Dark Crystal Robe Fabric','false','material',60,'stackable','liquid','none',-1,-1,33800,0,'true','true','true','true','true','none',''),
(5487,'Sealed Nightmare Robe Fabric','false','material',60,'stackable','liquid','none',-1,-1,44414,0,'true','true','true','true','true','none',''),
(5488,'Sealed Majestic Robe Fabric','false','material',60,'stackable','liquid','none',-1,-1,44414,0,'true','true','true','true','true','none',''),
(5489,'Sealed Tallum Stockings Fabric','false','material',60,'stackable','liquid','none',-1,-1,15153,0,'true','true','true','true','true','none',''),
(5490,'Phoenix Necklace Beads','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5491,'Inferno Necklace Beads','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5492,'Phoenix Ring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5493,'Inferno Ring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5494,'Sealed Dark Crystal Shield Fragment','false','material',60,'stackable','liquid','none',-1,-1,9523,0,'true','true','true','true','true','none',''),
(5495,'Sealed Shield of Nightmare Fragment','false','material',60,'stackable','liquid','none',-1,-1,13171,0,'true','true','true','true','true','none',''),
(5496,'Sealed Dark Crystal Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,8530,0,'true','true','true','true','true','none',''),
(5497,'Sealed Tallum Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,8530,0,'true','true','true','true','true','none',''),
(5498,'Sealed Boots of the Underworld Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5499,'Sealed Gust Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5500,'Sealed Red Flame Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5501,'Sealed Phoenix Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5502,'Sealed Boots of Nightmare Lining','false','material',60,'stackable','liquid','none',-1,-1,11842,0,'true','true','true','true','true','none',''),
(5503,'Sealed Majestic Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,11842,0,'true','true','true','true','true','none',''),
(5504,'Sealed Dark Legion Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5505,'Sealed Boots of Phantom Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5506,'Sealed Cerberus Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5507,'Sealed Dasparion\'s Boots Lining','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5508,'Sealed Dark Crystal Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,8530,0,'true','true','true','true','true','none',''),
(5509,'Sealed Tallum Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,8530,0,'true','true','true','true','true','none',''),
(5510,'Sealed Gloves of the Underworld Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5511,'Sealed Gust Bracer design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5512,'Sealed Gloves of Black Ore Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5513,'Sealed Phoenix Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5514,'Sealed Gauntlets of Nightmare Design','false','material',60,'stackable','liquid','none',-1,-1,11842,0,'true','true','true','true','true','none',''),
(5515,'Sealed Majestic Gauntlets Design','false','material',60,'stackable','liquid','none',-1,-1,11842,0,'true','true','true','true','true','none',''),
(5516,'Sealed Dark Legion Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5517,'Sealed Gloves of Phantom Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5518,'Sealed Cerberus Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5519,'Sealed Dasparion\'s Gloves Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5520,'Sealed Dark Crystal Breastplate Pattern','false','material',60,'stackable','liquid','none',-1,-1,31015,0,'true','true','true','true','true','none',''),
(5521,'Sealed Tallum Plate Armor Pattern','false','material',60,'stackable','liquid','none',-1,-1,43953,0,'true','true','true','true','true','none',''),
(5522,'Sealed Armor of Nightmare Pattern','false','material',60,'stackable','liquid','none',-1,-1,58728,0,'true','true','true','true','true','none',''),
(5523,'Sealed Majestic Plate Armor Pattern','false','material',60,'stackable','liquid','none',-1,-1,58728,0,'true','true','true','true','true','none',''),
(5524,'Sealed Dark Crystal Gaiters Pattern','false','material',60,'stackable','liquid','none',-1,-1,20292,0,'true','true','true','true','true','none',''),
(5525,'Sealed Dark Crystal Helmet Design','false','material',60,'stackable','liquid','none',-1,-1,12938,0,'true','true','true','true','true','none',''),
(5526,'Sealed Tallum Helm Design','false','material',60,'stackable','liquid','none',-1,-1,12938,0,'true','true','true','true','true','none',''),
(5527,'Sealed Helm of Nightmare Design','false','material',60,'stackable','liquid','none',-1,-1,16728,0,'true','true','true','true','true','none',''),
(5528,'Sealed Majestic Circlet Design','false','material',60,'stackable','liquid','none',-1,-1,16728,0,'true','true','true','true','true','none',''),
(5529,'Dragon Slayer Edge','false','material',60,'stackable','liquid','none',-1,-1,72900,0,'true','true','true','true','true','none',''),
(5530,'Berserker Blade Edge','false','material',60,'stackable','liquid','none',-1,-1,43600,0,'true','true','true','true','true','none',''),
(5531,'Heavy Sword Edge','false','material',60,'stackable','liquid','none',-1,-1,11912,0,'true','true','true','true','true','none',''),
(5532,'Meteor Shower Head','false','material',60,'stackable','liquid','none',-1,-1,59308,0,'true','true','true','true','true','none',''),
(5533,'Elysian Head','false','material',60,'stackable','liquid','none',-1,-1,72914,0,'true','true','true','true','true','none',''),
(5534,'Soul Bow Stave','false','material',60,'stackable','liquid','none',-1,-1,72850,0,'true','true','true','true','true','none',''),
(5535,'Carnage Bow Stave','false','material',60,'stackable','liquid','none',-1,-1,58615,0,'true','true','true','true','true','none',''),
(5536,'Bloody Orchid Head','false','material',60,'stackable','liquid','none',-1,-1,58785,0,'true','true','true','true','true','none',''),
(5537,'Soul Separator Head','false','material',60,'stackable','liquid','none',-1,-1,72900,0,'true','true','true','true','true','none',''),
(5538,'Dragon Grinder Edge','false','material',60,'stackable','liquid','none',-1,-1,72914,0,'true','true','true','true','true','none',''),
(5539,'Blood Tornado Edge','false','material',60,'stackable','liquid','none',-1,-1,59308,0,'true','true','true','true','true','none',''),
(5540,'Orcish Halberd Edge','false','material',60,'stackable','liquid','none',-1,-1,62500,0,'true','true','true','true','true','none',''),
(5541,'Tallum Glaive Edge','false','material',60,'stackable','liquid','none',-1,-1,72929,0,'true','true','true','true','true','none',''),
(5542,'Halberd Edge','false','material',60,'stackable','liquid','none',-1,-1,59308,0,'true','true','true','true','true','none',''),
(5543,'Dasparion\'s Staff Edge','false','material',60,'stackable','liquid','none',-1,-1,58754,0,'true','true','true','true','true','none',''),
(5544,'Branch of The Mother Tree Head','false','material',60,'stackable','liquid','none',-1,-1,72986,0,'true','true','true','true','true','none',''),
(5545,'Dark Legion\'s Edge Blade','false','material',60,'stackable','liquid','none',-1,-1,72900,0,'true','true','true','true','true','none',''),
(5546,'Sword of Miracles Edge','false','material',60,'stackable','liquid','none',-1,-1,66369,0,'true','true','true','true','true','none',''),
(5547,'Elemental Sword Edge','false','material',60,'stackable','liquid','none',-1,-1,58785,0,'true','true','true','true','true','none',''),
(5548,'Tallum Blade Edge','false','material',60,'stackable','liquid','none',-1,-1,58785,0,'true','true','true','true','true','none',''),
(5549,'Metallic Thread','false','material',2,'stackable','liquid','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(5550,'Durable Metal Plate','false','material',2,'stackable','liquid','none',-1,-1,15000,0,'true','true','true','true','true','none',''),
(5551,'Leolin\'s Mold','false','material',2,'stackable','liquid','none',-1,-1,238000,0,'true','true','true','true','true','none',''),
(5552,'Warsmith\'s Mold','false','material',2,'stackable','liquid','none',-1,-1,385000,0,'true','true','true','true','true','none',''),
(5553,'Arcsmith\'s Anvil','false','material',2,'stackable','liquid','none',-1,-1,531200,0,'true','true','true','true','true','none',''),
(5554,'Warsmith\'s Holder','false','material',2,'stackable','liquid','none',-1,-1,884000,0,'true','true','true','true','true','none',''),
(5555,'Token of Love','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','SpecialXMas',''),
(5556,'Star Ornament','false','material',0,'stackable','liquid','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(5557,'Bead Ornament','false','material',0,'stackable','liquid','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(5558,'Fir Tree Branch','false','material',0,'stackable','liquid','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(5559,'Flower Pot','false','material',0,'stackable','liquid','none',-1,-1,1,0,'true','true','true','true','true','none',''),
(5560,'Christmas Tree','false','potion',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','SummonItems','2137-1'),
(5561,'Special Christmas Tree','false','potion',0,'stackable','paper','none',-1,-1,1,0,'true','true','true','true','true','SummonItems','2138-1'),
(5562,'Echo Crystal - 1st Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2140-1'),
(5563,'Echo Crystal - 2nd Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2141-1'),
(5564,'Echo Crystal - 3rd Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2142-1'),
(5565,'Echo Crystal - 4th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2143-1'),
(5566,'Echo Crystal - 5th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2144-1'),
(5567,'Letter of Greetings','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5568,'Letter of Greetings','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5569,'Water Rune','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5570,'Water Mantra','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5571,'Wind Rune','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5572,'Wind Mantra','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5573,'Fire Rune','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5574,'Fire Mantra','false','none',0,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5575,'Ancient Adena','false','none',0,'asset','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5577,'Red Soul Crystal - Stage 11','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5578,'Green Soul Crystal - Stage 11','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5579,'Blue Soul Crystal - Stage 11','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5580,'Red Soul Crystal - Stage 12','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5581,'Green Soul Crystal - Stage 12','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5582,'Blue Soul Crystal - Stage 12','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5583,'Echo Crystal - 6th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2145-1'),
(5584,'Echo Crystal - 7th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2146-1'),
(5585,'Echo Crystal - 8th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2147-1'),
(5586,'Echo Crystal - 9th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2148-1'),
(5587,'Echo Crystal - 10th Carol','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2149-1'),
(5588,'Tutorial Guide','false','none',10,'normal','liquid','none',-1,-1,1,0,'true','false','true','true','true','Book',''),
(5589,'Energy Stone','false','potion',10,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','ItemSkills','2165-1'),
(5591,'CP Potion','false','potion',25,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','ItemSkills','2166-1'),
(5592,'Greater CP Potion','false','potion',100,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','ItemSkills','2166-2'),
(5593,'SP Scroll: Low Grade','false','scroll',30,'stackable','paper','none',-1,-1,2400,0,'true','true','true','true','true','ItemSkills','2167-1'),
(5594,'SP Scroll: Medium Grade','false','scroll',30,'stackable','paper','none',-1,-1,24000,0,'true','true','true','true','true','ItemSkills','2167-2'),
(5595,'SP Scroll: High Grade','false','scroll',30,'stackable','paper','none',-1,-1,480000,0,'true','true','true','true','true','ItemSkills','2167-3'),
(5650,'Alternative Dark Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5651,'Alternative Red Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5652,'Alternative Chilly Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5653,'Alternative Blue Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5654,'Alternative Golden Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5655,'Alternative Lute Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(5656,'Alternative Desert Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5657,'Alternative Blue Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5658,'Alternative Blue Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5659,'Alternative Golden Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5660,'Alternative Lute Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(5661,'Alternative Desert Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(5662,'Alternative Red Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5663,'Alternative Chilly Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5664,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5665,'Alternative Golden Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5666,'Alternative Great Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(5667,'Alternative Red Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5668,'Alternative Chilly Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5669,'Alternative Blue Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5670,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5671,'Alternative Golden Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5672,'Alternative Great Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(5673,'Alternative Red Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5674,'Alternative Twin Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5675,'Alternative Desert Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(5676,'Alternative Dark Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5677,'Alternative Red Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(5678,'Alternative Blue Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(5679,'Alternative Red Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(5680,'Alternative Chilly Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5681,'Alternative Blue Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5682,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5683,'Alternative Sea Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5684,'Alternative Chilly Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5685,'Alternative Blue Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5686,'Alternative Twin Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5687,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5688,'Alternative Golden Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5689,'Alternative Great Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(5690,'Alternative Red Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5691,'Alternative Chilly Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5692,'Alternative Blue Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5693,'Alternative Twin Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5694,'Alternative Great Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(5695,'Alternative Desert Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(5696,'Alternative Chilly Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(5697,'Alternative Blue Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5698,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5699,'Alternative Golden Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(5700,'Alternative Great Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(5701,'Alternative Red Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(5702,'Alternative Sea Codran Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(5703,'Lucky Charm','false','scroll',10,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','ItemSkills','2168-1'),
(5707,'Record of Seven Signs','false','none',0,'normal','liquid','none',-1,-1,600,0,'true','true','true','true','true','SevenSignsRecord',''),
(5708,'Lord of the Manor\'s Certificate of Approval','false','ticket_of_lord',0,'normal','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5741,'Recipe: Sealed Zubei\'s Gauntlets (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5742,'Recipe: Zubei\'s Gauntlets (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5743,'Recipe: Sealed Avadon Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5744,'Recipe: Sealed Avadon Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5745,'Recipe: Sealed Blue Wolf Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5746,'Recipe: Sealed Blue Wolf Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5747,'Recipe: Sealed Doom Gloves (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5748,'Recipe: Sealed Doom Gloves (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5749,'Recipe: Sealed Zubei\'s Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5750,'Recipe: Sealed Zubei\'s Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5751,'Recipe: Sealed Avadon Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5752,'Recipe: Sealed Avadon Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5753,'Recipe: Sealed Blue Wolf Boots (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5754,'Recipe: Sealed Blue Wolf Boots (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5755,'Recipe: Sealed Boots of Doom (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5756,'Recipe: Sealed Boots of Doom (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5757,'Sealed Zubei\'s Gauntlet Part','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5758,'Sealed Avadon Gloves Part','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5759,'Sealed Blue Wolf Gloves Fabric','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5760,'Sealed Doom Gloves Part','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5761,'Sealed Zubei\'s Boots Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5762,'Sealed Avadon Boots Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5763,'Sealed Blue Wolf Boots Design','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5764,'Sealed Doom Boots Part','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5789,'Soulshot: No Grade for Beginners','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','SoulShots','2039-1'),
(5790,'Spiritshot: No Grade for Beginners','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','SpiritShot','2061-1'),
(5803,'Lucky Charm: D-Grade','false','scroll',10,'stackable','paper','none',-1,-1,300,0,'true','true','true','true','true','ItemSkills','2168-2'),
(5804,'Lucky Charm: C-Grade','false','scroll',10,'stackable','paper','none',-1,-1,660,0,'true','true','true','true','true','ItemSkills','2168-3'),
(5805,'Lucky Charm: B-Grade','false','scroll',10,'stackable','paper','none',-1,-1,1300,0,'true','true','true','true','true','ItemSkills','2168-4'),
(5806,'Lucky Charm: A-Grade','false','scroll',10,'stackable','paper','none',-1,-1,2700,0,'true','true','true','true','true','ItemSkills','2168-5'),
(5807,'Lucky Charm: S Grade','false','scroll',10,'stackable','paper','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2168-6'),
(5809,'Spellbook: Aqua Splash','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(5810,'Spellbook: Rain of Fire','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(5811,'Spellbook: Mass Slow','false','spellbook',120,'stackable','paper','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(5812,'Spellbook: Servitor Empowerment','false','spellbook',120,'stackable','paper','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(5813,'Spellbook: Servitor Cure','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(5814,'Spellbook: Servitor Blessing','false','spellbook',120,'stackable','paper','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(5815,'Spellbook: Wild Magic','false','spellbook',120,'stackable','paper','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(5816,'Spellbook: Advanced Block','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(5818,'Alternative Dark Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(5819,'Alternative Red Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(5820,'Alternative Chilly Coda','false','none',2,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(5821,'Alternative Blue Coda','false','none',2,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5822,'Alternative Golden Coda','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5823,'Alternative Lute Coda','false','none',2,'stackable','paper','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(5824,'Alternative Desert Coda','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5825,'Alternative Red Cobol','false','none',2,'stackable','paper','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5826,'Alternative Chilly Cobol','false','none',2,'stackable','paper','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(5827,'Alternative Blue Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5828,'Alternative Thorn Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5829,'Alternative Golden Cobol','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5830,'Alternative Great Cobol','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5831,'Alternative Red Codran','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5832,'Alternative Sea Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5833,'Alternative Chilly Codran','false','none',2,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5834,'Alternative Blue Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5835,'Alternative Twin Codran','false','none',2,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5836,'Alternative Great Codran','false','none',2,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','none',''),
(5837,'Alternative Desert Codran','false','none',2,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(5838,'Mature Alternative Dark Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5839,'Mature Alternative Red Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5840,'Mature Alternative Chilly Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5841,'Mature Alternative Blue Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5842,'Mature Alternative Golden Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5843,'Mature Alternative Lute Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5844,'Mature Alternative Desert Coda','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5845,'Mature Alternative Red Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5846,'Mature Alternative Chilly Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5847,'Mature Alternative Blue Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5848,'Mature Alternative Thorn Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5849,'Mature Alternative Golden Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5850,'Mature Alternative Great Cobol','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5851,'Mature Alternative Red Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5852,'Mature Alternative Sea Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5853,'Mature Alternative Chilly Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5854,'Mature Alternative Blue Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5855,'Mature Alternative Twin Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5856,'Mature Alternative Great Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5857,'Mature Alternative Desert Codran','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5858,'Blessed Scroll of Escape: Clan Hall','false','scroll',120,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','ItemSkills','2177-1'),
(5859,'Blessed Scroll of Escape: Castle','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2178-1'),
(5860,'Lienrik Egg','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5861,'Lienrik Egg','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5862,'Stone of Contract','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5863,'Alligator Tooth','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5864,'Mysterious Map Piece','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5865,'Carnivore Spore','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5866,'Herbivorous Spore','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5867,'Jade Crystal','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5868,'Snake Scale','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5869,'Remains of Aden Residents','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5870,'Receipt of Supply','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5871,'Suspicious Document Piece','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5872,'Supply Items','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5873,'Pirate\'s Treasure Chest','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5874,'Sairon\'s Silver Hair','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5875,'Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5876,'Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5877,'Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5878,'Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5879,'Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5880,'Broken Titan Lamp','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5881,'Blade Stakato Fang','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5882,'Flare Shard','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5883,'Freezing Shard','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5884,'Cave Beast Tooth','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5885,'Death Wave Light','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5886,'Sealed Mysterious Stone','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5887,'Mysterious Stone','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5888,'Karik Horn','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5889,'Cave Howler Skull','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5890,'Mysterious Book','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5891,'Ancient Language Dictionary: Basic Level','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5892,'Ancient Language Dictionary: Intermediate Level','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5893,'Leaf of Eucalyptus','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5894,'Stone of Chill','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5895,'Ritron\'s Fruit','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5896,'Moon Face Flower','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5897,'Leech Fluids','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5898,'Royal Membership','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5899,'Kail\'s Coin','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5900,'Coin Collecting Album','false','none',0,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5901,'Blood Offering','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5902,'Scroll of Ancient Magic','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5903,'Ancient Ash Urn','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5904,'Wesley\'s Mixing Stone','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5905,'Magister\'s Mixing Stone','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(5906,'Five-Year Anniversary Gift Box (10 Honey Rice Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5907,'Five-Year Anniversary Gift Box (9 Honey Rice Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5908,'Red Soul Crystal: Grade 13','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5909,'Five-Year Anniversary Gift Box (8 Honey Rice Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5910,'Five-Year Anniversary Gift Box (7 Honey Rice Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5911,'Green Soul Crystal: Grade 13','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5912,'Five-Year Anniversary Gift Box (6 Honey Rice Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5913,'Five-Year Anniversary Gift Box (3 Honey Wheat Cake Set)','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5914,'Blue Soul Crystal: Grade 13','false','scroll',20,'normal','crystal','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(5915,'Pirate\'s Treasure Map','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(5916,'Spellbook Page','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2171-1'),
(5917,'Kranvel\'s Spellbook: Chapter of Fire','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5918,'Kranvel\'s Spellbook: Chapter of Water','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5919,'Kranvel\'s Spellbook: Chapter of Wind','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5920,'Kranvel\'s Spellbook: Chapter of Earth','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5921,'Worthless Piece of Paper','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(5922,'Blueprint: Giants Golem 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5923,'Blueprint: Giants Golem 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5924,'Blueprint: Giants Golem 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5925,'Blueprint: Giants Golem 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5926,'Blueprint: Giants Golem 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5927,'Book: Basics of Giants Magic,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5928,'Book: Basics of Giants Magic,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5929,'Book: Basics of Giants Magic,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5930,'Book: Basics of Giants Magic,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5931,'Book: Basics of Giants Magic,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5932,'Handbook: Giants Architecture,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5933,'Handbook: Giants Architecture,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5934,'Handbook: Giants Architecture,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5935,'Handbook: Giants Architecture,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5936,'Handbook: Giants Architecture,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5937,'Book: Giants Medical Science,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5938,'Book: Giants Medical Science,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5939,'Book: Giants Medical Science,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5940,'Book: Giants Medical Science,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5941,'Book: Giants Medical Science,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5942,'Giant\'s Love Letter','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5943,'Giants\' Doodle','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5944,'Ancient Parchment','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','ItemSkills','2172-1'),
(5945,'Book: Giants Science & Technology,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5946,'Book: Giants Science & Technology,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5947,'Book: Giants Science & Technology,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5948,'Book: Giants Science & Technology,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5949,'Book: Giants Science & Technology,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5950,'Almanac: Titan Culture,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5951,'Almanac: Titan Culture,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5952,'Almanac: Titan Culture,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5953,'Almanac: Titan Culture,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5954,'Almanac: Titan Culture,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5955,'Ancient Titan Book','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','ItemSkills','2173-1'),
(5956,'15 Year Old Wine','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(5957,'30 Year Old Wine','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(5958,'60 Year Old Wine','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(5959,'Ritron\'s Dessert Recipe','false','none',10,'normal','liquid','none',-1,-1,40000,0,'true','true','true','true','true','none',''),
(5960,'Ritron Jelly','false','none',10,'normal','liquid','none',-1,-1,1920,0,'true','true','true','true','true','none',''),
(5961,'Kail\'s Silver Basilisk','false','none',0,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(5962,'Kail\'s Gold Golem','false','none',0,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(5963,'Kail\'s Blood Dragon','false','none',0,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(5964,'Warehouse Keeper\'s Medal','false','quest',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(5965,'Blank Scroll','false','none',0,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(5966,'Ancient Red Papyrus','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2176-1'),
(5967,'Ancient Blue Papyrus','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2176-2'),
(5968,'Ancient Black Papyrus','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2176-3'),
(5969,'Ancient White Papyrus','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2176-4'),
(5970,'Ancient Chain Letter','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5971,'Ancient Joke Book','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5972,'Revelation of the Seals: Chapter of Avarice','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5973,'Revelation of the Seals: Chapter of Gnosis','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5974,'Revelation of the Seals: Chapter of Strife','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5975,'Revelation of the Seals: Chapter of Vengeance','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5976,'Revelation of the Seals: Chapter of Awakening','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5977,'Revelation of the Seals: Chapter of Calamity','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5978,'Revelation of the Seals: Chapter of Descent','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5979,'Ancient Epic,Chapter 1','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5980,'Ancient Epic,Chapter 2','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5981,'Ancient Epic,Chapter 3','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5982,'Ancient Epic,Chapter 4','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5983,'Ancient Epic,Chapter 5','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5984,'Imperial Genealogy 1','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5985,'Imperial Genealogy 2','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5986,'Imperial Genealogy 3','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5987,'Imperial Genealogy 4','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5988,'Imperial Genealogy 5','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5989,'Blueprint: Tower of Insolence,1st Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5990,'Blueprint: Tower of Insolence,2nd Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5991,'Blueprint: Tower of Insolence,3rd Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5992,'Blueprint: Tower of Insolence,4th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5993,'Blueprint: Tower of Insolence,5th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5994,'Blueprint: Tower of Insolence,6th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5995,'Blueprint: Tower of Insolence,7th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5996,'Blueprint: Tower of Insolence,8th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5997,'Blueprint: Tower of Insolence,9th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5998,'Blueprint: Tower of Insolence,10th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(5999,'Blueprint: Tower of Insolence,11th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(6000,'Blueprint: Tower of Insolence,12th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(6001,'Blueprint: Tower of Insolence,13th Floor','false','none',0,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(6002,'Ancient Porcelain','false','none',10,'stackable','liquid','none',-1,-1,8000,0,'true','true','true','true','true','none',''),
(6003,'Ancient Porcelain: Excellent','false','none',10,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(6004,'Ancient Porcelain: High Quality','false','none',10,'stackable','liquid','none',-1,-1,8000,0,'true','true','true','true','true','none',''),
(6005,'Ancient Porcelain: Low Quality','false','none',10,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6006,'Ancient Porcelain: Lowest Quality','false','none',10,'stackable','liquid','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(6007,'Reagent Pouch','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2174-1'),
(6008,'Reagent Pouch','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2174-2'),
(6009,'Reagent Pouch','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2174-3'),
(6010,'Reagent Box','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2175-1'),
(6011,'Wyrm\'s Blood','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6012,'Lava Stone','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6013,'Moonstone Shard','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6014,'Rotten Bone Piece','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6015,'Demon\'s Blood','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6016,'Infernium Ore','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6017,'Blood Root','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6018,'Volcanic Ash','false','none',0,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(6019,'Quicksilver','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6020,'Sulfur','false','none',0,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6021,'Dracoplasm','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6022,'Magma Dust','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6023,'Moon Dust','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6024,'Necroplasm','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6025,'Demonplasm','false','none',0,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6026,'Inferno Dust','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6027,'Draconic Essence','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6028,'Fire Essence','false','none',0,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6029,'Lunargent','false','none',0,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6030,'Midnight Oil','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6031,'Demonic Essence','false','none',0,'stackable','liquid','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6032,'Abyss Oil','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6033,'Hellfire Oil','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6034,'Nightmare Oil','false','none',0,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6035,'Magic Haste Potion','false','potion',20,'stackable','liquid','none',-1,-1,2400,0,'true','true','true','true','true','ItemSkills','2169-1'),
(6036,'Greater Magic Haste Potion','false','potion',20,'stackable','liquid','none',-1,-1,7200,0,'true','true','true','true','true','ItemSkills','2169-2'),
(6037,'Waking Scroll','false','scroll',5,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','ItemSkills','2170-1'),
(6038,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6039,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6040,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6041,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6042,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6043,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6044,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6045,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6046,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6047,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6048,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6049,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6050,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6051,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6052,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6053,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6054,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6055,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6056,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6057,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6058,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6059,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6060,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6061,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6062,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6063,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6064,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6065,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6066,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6067,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6068,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6069,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6070,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6071,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6072,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6073,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6074,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6075,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6076,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6077,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6078,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6079,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6080,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6081,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6082,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6083,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6084,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6085,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6086,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6087,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6088,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6089,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6090,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6091,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6092,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6093,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6094,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6095,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6096,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6097,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6098,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6099,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6100,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6101,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6102,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6103,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6104,'Trash - Trash','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6105,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6106,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6107,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6108,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6109,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6110,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6111,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6112,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6113,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6114,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6115,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6116,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6117,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6118,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6119,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6120,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6121,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6122,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6123,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6124,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6125,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6126,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6127,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6128,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6129,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6130,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6131,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6132,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6133,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6134,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6135,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6136,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6137,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6138,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6139,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6140,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6141,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6142,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6143,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6144,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6145,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6146,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6147,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6148,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6149,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6150,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6151,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6152,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6153,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6154,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6155,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6156,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6157,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6158,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6159,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6160,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6161,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6162,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6163,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6164,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6165,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6166,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6167,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6168,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6169,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6170,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6171,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6172,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6173,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6174,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6175,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6176,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6177,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6178,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6179,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6180,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6181,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6182,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6183,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6184,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6185,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6186,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6187,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6188,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6189,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6190,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6191,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6192,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6193,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6194,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6195,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6196,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6197,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6198,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6199,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6200,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6201,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6202,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6203,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6204,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6205,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6206,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6207,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6208,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6209,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6210,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6211,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6212,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6213,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6214,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6215,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6216,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6217,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6218,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6219,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6220,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6221,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6222,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6223,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6224,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6225,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6226,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6227,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6228,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6229,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6230,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6231,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6232,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6233,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6234,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6235,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6236,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6237,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6238,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6239,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6240,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6241,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6242,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6243,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6244,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6245,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6246,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6247,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6248,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6249,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6250,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6251,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6252,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6253,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6254,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6255,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6256,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6257,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6258,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6259,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6260,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6261,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6262,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6263,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6264,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6265,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6266,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6267,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6268,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6269,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6270,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6271,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6272,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6273,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6274,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6275,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6276,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6277,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6278,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6279,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6280,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6281,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6282,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6283,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6284,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6285,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6286,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6287,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6288,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6289,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6290,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6291,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6292,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6293,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6294,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6295,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket','');

INSERT INTO `etcitem` VALUES
(6296,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6297,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6298,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6299,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6300,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6301,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6302,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6303,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6304,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6305,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6306,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6316,'Food for Wyvern','false','none',10,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','PetFood','2180-1'),
(6317,'Mixing Manual','false','none',20,'normal','liquid','none',-1,-1,0,0,'true','false','true','true','true','Book',''),
(6318,'Blood Fire','false','quest',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6319,'Mimir\'s Elixir','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6320,'Pure Silver','false','quest',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6321,'True Gold','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6322,'Sage\'s Stone','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6329,'Recipe: Sealed Phoenix Necklace(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,34800,0,'true','true','true','true','true','Recipes',''),
(6330,'Recipe: Sealed Phoenix Necklace(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,69600,0,'true','true','true','true','true','Recipes',''),
(6331,'Recipe: Sealed Phoenix Earring(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,26200,0,'true','true','true','true','true','Recipes',''),
(6332,'Recipe: Sealed Phoenix Earring(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,52400,0,'true','true','true','true','true','Recipes',''),
(6333,'Recipe: Sealed Phoenix Ring(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,17420,0,'true','true','true','true','true','Recipes',''),
(6334,'Recipe: Sealed Phoenix Ring(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,34840,0,'true','true','true','true','true','Recipes',''),
(6335,'Recipe: Sealed Majestic Necklace(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,52000,0,'true','true','true','true','true','Recipes',''),
(6336,'Recipe: Sealed Majestic Necklace(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,104000,0,'true','true','true','true','true','Recipes',''),
(6337,'Recipe: Sealed Majestic Earring(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,39000,0,'true','true','true','true','true','Recipes',''),
(6338,'Recipe: Sealed Majestic Earring(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,78000,0,'true','true','true','true','true','Recipes',''),
(6339,'Recipe: Sealed Majestic Ring(70%)','false','recipe',30,'stackable','liquid','none',-1,-1,26000,0,'true','true','true','true','true','Recipes',''),
(6340,'Recipe: Sealed Majestic Ring(100%)','false','recipe',30,'stackable','liquid','none',-1,-1,52000,0,'true','true','true','true','true','Recipes',''),
(6341,'Sealed Phoenix Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,7231,0,'true','true','true','true','true','none',''),
(6342,'Sealed Majestic Earring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,8829,0,'true','true','true','true','true','none',''),
(6343,'Sealed Phoenix Necklace Beads','false','material',60,'stackable','liquid','none',-1,-1,9354,0,'true','true','true','true','true','none',''),
(6344,'Sealed Majestic Necklace Beads','false','material',60,'stackable','liquid','none',-1,-1,13643,0,'true','true','true','true','true','none',''),
(6345,'Sealed Phoenix Ring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,5228,0,'true','true','true','true','true','none',''),
(6346,'Sealed Majestic Ring Gemstone','false','material',60,'stackable','liquid','none',-1,-1,6143,0,'true','true','true','true','true','none',''),
(6350,'Amulet: Pa\'agrio\'s Honor','false','spellbook',120,'stackable','paper','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(6351,'Amulet: Ritual of Life','false','spellbook',120,'stackable','paper','none',-1,-1,8200,0,'true','true','true','true','true','none',''),
(6352,'Spellbook: Prayer','false','spellbook',120,'stackable','paper','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(6353,'Blue Gemstone','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6360,'Blue Seal Stone','false','none',0,'asset','gold','none',-1,-1,3,0,'true','true','true','true','true','none',''),
(6361,'Green Seal Stone','false','none',0,'asset','gold','none',-1,-1,5,0,'true','true','true','true','true','none',''),
(6362,'Red Seal Stone','false','none',0,'asset','gold','none',-1,-1,10,0,'true','true','true','true','true','none',''),
(6363,'Stolen Infernium Ore','false','none',0,'stackable','steel','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(6387,'Blessed Scroll of Resurrection for Pets','false','scroll',120,'stackable','paper','none',-1,-1,6000,0,'true','true','true','true','true','ScrollOfResurrection','2179-1'),
(6388,'Lord of the Manor\'s Certificate of Approval','false','none',0,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6389,'Squash Seed','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','false','true','true','true','ItemSkills','2003-1'),
(6390,'Large Squash Seed','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','false','true','true','true','ItemSkills','2004-1'),
(6391,'Nectar','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2005-1'),
(6392,'Event - Medal','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6393,'Event - Glittering Medal','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6395,'Amulet: Chant of Predator','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(6396,'Amulet: Chant of Eagle','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(6397,'Amulet: Chant of Vampire','false','spellbook',120,'stackable','paper','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(6398,'Spellbook: Body of Avatar','false','spellbook',120,'stackable','paper','none',-1,-1,4600,0,'true','true','true','true','true','none',''),
(6399,'Badge of Rabbit','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6400,'Badge of Hyena','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6401,'Badge of Fox','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6402,'Badge of Wolf','false','quest',0,'stackable','crystal','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6403,'Star Shard','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2023-1'),
(6404,'Gunpowder','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6405,'Magnesium','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6406,'Firework','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2024-1'),
(6407,'Large Firework','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2025-1'),
(6409,'2006 Battle Tournament - CP Potion','false','potion',500,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6410,'2006 Battle Tournament - Quick Healing Potion','false','potion',180,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6411,'Small Nimble Green Fish','false','none',100,'stackable','paper','none',-1,-1,138,0,'true','true','true','true','true','ItemSkills','2190-1'),
(6412,'Small Ugly Green Fish','false','none',100,'stackable','paper','none',-1,-1,141,0,'true','true','true','true','true','ItemSkills','2190-2'),
(6413,'Small Pudgy Green Fish','false','none',100,'stackable','paper','none',-1,-1,153,0,'true','true','true','true','true','ItemSkills','2190-3'),
(6414,'Nimble Green Fish','false','none',100,'stackable','paper','none',-1,-1,167,0,'true','true','true','true','true','ItemSkills','2190-4'),
(6415,'Ugly Green Fish','false','none',100,'stackable','paper','none',-1,-1,187,0,'true','true','true','true','true','ItemSkills','2190-5'),
(6416,'Pudgy Green Fish','false','none',100,'stackable','paper','none',-1,-1,208,0,'true','true','true','true','true','ItemSkills','2190-6'),
(6417,'Large Nimble Green Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2190-7'),
(6418,'Large Ugly Green Fish','false','none',100,'stackable','paper','none',-1,-1,248,0,'true','true','true','true','true','ItemSkills','2190-8'),
(6419,'Large Pudgy Green Fish','false','none',100,'stackable','paper','none',-1,-1,265,0,'true','true','true','true','true','ItemSkills','2190-9'),
(6420,'Small Jade Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,285,0,'true','true','true','true','true','ItemSkills','2191-1'),
(6421,'Small Jade Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,295,0,'true','true','true','true','true','ItemSkills','2191-2'),
(6422,'Small Jade Fat Fish','false','none',100,'stackable','paper','none',-1,-1,310,0,'true','true','true','true','true','ItemSkills','2191-3'),
(6423,'Jade Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,325,0,'true','true','true','true','true','ItemSkills','2191-4'),
(6424,'Jade Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,340,0,'true','true','true','true','true','ItemSkills','2191-5'),
(6425,'Jade Fat Fish','false','none',100,'stackable','paper','none',-1,-1,355,0,'true','true','true','true','true','ItemSkills','2191-6'),
(6426,'Big Jade Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,365,0,'true','true','true','true','true','ItemSkills','2191-7'),
(6427,'Big Jade Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,375,0,'true','true','true','true','true','ItemSkills','2191-8'),
(6428,'Big Jade Fat Fish','false','none',100,'stackable','paper','none',-1,-1,385,0,'true','true','true','true','true','ItemSkills','2191-9'),
(6429,'Small Blue Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,395,0,'true','true','true','true','true','ItemSkills','2192-1'),
(6430,'Small Blue Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2192-2'),
(6431,'Small Blue Fat Fish','false','none',100,'stackable','paper','none',-1,-1,410,0,'true','true','true','true','true','ItemSkills','2192-3'),
(6432,'Blue Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,415,0,'true','true','true','true','true','ItemSkills','2192-4'),
(6433,'Blue Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,418,0,'true','true','true','true','true','ItemSkills','2192-5'),
(6434,'Blue Fat Fish','false','none',100,'stackable','paper','none',-1,-1,420,0,'true','true','true','true','true','ItemSkills','2192-6'),
(6435,'Big Blue Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,425,0,'true','true','true','true','true','ItemSkills','2192-7'),
(6436,'Big Blue Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,431,0,'true','true','true','true','true','ItemSkills','2192-8'),
(6437,'Big Blue Fat Fish','false','none',100,'stackable','paper','none',-1,-1,435,0,'true','true','true','true','true','ItemSkills','2192-9'),
(6438,'Small Yellow Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,442,0,'true','true','true','true','true','ItemSkills','2193-1'),
(6439,'Small Yellow Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,447,0,'true','true','true','true','true','ItemSkills','2193-2'),
(6440,'Small Yellow Fat Fish','false','none',100,'stackable','paper','none',-1,-1,452,0,'true','true','true','true','true','ItemSkills','2193-3'),
(6441,'Yellow Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,540,0,'true','true','true','true','true','ItemSkills','2193-4'),
(6442,'Yellow Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,553,0,'true','true','true','true','true','ItemSkills','2193-5'),
(6443,'Yellow Fat Fish','false','none',100,'stackable','paper','none',-1,-1,568,0,'true','true','true','true','true','ItemSkills','2193-6'),
(6444,'Big Yellow Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,580,0,'true','true','true','true','true','ItemSkills','2193-7'),
(6445,'Big Yellow Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,594,0,'true','true','true','true','true','ItemSkills','2193-8'),
(6446,'Big Yellow Fat Fish','false','none',100,'stackable','paper','none',-1,-1,608,0,'true','true','true','true','true','ItemSkills','2193-9'),
(6447,'Small Orange Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,622,0,'true','true','true','true','true','ItemSkills','2194-1'),
(6448,'Small Orange Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,635,0,'true','true','true','true','true','ItemSkills','2194-2'),
(6449,'Small Orange Fat Fish','false','none',100,'stackable','paper','none',-1,-1,649,0,'true','true','true','true','true','ItemSkills','2194-3'),
(6450,'Orange Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,663,0,'true','true','true','true','true','ItemSkills','2194-4'),
(6451,'Orange Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,776,0,'true','true','true','true','true','ItemSkills','2194-5'),
(6452,'Orange Fat Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2194-6'),
(6453,'Big Orange Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,816,0,'true','true','true','true','true','ItemSkills','2194-7'),
(6454,'Big Orange Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,840,0,'true','true','true','true','true','ItemSkills','2194-8'),
(6455,'Big Orange Fat Fish','false','none',100,'stackable','paper','none',-1,-1,858,0,'true','true','true','true','true','ItemSkills','2194-9'),
(6456,'Small Purple Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,875,0,'true','true','true','true','true','ItemSkills','2195-1'),
(6457,'Small Purple Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,893,0,'true','true','true','true','true','ItemSkills','2195-2'),
(6458,'Small Purple Fat Fish','false','none',100,'stackable','paper','none',-1,-1,910,0,'true','true','true','true','true','ItemSkills','2195-3'),
(6459,'Purple Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,930,0,'true','true','true','true','true','ItemSkills','2195-4'),
(6460,'Purple Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,948,0,'true','true','true','true','true','ItemSkills','2195-5'),
(6461,'Purple Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1090,0,'true','true','true','true','true','ItemSkills','2195-6'),
(6462,'Big Purple Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1111,0,'true','true','true','true','true','ItemSkills','2195-7'),
(6463,'Big Purple Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1133,0,'true','true','true','true','true','ItemSkills','2195-8'),
(6464,'Big Purple Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1157,0,'true','true','true','true','true','ItemSkills','2195-9'),
(6465,'Small Red Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1277,0,'true','true','true','true','true','ItemSkills','2196-1'),
(6466,'Small Red Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1301,0,'true','true','true','true','true','ItemSkills','2196-2'),
(6467,'Small Red Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1326,0,'true','true','true','true','true','ItemSkills','2196-3'),
(6468,'Red Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1351,0,'true','true','true','true','true','ItemSkills','2196-4'),
(6469,'Red Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1376,0,'true','true','true','true','true','ItemSkills','2196-5'),
(6470,'Red Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1402,0,'true','true','true','true','true','ItemSkills','2196-6'),
(6471,'Big Red Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1577,0,'true','true','true','true','true','ItemSkills','2196-7'),
(6472,'Big Red Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1608,0,'true','true','true','true','true','ItemSkills','2196-8'),
(6473,'Big Red Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1715,0,'true','true','true','true','true','ItemSkills','2196-9'),
(6474,'Small White Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1747,0,'true','true','true','true','true','ItemSkills','2197-1'),
(6475,'Small White Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1781,0,'true','true','true','true','true','ItemSkills','2197-2'),
(6476,'Small White Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1814,0,'true','true','true','true','true','ItemSkills','2197-3'),
(6477,'White Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1849,0,'true','true','true','true','true','ItemSkills','2197-4'),
(6478,'White Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,1887,0,'true','true','true','true','true','ItemSkills','2197-5'),
(6479,'White Fat Fish','false','none',100,'stackable','paper','none',-1,-1,1923,0,'true','true','true','true','true','ItemSkills','2197-6'),
(6480,'Big White Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,1961,0,'true','true','true','true','true','ItemSkills','2197-7'),
(6481,'Big White Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','ItemSkills','2197-8'),
(6482,'Big White Fat Fish','false','none',100,'stackable','paper','none',-1,-1,2039,0,'true','true','true','true','true','ItemSkills','2197-9'),
(6483,'Small Black Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-1'),
(6484,'Small Black Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-2'),
(6485,'Small Black Fat Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-3'),
(6486,'Black Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,2309,0,'true','true','true','true','true','ItemSkills','2198-4'),
(6487,'Black Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,2357,0,'true','true','true','true','true','ItemSkills','2198-5'),
(6488,'Black Fat Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-6'),
(6489,'Big Black Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-7'),
(6490,'Big Black Ugly Fish','false','none',100,'stackable','paper','none',-1,-1,2502,0,'true','true','true','true','true','ItemSkills','2198-8'),
(6491,'Big Black Fat Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2198-9'),
(6492,'Small Green Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,153,0,'true','true','true','true','true','ItemSkills','2199-1'),
(6493,'Green Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,208,0,'true','true','true','true','true','ItemSkills','2199-2'),
(6494,'Big Green Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,265,0,'true','true','true','true','true','ItemSkills','2199-3'),
(6495,'Small Jade Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,285,0,'true','true','true','true','true','ItemSkills','2200-1'),
(6496,'Jade Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,315,0,'true','true','true','true','true','ItemSkills','2200-2'),
(6497,'Big Jade Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,345,0,'true','true','true','true','true','ItemSkills','2200-3'),
(6498,'Small Blue Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,395,0,'true','true','true','true','true','ItemSkills','2201-1'),
(6499,'Blue Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,419,0,'true','true','true','true','true','ItemSkills','2201-2'),
(6500,'Big Blue Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,435,0,'true','true','true','true','true','ItemSkills','2201-3'),
(6501,'Small Yellow Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,452,0,'true','true','true','true','true','ItemSkills','2202-1'),
(6502,'Yellow Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,568,0,'true','true','true','true','true','ItemSkills','2202-2'),
(6503,'Big Yellow Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,608,0,'true','true','true','true','true','ItemSkills','2202-3'),
(6504,'Small Orange Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,649,0,'true','true','true','true','true','ItemSkills','2203-1'),
(6505,'Orange Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,792,0,'true','true','true','true','true','ItemSkills','2203-2'),
(6506,'Big Orange Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,858,0,'true','true','true','true','true','ItemSkills','2203-3'),
(6507,'Small Purple Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,910,0,'true','true','true','true','true','ItemSkills','2204-1'),
(6508,'Purple Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1090,0,'true','true','true','true','true','ItemSkills','2204-2'),
(6509,'Big Purple Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1157,0,'true','true','true','true','true','ItemSkills','2204-3'),
(6510,'Small Red Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1326,0,'true','true','true','true','true','ItemSkills','2205-1'),
(6511,'Red Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1402,0,'true','true','true','true','true','ItemSkills','2205-2'),
(6512,'Big Red Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1715,0,'true','true','true','true','true','ItemSkills','2205-3'),
(6513,'Small White Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1814,0,'true','true','true','true','true','ItemSkills','2206-1'),
(6514,'White Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,1923,0,'true','true','true','true','true','ItemSkills','2206-2'),
(6515,'Big White Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,2039,0,'true','true','true','true','true','ItemSkills','2206-3'),
(6516,'Small Black Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,2166,0,'true','true','true','true','true','ItemSkills','2207-1'),
(6517,'Black Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,2403,0,'true','true','true','true','true','ItemSkills','2207-2'),
(6518,'Big Black Treasure Chest','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2207-3'),
(6519,'Green Colored Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(6520,'Green Colored Lure','false','lure',4,'stackable','liquid','none',-1,-1,120,0,'true','true','true','true','true','none',''),
(6521,'Green Colored Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(6522,'Purple Colored Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(6523,'Purple Colored Lure','false','lure',4,'stackable','liquid','none',-1,-1,180,0,'true','true','true','true','true','none',''),
(6524,'Purple Colored Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6525,'Yellow Colored Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,120,0,'true','true','true','true','true','none',''),
(6526,'Yellow Colored Lure','false','lure',4,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(6527,'Yellow Colored Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,180,0,'true','true','true','true','true','none',''),
(6528,'Event bait','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6535,'Fishing Shot: non-grade','false','shot',3,'stackable','paper','none',-1,-1,3,0,'true','true','true','true','true','FishShots','2181-1'),
(6536,'Fishing Shot: D-grade','false','shot',3,'stackable','paper','d',-1,-1,5,0,'true','true','true','true','true','FishShots','2182-1'),
(6537,'Fishing Shot: C-grade','false','shot',3,'stackable','paper','c',-1,-1,7,0,'true','true','true','true','true','FishShots','2183-1'),
(6538,'Fishing Shot: B-grade','false','shot',3,'stackable','paper','b',-1,-1,25,0,'true','true','true','true','true','FishShots','2184-1'),
(6539,'Fishing Shot: A-grade','false','shot',3,'stackable','paper','a',-1,-1,40,0,'true','true','true','true','true','FishShots','2185-1'),
(6540,'Fishing Shot: S-grade','false','shot',3,'stackable','paper','s',-1,-1,50,0,'true','true','true','true','true','FishShots','2186-1'),
(6541,'Blue Coba','false','none',2,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(6542,'Red Coba','false','none',2,'stackable','paper','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(6543,'Gold Coba','false','none',2,'stackable','paper','none',-1,-1,1750,0,'true','true','true','true','true','none',''),
(6544,'Desert Coba','false','none',2,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(6545,'Sea Coba','false','none',2,'stackable','paper','none',-1,-1,2250,0,'true','true','true','true','true','none',''),
(6546,'Twin Coba','false','none',2,'stackable','paper','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6547,'King Coba','false','none',2,'stackable','paper','none',-1,-1,2750,0,'true','true','true','true','true','none',''),
(6548,'Alternative Blue Coba','false','none',2,'stackable','paper','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(6549,'Alternative Red Coba','false','none',2,'stackable','paper','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(6550,'Alternative Gold Coba','false','none',2,'stackable','paper','none',-1,-1,1750,0,'true','true','true','true','true','none',''),
(6551,'Alternative Desert Coba','false','none',2,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(6552,'Alternative Sea Coba','false','none',2,'stackable','paper','none',-1,-1,2250,0,'true','true','true','true','true','none',''),
(6553,'Alternative Twin Coba','false','none',2,'stackable','paper','none',-1,-1,2500,0,'true','true','true','true','true','none',''),
(6554,'Alternative King Coba','false','none',2,'stackable','paper','none',-1,-1,2750,0,'true','true','true','true','true','none',''),
(6555,'Ripe Blue Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6556,'Ripe Red Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6557,'Ripe Gold Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6558,'Ripe Desert Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6559,'Ripe Sea Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6560,'Ripe Twin Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6561,'Ripe King Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6562,'Ripe Alternative Blue Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6563,'Ripe Alternative Red Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6564,'Ripe Alternative Gold Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6565,'Ripe Alternative Desert Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6566,'Ripe Alternative Sea Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6567,'Ripe Alternative Twin Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6568,'Ripe Alternative King Coba','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6569,'Blessed Scroll: Enchant Weapon (A)','false','scroll',120,'stackable','paper','none',-1,-1,1750000,0,'true','true','true','true','true','EnchantScrolls','2027-1'),
(6570,'Blessed Scroll: Enchant Armor (A)','false','scroll',120,'stackable','paper','none',-1,-1,750000,0,'true','true','true','true','true','EnchantScrolls','2209-1'),
(6571,'Blessed Scroll: Enchant Weapon (B)','false','scroll',120,'stackable','paper','none',-1,-1,1250000,0,'true','true','true','true','true','EnchantScrolls','2028-1'),
(6572,'Blessed Scroll: Enchant Armor (B)','false','scroll',120,'stackable','paper','none',-1,-1,250000,0,'true','true','true','true','true','EnchantScrolls','2210-1'),
(6573,'Blessed Scroll: Enchant Weapon (C)','false','scroll',120,'stackable','paper','none',-1,-1,250000,0,'true','true','true','true','true','EnchantScrolls','2029-1'),
(6574,'Blessed Scroll: Enchant Armor (C)','false','scroll',120,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','EnchantScrolls','2211-1'),
(6575,'Blessed Scroll: Enchant Weapon (D)','false','scroll',120,'stackable','paper','none',-1,-1,150000,0,'true','true','true','true','true','EnchantScrolls','2030-1'),
(6576,'Blessed Scroll: Enchant Armor (D)','false','scroll',120,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','EnchantScrolls','2212-1'),
(6577,'Blessed Scroll: Enchant Weapon (S)','false','scroll',120,'stackable','paper','none',-1,-1,2250000,0,'true','true','true','true','true','EnchantScrolls','2026-1'),
(6578,'Blessed Scroll: Enchant Armor (S)','false','scroll',120,'stackable','paper','none',-1,-1,1250000,0,'true','true','true','true','true','EnchantScrolls','2208-1'),
(6622,'Giant\'s Codex','false','none',10,'normal','paper','none',-1,-1,500000,0,'true','true','true','true','true','none',''),
(6623,'Dummy - Quest Item 1','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6624,'Dummy - Quest Item 2','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6625,'Dummy - Quest Item 3','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6626,'Dummy - Quest Item 4','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6627,'Dummy - Quest Item 5','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6628,'Dummy - Quest Item 6','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6629,'Dummy - Quest Item 7','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6630,'Dummy - Quest Item 8','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6631,'Dummy - Quest Item 9','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6632,'Dummy - Quest Item 10','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6633,'Dummy - General Item 1','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6634,'Dummy - General Item 2','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6635,'Dummy - General Item 3','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6636,'Dummy - General Item 4','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6637,'Dummy - General Item 5','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6638,'Dummy - General Item 6','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6639,'Dummy - General Item 7','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6640,'Dummy - General Item 8','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6641,'Dummy - General Item 9','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6642,'Dummy - General Item 10','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6643,'Golden Spice','false','none',40,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','BeastSpice','2188-1'),
(6644,'Crystal Spice','false','none',40,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','BeastSpice','2189-1'),
(6645,'Beast Soulshot','false','shot',1,'stackable','paper','none',-1,-1,21,0,'true','true','true','true','true','BeastSoulShot','2033-1'),
(6646,'Beast Spiritshot','false','shot',2,'stackable','paper','none',-1,-1,43,0,'true','true','true','true','true','BeastSpiritShot','2008-1'),
(6647,'Blessed Beast Spiritshot','false','shot',2,'stackable','paper','none',-1,-1,108,0,'true','true','true','true','true','BeastSpiritShot','2009-1'),
(6648,'Baby Buffalo Panpipe','false','pet_collar',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(6649,'Baby Cougar Chime','false','pet_collar',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(6650,'Baby Kookaburra Ocarina','false','pet_collar',20,'normal','leather','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(6651,'Noblesse Gate Pass','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6652,'Scroll: Protection of Valakas','false','scroll',10,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','ItemSkills','2231-1'),
(6653,'Scroll: Flames of Valakas','false','scroll',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(6654,'Scroll: Flames of Valakas','false','scroll',10,'stackable','paper','none',-1,-1,40000,0,'true','true','true','true','true','ItemSkills','2233-1'),
(6655,'Scroll: Slay Valakas','false','scroll',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2232-1'),
(6663,'Scroll of Escape: Orc Village','false','scroll',120,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(6664,'Scroll of Escape: Silenos Village','false','scroll',120,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(6665,'Deluxe Chest Key - Grade 1','false','none',10,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2229-1'),
(6666,'Deluxe Chest Key - Grade 2','false','none',10,'stackable','steel','none',-1,-1,200,0,'true','true','true','true','true','ItemSkills','2229-2'),
(6667,'Deluxe Chest Key - Grade 3','false','none',10,'stackable','steel','none',-1,-1,320,0,'true','true','true','true','true','ItemSkills','2229-3'),
(6668,'Deluxe Chest Key - Grade 4','false','none',10,'stackable','steel','none',-1,-1,560,0,'true','true','true','true','true','ItemSkills','2229-4'),
(6669,'Deluxe Chest Key - Grade 5','false','none',10,'stackable','steel','none',-1,-1,860,0,'true','true','true','true','true','ItemSkills','2229-5'),
(6670,'Deluxe Chest Key - Grade 6','false','none',10,'stackable','steel','none',-1,-1,1200,0,'true','true','true','true','true','ItemSkills','2229-6'),
(6671,'Deluxe Chest Key - Grade 7','false','none',10,'stackable','steel','none',-1,-1,1800,0,'true','true','true','true','true','ItemSkills','2229-7'),
(6672,'Deluxe Chest Key - Grade 8','false','none',10,'stackable','steel','none',-1,-1,2400,0,'true','true','true','true','true','ItemSkills','2229-8'),
(6673,'Festival Adena','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(6688,'Forgotten Blade Edge','false','material',60,'stackable','liquid','none',-1,-1,92529,0,'true','true','true','true','true','none',''),
(6689,'Basalt Battlehammer Head','false','material',60,'stackable','liquid','none',-1,-1,94306,0,'true','true','true','true','true','none',''),
(6690,'Imperial Staff Head','false','material',60,'stackable','liquid','none',-1,-1,92353,0,'true','true','true','true','true','none',''),
(6691,'Angel Slayer Blade','false','material',60,'stackable','liquid','none',-1,-1,92529,0,'true','true','true','true','true','none',''),
(6692,'Shining Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,90882,0,'true','true','true','true','true','none',''),
(6693,'Dragon Hunter Axe Blade','false','material',60,'stackable','liquid','none',-1,-1,90882,0,'true','true','true','true','true','none',''),
(6694,'Saint Spear Blade','false','material',60,'stackable','liquid','none',-1,-1,90882,0,'true','true','true','true','true','none',''),
(6695,'Demon Splinter Blade','false','material',60,'stackable','liquid','none',-1,-1,94306,0,'true','true','true','true','true','none',''),
(6696,'Heavens Divider Edge','false','material',60,'stackable','liquid','none',-1,-1,91082,0,'true','true','true','true','true','none',''),
(6697,'Arcana Mace Head','false','material',60,'stackable','liquid','none',-1,-1,94306,0,'true','true','true','true','true','none',''),
(6698,'Sealed Tateossian Earring Part','false','material',60,'stackable','liquid','none',-1,-1,10182,0,'true','true','true','true','true','none',''),
(6699,'Sealed Tateossian Ring Gem','false','material',60,'stackable','liquid','none',-1,-1,9176,0,'true','true','true','true','true','none',''),
(6700,'Sealed Tateossian Necklace Chain','false','material',60,'stackable','liquid','none',-1,-1,16706,0,'true','true','true','true','true','none',''),
(6701,'Sealed Imperial Crusader Breastplate Part','false','material',60,'stackable','liquid','none',-1,-1,37565,0,'true','true','true','true','true','none',''),
(6702,'Sealed Imperial Crusader Gaiters Pattern','false','material',60,'stackable','liquid','none',-1,-1,29182,0,'true','true','true','true','true','none',''),
(6703,'Sealed Imperial Crusader Gauntlets Design','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6704,'Sealed Imperial Crusader Boots Design','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6705,'Sealed Imperial Crusader Shield Part','false','material',60,'stackable','liquid','none',-1,-1,14341,0,'true','true','true','true','true','none',''),
(6706,'Sealed Imperial Crusader Helmet Pattern','false','material',60,'stackable','liquid','none',-1,-1,12329,0,'true','true','true','true','true','none',''),
(6707,'Sealed Draconic Leather Armor Part','false','material',60,'stackable','liquid','none',-1,-1,40365,0,'true','true','true','true','true','none',''),
(6708,'Sealed Draconic Leather Gloves Fabric','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6709,'Sealed Draconic Leather Boots Design','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6710,'Sealed Draconic Leather Helmet Pattern','false','material',60,'stackable','liquid','none',-1,-1,12329,0,'true','true','true','true','true','none',''),
(6711,'Sealed Major Arcana Robe Part','false','material',60,'stackable','liquid','none',-1,-1,40365,0,'true','true','true','true','true','none',''),
(6712,'Sealed Major Arcana Gloves fabric','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6713,'Sealed Major Arcana Boots Design','false','material',60,'stackable','liquid','none',-1,-1,14047,0,'true','true','true','true','true','none',''),
(6714,'Sealed Major Arcana Circlet Pattern','false','material',60,'stackable','liquid','none',-1,-1,12329,0,'true','true','true','true','true','none',''),
(6727,'Seed: Alternative Great Coba','false','seed',1,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Seed','2097-3'),
(6728,'Seed: Alternative Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6729,'Seed: Alternative Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6730,'Seed: Alternative Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6731,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6732,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6733,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6734,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6735,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6736,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6737,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6738,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6739,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6740,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6741,'Seed: Alternative Twin Coba','false','seed',1,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','Seed','2097-3'),
(6742,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6743,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6744,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6745,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6746,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6747,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6748,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6749,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6750,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6751,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6752,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6753,'Seed: Great Coba','false','seed',1,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Seed','2097-3'),
(6754,'Seed: Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6755,'Seed: Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6756,'Seed: Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(6757,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6758,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6759,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6760,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6761,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(6762,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6763,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6764,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6765,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6766,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(6767,'Seed: Twin Coba','false','seed',1,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','Seed','2097-3'),
(6768,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6769,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6770,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6771,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6772,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(6773,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6774,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6775,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6776,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6777,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6778,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(6779,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6780,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6781,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6782,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6783,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6784,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6785,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6786,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6787,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6788,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6789,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6790,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6791,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6792,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6793,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6794,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6795,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6796,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6797,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6798,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6799,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6800,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6801,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6802,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6803,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6804,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6805,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6806,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6807,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6808,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6809,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6810,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6811,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6812,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6813,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6814,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6815,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6816,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6817,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6818,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6819,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6820,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6821,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6822,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6823,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6824,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6825,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6826,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6827,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6828,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6829,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6830,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6831,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6832,'Nephilim Warrior Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6833,'Nephilim Shaman Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(6847,'Recipe: Sealed Tateossian Earring (70%)','false','recipe',30,'stackable','paper','none',-1,-1,74000,0,'true','true','true','true','true','Recipes',''),
(6848,'Recipe: Sealed Tateossian Earring (100%)','false','recipe',30,'stackable','paper','none',-1,-1,74000,0,'true','true','true','true','true','Recipes',''),
(6849,'Recipe: Sealed Tateossian Ring(70%)','false','recipe',30,'stackable','paper','none',-1,-1,49400,0,'true','true','true','true','true','Recipes',''),
(6850,'Recipe: Sealed Tateossian Ring(100%)','false','recipe',30,'stackable','paper','none',-1,-1,49400,0,'true','true','true','true','true','Recipes',''),
(6851,'Recipe: Sealed Tateossian Necklace(70%)','false','recipe',30,'stackable','paper','none',-1,-1,98800,0,'true','true','true','true','true','Recipes',''),
(6852,'Recipe: Sealed Tateossian Necklace(100%)','false','recipe',30,'stackable','paper','none',-1,-1,98800,0,'true','true','true','true','true','Recipes',''),
(6853,'Recipe: Sealed Imperial Crusader Breastplate (60%)','false','recipe',30,'stackable','paper','none',-1,-1,286000,0,'true','true','true','true','true','Recipes',''),
(6854,'Recipe: Sealed Imperial Crusader Breastplate (100%)','false','recipe',30,'stackable','paper','none',-1,-1,286000,0,'true','true','true','true','true','Recipes',''),
(6855,'Recipe: Sealed Imperial Crusader Gaiters (60%)','false','recipe',30,'stackable','paper','none',-1,-1,179200,0,'true','true','true','true','true','Recipes',''),
(6856,'Recipe: Sealed Imperial Crusader Gaiters (100%)','false','recipe',30,'stackable','paper','none',-1,-1,179200,0,'true','true','true','true','true','Recipes',''),
(6857,'Recipe: Sealed Imperial Crusader Gauntlets (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6858,'Recipe: Sealed Imperial Crusader Gauntlets (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6859,'Recipe: Sealed Imperial Crusader Boots (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6860,'Recipe: Sealed Imperial Crusader Boots (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6861,'Recipe: Sealed Imperial Crusader Shield (60%)','false','recipe',30,'stackable','paper','none',-1,-1,75200,0,'true','true','true','true','true','Recipes',''),
(6862,'Recipe: Sealed Imperial Crusader Shield (100%)','false','recipe',30,'stackable','paper','none',-1,-1,75200,0,'true','true','true','true','true','Recipes',''),
(6863,'Recipe: Sealed Imperial Crusader Helmet (60%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6864,'Recipe: Sealed Imperial Crusader Helmet (100%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6865,'Recipe: Sealed Draconic Leather Armor (60%)','false','recipe',30,'stackable','paper','none',-1,-1,348000,0,'true','true','true','true','true','Recipes',''),
(6866,'Recipe: Sealed Draconic Leather Armor (100%)','false','recipe',30,'stackable','paper','none',-1,-1,348000,0,'true','true','true','true','true','Recipes',''),
(6867,'Recipe: Sealed Draconic Leather Gloves (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6868,'Recipe: Sealed Draconic Leather Gloves (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6869,'Recipe: Sealed Draconic Leather Boots (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6870,'Recipe: Sealed Draconic Leather Boots (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6871,'Recipe: Sealed Draconic Leather Helmet (60%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6872,'Recipe: Sealed Draconic Leather Helmet (100%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6873,'Recipe: Sealed Major Arcana Robe (60%)','false','recipe',30,'stackable','paper','none',-1,-1,348000,0,'true','true','true','true','true','Recipes',''),
(6874,'Recipe: Sealed Major Arcana Robe (100%)','false','recipe',30,'stackable','paper','none',-1,-1,348000,0,'true','true','true','true','true','Recipes',''),
(6875,'Recipe: Sealed Major Arcana Gloves (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6876,'Recipe: Sealed Major Arcana Gloves (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6877,'Recipe: Sealed Major Arcana Boots (60%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6878,'Recipe: Sealed Major Arcana Boots (100%)','false','recipe',30,'stackable','paper','none',-1,-1,71600,0,'true','true','true','true','true','Recipes',''),
(6879,'Recipe: Sealed Major Arcana Circlet (60%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6880,'Recipe: Sealed Major Arcana Circlet (100%)','false','recipe',30,'stackable','paper','none',-1,-1,107400,0,'true','true','true','true','true','Recipes',''),
(6881,'Recipe: Forgotten Blade (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6882,'Recipe: Forgotten Blade (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6883,'Recipe: Basalt Battlehammer (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6884,'Recipe: Basalt Battlehammer (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6885,'Recipe: Imperial Staff (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6886,'Recipe: Imperial Staff(100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6887,'Recipe: Angel Slayer (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6888,'Recipe: Angel Slayer (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6889,'Recipe: Shining Bow (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6890,'Recipe: Shining Bow (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6891,'Recipe: Dragon Hunter Axe (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6892,'Recipe: Dragon Hunter Axe (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6893,'Recipe: Saint Spear (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6894,'Recipe: Saint Spear (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6895,'Recipe: Demon Splinter (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6896,'Recipe: Demon Splinter (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6897,'Recipe: Heavens Divider (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6898,'Recipe: Heavens Divider (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6899,'Recipe: Arcana Mace (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6900,'Recipe: Arcana Mace (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(6901,'Recipe: Shining Arrow (100%)','false','recipe',30,'stackable','paper','none',-1,-1,200000,0,'true','true','true','true','true','Recipes',''),
(6903,'Music Box M','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2187-1'),
(6904,'Party Mask Fabric','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6905,'Hair Pin Piece','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6906,'Pirate\'s Eye Patch Material','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6907,'Monocle Piece','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(6908,'Fish Oil','false','material',30,'stackable','liquid','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(6909,'Greater Fish Oil','false','material',30,'stackable','liquid','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(6910,'Premium Fish Oil','false','material',30,'stackable','liquid','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(6911,'Fish Scale','false','material',30,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(6912,'Shiny Fish Scale','false','material',30,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(6913,'Fish Gem','false','material',30,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(6914,'Shiny Fish Gem','false','material',30,'stackable','liquid','none',-1,-1,1000,0,'true','true','true','true','true','none',''),
(6915,'Thin Fish Bone','false','material',30,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(6916,'Thick Fish Bone','false','material',30,'stackable','liquid','none',-1,-1,450,0,'true','true','true','true','true','none',''),
(6920,'Recipe: Greater Fish Oil (100%)','false','recipe',30,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Recipes',''),
(6921,'Recipe: Premium Fish Oil(100%)','false','recipe',30,'stackable','paper','none',-1,-1,250,0,'true','true','true','true','true','Recipes',''),
(6922,'Recipe: Party Mask (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(6923,'Recipe: Lady\'s Hair Pin (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(6924,'Recipe: Pirate\'s Eye Patch (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(6925,'Recipe: Monocle (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(6926,'Recipe: Lesser Healing Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18,0,'true','true','true','true','true','Recipes',''),
(6927,'Recipe: Healing Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,66,0,'true','true','true','true','true','Recipes',''),
(6928,'Recipe: Greater Healing Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,180,0,'true','true','true','true','true','Recipes',''),
(6929,'Recipe: Antidote (100%)','false','recipe',30,'stackable','paper','none',-1,-1,15,0,'true','true','true','true','true','Recipes',''),
(6930,'Recipe: Greater Antidote (100%)','false','recipe',30,'stackable','paper','none',-1,-1,36,0,'true','true','true','true','true','Recipes',''),
(6931,'Recipe: Bandage (100%)','false','recipe',30,'stackable','paper','none',-1,-1,15,0,'true','true','true','true','true','Recipes',''),
(6932,'Recipe: Emergency Dressing (100%)','false','recipe',30,'stackable','paper','none',-1,-1,36,0,'true','true','true','true','true','Recipes',''),
(6933,'Recipe: Haste Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,240,0,'true','true','true','true','true','Recipes',''),
(6934,'Recipe: Potion of Alacrity (100%)','false','recipe',30,'stackable','paper','none',-1,-1,480,0,'true','true','true','true','true','Recipes',''),
(6935,'Recipe: Greater Haste Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,600,0,'true','true','true','true','true','Recipes',''),
(6936,'Recipe: Greater Swift Attack Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Recipes',''),
(6937,'Recipe: Magic Haste Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,480,0,'true','true','true','true','true','Recipes',''),
(6938,'Recipe: Greater Magic Haste Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Recipes',''),
(6939,'Recipe: Mystery Potion (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','Recipes',''),
(6940,'Recipe: Facelifting Potion - A (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6941,'Recipe: Facelifting Potion - B (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6942,'Recipe: Facelifting Potion - C (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6943,'Recipe: Dye Potion - A (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6944,'Recipe: Dye Potion - B (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6945,'Recipe: Dye Potion - C (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6946,'Recipe: Dye Potion - D (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6947,'Recipe: Hair Style Change Potion - A (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6948,'Recipe: Hair Style Change Potion - B (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6949,'Recipe: Hair Style Change Potion - C (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6950,'Recipe: Hair Style Change Potion - D (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6951,'Recipe: Hair Style Change Potion - E (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6952,'Recipe: Hair Style Change Potion - F (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6953,'Recipe: Hair Style Change Potion - G (100%)','false','recipe',30,'stackable','paper','none',-1,-1,4000,0,'true','true','true','true','true','Recipes',''),
(6954,'Recipe: Dye of STR <Str+1 Con-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6955,'Recipe: Dye of STR <Str+1 Dex-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6956,'Recipe: Dye of CON <Con+1 Str-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6957,'Recipe: Dye of CON <Con+1 Dex-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6958,'Recipe: Dye of DEX <Dex+1 Str-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6959,'Recipe: Dye of DEX <Dex+1 Con-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6960,'Recipe: Dye of INT <Int+1 Men-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6961,'Recipe: Dye of INT <Int+1 Wit-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6962,'Recipe: Dye of MEN <Men+1 Int-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6963,'Recipe: Dye of MEN <Men+1 Wit-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6964,'Recipe: Dye of WIT<Wit+1 Int-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6965,'Recipe: Dye of WIT<Wit+1 Men-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,7000,0,'true','true','true','true','true','Recipes',''),
(6966,'Recipe: Greater Dye of STR <Str+1 Con-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6967,'Recipe: Greater Dye of STR <Str+1 Dex-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6968,'Recipe: Greater Dye of CON <Con+1 Str-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6969,'Recipe: Greater Dye of CON <Con+1 Dex-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6970,'Recipe: Greater Dye of DEX <Dex+1 Str-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6971,'Recipe: Greater Dye of DEX <Dex+1 Con-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6972,'Recipe: Greater Dye of INT <Int+1 Men-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6973,'Recipe: Greater Dye of INT <Int+1 Wit-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6974,'Recipe: Greater Dye of MEN <Men+1 Int-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6975,'Recipe: Greater Dye of MEN <Men+1 Wit-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6976,'Recipe: Greater Dye of WIT<Wit+1 Int-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6977,'Recipe: Greater Dye of WIT<Wit+1 Men-1> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','Recipes',''),
(6978,'Recipe: Greater Dye of STR <Str+2 Con-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6979,'Recipe: Greater Dye of STR <Str+2 Dex-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6980,'Recipe: Greater Dye of CON <Con+2 Str-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6981,'Recipe: Greater Dye of CON <Con+2 Dex-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6982,'Recipe: Greater Dye of DEX <Dex+2 Str-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6983,'Recipe: Greater Dye of DEX <Dex+2 Con-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6984,'Recipe: Greater Dye of INT <Int+2 Men-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6985,'Recipe: Greater Dye of INT <Int+2 Wit-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6986,'Recipe: Greater Dye of MEN <Men+2 Int-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6987,'Recipe: Greater Dye of MEN <Men+2 Wit-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6988,'Recipe: Greater Dye of WIT<Wit+2 Int-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6989,'Recipe: Greater Dye of WIT<Wit+2 Men-2> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,12000,0,'true','true','true','true','true','Recipes',''),
(6990,'Recipe: Greater Dye of STR <Str+3 Con-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6991,'Recipe: Greater Dye of STR <Str+3 Dex-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6992,'Recipe: Greater Dye of CON <Con+3 Str-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6993,'Recipe: Greater Dye of CON <Con+3 Dex-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6994,'Recipe: Greater Dye of DEX <Dex+3 Str-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6995,'Recipe: Greater Dye of DEX <Dex+3 Con-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6996,'Recipe: Greater Dye of INT <Int+3 Men-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6997,'Recipe: Greater Dye of INT <Int+3 Wit-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6998,'Recipe: Greater Dye of MEN <Men+3 Int-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(6999,'Recipe: Greater Dye of MEN <Men+3 Wit-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(7000,'Recipe: Greater Dye of WIT<Wit+3 Int-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(7001,'Recipe: Greater Dye of WIT<Wit+3 Men-3> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,18000,0,'true','true','true','true','true','Recipes',''),
(7002,'Recipe: Greater Dye of STR <Str+4 Con-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7003,'Recipe: Greater Dye of STR <Str+4 Dex-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7004,'Recipe: Greater Dye of CON <Con+4 Str-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7005,'Recipe: Greater Dye of CON <Con+4 Dex-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7006,'Recipe: Greater Dye of DEX <Dex+4 Str-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7007,'Recipe: Greater Dye of DEX <Dex+4 Con-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7008,'Recipe: Greater Dye of INT <Int+4 Men-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7009,'Recipe: Greater Dye of INT <Int+4 Wit-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7010,'Recipe: Greater Dye of MEN <Men+4 Int-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7011,'Recipe: Greater Dye of MEN <Men+4 Wit-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7012,'Recipe: Greater Dye of WIT<Wit+4 Int-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7013,'Recipe: Greater Dye of WIT<Wit+4 Men-4> (100%)','false','recipe',30,'stackable','paper','none',-1,-1,29000,0,'true','true','true','true','true','Recipes',''),
(7016,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(7017,'Seed: Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7018,'Seed: Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7019,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(7020,'Seed: Chilly Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(7021,'Seed: Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7022,'Seed: Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7023,'Seed: Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(7024,'Seed: Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(7025,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(7026,'Seed: Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(7027,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(7028,'Seed: Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(7029,'Seed: Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(7030,'Seed: Alternative Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(7031,'Seed: Alternative Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7032,'Seed: Alternative Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7033,'Seed: Alternative Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(7034,'Seed: Alternative Chilly Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(7035,'Seed: Alternative Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7036,'Seed: Alternative Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7037,'Seed: Alternative Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(7038,'Seed: Alternative Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(7039,'Seed: Alternative Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(7040,'Seed: Alternative Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(7041,'Seed: Alternative Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(7042,'Seed: Alternative Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(7043,'Seed: Alternative Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(7044,'Seed: Alternative Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(7045,'Seed: Alternative Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7046,'Seed: Alternative Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7047,'Seed: Alternative Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7048,'Seed: Alternative Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7049,'Seed: Alternative Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7050,'Seed: Alternative Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7051,'Seed: Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(7052,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7053,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(7054,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7055,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7056,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7057,'Seed: Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(7061,'Echo Crystal - Theme of Birthday','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Potions','2073-1'),
(7062,'Echo Crystal - Theme of Wedding','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2230-1'),
(7063,'Map - Forest of the Dead','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7064,'Lidia\'s Diary','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7065,'Lidia\'s Letter','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7066,'Contract','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7067,'Special Bait 1','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7068,'Special Bait 2','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7069,'Special Bait 3','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7070,'Special Bait 4','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7071,'Special Fish 1','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7072,'Special Fish 2','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7073,'Special Fish 3','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7074,'Special Fish 4','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7075,'Entrance Pass to the Sepulcher','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7076,'Mysterious Cloth','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7077,'Jewel Box','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7078,'Sewing Kit','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7079,'Dimensional Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7080,'Ice Crystal','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7081,'Divine Stone of Wisdom','false','none',10,'normal','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7082,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7083,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7084,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7085,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7086,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7087,'Tattered Book','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7088,'Tattered Book','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7089,'Tattered Book','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7090,'Tattered Book','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7091,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7092,'Guild Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7093,'Sculpture of the Fallen Knight','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7094,'Record of Mother Tree Guardian','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7095,'Criticism of Biel\'s Song','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7096,'The Last Days of Swordsman Iron','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7097,'Contemplation of White Wing Army','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7098,'Record of Traitor Muhark','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7099,'Secret Book of Khavatari','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7100,'Importance of Strain','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7101,'Danger of Ice Spirit','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7102,'Guardian Angel of the Tablet - Vol. 1','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7103,'Guardian Angel of the Tablet - Vol. 1','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7104,'Guardian Angel of the Tablet - Vol. 1','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7105,'Guardian Angel of the Tablet - Vol. 2','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7106,'Guardian Angel of the Tablet - Vol. 2','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7107,'Guardian Angel of the Tablet - Vol. 2','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7108,'Guild\'s Secret Report','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7109,'Guild\'s Secret Report','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7110,'Research Report','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7111,'Research Report','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7112,'Research Report','false','none',0,'normal','paper','none',-1,-1,0,0,'false','false','false','false','false','Book',''),
(7113,'Dress Shoe Box','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7114,'Voucher - Buffalo','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7115,'Voucher - Cougar','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7116,'Voucher - Kookaburra','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7117,'Scroll of Escape: Talking Island','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-1'),
(7118,'Scroll of Escape: Elven Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-2'),
(7119,'Scroll of Escape: Dark Elf Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-3'),
(7120,'Scroll of Escape: Orc Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-4'),
(7121,'Scroll of Escape: Dwarven Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-5'),
(7122,'Scroll of Escape: Gludin Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-6'),
(7123,'Scroll of Escape: Town of Gludio','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-7'),
(7124,'Scroll of Escape: Town of Dion','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-8'),
(7125,'Scroll of Escape: Floran','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-9'),
(7126,'Scroll of Escape: Giran Castle Town','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-10'),
(7127,'Scroll of Escape: Hardin\'s Private Academy','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-11'),
(7128,'Scroll of Escape: Heine','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-12'),
(7129,'Scroll of Escape: Town of Oren','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-13'),
(7130,'Scroll of Escape: Ivory Tower','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-14'),
(7131,'Scroll of Escape: Hunters Village','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-15'),
(7132,'Scroll of Escape: Aden Castle Town','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-16'),
(7133,'Scroll of Escape: Town of Goddard','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-17'),
(7134,'Scroll of Escape: Rune Township','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-18'),
(7135,'Scroll of Escape: Town of Schuttgart','false','none',30,'stackable','paper','none',-1,-1,35000,0,'true','true','true','true','true','ItemSkills','2213-19'),
(7136,'Fruit Basket','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7137,'Avellan Spice','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7138,'Honey Pouch','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7139,'Bracelet of Lizardman','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7140,'Cross of Einhasad','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7141,'Cross of Einhasad','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7142,'Lost Skull of Elf','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7143,'Letter of Innocentin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7144,'Jewel of Adventurer','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7145,'Jewel of Adventurer','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7146,'Sealed Report Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7147,'Report Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7148,'Lidia\'s Hairpin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7149,'Silver Key','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7150,'Silver Spear','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7151,'Suspicious Totem Doll','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7152,'Flower Bouquet','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7153,'Silver Cross of Einhasad','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7154,'Broken Silver Cross of Einhasad','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7155,'Lidia\'s Dress','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7156,'Suspicious Totem Doll','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7157,'Gemstone Key','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7158,'Suspicious Totem Doll','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7159,'Box of Cookies','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7160,'Luxury Wine','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7161,'Skein of Yarn','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7162,'Rough Jewel','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7163,'Enchanted Iron','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7164,'Signet Ring','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7165,'Map','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7166,'Medicinal Herb','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7167,'Crystal of Seal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7168,'Blood of Saint','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7169,'Blood of Saint','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7170,'Seal of Light','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7171,'Bead of Obedience','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7172,'Gem of Saints','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7173,'Feather Ornament','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7174,'Tooth of Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7175,'Tooth of Dragon','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7176,'Letter of Iris','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7177,'Letter of Rohmer','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7178,'Black Bone Necklace','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7179,'Red Bone Necklace','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7180,'Incense Pouch','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7181,'Gem of Maille Lizardman','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7182,'Patrol\'s Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7183,'Shining Gem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7184,'Shining Red Gem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7185,'Jewel of Innocence','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7186,'Horn of Buffalo','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7187,'Nepenthes Seed','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7188,'Proof of Avenger','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7189,'Eye of Darkness','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7190,'Evil Spirit of Darkness','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7191,'Broken Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7192,'Unfinished Summon Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7193,'Summon Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7194,'Essence of Daimon','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7195,'Boiled Eggs','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7196,'Fee of Boiled Egg','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7197,'Special Drink','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7198,'Fee of Special Drink','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7199,'Leaf of Flava','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7200,'Buffalo Meat','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7201,'Antelope Horn','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7202,'Trunk of Nepenthes','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7203,'Foot of Bandersnatchling','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7204,'Secret Spice','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7205,'Soy Sauce Jar','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7206,'Boiled Eggs for Delivery','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7207,'Special Drink for Delivery','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7208,'Hot Food Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7209,'Food for Bumbalump','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7210,'Special Yeti Meat','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7211,'Mark of Ketra\'s Alliance - Level 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7212,'Mark of Ketra\'s Alliance - Level 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7213,'Mark of Ketra\'s Alliance - Level 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7214,'Mark of Ketra\'s Alliance - Level 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7215,'Mark of Ketra\'s Alliance - Level 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7216,'Varka\'s Badge - Soldier','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7217,'Varka\'s Badge - Captain','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7218,'Varka\'s Badge - General','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7219,'Totem of Valor','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7220,'Totem of Wisdom','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7221,'Mark of Varka\'s Alliance - Level 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7222,'Mark of Varka\'s Alliance - Level 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7223,'Mark of Varka\'s Alliance - Level 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7224,'Mark of Varka\'s Alliance - Level 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7225,'Mark of Varka\'s Alliance - Level 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7226,'Ketra\'s Badge - Soldier','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7227,'Ketra\'s Badge - Captain','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7228,'Ketra\'s Badge - General','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7229,'Feather of Valor','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7230,'Feather of Wisdom','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7231,'Munitions Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7232,'Munitions Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7233,'Varka\'s Mane','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7234,'Molar of Ketra Orc','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7235,'Head of Shadith','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7236,'Head of Mos','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7237,'Stolen Green Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7238,'Green Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7239,'Ice Heart of Ashutar','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7240,'Head of Hekaton','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7241,'Head of Tayr','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7242,'Stolen Red Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7243,'Red Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7244,'Fire Heart of Nastron','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7245,'Supply Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7246,'Golden Ram Badge - Recruit','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7247,'Golden Ram Badge - Soldier','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7248,'Splinter Stakato Chitin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7249,'Needle Stakato Chitin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7250,'Talon of Stakato','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7251,'Golden Ram Coin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7252,'Krorin\'s Journal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7253,'Letter to Archaeologist','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7254,'Broken Relic Part','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7255,'Sealed Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7256,'Goblet of Alectia','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7257,'Goblet of Tishas','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7258,'Goblet of Mekara','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7259,'Goblet of Morigul','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7260,'Chapel Key','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7261,'Used Grave Pass','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7262,'Antique Brooch','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7263,'Package to Vulcan','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7264,'Torch','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7265,'Vacualite Ore','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7266,'Vacualite','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7267,'Floating Stone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7268,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7269,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7270,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7271,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7272,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7273,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7274,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7275,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7276,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7277,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7278,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7279,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7280,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7281,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7282,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7283,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7284,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7285,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7286,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7287,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7288,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7289,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7290,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7291,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7292,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7293,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7294,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7295,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7296,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7297,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7298,'Resonance Amulet - 1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7299,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7300,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7301,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7302,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7303,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7304,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7305,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7306,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7307,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7308,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7309,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7310,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7311,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7312,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7313,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7314,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7315,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7316,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7317,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7318,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7319,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7320,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7321,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7322,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7323,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7324,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7325,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7326,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7327,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7328,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7329,'Resonance Amulet - 2','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7330,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7331,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7332,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7333,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7334,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7335,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7336,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7337,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7338,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7339,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7340,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7341,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7342,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7343,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7344,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7345,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7346,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7347,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7348,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7349,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7350,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7351,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7352,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7353,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7354,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7355,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7356,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7357,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7358,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7359,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7360,'Resonance Amulet - 3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7361,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7362,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7363,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7364,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7365,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7366,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7367,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7368,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7369,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7370,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7371,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7372,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7373,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7374,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7375,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7376,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7377,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7378,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7379,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7380,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7381,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7382,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7383,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7384,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7385,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7386,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7387,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7388,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7389,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7390,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7391,'Resonance Amulet - 4','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7392,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7393,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7394,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7395,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7396,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7397,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7398,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7399,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7400,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7401,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7402,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7403,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7404,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7405,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7406,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7407,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7408,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7409,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7410,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7411,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7412,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7413,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7414,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7415,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7416,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7417,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7418,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7419,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7420,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7421,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7422,'Resonance Amulet - 5','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7423,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7424,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7425,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7426,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7427,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7428,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7429,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7430,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7431,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7432,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7433,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7434,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7435,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7436,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7437,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7438,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7439,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7440,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7441,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7442,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7443,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7444,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7445,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7446,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7447,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7448,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7449,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7450,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7451,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7452,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7453,'Resonance Amulet - 6','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7454,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7455,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7456,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7457,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7458,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7459,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7460,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7461,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7462,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7463,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7464,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7465,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7466,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7467,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7468,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7469,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7470,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7471,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7472,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7473,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7474,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7475,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7476,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7477,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7478,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7479,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7480,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7481,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7482,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7483,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7484,'Resonance Amulet - 7','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none','');

INSERT INTO `etcitem` VALUES
(7485,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7486,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7487,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7488,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7489,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7490,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7491,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7492,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7493,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7494,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7495,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7496,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7497,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7498,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7499,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7500,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7501,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7502,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7503,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7504,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7505,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7506,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7507,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7508,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7509,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7510,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7511,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7512,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7513,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7514,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7515,'Halisha\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7516,'Ice Wine','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7517,'Donath\'s\' Dish','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7518,'Donath\'s\' Note - Vol.1','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7519,'Shaved Ice','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7520,'Ice Cream','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7521,'Ice Crystal Gemstone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7522,'Offering','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7523,'Offering','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7524,'Offering','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7525,'Offering','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7526,'Ancient Language Dictionary','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7527,'Ancient Language Dictionary','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7528,'Spinneret','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7529,'Investigative Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7530,'Investigative Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7531,'Investigative Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7532,'Investigative Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7533,'Investigative Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7534,'Ice Cold Flower','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7535,'Pure Ice','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7536,'Bitter Cold Beer','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7537,'Multiple Course Meal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7538,'Dead Souls Fish Soup','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7539,'Bitter Cold Vodka','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7540,'Silver Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7541,'Red Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7542,'Vampire\'s Heart','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7543,'Zombie\'s Brain','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7544,'Rib Bone of a Black Magus','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7545,'Zombie\'s Liver','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7546,'Top Quality Meat','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7547,'Young Wild Beast Meat','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7548,'Map Piece','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7549,'Yellow Map','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7550,'Map Piece','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7551,'Ivory Colored Map','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7552,'Broken Gemstone Fragment','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7553,'Gold Colored Gemstone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7554,'Scroll of Escape: Talking Island','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-1'),
(7555,'Scroll of Escape: Elven Village','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-2'),
(7556,'Scroll of Escape: Dark Elf Village','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-3'),
(7557,'Scroll of Escape: Orc Village','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-4'),
(7558,'Scroll of Escape: Dwarven Village','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-5'),
(7559,'Scroll of Escape: Giran Castle Town','false','none',0,'normal','paper','none',-1,-1,400,0,'false','false','true','false','true','ItemSkills','2214-10'),
(7561,'Fishing Manual','false','none',0,'normal','paper','none',-1,-1,100,0,'false','false','true','false','true','Book',''),
(7562,'Dimensional Diamond','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7563,'Galladucci\'s Order (Document)','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7564,'Galladucci\'s Order (Document)','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7565,'Galladucci\'s Order (Document)','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7566,'Purified Magic Necklace','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7567,'Gemstone Powder','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7568,'Magic Sword Hilt','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7569,'Four-leaf Golden Clover Coin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7570,'Mark of Traveler','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7571,'Baulro\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7572,'Ariel\'s Recommendation','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7573,'Roselyn\'s Note','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7574,'Very Expensive Necklace','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7579,'Draconic Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,91471,0,'true','true','true','true','true','none',''),
(7580,'Recipe: Draconic Bow (60%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(7581,'Recipe: Draconic Bow (100%)','false','recipe',30,'stackable','paper','none',-1,-1,976000,0,'true','true','true','true','true','Recipes',''),
(7582,'Baby Spice','false','none',10,'stackable','liquid','none',-1,-1,108,0,'true','true','true','true','true','PetFood',''),
(7583,'Pet Exchange Ticket: Buffalo','false','none',20,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','none',''),
(7584,'Pet Exchange Ticket: Cougar','false','none',20,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','none',''),
(7585,'Pet Exchange Ticket: Kookaburra','false','none',20,'stackable','paper','none',-1,-1,500000,0,'true','true','true','true','true','none',''),
(7586,'Sweet Fluid','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7587,'Legend of Seventeen','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7588,'Faded Poetry Book','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7589,'Echo Crystal - Forgotten Song','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7590,'Strand of Golden Hair','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7591,'Ring of Goddess: Waterbinder','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7592,'Necklace of Goddess: EverGreen','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7593,'Staff of Goddess: Rain Song','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7594,'Relic Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7595,'Orb of Binding','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7596,'Sorcery Ingredient','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7597,'Malruk Succubus Claw','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7598,'Crimson Moss','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7599,'Rahorakti\'s Miraculous Medicine','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7600,'Worn Tarot Card - Wealth','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7601,'Worn Tarot Card - Power','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7602,'Worn Tarot Card - Love','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7603,'Worn Tarot Card - Knowledge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7604,'Summoner Keats\' Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7605,'Miracle Potion of Transferred Life','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7606,'Kamilen\'s Antidote','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7607,'Coolant of the Repaired Wilma #3','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7608,'Sealed Envelope','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7609,'Proof of Catching a Fish','false','none',0,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(7610,'Wind Fishing Lure','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7611,'Icy Air Fishing Lure','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7612,'Earth Fishing Lure','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7613,'Flaming Fishing Lure','false','lure',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7614,'Chest Caught by Wind Fishing Lure','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7615,'Chest Caught by Icy Air Fishing Lure','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7616,'Chest Caught by Earth Fishing Lure','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7617,'Chest Caught by using a Flaming Fishing Lure','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(7618,'Scroll of Escape: Ketra Orc Village','false','none',30,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2213-20'),
(7619,'Scroll of Escape: Varka Silenos Village','false','none',30,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','ItemSkills','2213-21'),
(7620,'Trash','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7621,'Essence of Wind','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7622,'Lost Bait Ingredient','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7623,'Eye of Tarlk Basilisk','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7624,'Crimson Drake Heart','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7625,'Strange Golem Blueprint','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7626,'Kiki\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7627,'Small Glass Box','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7628,'Rukal\'s Musical Score','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(7629,'Looted Goods - White Cargo box','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2217-1'),
(7630,'Looted Goods - Blue Cargo box','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2217-2'),
(7631,'Looted Goods - Yellow Cargo box','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2217-3'),
(7632,'Looted Goods - Red Cargo Box','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2217-4'),
(7633,'Looted Goods - Purple Cargo Box','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2217-5'),
(7634,'Looted Goods - Brown Pouch','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2219-1'),
(7635,'Looted Goods - Gray Pouch','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2219-2'),
(7636,'Booty - Yellow Pouch','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2218-1'),
(7637,'Booty - Brown Pouch','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2218-2'),
(7638,'Spellbook - Mass Summon Storm Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7639,'Spellbook - Mass Summon Aqua Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7640,'Spellbook - Mass Summon Phantom Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7641,'Spellbook - Summon Feline Queen','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7642,'Spellbook - Summon Unicorn Seraphim','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7643,'Spellbook - Summon Nightshade','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7644,'Spellbook - Summon Cursed Man','false','spellbook',120,'stackable','paper','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(7645,'Spellbook - Balance Life','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7646,'Spellbook - Curse of Doom','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7647,'Spellbook - Curse of Abyss','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7648,'Spellbook - Arcane Chaos','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7649,'Spellbook - Fire Vortex','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7650,'Spellbook - Ice Vortex','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7651,'Spellbook - Wind Vortex','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7652,'Spellbook - Light Vortex','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7653,'Spellbook - Dark Vortex','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7654,'Spellbook - Mass Warrior Bane','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7655,'Spellbook - Mass Mage Bane','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7656,'Spellbook - Warrior Servitor','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7657,'Spellbook - Wizard Servitor','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7658,'Spellbook - Assassin Servitor','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7659,'Spellbook - Final Servitor','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7660,'Spellbook - Warrior Bane','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7661,'Spellbook - Mage Bane','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7662,'Spellbook - Elemental Protection','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7663,'Spellbook - Divine Protection','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7664,'Spellbook - Arcane Protection','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7665,'Spellbook - Prophecy of Water','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7666,'Spellbook - Prophecy of Fire','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7667,'Spellbook - Prophecy of Wind','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7668,'Spellbook - Block Shield','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7669,'Spellbook - Block Wind Walk','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7670,'Spellbook - Mass Block Shield','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7671,'Spellbook - Mass Block Wind Walk','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7672,'Amulet - Chant of Spirit','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7673,'Amulet - Chant of Victory','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7674,'Amulet - Pa\'agrio\'s Eye','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7675,'Amulet - Pa\'agrio\'s Soul','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7676,'Amulet - Seal of Despair','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7677,'Virgil\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(7678,'Caradine\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(7679,'Caradine\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(7684,'Raccoon Ears Fabric','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7685,'Outlaw\'s Eyepatch Strap','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7686,'Maiden\'s Hairpin Piece','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7687,'Rabbit Ears Fabric','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7688,'Cat Ears Fabric','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7689,'Recipe - Raccoon Ears (100%)','false','recipe',30,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','Recipes',''),
(7690,'Recipe - Outlaw\'s Eyepatch (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(7691,'Recipe - Maiden\'s Hairpin (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(7692,'Recipe - Rabbit Ears (100%)','false','recipe',30,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','Recipes',''),
(7693,'Recipe - Cat Ears (100%)','false','recipe',30,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','Recipes',''),
(7697,'Piece of Forget-me-not Hairpin','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7698,'Piece of Daisy Hairpin','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7699,'Recipe: Forget-me-not Hairpin (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(7700,'Recipe: Daisy Hairpin (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(7725,'Loot - Gray Pouch','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2218-3'),
(7726,'Small Nimble Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,69,0,'true','true','true','true','true','ItemSkills','2220-1'),
(7727,'Small Ugly Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,71,0,'true','true','true','true','true','ItemSkills','2220-2'),
(7728,'Small Pudgy Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,77,0,'true','true','true','true','true','ItemSkills','2220-3'),
(7729,'Nimble Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,84,0,'true','true','true','true','true','ItemSkills','2220-4'),
(7730,'Ugly Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,94,0,'true','true','true','true','true','ItemSkills','2220-5'),
(7731,'Pudgy Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,104,0,'true','true','true','true','true','ItemSkills','2220-6'),
(7732,'Large Nimble Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,113,0,'true','true','true','true','true','ItemSkills','2220-7'),
(7733,'Large Ugly Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,124,0,'true','true','true','true','true','ItemSkills','2220-8'),
(7734,'Large Pudgy Green Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,133,0,'true','true','true','true','true','ItemSkills','2220-9'),
(7735,'Small Jade Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,143,0,'true','true','true','true','true','ItemSkills','2221-1'),
(7736,'Small Jade Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2221-2'),
(7737,'Small Jade Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,167,0,'true','true','true','true','true','ItemSkills','2221-3'),
(7738,'Jade Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,166,0,'true','true','true','true','true','ItemSkills','2221-4'),
(7739,'Jade Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,165,0,'true','true','true','true','true','ItemSkills','2221-5'),
(7740,'Jade Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,165,0,'true','true','true','true','true','ItemSkills','2221-6'),
(7741,'Large Jade Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,164,0,'true','true','true','true','true','ItemSkills','2221-7'),
(7742,'Large Jade Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,164,0,'true','true','true','true','true','ItemSkills','2221-8'),
(7743,'Large Jade Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2221-9'),
(7744,'Small Blue Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,163,0,'true','true','true','true','true','ItemSkills','2222-1'),
(7745,'Small Blue Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-2'),
(7746,'Small Blue Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-3'),
(7747,'Blue Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-4'),
(7748,'Blue Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-5'),
(7749,'Blue Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-6'),
(7750,'Large Blue Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-7'),
(7751,'Large Blue Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-8'),
(7752,'Large Blue Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2222-9'),
(7753,'Small Yellow Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-1'),
(7754,'Small Yellow Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-2'),
(7755,'Small Yellow Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-3'),
(7756,'Yellow Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-4'),
(7757,'Yellow Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,277,0,'true','true','true','true','true','ItemSkills','2223-5'),
(7758,'Yellow Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-6'),
(7759,'Large Yellow Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-7'),
(7760,'Large Yellow Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-8'),
(7761,'Large Yellow Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2223-9'),
(7762,'Small Orange Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-1'),
(7763,'Small Orange Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-2'),
(7764,'Small Orange Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-3'),
(7765,'Orange Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-4'),
(7766,'Orange Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-5'),
(7767,'Orange Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-6'),
(7768,'Large Orange Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-7'),
(7769,'Large Orange Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-8'),
(7770,'Large Orange Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2224-9'),
(7771,'Small Purple Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-1'),
(7772,'Small Purple Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-2'),
(7773,'Small Purple Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,455,0,'true','true','true','true','true','ItemSkills','2225-3'),
(7774,'Purple Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-4'),
(7775,'Purple Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-5'),
(7776,'Purple Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-6'),
(7777,'Large Purple Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-7'),
(7778,'Large Purple Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-8'),
(7779,'Large Purple Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2225-9'),
(7780,'Small Red Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-1'),
(7781,'Small Red Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-2'),
(7782,'Small Red Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-3'),
(7783,'Red Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-4'),
(7784,'Red Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-5'),
(7785,'Red Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-6'),
(7786,'Large Red Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-7'),
(7787,'Large Red Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-8'),
(7788,'Large Red Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2226-9'),
(7789,'Small White Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-1'),
(7790,'Small White Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-2'),
(7791,'Small White Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-3'),
(7792,'White Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-4'),
(7793,'White Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-5'),
(7794,'White Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-6'),
(7795,'Large White Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-7'),
(7796,'Large White Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-8'),
(7797,'Large White Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2227-9'),
(7798,'Small Black Nimble Fish: For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-1'),
(7799,'Small Black Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-2'),
(7800,'Small Black Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-3'),
(7801,'Black Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-4'),
(7802,'Black Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-5'),
(7803,'Black Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-6'),
(7804,'Large Black Nimble Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-7'),
(7805,'Large Black Ugly Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-8'),
(7806,'Large Black Fat Fish - For Beginners','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2228-9'),
(7807,'Green Colored Lure - For Beginners','false','lure',5,'stackable','liquid','none',-1,-1,50,0,'true','true','true','true','true','none',''),
(7808,'Purple Colored Lure - For Beginners','false','lure',5,'stackable','liquid','none',-1,-1,70,0,'true','true','true','true','true','none',''),
(7809,'Yellow Colored Lure - For Beginners','false','lure',5,'stackable','liquid','none',-1,-1,60,0,'true','true','true','true','true','none',''),
(7832,'Apprentice Adventurer\'s Weapon Exchange Coupon','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(7833,'Adventurers Magic Accessory Exchange Coupon','false','none',1,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(7835,'Amulet: Seal of Disease','false','spellbook',120,'stackable','paper','none',-1,-1,11600,0,'true','true','true','true','true','none',''),
(7838,'Santa\'s Hat','false','none',10,'normal','paper','none',-1,-1,0,0,'true','false','true','true','true','none',''),
(7904,'Boat Ticket: Rune to Gludin','false','none',20,'stackable','paper','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7905,'Boat Ticket: Gludin to Rune','false','none',20,'stackable','paper','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(7906,'Blessing of Fire','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2248-1'),
(7907,'Blessing of Water','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2249-1'),
(7908,'Blessing of Wind','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2250-1'),
(7909,'Blessing of Earth','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2251-1'),
(7910,'Blessing of Darkness','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2252-1'),
(7911,'Blessing of Sanctity','false','none',20,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2253-1'),
(7912,'Fire Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7913,'Water Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7914,'Wind Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7915,'Earth Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7916,'Darkness Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7917,'Sanctity Crystal','false','none',20,'stackable','liquid','none',-1,-1,3000,0,'true','true','true','true','true','ItemSkills',''),
(7918,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7919,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7920,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7921,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7922,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7923,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7924,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7925,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7926,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7927,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7928,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7929,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7930,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7931,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7932,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7933,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7934,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7935,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7936,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7937,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7938,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7939,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7940,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7941,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7942,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7943,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7944,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7945,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7946,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7947,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7948,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7949,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7950,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7951,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7952,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7953,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7954,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7955,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7956,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7957,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7958,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7959,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7960,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7961,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7962,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7963,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7964,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7965,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7966,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7967,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7968,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7969,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7970,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7971,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7972,'Nephilim Shaman Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7973,'Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7974,'Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7975,'Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7976,'Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7977,'Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7978,'Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7979,'Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7980,'Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7981,'Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7982,'Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7983,'Mercenary Posting Ticket (Teleporter1)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7984,'Mercenary Posting Ticket (Teleporter2)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7985,'Mercenary Posting Ticket (Teleporter3)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7986,'Mercenary Posting Ticket (Teleporter4)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7987,'Mercenary Posting Ticket (Teleporter5)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7988,'Greater Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7989,'Greater Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7990,'Greater Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7991,'Greater Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7992,'Greater Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7993,'Greater Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7994,'Greater Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7995,'Greater Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7996,'Greater Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7997,'Greater Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7998,'Dawn Mercenary Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(7999,'Dawn Mercenary Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8000,'Dawn Mercenary Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8001,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8002,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8003,'Dawn Mercenary Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8004,'Dawn Mercenary Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8005,'Dawn Mercenary Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8006,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8007,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8008,'Greater Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8009,'Greater Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8010,'Greater Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8011,'Greater Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8012,'Greater Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8013,'Greater Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8014,'Greater Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8015,'Greater Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8016,'Greater Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8017,'Greater Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8018,'Recruit Posting Ticket (Sword/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8019,'Recruit Posting Ticket (Spear/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8020,'Recruit Posting Ticket (Bow/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8021,'Recruit Posting Ticket (Cleric/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8022,'Recruit Posting Ticket (Wizard/Stationary)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8023,'Recruit Posting Ticket (Sword/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8024,'Recruit Posting Ticket (Spear/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8025,'Recruit Posting Ticket (Bow/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8026,'Recruit Posting Ticket (Cleric/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8027,'Recruit Posting Ticket (Wizard/Mobile)','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8028,'Nephilim Warrior Posting Ticket','false','castle_guard',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8029,'Nephilim Shaman Posting Ticket','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','MercTicket',''),
(8030,'Hot Spring Nectar','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8031,'Hot Spring Mineral Water','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8032,'Hot Spring Water','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8033,'Hot Spring Sulfur','false','quest',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8034,'Rainbow Springs Clan Hall War Decree','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8035,'Hot Spring Letter A','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8036,'Hot Spring Letter B','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8037,'Hot Spring Letter C','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8038,'Hot Spring Letter D','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8039,'Hot Spring Letter E','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8040,'Hot Spring Letter F','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8041,'Hot Spring Letter G','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8042,'Hot Spring Letter H','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8043,'Hot Spring Letter I','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8044,'Hot Spring Letter J','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8045,'Hot Spring Letter K','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8046,'Hot Spring Letter L','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8047,'Hot Spring Letter N','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8048,'Hot Spring Letter O','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8049,'Hot Spring Letter P','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8050,'Hot Spring Letter R','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8051,'Hot Spring Letter S','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8052,'Hot Spring letter T','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8053,'Hot Spring Letter U','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8054,'Hot Spring Letter W','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8055,'Hot Spring Letter Y','false','none',0,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8056,'Key of Splendor Room','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2238-1'),
(8057,'Silver Hemocyte','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8058,'Lockup Research Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8059,'Research Report','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Book',''),
(8060,'Key of Enigma','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2260-1'),
(8061,'Scribbled Memo','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8062,'Blood of Maille Lizardman','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8063,'Leg of King Araneid','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8064,'Visitor\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8065,'Faded Visitor\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8066,'Necromancer\'s Heart','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8067,'Pagan\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8068,'Pagan Totem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(8069,'Monk\'s Scripture','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8070,'Water Bottle','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8071,'Bottle of water from the Holy Grail','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8072,'Antelope Skin','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8073,'Frintezza\'s Magic Force Field Removal Scroll','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8074,'Watching Eyes','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8075,'Roughly Hewn Rock Golem Shard','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8076,'Delu Lizardman\'s Scale','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8077,'Silver Ice Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8078,'Black Ice Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8079,'Misa\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8080,'Rafforty\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8081,'Piece of Tablet','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8082,'Report Piece','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8083,'Scout\'s Memo','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8084,'Crystal of Purity','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8085,'Fang of Stakato','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8086,'Box Containing the Fire of Holy Spirit','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8087,'Cursed Doll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8088,'Orc Grave Goods','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8089,'Cursed Grave Goods','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8090,'Electric Wave Detector','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8091,'Electric Wave Detector','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8092,'Telescope Golem\'s Corpse','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8093,'Golem\'s Dispatcher','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8094,'Storage Medium','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8095,'Storage Medium','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8096,'Ginzu Golem\'s Black Box','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8097,'X-688','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8098,'Supplying Goods for Railroad Worker','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8099,'Thief Guild\'s Mark','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8100,'Destroyed Golem Shards','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(8101,'Dwarf\'s Favor','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8153,'Adventurer\'s Guide Book','false','none',0,'normal','paper','none',-1,-1,2000,0,'true','true','true','true','true','none',''),
(8154,'Herb of Life','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2244-1'),
(8155,'Herb of Mana','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2245-1'),
(8156,'Herb of Power','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2246-1'),
(8157,'Herb of Magic','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2247-1'),
(8158,'Memento Mori: C-Grade','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8159,'Memento Mori: B-Grade','false','none',0,'stackable','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8160,'Memento Mori: A-Grade','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8161,'Dragon Heart: C-Grade','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8162,'Dragon Heart: B-Grade','false','none',0,'stackable','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8163,'Dragon Heart: A-Grade','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8164,'Earth Egg: C-Grade','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8165,'Earth Egg: B-Grade','false','none',0,'stackable','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8166,'Earth Egg: A-Grade','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8167,'Nonliving Nucleus: C-Grade','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8168,'Nonliving Nucleus: B-Grade','false','none',0,'stackable','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8169,'Nonliving Nucleus: A-Grade','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8170,'Angelic Essence: C-Grade','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8171,'Angelic Essence: B-Grade','false','none',0,'stackable','paper','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8172,'Angelic Essence: A-Grade','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8173,'Cradle of Creation: C-Grade (Not used)','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8174,'Cradle of Creation: B-Grade (Not used)','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8175,'Cradle of Creation','false','none',0,'stackable','paper','none',-1,-1,50000,0,'true','true','true','true','true','none',''),
(8176,'Destruction Tombstone','false','none',0,'stackable','paper','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8192,'Soul Breaking Arrow','false','none',3,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none','2234-1'),
(8193,'Fisherman\'s Potion - Green','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-1'),
(8194,'Fisherman\'s Potion - Jade','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-2'),
(8195,'Fisherman\'s Potion - Blue','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-3'),
(8196,'Fisherman\'s Potion - Yellow','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-4'),
(8197,'Fisherman\'s Potion - Orange','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-5'),
(8198,'Fisherman\'s Potion - Purple','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-6'),
(8199,'Fisherman\'s Potion - Red','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-7'),
(8200,'Fisherman\'s Potion - White','false','none',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2274-8'),
(8201,'Fisherman\'s Potion - Black','false','none',100,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2274-9'),
(8202,'Fishing Potion','false','seed',100,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','ItemSkills','2275-1'),
(8223,'Seed: Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8224,'Seed: Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(8225,'Seed: Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(8226,'Seed: Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(8227,'Seed: Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(8228,'Seed: Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(8229,'Seed: Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(8230,'Seed: Alternative Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8231,'Seed: Alternative Great Codran','false','seed',1,'stackable','paper','none',-1,-1,75,0,'true','true','true','true','true','Seed','2097-3'),
(8232,'Seed: Alternative Desert Codran','false','seed',1,'stackable','paper','none',-1,-1,100,0,'true','true','true','true','true','Seed','2097-3'),
(8233,'Seed: Alternative Blue Coba','false','seed',1,'stackable','paper','none',-1,-1,400,0,'true','true','true','true','true','Seed','2097-3'),
(8234,'Seed: Alternative Red Coba','false','seed',1,'stackable','paper','none',-1,-1,500,0,'true','true','true','true','true','Seed','2097-3'),
(8235,'Seed: Alternative Golden Coba','false','seed',1,'stackable','paper','none',-1,-1,650,0,'true','true','true','true','true','Seed','2097-3'),
(8236,'Seed: Alternative Desert Coba','false','seed',1,'stackable','paper','none',-1,-1,750,0,'true','true','true','true','true','Seed','2097-3'),
(8237,'Seed: Dark Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8238,'Seed: Red Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8239,'Seed: Chilly Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8240,'Seed: Blue Coda','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(8241,'Seed: Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(8242,'Seed: Lute Coda','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(8243,'Seed: Desert Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(8244,'Seed: Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(8245,'Seed: Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(8246,'Seed: Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8247,'Seed: Thorn Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8248,'Seed: Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8249,'Seed: Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8250,'Seed: Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(8251,'Seed: Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8252,'Seed: Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(8253,'Seed: Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8254,'Seed: Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8255,'Alternative Dark Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8256,'Alternative Red Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8257,'Seed: Alternative Chilly Coda','false','seed',1,'stackable','paper','none',-1,-1,5,0,'true','true','true','true','true','Seed','2097-1'),
(8258,'Alternative Blue Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,10,0,'true','true','true','true','true','Seed','2097-1'),
(8259,'Seed: Alternative Golden Coda','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(8260,'Alternative Lute Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,30,0,'true','true','true','true','true','Seed','2097-1'),
(8261,'Alternative Desert Coda Seed','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-1'),
(8262,'Seed: Alternative Red Cobol','false','seed',1,'stackable','paper','none',-1,-1,20,0,'true','true','true','true','true','Seed','2097-2'),
(8263,'Seed: Alternative Chilly Cobol','false','seed',1,'stackable','paper','none',-1,-1,25,0,'true','true','true','true','true','Seed','2097-2'),
(8264,'Seed: Alternative Blue Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8265,'Alternative Thorn Cobol Seed','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8266,'Seed: Alternative Golden Cobol','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-2'),
(8267,'Seed: Alternative Great Cobol','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-2'),
(8268,'Seed: Alternative Red Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(8269,'Seed: Alternative Sea Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8270,'Seed: Alternative Chilly Codran','false','seed',1,'stackable','paper','none',-1,-1,40,0,'true','true','true','true','true','Seed','2097-3'),
(8271,'Seed: Alternative Blue Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8272,'Seed: Alternative Twin Codran','false','seed',1,'stackable','paper','none',-1,-1,50,0,'true','true','true','true','true','Seed','2097-3'),
(8273,'Anteroom Key','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2235-1'),
(8274,'Chapel Key','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2236-1'),
(8275,'Key of Darkness','false','none',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2237-1'),
(8276,'Sekina\'s Scale','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8277,'Themis\' Scale','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8278,'Vermilion Shard','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8279,'Nucleus of Hekaton Prime','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8280,'Tiphon Shard','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8281,'Glaki\'s Necleus','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8282,'Rahha\'s Fang','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8283,'Sting of Giant Poison Bee','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8284,'Cloudy Gem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8285,'Talon of Young Araneid','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8286,'Fairy Breath','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8287,'Starstone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8288,'Yumi\'s Letter','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8289,'Starstone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8290,'Flower of Pavel','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8291,'Heart of Atlanta','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8292,'Wendy\'s Necklace','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8293,'Trainer License','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8294,'Recipe: Steel Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,8180,0,'true','true','true','true','true','Recipes',''),
(8295,'Recipe: Titan Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(8296,'Recipe: Pa\'agrian Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,86000,0,'true','true','true','true','true','Recipes',''),
(8297,'Recipe: Guardian\'s Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8298,'Recipe: Guardian\'s Sword (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8299,'Recipe: Infernal Master (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8300,'Recipe: Infernal Master (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8301,'Recipe: Priest Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(8302,'Recipe: Sword of Magic Fog (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(8303,'Recipe: Mysterious Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8304,'Recipe: Ecliptic Sword (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8305,'Recipe: Wizard\'s Tear (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8306,'Recipe: Wizard\'s Tear (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8307,'Recipe: Priest Mace (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(8308,'Recipe: Ecliptic Axe (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(8309,'Recipe: Spell Breaker (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(8310,'Recipe: Spell Breaker (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(8311,'Recipe: Kaim Vanul\'s Bones (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8312,'Recipe: Kaim Vanul\'s Bones (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,262000,0,'true','true','true','true','true','Recipes',''),
(8313,'Recipe: Spiritual Eye (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8314,'Recipe: Spiritual Eye (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8315,'Recipe: Flaming Dragon Skull (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(8316,'Recipe: Flaming Dragon Skull (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(8317,'Recipe: Titan Hammer (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,28000,0,'true','true','true','true','true','Recipes',''),
(8318,'Recipe: Dwarven Hammer (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,122600,0,'true','true','true','true','true','Recipes',''),
(8319,'Recipe: Karik Horn (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8320,'Recipe: Destroyer Hammer (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8321,'Recipe: Ice Storm Hammer (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(8322,'Recipe: Ice Storm Hammer (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,173600,0,'true','true','true','true','true','Recipes',''),
(8323,'Recipe: Star Buster (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8324,'Recipe: Star Buster (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8325,'Recipe: Doom Crusher (100%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(8326,'Recipe: Doom Crusher (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,540000,0,'true','true','true','true','true','Recipes',''),
(8327,'Steel Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,11912,0,'true','true','true','true','true','none',''),
(8328,'Titan Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,20950,0,'true','true','true','true','true','none',''),
(8329,'Pa\'agrian Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,38420,0,'true','true','true','true','true','none',''),
(8330,'Guardian Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,45769,0,'true','true','true','true','true','none',''),
(8331,'Infernal Master Blade','false','material',60,'stackable','liquid','none',-1,-1,58615,0,'true','true','true','true','true','none',''),
(8332,'Priest Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,12037,0,'true','true','true','true','true','none',''),
(8333,'Sword of Magic Fog Blade','false','material',60,'stackable','liquid','none',-1,-1,20300,0,'true','true','true','true','true','none',''),
(8334,'Mysterious Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,25187,0,'true','true','true','true','true','none',''),
(8335,'Ecliptic Sword Blade','false','material',60,'stackable','liquid','none',-1,-1,43890,0,'true','true','true','true','true','none',''),
(8336,'Blade of the Wizard\'s Tear','false','material',60,'stackable','liquid','none',-1,-1,45692,0,'true','true','true','true','true','none',''),
(8337,'Priest Mace Head','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8338,'Axe of Eclipse Head','false','material',60,'stackable','liquid','none',-1,-1,41636,0,'true','true','true','true','true','none',''),
(8339,'Spell Breaker Head','false','material',60,'stackable','liquid','none',-1,-1,34950,0,'true','true','true','true','true','none',''),
(8340,'Bones Head of Kaim Vanul','false','material',60,'stackable','liquid','none',-1,-1,45769,0,'true','true','true','true','true','none',''),
(8341,'Spiritual Eye Piece','false','material',60,'stackable','liquid','none',-1,-1,59384,0,'true','true','true','true','true','none',''),
(8342,'Flaming Dragon Skull Piece','false','material',60,'stackable','liquid','none',-1,-1,72914,0,'true','true','true','true','true','none',''),
(8343,'Titan Hammer Piece','false','material',60,'stackable','liquid','none',-1,-1,19757,0,'true','true','true','true','true','none',''),
(8344,'Dwarven Hammer Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8345,'Karik Horn Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8346,'Hammer Piece of Destroyer','false','material',60,'stackable','liquid','none',-1,-1,59308,0,'true','true','true','true','true','none',''),
(8347,'Ice Storm Hammer Head','false','material',60,'stackable','liquid','none',-1,-1,38867,0,'true','true','true','true','true','none',''),
(8348,'Star Buster Head','false','material',60,'stackable','liquid','none',-1,-1,45846,0,'true','true','true','true','true','none',''),
(8349,'Doom Crusher Head','false','material',60,'stackable','liquid','none',-1,-1,72929,0,'true','true','true','true','true','none',''),
(8351,'Black Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,900,0,'true','true','true','true','true','none',''),
(8352,'Red Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,700,0,'true','true','true','true','true','none',''),
(8353,'Green Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(8354,'Yellow Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,400,0,'true','true','true','true','true','none',''),
(8355,'Blue Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,300,0,'true','true','true','true','true','none',''),
(8356,'White Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(8357,'Orange Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(8358,'Purple Colored Fish Scale','false','material',10,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','none',''),
(8359,'Jade Colored Fish Scale','false','none',10,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(8360,'Adventurer\'s Box - C Accessory','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8361,'Adventurer\'s Box - B Accessory','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8362,'Adventurer\'s Box - Hair Accessory','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8363,'Adventurer\'s Box - Cradle of Creation','false','recipe',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8364,'Recipe: Party Hat (100%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8365,'Recipe: Party Hat (70%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8366,'Recipe: Feathered Hat (100%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8367,'Recipe: Feathered Hat (70%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8368,'Recipe: Artisan\'s Goggles (100%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8369,'Recipe: Artisan\'s Goggles (70%)','false','recipe',30,'stackable','paper','none',-1,-1,400000,0,'true','true','true','true','true','Recipes',''),
(8370,'Recipe: Red Horn of Victory (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8371,'Recipe: Little Angel Wings (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(8372,'Recipe: Fairy Antennae (100%)','false','recipe',30,'stackable','paper','none',-1,-1,100000,0,'true','true','true','true','true','Recipes',''),
(8373,'Party Hat Fabric','false','material',60,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8374,'Feathered Hat Fabric','false','material',60,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8375,'Artisan\'s Goggles Fabric','false','material',60,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8376,'Red Horn of Victory Fragment','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8377,'Little Angel Wings Piece','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(8378,'Fairy Antennae Piece','false','material',60,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(8379,'Petrification Scroll','false','material',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none','2239-1'),
(8380,'Spellbook: Betray','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8381,'Spellbook: Mass Curse Fear','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8382,'Spellbook: Mass Curse Gloom','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8383,'Spellbook: Mass Surrender to Fire','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8384,'Spellbook: Mass Surrender to Water','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8385,'Spellbook: Mass Surrender to Wind','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8386,'Spellbook - Arcane Disruption','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8387,'Spellbook - Summon Cursed Bones','false','spellbook',120,'stackable','paper','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(8388,'Spellbook: Greater Might','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8389,'Spellbook: Greater Shield','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8390,'Amulet: War Chant','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8391,'Amulet: Earth Chant','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8392,'Spellbook: Holy Resistance','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8393,'Spellbook: Unholy Resistance','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8394,'Spellbook: Trance','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8395,'Spellbook: Erase','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8396,'Spellbook: Magical Backfire','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8397,'Spellbook: Clarity','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8398,'Spellbook: Mana Burn','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8399,'Spellbook: Mana Storm','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8400,'Spellbook: Turn Undead','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8401,'Spellbook: Major Heal','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8402,'Spellbook: Major Group Heal','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8403,'Small Nimble Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-1'),
(8404,'Small Ugly Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-2'),
(8405,'Small Pudgy Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-3'),
(8406,'Nimble Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-4'),
(8407,'Ugly Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-5'),
(8408,'Pudgy Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-6'),
(8409,'Large Nimble Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-7'),
(8410,'Large Ugly Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2261-8'),
(8411,'Large Pudgy Green Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,265,0,'true','true','true','true','true','ItemSkills','2261-9'),
(8412,'Small Jade Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-1'),
(8413,'Small Jade Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-2'),
(8414,'Small Jade Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,310,0,'true','true','true','true','true','ItemSkills','2262-3'),
(8415,'Jade Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-4'),
(8416,'Jade Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-5'),
(8417,'Jade Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-6'),
(8418,'Large Jade Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,365,0,'true','true','true','true','true','ItemSkills','2262-7'),
(8419,'Large Jade Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2262-8'),
(8420,'Large Jade Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,385,0,'true','true','true','true','true','ItemSkills','2262-9'),
(8421,'Small Blue Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-1'),
(8422,'Small Blue Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-2'),
(8423,'Small Blue Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,410,0,'true','true','true','true','true','ItemSkills','2263-3'),
(8424,'Blue Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-4'),
(8425,'Blue Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,418,0,'true','true','true','true','true','ItemSkills','2263-5'),
(8426,'Blue Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-6'),
(8427,'Large Blue Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-7'),
(8428,'Large Blue Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-8'),
(8429,'Large Blue Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2263-9'),
(8430,'Small Yellow Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,442,0,'true','true','true','true','true','ItemSkills','2264-1'),
(8431,'Small Yellow Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-2'),
(8432,'Small Yellow Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-3'),
(8433,'Yellow Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-4'),
(8434,'Yellow Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-5'),
(8435,'Yellow Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-6'),
(8436,'Large Yellow Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,580,0,'true','true','true','true','true','ItemSkills','2264-7'),
(8437,'Large Yellow Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,594,0,'true','true','true','true','true','ItemSkills','2264-8'),
(8438,'Large Yellow Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2264-9'),
(8439,'Small Orange Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,622,0,'true','true','true','true','true','ItemSkills','2265-1'),
(8440,'Small Orange Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,635,0,'true','true','true','true','true','ItemSkills','2265-2'),
(8441,'Small Orange Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,649,0,'true','true','true','true','true','ItemSkills','2265-3'),
(8442,'Orange Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-4'),
(8443,'Orange Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-5'),
(8444,'Orange Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-6'),
(8445,'Large Orange Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-7'),
(8446,'Large Orange Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-8'),
(8447,'Large Orange Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2265-9'),
(8448,'Small Purple Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-1'),
(8449,'Small Purple Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-2'),
(8450,'Small Purple Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-3'),
(8451,'Purple Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-4'),
(8452,'Purple Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-5'),
(8453,'Purple Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-6'),
(8454,'Large Purple Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-7'),
(8455,'Large Purple Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-8'),
(8456,'Large Purple Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2266-9'),
(8457,'Small Red Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-1'),
(8458,'Small Red Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-2'),
(8459,'Small Red Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,1326,0,'true','true','true','true','true','ItemSkills','2267-3'),
(8460,'Red Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-4'),
(8461,'Red Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-5'),
(8462,'Red Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-6'),
(8463,'Large Red Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-7'),
(8464,'Large Red Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,1608,0,'true','true','true','true','true','ItemSkills','2267-8'),
(8465,'Large Red Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2267-9'),
(8466,'Small White Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-1'),
(8467,'Small White Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-2'),
(8468,'Small White Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-3'),
(8469,'White Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-4'),
(8470,'White Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-5'),
(8471,'White Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-6'),
(8472,'High Grade - Large White Nimble Fish','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-7'),
(8473,'Large White Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-8'),
(8474,'Large White Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2268-9'),
(8475,'Small Black Nimble Fish: Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-1'),
(8476,'Small Black Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-2'),
(8477,'Small Black Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-3'),
(8478,'Black Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-4'),
(8479,'Black Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-5'),
(8480,'Black Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-6'),
(8481,'Large Black Nimble Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-7'),
(8482,'Large Black Ugly Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-8'),
(8483,'Large Black Fat Fish - Upper Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2269-9'),
(8484,'Prize-Winning Fishing Lure','false','lure',4,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','none',''),
(8485,'Prize-Winning Night Fishing Lure','false','lure',4,'stackable','liquid','none',-1,-1,240,0,'true','true','true','true','true','none',''),
(8486,'Prize-Winning Novice Fishing Lure','false','lure',5,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(8487,'Recipe: Destroyer Hammer (60%)','false','recipe',30,'stackable','liquid','none',-1,-1,366000,0,'true','true','true','true','true','Recipes',''),
(8488,'Engraved Hammer','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8489,'Daimon\'s Eyes','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8490,'Hestia\'s Fairy Stone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8491,'Nucleus of Lesser Golem','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8492,'Falston\'s Fang','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8493,'Shaid\'s Talon','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8494,'Nucleus of Flamestone Giant','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8495,'Book of Grey Star','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8496,'Gludio\'s Luminous Lure','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8497,'Dion\'s Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8498,'Giran\'s Luminous Lure','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8499,'Oren\'s Luminous Lure','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8500,'Aden\'s Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8501,'Innadril\'s Luminous Lure','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8502,'Goddard\'s Luminous Lure','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8503,'Rune\'s Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8504,'Schuttgart\'s Luminous Lure','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8505,'Green Luminous Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8506,'Green Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,120,0,'true','true','true','true','true','none',''),
(8507,'Green Colored Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8508,'Purple Luminous Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8509,'Purple Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,180,0,'true','true','true','true','true','none',''),
(8510,'Purple Luminous Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8511,'Yellow Luminous Lure - Low Grade','false','lure',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8512,'Yellow Luminous Lure','false','lure',4,'stackable','liquid','none',-1,-1,150,0,'true','true','true','true','true','none',''),
(8513,'Yellow Luminous Lure - High Grade','false','lure',3,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8514,'Remnants of Old Dwarves\' Dreams','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8515,'Charm of Courage: No Grade','false','scroll',10,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','Potions','5041-1'),
(8516,'Charm of Courage: D-Grade','false','scroll',10,'stackable','paper','d',-1,-1,6600,0,'true','true','true','true','true','Potions','5041-1'),
(8517,'Charm of Courage: C-Grade','false','scroll',10,'stackable','paper','c',-1,-1,13200,0,'true','true','true','true','true','Potions','5041-1'),
(8518,'Charm of Courage: B-Grade','false','scroll',10,'stackable','paper','b',-1,-1,26000,0,'true','true','true','true','true','Potions','5041-1'),
(8519,'Charm of Courage: A-Grade','false','scroll',10,'stackable','paper','a',-1,-1,54000,0,'true','true','true','true','true','Potions','5041-1'),
(8520,'Charm of Courage: S-Grade','false','scroll',10,'stackable','paper','s',-1,-1,100000,0,'true','true','true','true','true','Potions','5041-1'),
(8521,'Seed: Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(8522,'Seed: Alternative Sea Coba','false','seed',1,'stackable','paper','none',-1,-1,900,0,'true','true','true','true','true','Seed','2097-3'),
(8523,'Seed: Twin Coba','false','seed',1,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','Seed','2097-3'),
(8524,'Seed: Alternative Twin Coba','false','seed',1,'stackable','paper','none',-1,-1,1000,0,'true','true','true','true','true','Seed','2097-3'),
(8525,'Seed: Great Coba','false','seed',1,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Seed','2097-3'),
(8526,'Seed: Alternative Great Coba','false','seed',1,'stackable','paper','none',-1,-1,1200,0,'true','true','true','true','true','Seed','2097-3'),
(8534,'Adventurer\'s Box: C-Grade Accessory (Low Grade)','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-1'),
(8535,'Adventurer\'s Box: C-Grade Accessory (Medium Grade)','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-2'),
(8536,'Adventurer\'s Box: C-Grade Accessory (High Grade)','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-3'),
(8537,'Adventurer\'s Box: B-Grade Accessory (Low Grade)','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-4'),
(8538,'Adventurer\'s Box: B-Grade Accessory (High Grade)','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-5'),
(8539,'Adventurer\'s Box: Hair Accessory','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-6'),
(8540,'Adventurer\'s Box: Cradle of Creation','false','none',20,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2270-7'),
(8542,'Newbie Travel Token','false','none',10,'stackable','liquid','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8543,'Bead Parcel','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8544,'Timora Orc\'s Head','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8545,'Kasha Spider\'s Tooth','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8546,'Horn of Baar Dre Vanul','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8547,'Old Box','false','quest',100,'stackable','paper','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(8548,'Hot Springs Lure','false','lure',3,'stackable','liquid','none',-1,-1,200,0,'true','true','true','true','true','none',''),
(8549,'Bruin Lizardman Blood','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8550,'Picot Araneid\'s Leg','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8551,'Box of Cheerleading Gear Used to encourage victory.','false','material',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8553,'Red Mask of Victory,Fabric','false','recipe',60,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8554,'Recipe: Red Mask of Victory (100%)','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8555,'Echo Crystal - Viva Victory Korea','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2272-1'),
(8556,'Dewdrop of Destruction','false','none',3,'stackable','gold','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8570,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8571,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8572,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8573,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8574,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8575,'Event Gift Box','false','none',20,'stackable','steel','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8592,'Weapon Exchange Coupon - No Grade','false','none',1,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8593,'Weapon Exchange Coupon - D Grade','false','scroll',1,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8594,'Scroll: Recovery (No Grade)','false','scroll',10,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','ItemSkills','2286-1'),
(8595,'Scroll: Recovery (Grade D)','false','scroll',10,'stackable','paper','d',-1,-1,4800,0,'true','true','true','true','true','ItemSkills','2286-2'),
(8596,'Scroll: Recovery (Grade C)','false','scroll',10,'stackable','paper','c',-1,-1,14000,0,'true','true','true','true','true','ItemSkills','2286-3'),
(8597,'Scroll: Recovery (Grade B)','false','scroll',10,'stackable','paper','b',-1,-1,28000,0,'true','true','true','true','true','ItemSkills','2286-4'),
(8598,'Scroll: Recovery (Grade A)','false','scroll',10,'stackable','paper','a',-1,-1,48000,0,'true','true','true','true','true','ItemSkills','2286-5'),
(8599,'Scroll: Recovery (Grade S)','false','scroll',10,'stackable','paper','s',-1,-1,80000,0,'true','true','true','true','true','ItemSkills','2286-6'),
(8600,'Herb of Life','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2278-1'),
(8601,'Greater Herb of Life','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2278-2'),
(8602,'Superior Herb of Life','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2278-3'),
(8603,'Herb of Mana','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2279-1'),
(8604,'Greater Herb of Mana','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2279-2'),
(8605,'Superior Herb of Mana','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2279-3'),
(8606,'Herb of Power','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2280-1'),
(8607,'Herb of Magic','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2281-1'),
(8608,'Herb of Atk. Spd.','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2282-1'),
(8609,'Herb of Casting Spd.','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2283-1'),
(8610,'Herb of Critical Attack - Probability','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2284-1'),
(8611,'Herb of Speed','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2285-1'),
(8612,'Herb of the Warrior','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2280-1;2282-1;2284-1'),
(8613,'Herb of the Mystic','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2281-1;2283-1'),
(8614,'Herb of Recovery','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2278-3;2279-3'),
(8615,'Summoning Crystal','false','none',10,'stackable','crystal','none',-1,-1,35000,0,'true','true','true','true','true','none',''),
(8616,'Spellbook: Summon Friend','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8617,'Spellbook: Word of Invitation','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8618,'Ancient Book - Divine Inspiration (Modern Language Version)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8619,'Ancient Book - Divine Inspiration (Original Language Version)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8620,'Ancient Book - Divine Inspiration (Manuscript)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8621,'Ancient Book - Divine Inspiration (Original Version)','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8622,'Elixir of Life (No Grade)','false','potion',5,'stackable','liquid','none',-1,-1,1300,0,'true','true','true','true','true','Elixir','2287-1'),
(8623,'Elixir of Life (D-Grade)','false','potion',5,'stackable','liquid','d',-1,-1,3450,0,'true','true','true','true','true','Elixir','2287-2'),
(8624,'Elixir of Life (C-Grade)','false','potion',5,'stackable','liquid','c',-1,-1,7200,0,'true','true','true','true','true','Elixir','2287-3'),
(8625,'Elixir of Life (B-Grade)','false','potion',5,'stackable','liquid','b',-1,-1,10000,0,'true','true','true','true','true','Elixir','2287-4'),
(8626,'Elixir of Life (A-Grade)','false','potion',5,'stackable','liquid','a',-1,-1,12500,0,'true','true','true','true','true','Elixir','2287-5'),
(8627,'Elixir of Life (S-Grade)','false','potion',5,'stackable','liquid','s',-1,-1,15000,0,'true','true','true','true','true','Elixir','2287-6'),
(8628,'Elixir of Mental Strength (No Grade)','false','potion',5,'stackable','liquid','none',-1,-1,1200,0,'true','true','true','true','true','Elixir','2288-1'),
(8629,'Elixir of Mental Strength (D-Grade)','false','potion',5,'stackable','liquid','d',-1,-1,3400,0,'true','true','true','true','true','Elixir','2288-2'),
(8630,'Elixir of Mental Strength (C-Grade)','false','potion',5,'stackable','liquid','c',-1,-1,8700,0,'true','true','true','true','true','Elixir','2288-3'),
(8631,'Elixir of Mental Strength (B-Grade)','false','potion',5,'stackable','liquid','b',-1,-1,11600,0,'true','true','true','true','true','Elixir','2288-4'),
(8632,'Elixir of Mental Strength (A-Grade)','false','potion',5,'stackable','liquid','a',-1,-1,14400,0,'true','true','true','true','true','Elixir','2288-5'),
(8633,'Elixir of Mental Strength (S-Grade)','false','potion',5,'stackable','liquid','s',-1,-1,16800,0,'true','true','true','true','true','Elixir','2288-6'),
(8634,'Elixir of CP (No Grade)','false','potion',5,'stackable','liquid','none',-1,-1,600,0,'true','true','true','true','true','Elixir','2289-1'),
(8635,'Elixir of CP (D-Grade)','false','potion',5,'stackable','liquid','d',-1,-1,1400,0,'true','true','true','true','true','Elixir','2289-2'),
(8636,'Elixir of CP (C-Grade)','false','potion',5,'stackable','liquid','c',-1,-1,3000,0,'true','true','true','true','true','Elixir','2289-3'),
(8637,'Elixir of CP (B-Grade)','false','potion',5,'stackable','liquid','b',-1,-1,4000,0,'true','true','true','true','true','Elixir','2289-4'),
(8638,'Elixir of CP (A-Grade)','false','potion',5,'stackable','liquid','a',-1,-1,5000,0,'true','true','true','true','true','Elixir','2289-5'),
(8639,'Elixir of CP (S-Grade)','false','potion',5,'stackable','liquid','s',-1,-1,6000,0,'true','true','true','true','true','Elixir','2289-6'),
(8640,'Recipe: Elixir of Life (No Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8641,'Recipe: Elixir of Life (D-Grade)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8642,'Recipe: Elixir of Life (C-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8643,'Recipe: Elixir of Life (B-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2000,0,'true','true','true','true','true','Recipes',''),
(8644,'Recipe: Elixir of Life (A-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2500,0,'true','true','true','true','true','Recipes',''),
(8645,'Recipe: Elixir of Life (S-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,3000,0,'true','true','true','true','true','Recipes',''),
(8646,'Recipe: Elixir of Mental Strength (No Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8647,'Recipe: Elixir of Mental Strength (D-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8648,'Recipe: Elixir of Mental Strength (C-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,1760,0,'true','true','true','true','true','Recipes',''),
(8649,'Recipe: Elixir of Mental Strength (B-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2320,0,'true','true','true','true','true','Recipes',''),
(8650,'Recipe: Elixir of Mental Strength (A-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,2880,0,'true','true','true','true','true','Recipes',''),
(8651,'Recipe: Elixir of Mental Strength (S-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,3360,0,'true','true','true','true','true','Recipes',''),
(8652,'Recipe: Elixir of CP (No Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8653,'Recipe: Elixir of CP (D-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8654,'Recipe: Elixir of CP (C-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8655,'Recipe: Elixir of CP (B-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8656,'Recipe: Elixir of CP (A-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8657,'Recipe: Elixir of CP (S-Grade) (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8658,'Mysterious Solvent','false','none',2,'stackable','liquid','none',-1,-1,100,0,'true','true','true','true','true','none',''),
(8659,'Coffer of Shadows','false','potion',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8663,'Mystery Potion (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(8664,'Facelifting Potion - A (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2291-1'),
(8665,'Facelifting Potion - B (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2292-1'),
(8666,'Facelifting Potion - C (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2293-1'),
(8667,'Dye Potion - A (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2294-1'),
(8668,'Dye Potion - B (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2295-1'),
(8669,'Dye Potion - C (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2296-1'),
(8670,'Dye Potion - D (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2297-1'),
(8671,'Hair Style Change Potion - A (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2298-1'),
(8672,'Hair Style Change Potion - B (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2299-1'),
(8673,'Hair Style Change Potion - C (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2300-1'),
(8674,'Hair Style Change Potion - D (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2301-1'),
(8675,'Hair Style Change Potion - E (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2302-1'),
(8676,'Hair Style Change Potion - F (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2303-1'),
(8677,'Hair Style Change Potion - G (Event)','false','potion',50,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2304-1'),
(8690,'Recipe: Sirra\'s Blade (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8691,'Recipe: Sirra\'s Blade (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8692,'Recipe: Sword of Ipos (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8693,'Recipe: Sword of Ipos (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8694,'Recipe: Barakiel\'s Axe (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8695,'Recipe: Barakiel\'s Axe (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8696,'Recipe: Behemoth\'s Tuning Fork (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8697,'Recipe: Behemoth\'s Tuning Fork (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8698,'Recipe: Naga Storm (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8699,'Recipe: Naga Storm (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8700,'Recipe: Tiphon\'s Spear (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8701,'Recipe: Tiphon\'s Spear (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8702,'Recipe: Shyeed\'s Bow (60%)','false','recipe',30,'stackable','paper','none',-1,-1,706000,0,'true','true','true','true','true','Recipes',''),
(8703,'Recipe: Shyeed\'s Bow (100%)','false','recipe',30,'stackable','paper','none',-1,-1,706000,0,'true','true','true','true','true','Recipes',''),
(8704,'Recipe: Sobekk\'s Hurricane (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8705,'Recipe: Sobekk\'s Hurricane (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8706,'Recipe: Themis\' Tongue (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8707,'Recipe: Themis\' Tongue (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8708,'Recipe: Cabrio\'s Hand (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8709,'Recipe: Cabrio\'s Hand (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8710,'Recipe: Daimon Crystal (60%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8711,'Recipe: Daimon Crystal (100%)','false','recipe',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(8712,'Sirra\'s Blade Edge','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8713,'Sword of Ipos Blade','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8714,'Barakiel\'s Axe Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8715,'Behemoth\'s Tuning Fork Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8716,'Naga Storm Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8717,'Tiphon\'s Spear Edge','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8718,'Shyeed\'s Bow Shaft','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8719,'Sobekk\'s Hurricane Edge','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8720,'Themis\' Tongue Piece','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8721,'Cabrio\'s Hand Head','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8722,'Daimon Crystal Fragment','false','material',60,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8723,'Life Stone: level 46','false','none',2,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(8724,'Life Stone: level 49','false','none',2,'stackable','liquid','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(8725,'Life Stone: level 52','false','none',2,'stackable','liquid','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(8726,'Life Stone: level 55','false','none',2,'stackable','liquid','none',-1,-1,8640,0,'true','true','true','true','true','none',''),
(8727,'Life Stone: level 58','false','none',2,'stackable','liquid','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(8728,'Life Stone: level 61','false','none',2,'stackable','liquid','none',-1,-1,12000,0,'true','true','true','true','true','none',''),
(8729,'Life Stone: level 64','false','none',2,'stackable','liquid','none',-1,-1,15000,0,'true','true','true','true','true','none',''),
(8730,'Life Stone: level 67','false','none',2,'stackable','liquid','none',-1,-1,18000,0,'true','true','true','true','true','none',''),
(8731,'Life Stone: level 70','false','none',2,'stackable','liquid','none',-1,-1,21600,0,'true','true','true','true','true','none',''),
(8732,'Life Stone: level 76','false','none',2,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','none','');

INSERT INTO `etcitem` VALUES
(8733,'Mid-Grade Life Stone: level 46','false','none',2,'stackable','liquid','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8734,'Mid-Grade Life Stone: level 49','false','none',2,'stackable','liquid','none',-1,-1,24000,0,'true','true','true','true','true','none',''),
(8735,'Mid-Grade Life Stone: level 52','false','none',2,'stackable','liquid','none',-1,-1,28800,0,'true','true','true','true','true','none',''),
(8736,'Mid-Grade Life Stone: level 55','false','none',2,'stackable','liquid','none',-1,-1,34560,0,'true','true','true','true','true','none',''),
(8737,'Mid-Grade Life Stone: level 58','false','none',2,'stackable','liquid','none',-1,-1,40000,0,'true','true','true','true','true','none',''),
(8738,'Mid-Grade Life Stone: level 61','false','none',2,'stackable','liquid','none',-1,-1,48000,0,'true','true','true','true','true','none',''),
(8739,'Mid-Grade Life Stone: level 64','false','none',2,'stackable','liquid','none',-1,-1,60000,0,'true','true','true','true','true','none',''),
(8740,'Mid-Grade Life Stone: level 67','false','none',2,'stackable','liquid','none',-1,-1,72000,0,'true','true','true','true','true','none',''),
(8741,'Mid-Grade Life Stone: level 70','false','none',2,'stackable','liquid','none',-1,-1,86400,0,'true','true','true','true','true','none',''),
(8742,'Mid-Grade Life Stone: level 76','false','none',2,'stackable','liquid','none',-1,-1,96000,0,'true','true','true','true','true','none',''),
(8743,'High-Grade Life Stone: level 46','false','none',2,'stackable','liquid','none',-1,-1,200000,0,'true','true','true','true','true','none',''),
(8744,'High-Grade Life Stone: level 49','false','none',2,'stackable','liquid','none',-1,-1,240000,0,'true','true','true','true','true','none',''),
(8745,'High-Grade Life Stone: level 52','false','none',2,'stackable','liquid','none',-1,-1,288000,0,'true','true','true','true','true','none',''),
(8746,'High-Grade Life Stone: level 55','false','none',2,'stackable','liquid','none',-1,-1,345600,0,'true','true','true','true','true','none',''),
(8747,'High-Grade Life Stone: level 58','false','none',2,'stackable','liquid','none',-1,-1,400000,0,'true','true','true','true','true','none',''),
(8748,'High-Grade Life Stone: level 61','false','none',2,'stackable','liquid','none',-1,-1,480000,0,'true','true','true','true','true','none',''),
(8749,'High-Grade Life Stone: level 64','false','none',2,'stackable','liquid','none',-1,-1,600000,0,'true','true','true','true','true','none',''),
(8750,'High-Grade Life Stone: level 67','false','none',2,'stackable','liquid','none',-1,-1,720000,0,'true','true','true','true','true','none',''),
(8751,'High-Grade Life Stone: level 70','false','none',2,'stackable','liquid','none',-1,-1,864000,0,'true','true','true','true','true','none',''),
(8752,'High-Grade Life Stone: level 76','false','none',2,'stackable','liquid','none',-1,-1,960000,0,'true','true','true','true','true','none',''),
(8753,'Top-Grade Life Stone: level 46','false','none',2,'stackable','liquid','none',-1,-1,1000000,0,'true','true','true','true','true','none',''),
(8754,'Top-Grade Life Stone: level 49','false','none',2,'stackable','liquid','none',-1,-1,1200000,0,'true','true','true','true','true','none',''),
(8755,'Top-Grade Life Stone: level 52','false','none',2,'stackable','liquid','none',-1,-1,1440000,0,'true','true','true','true','true','none',''),
(8756,'Top-Grade Life Stone: level 55','false','none',2,'stackable','liquid','none',-1,-1,1728000,0,'true','true','true','true','true','none',''),
(8757,'Top-Grade Life Stone: level 58','false','none',2,'stackable','liquid','none',-1,-1,2000000,0,'true','true','true','true','true','none',''),
(8758,'Top-Grade Life Stone: level 61','false','none',2,'stackable','liquid','none',-1,-1,2400000,0,'true','true','true','true','true','none',''),
(8759,'Top-Grade Life Stone: level 64','false','none',2,'stackable','liquid','none',-1,-1,3000000,0,'true','true','true','true','true','none',''),
(8760,'Top-Grade Life Stone: level 67','false','none',2,'stackable','liquid','none',-1,-1,3600000,0,'true','true','true','true','true','none',''),
(8761,'Top-Grade Life Stone: level 70','false','none',2,'stackable','liquid','none',-1,-1,4320000,0,'true','true','true','true','true','none',''),
(8762,'Top-Grade Life Stone: level 76','false','none',2,'stackable','liquid','none',-1,-1,4800000,0,'true','true','true','true','true','none',''),
(8764,'Trap Stone','false','quest',2,'stackable','liquid','none',-1,-1,500,0,'true','true','true','true','true','none',''),
(8765,'Red Gem','false','none',0,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8766,'Spirit Bead','false','none',0,'stackable','crystal','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8767,'Tyrannosaurus Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8768,'Diary Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8769,'Expedition Member\'s Letter','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8770,'Ornithomimus Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8771,'Deinonychus Bone','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8772,'Pachycephalosaurus Skin','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8773,'Practice Elrokian Trap','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8774,'Dinosaur Tissue','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8775,'Dinosaur Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8776,'Bones of a Plains Dinosaur','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8777,'Ancient Creatures and How I Long To Be With Them','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8778,'Mantarasa Egg','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8779,'Ornithomimus Claw','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8780,'Deinonychus Bone Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8781,'Epitaph of Wisdom','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8782,'Gazkh Fragment','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8783,'Bone Powder','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8784,'Gazkh','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8785,'Dinosaur Fang Necklace','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8786,'Primeval Potion','false','none',2,'stackable','liquid','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(8787,'Sprigant\'s Fruit','false','none',2,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8868,'Ziggo\'s Gemstone','false','none',0,'stackable','crystal','none',-1,-1,100000000,0,'true','true','true','true','true','none',''),
(8869,'Shadow Item Exchange Coupon: D Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8870,'Shadow Item Exchange Coupon: C Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(8871,'Strategy Guide','false','none',20,'normal','leather','none',-1,-1,45000,0,'true','true','true','true','true','none',''),
(8872,'Flash Gunpowder','false','none',20,'stackable','liquid','none',-1,-1,1500,0,'true','true','true','true','true','none',''),
(8873,'Phoenix Blood','false','none',20,'stackable','leather','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8874,'Einhasad\'s Holy Water','false','none',20,'stackable','leather','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8875,'Battle Symbol','false','none',20,'stackable','leather','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8876,'Magic Symbol','false','none',20,'stackable','leather','none',-1,-1,20000,0,'true','true','true','true','true','none',''),
(8877,'Spellbook: Soul of the Phoenix','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8878,'Spellbook: Summon Feline King','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8879,'Spellbook: Summon Magnus the Unicorn','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8880,'Spellbook: Summon Spectral Knight','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8881,'Spellbook: Cleanse','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8882,'Spellbook: Salvation','false','spellbook',120,'stackable','paper','none',-1,-1,110000,0,'true','true','true','true','true','none',''),
(8883,'Spellbook: Mystic Immunity','false','spellbook',120,'stackable','paper','none',-1,-1,110000,0,'true','true','true','true','true','none',''),
(8884,'Spellbook: Spell Turning','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8885,'Amulet: Magnus\' Chant','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8886,'Amulet: Victories of Pa\'agrio','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8887,'Amulet: Pa\'agrio\'s Emblem','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8888,'Amulet: Pa\'agrio\'s Fist','false','spellbook',120,'stackable','paper','none',-1,-1,110000,0,'true','true','true','true','true','none',''),
(8889,'Amulet: Gate Chant','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8890,'Spellbook: Summon Attractive Cubic','false','spellbook',120,'stackable','paper','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(8891,'Spellbook: Aura Flash','false','spellbook',120,'stackable','paper','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(8892,'Ancient Tactical Manual: Symbol of Defense','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8893,'Ancient Tactical Manual: Symbol of Noise','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8894,'Ancient Tactical Manual: Symbol of Resistance','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8895,'Ancient Tactical Manual: Symbol of Honor','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8896,'Ancient Tactical Manual: Symbol of Energy','false','spellbook',120,'stackable','paper','none',-1,-1,120000,0,'true','true','true','true','true','none',''),
(8897,'Ancient Tactical Manual: Symbol of the Sniper','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8898,'Ancient Tactical Manual: Symbol of the Assassin','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8899,'Ancient Spellbook: Volcano','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8900,'Ancient Spellbook: Cyclone','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8901,'Ancient Spellbook: Raging Waves','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8902,'Ancient Spellbook: Day of Doom','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8903,'Ancient Spellbook: Gehenna','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8904,'Ancient Spellbook: Anti-Summoning Field','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8905,'Ancient Spellbook: Purification Field','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8906,'Ancient Spellbook: Miracle','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8907,'Ancient Spellbook: Flames of Invincibility','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8908,'Ancient Spellbook: Mass Recharge','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8909,'Blueprint: Summon Swoop Cannon','false','spellbook',120,'stackable','paper','none',-1,-1,9600,0,'true','true','true','true','true','none',''),
(8924,'Boat Ticket: Primeval Isle to Rune.','false','none',20,'stackable','paper','none',-1,-1,25000,0,'true','true','true','true','true','none',''),
(8925,'Boat Ticket: Rune to Primeval Isle.','false','none',20,'stackable','paper','none',-1,-1,25000,0,'true','true','true','true','true','none',''),
(8939,'Dominic\'s Mark','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8940,'Mark of the Future: Human','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8941,'Mark of the Future: Dwarf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8942,'Mark of the Future: Elf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8943,'Mark of the Future: Dark Elf','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8944,'Mark of the Future: Orc','false','quest',0,'stackable','steel','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8945,'Spellbook: Celestial Shield','false','spellbook',120,'stackable','paper','none',-1,-1,8100,0,'true','true','true','true','true','none',''),
(8946,'Spellbook: Invocation','false','spellbook',120,'stackable','paper','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(8952,'Greater Herb of Life','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2278-2'),
(8953,'Greater Herb of Mana','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2279-2'),
(8954,'Blue Primeval Crystal','false','scroll',10,'stackable','paper','s',-1,-1,50000,0,'true','true','true','true','true','ItemSkills','2306-1'),
(8955,'Green Primeval Crystal','false','scroll',10,'stackable','paper','s',-1,-1,100000,0,'true','true','true','true','true','ItemSkills','2306-2'),
(8956,'Red Primeval Crystal','false','scroll',10,'stackable','paper','s',-1,-1,200000,0,'true','true','true','true','true','ItemSkills','2306-3'),
(8957,'Attack Orders','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8958,'Defense Orders','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8959,'Supply Orders','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8960,'No Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8961,'D-Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8962,'C-Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8963,'B-Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8964,'A-Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8965,'S-Grade Shadow Armor Set Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8966,'No Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8967,'D Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8968,'C Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8969,'B Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8970,'A Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(8971,'A,S Grade Item Set Box (Warrior Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9104,'Composite Bow and Wooden Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9105,'Gastraphetes and Bone Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9106,'Akat Long Bow and Steel Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9107,'Dark Elven Long Bow and Silver Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9108,'Carnage Bow and Mithril Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9109,'Soul Bow and Mithril Arrow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9110,'No Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9111,'D-Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9112,'C-Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9113,'B-Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9114,'Low A-Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9115,'High A-Grade Shadow Armor Set Box (Heavy Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9116,'No Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9117,'D-Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9118,'C-Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9119,'B-Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9120,'Low A-Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9121,'High A-Grade Shadow Armor Set Box (Light Armor Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9122,'No Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9123,'D-Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9124,'C-Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9125,'B-Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9126,'Low A-Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9127,'High A-Grade Shadow Armor Set Box (Robe Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9130,'No Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9131,'D Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9132,'C Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9133,'B Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9134,'A Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9135,'A,S Grade Item Set Box (Magic Use)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9139,'Santa\'s Hat','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9142,'Apiga','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9143,'Golden Apiga','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(9144,'Pirate\'s Booty','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9146,'Scroll of Guidance (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2310-1'),
(9147,'Scroll of Death Whisper (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2311-1'),
(9148,'Scroll of Focus (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2312-1'),
(9149,'Scroll of Acumen (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2313-1'),
(9150,'Scroll of Haste (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2314-1'),
(9151,'Scroll of Agility (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2315-1'),
(9152,'Scroll of Empower (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2316-1'),
(9153,'Scroll of Might (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2317-1'),
(9154,'Scroll of Wind Walk (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2318-1'),
(9155,'Scroll of Shield (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2319-1'),
(9156,'Blessed Scroll of Escape (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2320-1'),
(9157,'Blessed Scroll of Resurrection (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ScrollOfResurrection','2321-1'),
(9161,'Santa\'s Antlers','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9162,'Red Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9163,'Blue Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9164,'Orange Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9165,'Black Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9166,'White Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9167,'Green Philosopher\'s Stone Transmutation Circle','false','recipe',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9168,'Philosopher\'s Stone Ore','false','material',2,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9169,'Philosopher\'s Stone Conversion Formula','false','material',2,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9170,'Magic Reagents','false','material',2,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9171,'Red Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9172,'Blue Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9173,'Orange Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9174,'Black Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9175,'White Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9176,'Green Philosopher\'s Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9205,'Alchemist\'s Chest Key','false','none',10,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9206,'Greater Healing Potion (Event)','false','potion',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9207,'Quick Healing Potion (Event)','false','potion',5,'stackable','liquid','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9451,'Dynastic Essence','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9482,'Recipe: Sealed Dynasty Breast Plate (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9483,'Recipe: Sealed Dynasty Gaiter (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9484,'Recipe: Sealed Dynasty Helmet (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9485,'Recipe: Sealed Dynasty Gauntlet (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9486,'Recipe: Sealed Dynasty Boots (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9487,'Recipe: Sealed Dynasty Leather Armor (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9488,'Recipe: Sealed Dynasty Leather Leggings (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9489,'Recipe: Sealed Dynasty Leather Helmet (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9490,'Recipe: Sealed Dynasty Leather Gloves (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9491,'Recipe: Sealed Dynasty Leather Boots (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9492,'Recipe: Sealed Dynasty Tunic (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9493,'Recipe: Sealed Dynasty Stockings (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9494,'Recipe: Sealed Dynasty Circlet (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9495,'Recipe: Sealed Dynasty Gloves (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9496,'Recipe: Sealed Dynasty Shoes (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9497,'Recipe: Sealed Dynasty Shield (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9498,'Recipe: Sealed Dynasty Breast Plate (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9499,'Recipe: Sealed Dynasty Gaiter (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9500,'Recipe: Sealed Dynasty Helmet (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9501,'Recipe: Sealed Dynasty Gauntlet (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9502,'Recipe: Sealed Dynasty Boots (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9503,'Recipe: Sealed Dynasty Leather Armor (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9504,'Recipe: Sealed Dynasty Leather Leggings (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9505,'Recipe: Sealed Dynasty Leather Helmet (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9506,'Recipe: Sealed Dynasty Leather Gloves (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9507,'Recipe: Sealed Dynasty Leather Boots (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9508,'Recipe: Sealed Dynasty Tunic (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9509,'Recipe: Sealed Dynasty Stockings (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9510,'Recipe: Sealed Dynasty Circlet (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9511,'Recipe: Sealed Dynasty Gloves (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9512,'Recipe: Sealed Dynasty Shoes (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9513,'Recipe: Sealed Dynasty Shield (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9530,'Sealed Dynasty Breast Plate Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9531,'Sealed Dynasty Gaiter Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9532,'Sealed Dynasty Helmet Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9533,'Sealed Dynasty Gauntlet Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9534,'Sealed Dynasty Boot Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9535,'Sealed Dynasty Leather Armor Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9536,'Sealed Dynasty Leather Leggings Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9537,'Sealed Dynasty Leather Helmet Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9538,'Sealed Dynasty Leather Glove Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9539,'Sealed Dynasty Leather Boots Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9540,'Sealed Dynasty Tunic Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9541,'Sealed Dynasty Stocking Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9542,'Sealed Dynasty Circlet Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9543,'Sealed Dynasty Glove Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9544,'Sealed Dynasty Shoes Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9545,'Sealed Dynasty Shield Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9546,'Fire Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2329-1'),
(9547,'Water Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2330-1'),
(9548,'Earth Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2332-1'),
(9549,'Wind Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2331-1'),
(9550,'Dark Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2334-1'),
(9551,'Divine Stone','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2333-1'),
(9552,'Fire Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2329-2'),
(9553,'Water Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2330-2'),
(9554,'Earth Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2332-2'),
(9555,'Wind Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2331-2'),
(9556,'Dark Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2334-2'),
(9557,'Divine Crystal','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2333-2'),
(9558,'Fire Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2329-3'),
(9559,'Water Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2330-3'),
(9560,'Earth Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2332-3'),
(9561,'Wind Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2331-3'),
(9562,'Dark Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2334-3'),
(9563,'Divine Jewel','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2333-3'),
(9564,'Fire Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2329-4'),
(9565,'Water Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2330-4'),
(9566,'Earth Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2332-4'),
(9567,'Wind Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2331-4'),
(9568,'Dark Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2334-4'),
(9569,'Divine Energy','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','EnchantAttribute','2333-4'),
(9570,'Red Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(9571,'Blue Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(9572,'Green Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(9573,'Life Stone: level 80','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9574,'Mid-Grade Life Stone: level 80','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9575,'High-Grade Life Stone: level 80','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9576,'Top-Grade Life Stone: level 80','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9593,'Yellow Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9594,'Green Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9595,'Blue Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9596,'Red Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9597,'White Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9598,'Black Seed of Evil - Shard','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9599,'Ancient Tome of the Demon','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9600,'Hidden First Page','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9601,'Hidden Second Page','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9602,'Demon Contract Fragment','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9603,'Hellbound Item 5','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9604,'Hellbound Item 6','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9616,'Dynasty Sword Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9617,'Dynasty Blade Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9618,'Dynasty Phantom Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9619,'Dynasty Bow Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9620,'Dynasty Knife Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9621,'Dynasty Halberd Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9622,'Halberd Cudgel Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9623,'Dynasty Mace Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9624,'Dynasty Bagh-Nakh Piece','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9625,'Giant\'s Codex - Oblivion','false','none',10,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9626,'Giant\'s Codex - Discipline','false','none',10,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9627,'Giant\'s Codex - Mastery','false','none',10,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9628,'Leonard','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9629,'Adamantine','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9630,'Orichalcum','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9631,'Tough Leather','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9632,'Wooden Bolt','false','bolt',6,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9633,'Bone Bolt','false','bolt',5,'stackable','wood','none',-1,-1,2,0,'true','true','true','true','true','none',''),
(9634,'Steel Bolt','false','bolt',4,'stackable','wood','none',-1,-1,5,0,'true','true','true','true','true','none',''),
(9635,'Silver Bolt','false','bolt',4,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9636,'Mithril Bolt','false','bolt',3,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9637,'Shining Bolt','false','bolt',3,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9647,'Scroll of Escape: Kamael Village','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2213-22'),
(9648,'Transform Sealbook - Onyx Beast','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9649,'Transform Sealbook - Death Blader','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9650,'Transform Sealbook - Grail Apostle','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9651,'Transform Sealbook - Unicorn','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9652,'Transform Sealbook - Lilim Knight','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9653,'Transform Sealbook - Golem Guardian','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9654,'Transform Sealbook - Inferno Drake','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9655,'Transform Sealbook - Dragon Bomber','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9668,'Great Wolf Food','false','none',10,'stackable','wood','none',-1,-1,1083,0,'true','true','true','true','true','PetFood','2361-1'),
(9672,'Magic Bottle','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9673,'Holy Water','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9674,'Darion\'s Badge','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9675,'Prayer Fragment','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9676,'Mark of Betrayal','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9678,'Magic Gem','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9679,'Steel Citadel Blueprints','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9680,'Dim Life Force','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9681,'Life Force','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9682,'Contained Life Force','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9683,'Sand Worm Tooth','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9684,'Native Treasure','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9685,'Gate Key: Darkness','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2354-1'),
(9686,'Gate Key: Destruction','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2355-1'),
(9687,'Gate Key: Blood','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2356-1'),
(9688,'Ballista Bomb','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2342-1'),
(9689,'Spirit of the Lake','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2368-1'),
(9690,'Contaminated Crystal','false','none',20,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9691,'Water Dragon Scale','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2369-1'),
(9692,'Red Coral','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9693,'Crystal Fragment','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9694,'Secret Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9695,'Blue Crystal','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9696,'Red Crystal','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9697,'Clear Crystal','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9698,'Blue Coral Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2366-1'),
(9699,'Red Coral Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','PaganKeys','2367-1'),
(9700,'Water Dragon Claw','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2360-1'),
(9701,'Sealed Magic Field Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9702,'Caravaner\'s Remedy','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9703,'Gate Key: Kamael','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9704,'Gate Key: Archives','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9705,'Gate Key: Observation','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9706,'Gate Key: Spicula','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9707,'Gate Key: Harkilgamed','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9708,'Gate Key: Rodenpicula','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9709,'Gate Key: Arviterre','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9710,'Gate Key: Katenar','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9711,'Gate Key: Prediction','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9712,'Gate Key: Massive Cavern','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9713,'Nornil\'s Power','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9714,'Key of the Evil Eye','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9715,'Giant Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9716,'Scroll of Escape: Kamael Village','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2214-6'),
(9717,'Information on Eranus','false','quest',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9718,'Report on the Crimson Duchess','false','quest',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9719,'List of Attackers','false','quest',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9721,'Freezer','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9722,'Resonance Amulet - 1','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9723,'Resonance Amulet - 1','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9724,'Resonance Amulet - 1','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9725,'Resonance Amulet - 2','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9726,'Resonance Amulet - 2','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9727,'Resonance Amulet - 2','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9728,'Resonance Amulet - 3','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9729,'Resonance Amulet - 3','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9730,'Resonance Amulet - 3','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9731,'Resonance Amulet - 4','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9732,'Resonance Amulet - 4','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9733,'Resonance Amulet - 4','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9734,'Resonance Amulet - 5','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9735,'Resonance Amulet - 5','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9736,'Resonance Amulet - 5','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9737,'Resonance Amulet - 6','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9738,'Resonance Amulet - 6','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9739,'Resonance Amulet - 6','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9740,'Halisha\'s Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9741,'Halisha\'s Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9742,'Halisha\'s Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9743,'Shining Medallion','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9744,'Blood Jewel','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9745,'Black Echo Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9746,'Commander\'s Feather','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9747,'Crimson Spider Claw','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9748,'Muertos Feather','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9749,'Felim Lizardman Head','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9750,'Venomous Spider Leg','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9751,'Tumran Bugbear Heart','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9752,'Shubain\'s Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9753,'Gwain\'s Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9754,'Breka Orc Head','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9755,'Message Plate','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9756,'Report - East','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9757,'Report - North','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9758,'Harkilgamed\'s Letter','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9759,'Tenain\'s Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9760,'Orkurus\' Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9761,'Frozen Cell Samples','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9762,'Orders','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9763,'Organization Chart','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9764,'Gobie\'s Orders','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9765,'Letter to the Humans','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9766,'Humans\' Reply','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9767,'Letter to the Dark Elves','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9768,'Dark Elves\' Reply','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9769,'Report to Sione','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9770,'Empty Soul Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9771,'Tak\'s Captured Soul','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9772,'Steelrazor Evaluation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9773,'Enmity Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9774,'Enmity Crystal Core','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9775,'Manuscript Page','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9776,'Encoded Page on the Ancient Race','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9777,'Kamael Inquisitor Trainee Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9778,'Fragment of Attack Orders','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9779,'Grandis\' Attack Orders','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9780,'Manashen\'s Talisman','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9781,'Research on the Giants and the Ancient Race','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9782,'Kamael Inquisitor Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9783,'Echo Crystal of Free Thought','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9784,'Parme\'s Letter','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9785,'Refined Crystal Sample','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9786,'Stabilized Ectoplasm','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9787,'Ectoplasm','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9788,'Hardin\'s Instructions','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9789,'Glass Jaguar Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9790,'Blank Sealbook','false','quest',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9791,'Transform Sealbook - Onyx Beast','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9792,'Warehouse Manifest','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9793,'Grocery Store Manifest','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9794,'Weapon Shop Manifest','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9795,'Supply Report','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9796,'Hills of Gold Monster Claw','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9797,'Dungeon Leader Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9798,'Fragment of the Dungeon Leader Mark','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9799,'Wolf Tail','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9800,'Ranku\'s Blueprint','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9801,'Demon Prince\'s Blueprint','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9802,'Safe Key','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9803,'Sealed Document','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9804,'Wyrm Heart','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9805,'Kekropus\' Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9806,'Soul Breaker Certificate','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9807,'Wolf Tail','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9808,'Muertos Claw','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9809,'Grey Keltir Tooth','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9810,'Black Wolf Tooth','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9811,'Fortress Certificate','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9812,'Castle Certificate','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9814,'Memento Mori','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9815,'Dragon Heart','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9816,'Earth Egg','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9817,'Nonliving Nucleus','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9818,'Angelic Essence','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9849,'Fiery Demon Blood','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2357-1'),
(9850,'Basic Caravan Certificate','false','none',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9851,'Standard Caravan Certificate','false','none',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9852,'Premium Caravan Certificate','false','none',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9853,'Mark of Friendship and Trust','false','none',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9881,'Diploma','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9882,'Great Wolf Necklace','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(9897,'Scroll of Transformation - Pig','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2370-1'),
(9898,'SP Scroll: Highest Grade','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2167-4'),
(9910,'Blood Oath','false','none',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9911,'Blood Alliance','false','none',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(9912,'Knight\'s Epaulette','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9967,'Recipe - Dynasty Sword (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9968,'Recipe - Dynasty Blade (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9969,'Recipe - Dynasty Phantom (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9970,'Recipe - Dynasty Bow (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9971,'Recipe - Dynasty Knife (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9972,'Recipe - Dynasty Halberd (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9973,'Recipe - Dynasty Cudgel (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9974,'Recipe - Dynasty Mace (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9975,'Recipe - Dynasty Bagh-Nakh (60%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9976,'Recipe - Dynasty Sword (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9977,'Recipe - Dynasty Blade (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9978,'Recipe - Dynasty Phantom (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9979,'Recipe - Dynasty Bow (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9980,'Recipe - Dynasty Knife (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9981,'Recipe - Dynasty Halberd (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9982,'Recipe - Dynasty Cudgel (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9983,'Recipe - Dynasty Mace (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9984,'Recipe - Dynasty Bagh-Nakh (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9985,'Recipe - Sealed Dynasty Earrings (70%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9986,'Recipe - Sealed Dynasty Necklace (70%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9987,'Recipe - Sealed Dynasty Ring (70%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(9988,'Recipe - Sealed Dynasty Earrings (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9989,'Recipe - Sealed Dynasty Necklace (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9990,'Recipe - Sealed Dynasty Ring (100%)','false','none',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9991,'Sealed Dynasty Earring Gemstone','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9992,'Sealed Dynasty Necklace Gemstone','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9993,'Sealed Dynasty Ring Gemstone','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9994,'Map of Hellbound','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(9997,'Fire Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2335-1'),
(9998,'Water Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2336-1'),
(9999,'Earth Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2338-1'),
(10000,'Wind Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2337-1'),
(10001,'Dark Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2340-1'),
(10002,'Divine Potion','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2339-1'),
(10012,'Scorpion Poison stinger','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10013,'Race Stamp','false','none',20,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10014,'Control Room Card','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10015,'Prison Gate Key','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10016,'Underground Warehouse Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10017,'Coral Treasure Chest Key','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10025,'Battle Manual - Fallen Arrow','false','spellbook',120,'stackable','wood','none',-1,-1,75,0,'true','true','true','true','true','none',''),
(10026,'Battle Manual - Fallen Attack','false','spellbook',120,'stackable','wood','none',-1,-1,75,0,'true','true','true','true','true','none',''),
(10027,'Battle Manual - Detect Trap','false','spellbook',120,'stackable','wood','none',-1,-1,550,0,'true','true','true','true','true','none',''),
(10028,'Battle Manual - Defuse Trap','false','spellbook',120,'stackable','wood','none',-1,-1,550,0,'true','true','true','true','true','none',''),
(10029,'Battle Manual - Dark Strike','false','spellbook',120,'stackable','wood','none',-1,-1,700,0,'true','true','true','true','true','none',''),
(10030,'Battle Manual - Dark Smash','false','spellbook',120,'stackable','wood','none',-1,-1,2900,0,'true','true','true','true','true','none',''),
(10031,'Battle Manual - Double Thrust','false','spellbook',120,'stackable','wood','none',-1,-1,700,0,'true','true','true','true','true','none',''),
(10032,'Battle Manual - Abyssal Blaze','false','spellbook',120,'stackable','wood','none',-1,-1,700,0,'true','true','true','true','true','none',''),
(10033,'Battle Manual - Dark Explosion','false','spellbook',120,'stackable','wood','none',-1,-1,1150,0,'true','true','true','true','true','none',''),
(10034,'Battle Manual - Shift Target','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10035,'Battle Manual - Change Life Stone','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10036,'Battle Manual - Spread Wing','false','spellbook',120,'stackable','wood','none',-1,-1,5000,0,'true','true','true','true','true','none',''),
(10037,'Battle Manual - Slashing Blade','false','spellbook',120,'stackable','wood','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(10038,'Battle Manual - Crushing Pain','false','spellbook',120,'stackable','wood','none',-1,-1,7000,0,'true','true','true','true','true','none',''),
(10039,'Battle Manual - Contagion','false','spellbook',120,'stackable','wood','none',-1,-1,7950,0,'true','true','true','true','true','none',''),
(10040,'Battle Manual - Life to Soul','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10041,'Battle Manual - Scorn','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10042,'Battle Manual - Triple Thrust','false','spellbook',120,'stackable','wood','none',-1,-1,2900,0,'true','true','true','true','true','none',''),
(10043,'Battle Manual - Shining Edge','false','spellbook',120,'stackable','wood','none',-1,-1,4400,0,'true','true','true','true','true','none',''),
(10044,'Battle Manual - Checkmate','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10045,'Battle Manual - Soul of Pain','false','spellbook',120,'stackable','wood','none',-1,-1,3000,0,'true','true','true','true','true','none',''),
(10046,'Battle Manual - Dark Flame','false','spellbook',120,'stackable','wood','none',-1,-1,4000,0,'true','true','true','true','true','none',''),
(10047,'Battle Manual - Annihilation Circle','false','spellbook',120,'stackable','wood','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(10048,'Battle Manual - Curse of Divinity','false','spellbook',120,'stackable','wood','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(10049,'Battle Manual - Steal Divinity','false','spellbook',120,'stackable','wood','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(10050,'Battle Manual - Blink','false','spellbook',120,'stackable','wood','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(10051,'Battle Manual - Transfer Soul','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10052,'Battle Manual - Twin Shot','false','spellbook',120,'stackable','wood','none',-1,-1,2900,0,'true','true','true','true','true','none',''),
(10053,'Battle Manual - Rising Shot','false','spellbook',120,'stackable','wood','none',-1,-1,3850,0,'true','true','true','true','true','none',''),
(10054,'Battle Manual - Deadly Roulette','false','spellbook',120,'stackable','wood','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(10055,'Battle Manual - Temptation','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10056,'Battle Manual - Create Bio Potion','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10057,'Battle Manual - Create Dark Seed','false','spellbook',120,'stackable','wood','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(10058,'Battle Manual - Fire Trap','false','spellbook',120,'stackable','wood','none',-1,-1,1550,0,'true','true','true','true','true','none',''),
(10059,'Battle Manual - Poison Trap','false','spellbook',120,'stackable','wood','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(10060,'Battle Manual - Slow Trap','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10061,'Battle Manual - Flash Trap','false','spellbook',120,'stackable','wood','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(10062,'Battle Manual - Binding Trap','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10063,'Battle Manual - Quiver of Bolts - Grade A','false','spellbook',120,'stackable','wood','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(10064,'Battle Manual - Quiver of Bolts - Grade S','false','spellbook',120,'stackable','wood','none',-1,-1,10000,0,'true','true','true','true','true','none',''),
(10065,'Battle Manual - Cure Dark Seed','false','spellbook',120,'stackable','wood','none',-1,-1,8200,0,'true','true','true','true','true','none',''),
(10066,'Battle Manual - Decoy','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10067,'Battle Manual - Chain Lightning','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10068,'Battle Manual - Enuma Elish','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10069,'Battle Manual - Leopold','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10070,'Battle Manual - Change Weapon','false','spellbook',120,'stackable','wood','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(10071,'Battle Manual - Quiver of Bolts - Grade B','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10072,'Battle Manual - Increase Power','false','spellbook',120,'stackable','wood','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(10073,'Battle Manual - Rapid Attack','false','spellbook',120,'stackable','wood','none',-1,-1,250,0,'true','true','true','true','true','none',''),
(10074,'Battle Manual - Furious Soul','false','spellbook',120,'stackable','wood','none',-1,-1,1150,0,'true','true','true','true','true','none',''),
(10075,'Battle Manual - Sword Shield','false','spellbook',120,'stackable','wood','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(10076,'Battle Manual - Disarm','false','spellbook',120,'stackable','wood','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(10077,'Battle Manual - Fast Shot','false','spellbook',120,'stackable','wood','none',-1,-1,2050,0,'true','true','true','true','true','none',''),
(10078,'Battle Manual - Death Mark','false','spellbook',120,'stackable','wood','none',-1,-1,1150,0,'true','true','true','true','true','none',''),
(10079,'Battle Manual - Courage','false','spellbook',120,'stackable','wood','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(10080,'Battle Manual - Violent Temper','false','spellbook',120,'stackable','wood','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(10081,'Battle Manual - Soul to Empower','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10082,'Battle Manual - Darkness Protection','false','spellbook',120,'stackable','wood','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(10083,'Battle Manual - Dark Weapon','false','spellbook',120,'stackable','wood','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(10084,'Battle Manual - Pride of Kamael','false','spellbook',120,'stackable','wood','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(10085,'Battle Manual - Surrender To Unholy','false','spellbook',120,'stackable','wood','none',-1,-1,1250,0,'true','true','true','true','true','none',''),
(10086,'Battle Manual - Bleeding Shot','false','spellbook',120,'stackable','wood','none',-1,-1,3350,0,'true','true','true','true','true','none',''),
(10087,'Battle Manual - Sharpshooting','false','spellbook',120,'stackable','wood','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(10088,'Battle Manual - Real Target','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10089,'Battle Manual - Imbue Dark Seed','false','spellbook',120,'stackable','wood','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(10090,'Battle Manual - Prahnah','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10091,'Battle Manual - Final Form','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10092,'Battle Manual - Shadow Bind','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10093,'Battle Manual - Voice Bind','false','spellbook',120,'stackable','wood','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(10094,'Battle Manual - Rush','false','spellbook',120,'stackable','wood','none',-1,-1,2050,0,'true','true','true','true','true','none',''),
(10095,'Battle Manual - Storm Assault','false','spellbook',120,'stackable','wood','none',-1,-1,4400,0,'true','true','true','true','true','none',''),
(10096,'Battle Manual - Wing Assault','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10097,'Battle Manual - Shoulder Charge','false','spellbook',120,'stackable','wood','none',-1,-1,2900,0,'true','true','true','true','true','none',''),
(10098,'Battle Manual - Blade Rush','false','spellbook',120,'stackable','wood','none',-1,-1,6000,0,'true','true','true','true','true','none',''),
(10099,'Spellbook - Count of Fire','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10100,'Spellbook - Diamond Dust','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10101,'Spellbook - Throne of Ice','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10102,'Spellbook - Throne of Wind','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10103,'Spellbook - Divine Power','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10104,'Spellbook - Mana Gain','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10105,'Amulet - Chant of Protection','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10106,'Amulet - Seal of Blockade','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10107,'Spellbook - Fire Vortex Buster','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10108,'Spellbook - Ice Vortex Crusher','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10109,'Spellbook - Wind Vortex Slug','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10110,'Spellbook - Meteor','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10111,'Spellbook - Star Fall','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10112,'Dark Seed','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','false','true','false','false','none',''),
(10113,'Special Bolt','false','none',6,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10114,'Sealed Dynasty Sigil Piece','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10115,'Recipe: Sealed Dynasty Sigil (60%)','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10116,'Recipe: Sealed Dynasty Sigil (100%)','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10117,'Chaotic Sealed Dynasty Sigil','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10118,'Chaotic Dynasty Sickle','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10129,'Scroll of Escape: Fortress','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2365-1'),
(10130,'Blessed Scroll of Escape: Fortress','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2364-1'),
(10131,'Onyx Beast Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2371-1'),
(10132,'Death Blader Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2372-1'),
(10133,'Grail Apostle Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2373-1'),
(10134,'Unicorn Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2374-1'),
(10135,'Lilim Knight Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2375-1'),
(10136,'Golem Guardian Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2376-1'),
(10137,'Inferno Drake Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2377-1'),
(10138,'Dragon Bomber Transform Scroll','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2378-1'),
(10143,'Battleground Spell - Shield Master','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2379-1;2380-1;2381-1;2382-1;2383-1'),
(10144,'Battleground Spell - Wizard','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2379-1;2380-1;2381-1;2384-1;2385-1'),
(10145,'Battleground Spell - Healer','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2379-1;2380-1;2381-1;2384-1;2386-1'),
(10146,'Battleground Spell - Dagger Master','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2379-1;2387-1;2381-1;2388-1;2383-1'),
(10147,'Battleground Spell - Bow Master','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2379-1;2387-1;2381-1;2383-1;2389-1'),
(10148,'Battleground Spell - Berserker','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2390-1;2391-1'),
(10149,'Battleground Blessed Scroll of Escape','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2392-1'),
(10150,'Battleground Blessed Scroll of Resurrection','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ScrollOfResurrection','2393-1'),
(10151,'Battleground Transform Spell','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2394-1'),
(10152,'Battle Health Recovery Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10153,'Battle Mana Recovery Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10154,'Battle CP Recovery Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10155,'Mental Strengthening Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2396-1'),
(10156,'Medusa\'s Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10157,'Instant Haste Potion','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2398-1'),
(10159,'Capture Rope','false','none',5,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10160,'Cursed Red Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10161,'Cursed Blue Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10162,'Cursed Green Soul Crystal - Stage 14','false','none',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10163,'Wolf Collar','false','pet_collar',10,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(10164,'Animal Slayer\'s List','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10165,'Bloody Red Claw','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10166,'Spring CP Potion','false','none',25,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10171,'Seed: Dark Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10172,'Seed: Red Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10173,'Seed: Chilly Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10174,'Seed: Blue Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10178,'Sweet Fruit Cocktail','false','none',5,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10179,'Fresh Fruit Cocktail','false','none',5,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10180,'Battle Manual - Penetrate Shot','false','spellbook',120,'stackable','wood','none',-1,-1,800,0,'true','true','true','true','true','none',''),
(10181,'Battle Manual - Erase Mark','false','spellbook',120,'stackable','wood','none',-1,-1,1050,0,'true','true','true','true','true','none',''),
(10182,'Battle Manual - Ultimate Escape','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10183,'Battle Manual - Create Special Bolt','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10184,'Battle Manual - Restoration Impact','false','spellbook',120,'stackable','wood','none',-1,-1,4800,0,'true','true','true','true','true','none',''),
(10185,'Battle Manual - Destroy Instinct','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10186,'Battle Manual - Restoration','false','spellbook',120,'stackable','wood','none',-1,-1,3200,0,'true','true','true','true','true','none',''),
(10187,'Battle Manual - Oblivion','false','spellbook',120,'stackable','wood','none',-1,-1,3700,0,'true','true','true','true','true','none',''),
(10188,'Battle Manual - Thin Skin','false','spellbook',120,'stackable','wood','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(10189,'Battle Manual - Protection Instinct','false','spellbook',120,'stackable','wood','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(10190,'Battle Manual - Vampiric Impulse','false','spellbook',120,'stackable','wood','none',-1,-1,5400,0,'true','true','true','true','true','none',''),
(10191,'Battle Manual - Magic Impulse','false','spellbook',120,'stackable','wood','none',-1,-1,6250,0,'true','true','true','true','true','none',''),
(10192,'Battle Manual - Enervation','false','spellbook',120,'stackable','wood','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(10193,'Battle Manual - Weak Constitution','false','spellbook',120,'stackable','wood','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(10194,'Battle Manual - Spite','false','spellbook',120,'stackable','wood','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(10195,'Battle Manual - Mental Impoverish','false','spellbook',120,'stackable','wood','none',-1,-1,7700,0,'true','true','true','true','true','none',''),
(10196,'Battle Manual - Soul Harmony','false','spellbook',120,'stackable','wood','none',-1,-1,9300,0,'true','true','true','true','true','none',''),
(10197,'Alternative Dark Coda Seed','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10198,'Alternative Red Coda Seed','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10199,'Seed: Alternative Chilly Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10200,'Alternative Blue Coda Seed','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10201,'Seed: Alternative Golden Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10202,'Seed: Golden Coda','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Seed','2097-1'),
(10203,'Spellbook - Empowering Echo','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10204,'Battle Manual - Soul Gathering','false','spellbook',120,'stackable','wood','none',-1,-1,4250,0,'true','true','true','true','true','none',''),
(10205,'White Seed of Evil Lump','false','none',100,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10206,'Black Seed of Evil Lump','false','none',100,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10213,'Inventory','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10254,'1st Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10255,'2nd Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10256,'3rd Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10257,'4th Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10258,'5th Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10259,'6th Place Treasure Sack','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10260,'Haste Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2429-1'),
(10261,'Accuracy Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2430-1'),
(10262,'Critical Power Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2431-1'),
(10263,'Critical Attack Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2432-1'),
(10264,'Casting Spd. Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2433-1'),
(10265,'Evasion Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2434-1'),
(10266,'Magic Power Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2435-1'),
(10267,'Power Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2436-1'),
(10268,'Speed Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2437-1'),
(10269,'Defense Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2438-1'),
(10270,'MP Consumption Juice','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2439-1'),
(10271,'Marvelous Fruit Juice #12','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10272,'Treasure Sack Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10274,'Rabbit Transformation Scroll','false','scroll',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2428-1'),
(10275,'Battle Manual - Warp','false','spellbook',120,'stackable','wood','none',-1,-1,2050,0,'true','true','true','true','true','none',''),
(10276,'Battle Manual - Soul Shock','false','spellbook',120,'stackable','wood','none',-1,-1,2600,0,'true','true','true','true','true','none',''),
(10279,'Onyx Beast Transform Scroll','false','scroll',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10280,'Certificate - Emergent Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10281,'Certificate - Warrior Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10282,'Certificate - Knight Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10283,'Certificate - Rogue Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10284,'Certificate - Wizard Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10285,'Certificate - Healer Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10286,'Certificate - Summoner Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10287,'Certificate - Enchanter Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10288,'Transform Sealbook - Divine Knight','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10289,'Transform Sealbook - Divine Warrior','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10290,'Transform Sealbook - Divine Rogue','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10291,'Transform Sealbook - Divine Healer','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10292,'Transform Sealbook - Divine Wizard','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10293,'Transform Sealbook - Divine Enchanter','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10294,'Transform Sealbook - Divine Summoner','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10295,'Transform Sealbook - Zaken','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10296,'Transform Sealbook - Anakim','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10297,'Transform Sealbook - Venom','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10298,'Transform Sealbook - Gordon','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10299,'Transform Sealbook - Ranku','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10300,'Transform Sealbook - Kechi','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10301,'Transform Sealbook - Demon Prince','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10302,'Transform Sealbook - Heretic','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10303,'Transform Sealbook - Vale Master','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10304,'Transform Sealbook - Saber Tooth Tiger','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10305,'Transform Sealbook - Oel Mahum','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10306,'Transform Sealbook - Doll Blader','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10307,'Great Snow Wolf Necklace','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'false','false','true','false','true','SummonItems',''),
(10308,'Red Dragon Bugle of Wind','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'false','false','true','false','true','SummonItems',''),
(10309,'Red Dragon Bugle of Star','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'false','false','true','false','true','SummonItems',''),
(10310,'Red Dragon Bugle of Dusk','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'false','false','true','false','true','SummonItems',''),
(10311,'Improved Buffalo Panpipe','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(10312,'Improved Cougar Chime','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(10313,'Improved Kookaburra Ocarina','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(10327,'Evil Weapon','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10328,'Stolen Cargo','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10329,'Hate Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10330,'Old Treasure Map','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10331,'Sonin\'s Credentials','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10332,'Pano\'s Credentials','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10333,'Alex\'s Credentials','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10334,'Badge - Temple Executor','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10335,'Giants\' Experimental Tool Fragment','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10336,'Giants\' Experimental Tool','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10337,'Giants\' Technology Report','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10338,'Rouke\'s Report','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10339,'Badge - Temple Missionary','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10340,'Report Fragment','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10341,'Temple Manifesto','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10342,'Relics of the Dark Elf Trainee','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10343,'Angus\' Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10344,'Pupina\'s Recommendation','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10345,'Records Chest Key Fragment','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10346,'Records Chest','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10347,'Dark Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10348,'Dark Oxide','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10349,'Cryptogram of the Goddess Sword','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10350,'Predecessor\'s Report','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10351,'Cryptogram of the Angel Search','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10352,'Prophecy Fragment','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10353,'Fallen Angel Blood','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10354,'Sealed Prophecy - Path of the God','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10355,'Prophecy - Path of the God','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10356,'Empty Sound Crystal','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10357,'Angel Medicine','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10358,'Angel\'s Message','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10359,'Metallograph','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10360,'Broken Metal Pieces','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10361,'Nikola\'s Map','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10362,'Loraine\'s Certificate','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10363,'Metallograph','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10364,'Broken Metal Pieces','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10365,'Nikola\'s Map','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10366,'Metallograph - Research Report','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10367,'Leto Lizardman Accessory','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10368,'Metallograph','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10369,'Broken Metal Pieces','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10370,'Metallograph - Decipher Pattern','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10371,'Repaired Metallograph','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10372,'Red Stone','false','quest',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10373,'Recipe - Icarus Sawsword (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10374,'Recipe - Icarus Disperser (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10375,'Recipe - Icarus Spirit (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10376,'Recipe - Icarus Heavy Arms (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10377,'Recipe - Icarus Trident (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10378,'Recipe - Icarus Hammer (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10379,'Recipe - Icarus Hand (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10380,'Recipe - Icarus Hall (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10381,'Recipe - Icarus Spitter (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10382,'Recipe - Icarus Stinger (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10383,'Recipe - Icarus Wingblade (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10384,'Recipe - Icarus Shooter (60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10385,'Recipe - Icarus Sawsword (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10386,'Recipe - Icarus Disperser (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10387,'Recipe - Icarus Spirit (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10388,'Recipe - Icarus Heavy Arms (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10389,'Recipe - Icarus Trident (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10390,'Recipe - Icarus Hammer (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10391,'Recipe - Icarus Hand (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10392,'Recipe - Icarus Hall (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10393,'Recipe - Icarus Spitter (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10394,'Recipe - Icarus Stinger (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10395,'Recipe - Icarus Wingblade (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10396,'Recipe - Icarus Shooter (100%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10397,'Icarus Sawsword Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10398,'Icarus Disperser Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10399,'Icarus Spirit Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10400,'Icarus Heavy Arms Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10401,'Icarus Trident Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10402,'Icarus Hammer Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10403,'Icarus Hand Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10404,'Icarus Hall Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10405,'Icarus Spitter Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10406,'Icarus Stinger Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10407,'Icarus Wingblade Piece','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10408,'Old Agathion','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10409,'A Bottle of Souls','false','none',2,'stackable','wood','none',-1,-1,500,0,'true','true','true','true','true','ItemSkills','2498-1'),
(10410,'Full Bottle of Souls - 5 Souls','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2499-1'),
(10411,'Full Bottle of Souls - 5 Souls (For Combat)','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions','2499-1'),
(10412,'Full Bottle of Souls - 10 Souls','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Potions',''),
(10413,'Dynastic Essence II','false','none',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10414,'Agathion Exchange Coupon','false','none',1,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10425,'Improved Baby Pet Food','false','none',10,'stackable','wood','none',-1,-1,1083,0,'true','true','true','true','true','PetFood','2361-1'),
(10426,'Fenrir Necklace','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','SummonItems',''),
(10427,'Tully\'s Platinum Medal','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10428,'Tully\'s Tin Medal','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10429,'Tully\'s Lead Medal','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10430,'Tully\'s Zinc Medal','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10431,'Tully\'s Copper Medal','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10432,'Kertin\'s Herb of Life','false','herb',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2485-1'),
(10433,'Kertin\'s Herb of Mana','false','herb',0,'normal','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2486-1'),
(10473,'Magic Accessory Set','false','none',20,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10480,'Red Soul Crystal - Stage 15','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10481,'Blue Soul Crystal - Stage 15','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10482,'Green Soul Crystal - Stage 15','false','none',20,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(10483,'Life Stone - level 82','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10484,'Mid-Grade Life Stone - level 82','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10485,'High-Grade Life Stone - level 82','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10486,'Top-Grade Life Stone - level 82','false','none',2,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10515,'Beast Soulshot Compressed Pack','false','shot',100,'stackable','wood','none',-1,-1,10833,0,'true','true','true','true','true','ItemSkills','2500-1'),
(10516,'Beast Spiritshot Compressed Pack','false','shot',100,'stackable','wood','none',-1,-1,21666,0,'true','true','true','true','true','ItemSkills','2501-1'),
(10517,'Blessed Beast Spiritshot Compressed Pack','false','shot',100,'stackable','wood','none',-1,-1,54166,0,'true','true','true','true','true','ItemSkills','2502-1'),
(10520,'Echo Crystal - Kuraki Mai','false','none',10,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10521,'Rough Ore of Fire','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2329-1'),
(10522,'Rough Ore of Water','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2330-1'),
(10523,'Rough Ore of the Earth','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2332-1'),
(10524,'Rough Ore of Wind','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2331-1'),
(10525,'Rough Ore of Darkness','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2334-1'),
(10526,'Rough Ore of Divinity','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','EnchantAttribute','2333-1'),
(10544,'Recipe - Dynasty Staff(60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10545,'Recipe - Dynasty Crusher(60%)','false','recipe',30,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(10546,'Recipe - Dynasty Staff Fragment','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10547,'Recipe - Dynasty Crusher Fragment','false','material',60,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10549,'Forgotten Scroll - Protection of Rune','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2441-1'),
(10550,'Forgotten Scroll - Protection of Elemental','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2442-1'),
(10551,'Forgotten Scroll - Protection of Alignment','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2443-1'),
(10552,'Forgotten Scroll - Fighter\'s Will','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2444-1'),
(10553,'Forgotten Scroll - Archer\'s Will','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2445-1'),
(10554,'Forgotten Scroll - Anti-Magic Armor','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2446-1'),
(10555,'Forgotten Scroll - Seed of Revenge','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2447-1'),
(10556,'Forgotten Scroll - Hell Scream','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2448-1'),
(10557,'Forgotten Scroll - Song of Windstorm','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2449-1'),
(10558,'Forgotten Scroll - Dance of Blade Storm','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2450-1'),
(10559,'Forgotten Scroll - Sixth Sense','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2451-1'),
(10560,'Forgotten Scroll - Expose Weak Point','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2452-1'),
(10561,'Forgotten Scroll - Exciting Adventure','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2453-1'),
(10562,'Forgotten Scroll - Wind Riding','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2454-1'),
(10563,'Forgotten Scroll - Ghost Walking','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2455-1'),
(10564,'Forgotten Scroll - Flame Hawk','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2456-1'),
(10565,'Forgotten Scroll - Arrow Rain','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2457-1'),
(10566,'Forgotten Scroll - Ghost Piercing','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2458-1'),
(10567,'Forgotten Scroll - Dread Pool','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2459-1'),
(10568,'Forgotten Scroll - Weapon Blockade','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2460-1'),
(10569,'Forgotten Scroll - Force of Destruction','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2461-1'),
(10570,'Forgotten Scroll - Demolition Impact','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2462-1'),
(10571,'Forgotten Scroll - Golem Armor','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2463-1'),
(10572,'Forgotten Scroll - Flame Armor','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2464-1'),
(10573,'Forgotten Scroll - Frost Armor','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2465-1'),
(10574,'Forgotten Scroll - Hurricane Armor','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2466-1'),
(10575,'Forgotten Scroll - Vampiric Mist','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2467-1'),
(10576,'Forgotten Scroll - Servitor Barrier','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2468-1'),
(10577,'Forgotten Scroll - Excessive Loyalty','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2469-1'),
(10578,'Forgotten Scroll - Mutual Response','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2470-1'),
(10579,'Forgotten Scroll - Improve Combat','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2471-1'),
(10580,'Forgotten Scroll - Improve Magic','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2472-1'),
(10581,'Forgotten Scroll - Improve Condition','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2473-1'),
(10582,'Forgotten Scroll - Improve Critical Attack','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2474-1'),
(10583,'Forgotten Scroll - Improve Shield Defense','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2475-1'),
(10584,'Forgotten Scroll - Improve Movement','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2476-1'),
(10585,'Forgotten Scroll - Sublime Self Sacrifice','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2477-1'),
(10586,'Forgotten Scroll - Blessing of Eva','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2478-1'),
(10587,'Forgotten Scroll - Lord of Vampire','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2479-1'),
(10588,'Forgotten Scroll - Throne Root','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2480-1'),
(10589,'Forgotten Scroll - Seal of Limit','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2481-1'),
(10590,'Spellbook - Summon Smart Cubic','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10591,'Forgotten Scroll - Spirit of Phoenix','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2482-1'),
(10592,'Forgotten Scroll - Eva\'s Will','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2483-1'),
(10593,'Forgotten Scroll - Pain of Shilen','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2484-1'),
(10594,'Forgotten Scroll - Wild Shot','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2488-1'),
(10595,'Forgotten Scroll - Lightning Shock','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2489-1'),
(10596,'Battle Manual - Soul Cleanse','false','spellbook',120,'stackable','wood','none',-1,-1,8700,0,'true','true','true','true','true','none',''),
(10597,'Battle Manual - Curse of Life Flow','false','spellbook',120,'stackable','wood','none',-1,-1,7200,0,'true','true','true','true','true','none',''),
(10598,'Battle Manual - Soul Vortex','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10599,'Battle Manual - Soul Vortex Extinction','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10600,'Battle Manual - Soul Barrier','false','spellbook',120,'stackable','wood','none',-1,-1,6750,0,'true','true','true','true','true','none',''),
(10601,'Battle Manual - Lightning Barrier','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10602,'Battle Manual - Soul Strike','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10603,'Battle Manual - Betrayal Mark','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10604,'Battle Manual - Rush Impact','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10605,'Battle Manual - Mass Disarm','false','spellbook',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10607,'Agathion Seal Bracelet - Rudolph','false','none',150,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(10608,'Amulet - Chant of Combat','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2505-1'),
(10609,'Amulet - Chant of Critical Attack','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2506-1'),
(10610,'Amulet - Chant of Blood Awakening','false','none',120,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2507-1'),
(10611,'Snow Fenrir Necklace','false','pet_collar',20,'normal','wood','none',-1,-1,0,0,'false','false','true','false','true','SummonItems',''),
(10612,'Certificate - Master Ability','false','none',120,'stackable','wood','none',-1,-1,0,0,'false','false','false','false','false','none',''),
(10632,'Wondrous Cubic','false','none',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','ItemSkills','2510-1'),
(10633,'Rough Blue Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10634,'Rough Yellow Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10635,'Rough Green Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10636,'Rough Red Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10637,'Rough White Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10638,'Rough Black Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10639,'Mouse Coin','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10640,'Cloned Squash Seed','false','none',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10641,'Cloned Large Squash Seed','false','none',0,'stackable','wood','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10642,'Fine Blue Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10643,'Fine Yellow Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10644,'Fine Green Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10645,'Fine Red Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10646,'Fine White Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10647,'Fine Black Cubic Piece','false','none',0,'stackable','wood','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10649,'Feather of Blessing','false','none',180,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10650,'Adventurer\'s Scroll of Escape','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2531-1'),
(10651,'Teleporter Transformation Scroll (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10652,'Teleporter\'s Tear (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10653,'Guard Transformation Scroll (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10654,'Guard Edict (Event)','false','scroll',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10655,'Herb of Vampiric Rage','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2512-1'),
(10656,'Herb of Critical Attack - Power','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2514-1'),
(10657,'Herb of Doubt','false','herb',0,'normal','paper','none',-1,-1,0,0,'false','true','true','true','false','ItemSkills','2513-1'),
(10661,'Pet Summon Item - Warrior Use','false','pet_collar',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10662,'Pet Summon Item - Wizard Use','false','pet_collar',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10663,'Pet Summon Item - Mixing Use','false','pet_collar',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10664,'Pet Summon Item - Warrior Pet','false','pet_collar',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10665,'Pet Summon Item - Warrior Pet','false','pet_collar',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10666,'Potion of Replenish Energy','false','none',80,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(10836,'Pathfinder Supplies (level 2)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10837,'Pathfinder Supplies (level 4)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10838,'Pathfinder Supplies (level 5)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10839,'Pathfinder Supplies (level 6)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10840,'Pathfinder Supplies (level 7)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10841,'Pathfinder Supplies (level 8)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10842,'Pathfinder Supplies (level 11)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10843,'Pathfinder Supplies (level 12)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10844,'Pathfinder Supplies (level 13)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10845,'Pathfinder Supplies (level 14)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10846,'Pathfinder Supplies (level 15)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10847,'Pathfinder Supplies (level 18)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10848,'Pathfinder Supplies (level 19)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10849,'Pathfinder Supplies (level 20)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10850,'Pathfinder Supplies (level 21)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10851,'Pathfinder Supplies (level 22)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10852,'Pathfinder Supplies (level 25)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10853,'Pathfinder Supplies (level 26)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10854,'Pathfinder Supplies (level 27)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10855,'Pathfinder Supplies (level 28)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10856,'Pathfinder Supplies (level 29)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10857,'Pathfinder Supplies (level 32)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10858,'Pathfinder Supplies (level 33)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10859,'Pathfinder Supplies (level 34)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10860,'Pathfinder Supplies (level 35)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10861,'Pathfinder Supplies (level 36)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10862,'Pathfinder Supplies (level 38)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10863,'Pathfinder Supplies (level 39)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10864,'Pathfinder Supplies (level 40)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10865,'Pathfinder Supplies (level 41)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10866,'Energy Ore','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10867,'Bloody Cloth Fragment','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10868,'Helvetia\'s Antidote','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(10869,'Contaminated Kasha Spider Venom','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12362,'Weapon-Type Enhance Backup Stone (D-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12363,'Weapon-Type Enhance Backup Stone (C-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12364,'Weapon-Type Enhance Backup Stone (B-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12365,'Weapon-Type Enhance Backup Stone (A-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12366,'Weapon-Type Enhance Backup Stone (S-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12367,'Armor-Type Enhance Backup Stone (D-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12368,'Armor-Type Enhance Backup Stone (C-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12369,'Armor-Type Enhance Backup Stone (B-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12370,'Armor-Type Enhance Backup Stone (A-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12371,'Armor-Type Enhance Backup Stone (S-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12374,'Mammon\'s Varnish Enhancer','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12375,'Foundation Great Sword','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12376,'Foundation Great Axe','false','none',1940,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12377,'Foundation Innominate Victory','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12378,'Foundation Dark Elven Long Bow','false','none',1720,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12379,'Foundation Sword of Valhalla','false','none',900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12380,'Foundation Spell Breaker','false','none',1620,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12381,'Foundation Arthro Nail','false','none',1420,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12382,'Foundation Ice Storm Hammer','false','none',1950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12383,'Foundation Military Fleuret','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12384,'Foundation Sprite\'s Staff','false','none',960,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12385,'Foundation Kris','false','none',980,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12386,'Foundation Keshanberk','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12387,'Foundation Peacemaker','false','none',1720,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12388,'Foundation Heavy War Axe','false','none',1620,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12389,'Foundation Hell Knife','false','none',740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12390,'Foundation Guardian Sword','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12391,'Foundation Sword of Damascus','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12392,'Foundation Dismantler','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12393,'Foundation Lance','false','none',1920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12394,'Foundation Bellion Cestus','false','none',1390,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12395,'Foundation Staff of Evil Spirits','false','none',930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12396,'Foundation Deadman\'s Glory','false','none',1600,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12397,'Foundation Star Buster','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12398,'Foundation Art of Battle Axe','false','none',1570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12399,'Foundation Demon Dagger','false','none',970,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12400,'Foundation Kaim Vanul\'s Bones','false','none',1570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12401,'Foundation Colichemarde','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12402,'Foundation Wizard\'s Tear','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12403,'Foundation Bow of Peril','false','none',1700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12404,'Foundation Hell Hound','false','none',1700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12405,'Foundation Dasparion\'s Staff','false','none',920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12406,'Foundation Doomchanter','false','none',1670,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12407,'Foundation White Lightning','false','none',1330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12408,'Foundation Meteor Shower','false','none',1600,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12409,'Foundation Blood Tornado','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12410,'Foundation Bloody Orchid','false','none',960,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12411,'Foundation Elemental Sword','false','none',830,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12412,'Foundation Spiritual Eye','false','none',1550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12413,'Foundation Infernal Master','false','none',1900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12414,'Foundation Carnage Bow','false','none',1670,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12415,'Foundation Tallum Blade','false','none',1330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12416,'Foundation Destroyer Hammer','false','none',1910,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12417,'Foundation Divine Pain','false','none',1900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12418,'Foundation Halberd','false','none',1900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12419,'Foundation Lacerator','false','none',1320,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12420,'Foundation Dark Legion','false','none',1320,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12421,'Foundation Undertaker','false','none',1840,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12422,'Foundation Doom Crusher','false','none',1900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12423,'Foundation Dragon Grinder','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12424,'Foundation Dragon Slayer','false','none',1840,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12425,'Foundation Flaming Dragon Skull','false','none',1530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12426,'Foundation Branch of the Mother Tree','false','none',900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12427,'Foundation Sword of Miracles','false','none',840,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12428,'Foundation Reaper','false','none',1660,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12429,'Foundation Soul Separator','false','none',950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12430,'Foundation Elysian','false','none',1580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12431,'Foundation Soul Bow','false','none',1660,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12432,'Foundation Tallum Glaive','false','none',1840,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none','');

INSERT INTO `etcitem` VALUES
(12433,'Foundation Naga Storm','false','none',930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12434,'Foundation Daimon Crystal','false','none',880,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12435,'Foundation Barakiel\'s Axe','false','none',1550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12436,'Foundation Screaming Vengeance','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12437,'Foundation Behemoth\'s Tuning Fork','false','none',1890,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12438,'Foundation Durendal','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12439,'Foundation Shyeed\'s Bow','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12440,'Foundation Sword of Ipos','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12441,'Foundation Sobekk\'s Hurricane','false','none',1330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12442,'Foundation Sirra\'s Blade','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12443,'Foundation Eclair Bijou','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12444,'Foundation Tiphon\'s Spear','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12445,'Foundation Themis\' Tongue','false','none',820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12446,'Foundation Cabrio\'s Hand','false','none',1510,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12447,'Foundation Gram','false','none',1800,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12448,'Foundation Demon Splinter','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12449,'Foundation Draconic Bow','false','none',1650,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12450,'Foundation Dragon Hunter Axe','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12451,'Foundation Laevateinn','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12452,'Foundation Basalt Battlehammer','false','none',1570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12453,'Foundation Sarnga','false','none',1600,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12454,'Foundation Saint Spear','false','none',1800,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12455,'Foundation Arcana Mace','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12456,'Foundation Angel Slayer','false','none',950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12457,'Foundation Imperial Staff','false','none',910,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12458,'Foundation Forgotten Blade','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12459,'Foundation Heaven\'s Divider','false','none',1380,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12460,'Foundation Dynasty Ancient Sword','false','none',1800,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12461,'Foundation Dynasty Knife','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12462,'Foundation Dynasty Rapier','false','none',1280,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12463,'Foundation Dynasty Mace','false','none',1080,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12464,'Foundation Dynasty Bagh-Nakh','false','none',1550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12465,'Foundation Dynasty Bow','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12466,'Foundation Dynasty Blade','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12467,'Foundation Dynasty Sword','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12468,'Foundation Dynasty Staff','false','none',1080,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12469,'Foundation Dynasty Cudgel','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12470,'Foundation Dynasty Crusher','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12471,'Foundation Dynasty Crossbow','false','none',1580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12472,'Foundation Dynasty Phantom','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12473,'Foundation Dynasty Halberd','false','none',2010,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12474,'Foundation Icarus Disperser','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12475,'Foundation Icarus Sawsword','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12476,'Foundation Icarus Shooter','false','none',1580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12477,'Foundation Icarus Stinger','false','none',1280,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12478,'Foundation Icarus Spirit','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12479,'Foundation Icarus Spitter','false','none',1520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12480,'Foundation Icarus Wingblade','false','none',1800,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12481,'Foundation Icarus Trident','false','none',2010,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12482,'Foundation Icarus Hammer','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12483,'Foundation Icarus Hand','false','none',1550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12484,'Foundation Icarus Heavy Arms','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12485,'Foundation Icarus Hall','false','none',1080,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12486,'Foundation Sealed Zubei\'s Gauntlet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12487,'Foundation Sealed Zubei\'s Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12488,'Foundation Sealed Avadon Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12489,'Foundation Sealed Avadon Boots','false','none',1170,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12490,'Foundation Zubei\'s Leather Gaiters','false','none',1480,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12491,'Foundation Zubei\'s Leather Shirt','false','none',4330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12492,'Foundation Zubei\'s Gaiters','false','none',3570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12493,'Foundation Zubei\'s Gauntlet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12494,'Foundation Zubei\'s Gauntlet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12495,'Foundation Zubei\'s Gauntlet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12496,'Foundation Zubei\'s Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12497,'Foundation Zubei\'s Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12498,'Foundation Zubei\'s Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12499,'Foundation Zubei\'s Shield','false','none',1210,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12500,'Foundation Zubei\'s Helmet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12501,'Foundation Zubei\'s Breastplate','false','none',7970,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12502,'Foundation Avadon Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12503,'Foundation Avadon Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12504,'Foundation Avadon Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12505,'Foundation Avadon Leather Armor','false','none',5600,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12506,'Foundation Avadon Robe','false','none',2540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12507,'Foundation Avadon Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12508,'Foundation Avadon Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12509,'Foundation Avadon Boots','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12510,'Foundation Avadon Circlet','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12511,'Foundation Avadon Shield','false','none',1210,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12512,'Foundation Avadon Gaiters','false','none',3520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12513,'Foundation Avadon Breastplate','false','none',7920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12514,'Foundation Tunic of Zubei','false','none',1960,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12515,'Foundation Stockings of Zubei','false','none',940,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12516,'Foundation Doom Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12517,'Foundation Doom Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12518,'Foundation Doom Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12519,'Foundation Doom Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12520,'Foundation Doom Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12521,'Foundation Doom Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12522,'Foundation Doom Shield','false','none',1200,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12523,'Foundation Doom Plate Armor','false','none',9980,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12524,'Foundation Doom Helmet','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12525,'Foundation Leather Armor of Doom','false','none',5500,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12526,'Foundation Sealed Doom Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12527,'Foundation Sealed Boots of Doom','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12528,'Foundation Sealed Blue Wolf Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12529,'Foundation Sealed Blue Wolf Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12530,'Foundation Tunic of Doom','false','none',1900,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12531,'Foundation Blue Wolf Gaiters','false','none',3370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12532,'Foundation Blue Wolf Leather Armor','false','none',5500,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12533,'Foundation Blue Wolf Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12534,'Foundation Blue Wolf Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12535,'Foundation Blue Wolf Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12536,'Foundation Blue Wolf Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12537,'Foundation Blue Wolf Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12538,'Foundation Blue Wolf Gloves','false','none',590,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12539,'Foundation Blue Wolf Tunic','false','none',1920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12540,'Foundation Blue Wolf Helmet','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12541,'Foundation Blue Wolf Stockings','false','none',920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12542,'Foundation Blue Wolf Breastplate','false','none',7820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12543,'Foundation Stockings of Doom','false','none',910,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12544,'Foundation Dark Crystal Gaiters','false','none',3320,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12545,'Foundation Dark Crystal Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12546,'Foundation Dark Crystal Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12547,'Foundation Dark Crystal Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12548,'Foundation Dark Crystal Leather Armor','false','none',4300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12549,'Foundation Dark Crystal Robe','false','none',2450,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12550,'Foundation Dark Crystal Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12551,'Foundation Dark Crystal Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12552,'Foundation Dark Crystal Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12553,'Foundation Dark Crystal Shield','false','none',1190,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12554,'Foundation Dark Crystal Helmet','false','none',570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12555,'Foundation Dark Crystal Breastplate','false','none',7700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12556,'Foundation Dark Crystal Leggings','false','none',1480,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12557,'Foundation Sealed Dark Crystal Gaiters','false','none',3320,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12558,'Foundation Sealed Dark Crystal Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12559,'Foundation Sealed Dark Crystal Leather Armor','false','none',4300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12560,'Foundation Dark Crystal Robe','false','none',2450,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12561,'Foundation Sealed Dark Crystal Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12562,'Foundation Sealed Dark Crystal Shield','false','none',1190,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12563,'Foundation Sealed Dark Crystal Helmet','false','none',570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12564,'Foundation Sealed Dark Crystal Breastplate','false','none',7700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12565,'Foundation Sealed Dark Crystal Leggings','false','none',1480,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12566,'Foundation Sealed Tallum Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12567,'Foundation Sealed Tallum Leather Armor','false','none',5400,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12568,'Foundation Sealed Tallum Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12569,'Foundation Sealed Tallum Tunic','false','none',1860,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12570,'Foundation Sealed Tallum Plate Armor','false','none',9780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12571,'Foundation Sealed Tallum Helmet','false','none',570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12572,'Foundation Sealed Tallum Stockings','false','none',920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12573,'Foundation Holy Spirit\'s Cloak','false','none',220,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12574,'Foundation Tallum Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12575,'Foundation Tallum Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12576,'Foundation Tallum Gloves','false','none',580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12577,'Foundation Tallum Leather Armor','false','none',5400,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12578,'Foundation Tallum Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12579,'Foundation Tallum Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12580,'Foundation Tallum Boots','false','none',1130,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12581,'Foundation Tallum Tunic','false','none',1860,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12582,'Foundation Tallum Plate Armor','false','none',9780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12583,'Foundation Tallum Helmet','false','none',570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12584,'Foundation Tallum Stockings','false','none',920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12585,'Foundation Majestic Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12586,'Foundation Majestic Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12587,'Foundation Majestic Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12588,'Foundation Majestic Leather Armor','false','none',5350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12589,'Foundation Majestic Robe','false','none',2330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12590,'Foundation Majestic Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12591,'Foundation Majestic Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12592,'Foundation Majestic Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12593,'Foundation Majestic Circlet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12594,'Foundation Majestic Plate Armor','false','none',9200,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12595,'Foundation Sealed Majestic Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12596,'Foundation Sealed Majestic Leather Armor','false','none',5350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12597,'Foundation Sealed Majestic Robe','false','none',2330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12598,'Foundation Sealed Majestic Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12599,'Foundation Sealed Majestic Circlet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12600,'Foundation Sealed Majestic Plate Armor','false','none',9200,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12601,'Foundation Sealed Armor of Nightmare','false','none',9580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12602,'Foundation Sealed Gauntlet of Nightmare','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12603,'Foundation Sealed Leather Armor of Nightmare','false','none',5300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12604,'Foundation Sealed Nightmare Robe','false','none',2300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12605,'Foundation Sealed Boots of Nightmare','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12606,'Foundation Sealed Shield of Nightmare','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12607,'Foundation Sealed Helm of Nightmare','false','none',560,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12608,'Foundation Armor of Nightmare','false','none',9580,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12609,'Foundation Gauntlet of Nightmare','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12610,'Foundation Gauntlet of Nightmare','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12611,'Foundation Gauntlet of Nightmare','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12612,'Foundation Nightmarish Leather Armor','false','none',5300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12613,'Foundation Nightmare Robe','false','none',2300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12614,'Foundation Boots of Nightmare','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12615,'Foundation Boots of Nightmare','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12616,'Foundation Boots of Nightmare','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12617,'Foundation Shield of Nightmare','false','none',1180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12618,'Foundation Helm of Nightmare','false','none',560,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12619,'Foundation Draconic Leather Gloves','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12620,'Foundation Draconic Leather Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12621,'Foundation Draconic Leather Armor','false','none',4950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12622,'Foundation Draconic Leather Helmet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12623,'Foundation Major Arcana Gloves','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12624,'Foundation Major Arcana Robe','false','none',2300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12625,'Foundation Major Arcana Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12626,'Foundation Major Arcana Circlet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12627,'Foundation Sealed Draconic Leather Gloves','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12628,'Foundation Sealed Draconic Leather Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12629,'Foundation Sealed Draconic Leather Armor','false','none',4950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12630,'Foundation Sealed Draconic Leather Helmet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12631,'Foundation Sealed Major Arcana Gloves','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12632,'Foundation Sealed Major Arcana Robe','false','none',2300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12633,'Foundation Sealed Major Arcana Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12634,'Foundation Sealed Major Arcana Circlet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12635,'Foundation Sealed Imperial Crusader Gaiters','false','none',3260,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12636,'Foundation Sealed Imperial Crusader Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12637,'Foundation Sealed Imperial Crusader Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12638,'Foundation Sealed Imperial Crusader Shield','false','none',1170,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12639,'Foundation Sealed Imperial Crusader Helmet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12640,'Foundation Sealed Imperial Crusader Breastplate','false','none',7620,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12641,'Foundation Imperial Crusader Gaiters','false','none',3260,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12642,'Foundation Imperial Crusader Gauntlet','false','none',540,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12643,'Foundation Imperial Crusader Boots','false','none',1110,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12644,'Foundation Imperial Crusader Shield','false','none',1170,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12645,'Foundation Imperial Crusader Helmet','false','none',550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12646,'Foundation Imperial Crusader Breastplate','false','none',7620,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12647,'Foundation Dynasty Gaiters','false','none',3210,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12648,'Foundation Dynasty Gauntlet','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12649,'Foundation Dynasty Gloves','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12650,'Foundation Dynasty Leather Gloves','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12651,'Foundation Dynasty Leather Leggings','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12652,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12653,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12654,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12655,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12656,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12657,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12658,'Foundation Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12659,'Foundation Dynasty Leather Boots','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12660,'Foundation Dynasty Leather Helmet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12661,'Foundation Dynasty Boots','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12662,'Foundation Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12663,'Foundation Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12664,'Foundation Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12665,'Foundation Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12666,'Foundation Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12667,'Foundation Dynasty Shield','false','none',1390,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12668,'Foundation Dynasty Shoes','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12669,'Foundation Dynasty Silver Satin Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12670,'Foundation Dynasty Silver Satin Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12671,'Foundation Dynasty Silver Satin Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12672,'Foundation Dynasty Silver Satin Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12673,'Foundation Dynasty Silver Satin Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12674,'Foundation Dynasty Circlet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12675,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12676,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12677,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12678,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12679,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12680,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12681,'Foundation Dynasty Jewel Leather Mail','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12682,'Foundation Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12683,'Foundation Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12684,'Foundation Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12685,'Foundation Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12686,'Foundation Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12687,'Foundation Dynasty Platinum Plate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12688,'Foundation Dynasty Platinum Plate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12689,'Foundation Dynasty Platinum Plate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12690,'Foundation Dynasty Platinum Plate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12691,'Foundation Dynasty Platinum Plate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12692,'Foundation Dynasty Helmet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12693,'Foundation Dynasty Stockings','false','none',860,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12694,'Foundation Sealed Dynasty Gaiters','false','none',3210,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12695,'Foundation Sealed Dynasty Gauntlet','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12696,'Foundation Sealed Dynasty Gloves','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12697,'Foundation Sealed Dynasty Leather Gloves','false','none',520,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12698,'Foundation Sealed Dynasty Leather Leggings','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12699,'Foundation Sealed Dynasty Leather Armor','false','none',4180,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12700,'Foundation Sealed Dynasty Leather Boots','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12701,'Foundation Sealed Dynasty Leather Helmet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12702,'Foundation Sealed Dynasty Boots','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12703,'Foundation Sealed Dynasty Breastplate','false','none',7570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12704,'Foundation Sealed Dynasty Shield','false','none',1370,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12705,'Foundation Sealed Dynasty Shoes','false','none',1090,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12706,'Foundation Sealed Dynasty Circlet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12707,'Foundation Sealed Dynasty Tunic','false','none',1780,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12708,'Foundation Sealed Dynasty Helmet','false','none',530,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12709,'Foundation Sealed Dynasty Stockings','false','none',860,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12710,'Foundation Adamantite Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12711,'Foundation Adamantite Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12712,'Foundation Adamantite Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12713,'Foundation Earring of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12714,'Foundation Necklace of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12715,'Foundation Ring of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12716,'Foundation Sealed Phoenix Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12717,'Foundation Sealed Phoenix Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12718,'Foundation Sealed Phoenix Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12719,'Foundation Phoenix Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12720,'Foundation Phoenix Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12721,'Foundation Phoenix Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12722,'Foundation Majestic Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12723,'Foundation Majestic Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12724,'Foundation Majestic Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12725,'Foundation Sealed Majestic Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12726,'Foundation Sealed Majestic Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12727,'Foundation Sealed Majestic Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12728,'Foundation Sealed Tateossian Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12729,'Foundation Sealed Tateossian Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12730,'Foundation Sealed Tateossian Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12731,'Foundation Tateossian Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12732,'Foundation Tateossian Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12733,'Foundation Tateossian Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12734,'Foundation Dynasty Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12735,'Foundation Dynasty Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12736,'Foundation Dynasty Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12737,'Foundation Sealed Dynasty Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12738,'Foundation Sealed Dynasty Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12739,'Foundation Sealed Dynasty Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12753,'Kamael Village Teleportation Scroll','false','scroll',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2525-1'),
(12754,'Accessory Life Stone - level 46','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12755,'Accessory Life Stone - level 49','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12756,'Accessory Life Stone - level 52','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12757,'Accessory Life Stone - level 55','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12758,'Accessory Life Stone - level 58','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12759,'Accessory Life Stone - level 61','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12760,'Accessory Life Stone - level 64','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12761,'Accessory Life Stone - level 67','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12762,'Accessory Life Stone - level 70','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12763,'Accessory Life Stone - level 76','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12764,'Fish Chest','false','quest',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12765,'Seed Jar','false','quest',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12768,'Forgotten Scroll - Evasion Counter','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2526-1'),
(12769,'Forgotten Scroll - Evasion Chance','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2527-1'),
(12770,'Forgotten Scroll - Evasion Haste','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2528-1'),
(12771,'Forgotten Scroll - Shadow Step','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2529-1'),
(12772,'Spellbook - Inquisitor','false','spellbook',120,'stackable','paper','none',-1,-1,12500,0,'true','true','true','true','true','none',''),
(12773,'Battle Manual - Body Reconstruction','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12774,'Battle Manual - Blood Construct','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12775,'Battle Manual - Imbue Seed of Destruction','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12776,'Battle Manual - Oblivion Trap','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12777,'Battle Manual - Painkiller','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12778,'Battle Manual - Soul Web','false','spellbook',120,'stackable','paper','none',-1,-1,11050,0,'true','true','true','true','true','none',''),
(12819,'Recovery Spellbook for Combat Use','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12820,'Blueprint - Summon Merchant Golem','false','spellbook',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12821,'Accessory Life Stone - level 80','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12822,'Accessory Life Stone - level 82','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12823,'Casian\'s Blue Crystal','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12824,'Pathfinder Supplies (level 1)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12825,'Pathfinder Supplies (level 3)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12826,'Pathfinder Supplies (level 9)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12827,'Pathfinder Supplies (level 10)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12828,'Pathfinder Supplies (level 16)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12829,'Pathfinder Supplies (level 17)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12830,'Pathfinder Supplies (level 23)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12831,'Pathfinder Supplies (level 24)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12832,'Pathfinder Supplies (level 30)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12833,'Pathfinder Supplies (level 31)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12834,'Pathfinder Supplies (level 37)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(12840,'Accessory Life Stone - level 46','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12841,'Accessory Life Stone - level 49','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12842,'Accessory Life Stone - level 52','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12843,'Accessory Life Stone - level 55','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12844,'Accessory Life Stone - level 58','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12845,'Accessory Life Stone - level 61','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12846,'Accessory Life Stone - level 64','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12847,'Accessory Life Stone - level 67','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12848,'Accessory Life Stone - level 70','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12849,'Accessory Life Stone - level 76','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12850,'Accessory Life Stone - level 80','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(12851,'Accessory Life Stone - level 82','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13002,'Essence of Kamaloka','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13003,'Pathfinder\'s Reward - D-Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13004,'Pathfinder\'s Reward - C-Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13005,'Pathfinder\'s Reward - B-Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13006,'Pathfinder\'s Reward - A-Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13007,'Pathfinder\'s Reward - S-Grade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13008,'Spellbook - Bless the Blood','false','spellbook',120,'stackable','paper','none',-1,-1,12500,0,'true','true','true','true','true','none',''),
(13010,'Extra Entrance Pass - Kamaloka (Hall of the Abyss)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13011,'Extra Entrance Pass - Near Kamaloka','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13012,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13013,'Kamaloka Additional Entrance Ticket 4','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13014,'Feather of Blessing','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13015,'My Teleport Spellbook','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','TeleportBookmark',''),
(13016,'My Teleport Scroll','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13017,'White Weasel Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13018,'Fairy Princess Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13019,'Wild Beast Fighter Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13020,'Fox Shaman Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13021,'Color Name','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13027,'Gran Kain\'s Gift Box - 30 day limited period','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13028,'Vitality Replenishing Herb','false','herb',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2580-1'),
(13029,'Vitality Replenishing Transformation Herb - Timitran','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13030,'Vitality Replenishing Transformation Herb - Lava Golem','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13031,'Vitality Replenishing Transformation Herb - Yeti','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13032,'Pailaka Instant Shield','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2577-1'),
(13033,'Quick Healing Potion','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13037,'Pailaka Soulshot - Grade D','false','none',3,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13038,'Essence of Water','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13039,'Essence of Fire','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13040,'Fire Attribute Enhancer','false','none',10,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13041,'Water Attribute Enhancer','false','none',10,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13045,'Pailaka Soulshot - Grade C','false','none',3,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13046,'Pailaka Weapon Upgrade Stage 1','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13047,'Pailaka Weapon Upgrade Stage 2','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13048,'Pailaka Antidote','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13049,'Divine Soul','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13051,'Hair Accessory','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13055,'Pailaka Soulshot - Grade A','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13056,'Weapon Upgrade Stage 1','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13057,'Weapon Upgrade Stage 2','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13059,'Long-Range Defense Increasing Potion','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13060,'Tinplate Golem Transformation Stick','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13063,'Unfair Joystick','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13064,'Unfair Naval Cannon Joystick','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13065,'Lucky 7 Treasure','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13066,'Treasure of the Seven Fortunes','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13067,'Fantasy Isle Coin','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13068,'Fantasy Isle Coin (PC Cafe)','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13069,'Long Prolonging Dream','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13070,'Premium Parcel Box Test','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13071,'Red Soul Crystal - Stage 16','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(13072,'Blue Soul Crystal - Stage 16','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(13073,'Green Soul Crystal - Stage 16','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','SoulCrystals',''),
(13077,'Chaotic Arcana Sickle','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13079,'My Teleport Spellbook 1-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13080,'My Teleport Scroll 30-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13081,'Kamaloka Entrance Pass Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13082,'Feather of Blessing 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13083,'Agathion of Love 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13084,'Pumpkin Transformation Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13085,'Kamaloka Entrance Pass 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13086,'Kat the Cat Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13087,'Feline Queen Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13088,'Monster Eye Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13089,'Brown Bear Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13090,'Fungus Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13091,'Skull Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13092,'Ornithomimus Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13093,'Feline King Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13094,'Kai the Cat Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13095,'OX Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13096,'Rock-Paper-Scissors Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13097,'Purple Maned Horse Bracelet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13098,'Color Name 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13099,'Sealed Arcana Sigil Piece','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13100,'Recipe - Sealed Arcana Sigil (60%)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13101,'Recipe - Sealed Arcana Sigil (100%)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13102,'Chaotic Sealed Arcana Sigil','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13103,'My Teleport Spellbook 1-Book Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13104,'My Teleport Scroll 30-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13105,'Kamaloka Entrance Pass 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13106,'Feather of Blessing 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13107,'Agathion of Love 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13108,'Pumpkin Transformation Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13109,'Kamaloka Entrance Pass 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13110,'Kat the Cat Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13111,'Feline Queen Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13112,'Monster Eye Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13113,'Brown Bear Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13114,'Fungus Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13115,'Skull Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13116,'Ornithomimus Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13117,'Feline King Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13118,'Kai the Cat Hat 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13119,'OX Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13120,'Rock-Paper-Scissors Stick 30-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13121,'Purple-Maned Horse 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13122,'Color Name 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13123,'My Teleport Spellbook Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13124,'Color Name 1-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13125,'My Teleport Scroll 10-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13126,'Vitamin Experience Pack - used for events','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13127,'Promotional Parcel 2','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13128,'Phoenix Feather','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13129,'Pailaka Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2594-1'),
(13130,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13131,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13132,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13133,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13134,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13135,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13136,'Temple Book of Secrets','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13149,'Pailaka Final Key','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13150,'Pailaka All-Purpose Key','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13151,'Pailaka Energy Replenishing Potion (100%)','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13152,'Pailaka Energy Replenishing Potion (50%)','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13225,'Kamaloka (Hall of the Abyss) 15-Sheet Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13226,'Near Kamaloka 15-Sheet Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13227,'Kamaloka (Labyrinth of the Abyss) 15-Sheet Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13228,'Kamaloka (Hall of the Abyss) 15-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13229,'Near Kamaloka 15-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13230,'Kamaloka (Labyrinth of the Abyss) 15-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13231,'Kamaloka (Hall of the Abyss) 5-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13232,'Near Kamaloka 5-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13233,'Kamaloka (Labyrinth of the Abyss) 5-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13255,'Gran Kain\'s Gift Box - 7 Day','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13256,'Gran Kain\'s Gift Box Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13257,'Gran Kain\'s Gift Box Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13258,'Gran Kain\'s Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2595-1'),
(13259,'Gran Kain\'s Blessed Scroll of Resurrection','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ScrollOfResurrection','2596-1'),
(13261,'Gran Kain\'s Echo Crystal - Theme of Journey','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2597-1'),
(13262,'Gran Kain\'s Echo Crystal - Theme of Battle','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2598-1'),
(13263,'Gran Kain\'s Echo Crystal - Theme of Love','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2599-1'),
(13264,'Gran Kain\'s Echo Crystal - Theme of Solitude','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2600-1'),
(13265,'Gran Kain\'s Echo Crystal - Theme of the Feast','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2601-1'),
(13266,'Gran Kain\'s Echo Crystal - Theme of Celebration','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2602-1'),
(13267,'Gran Kain\'s Echo Crystal - Theme of Comedy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2603-1'),
(13268,'Gran Kain\'s Firework','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2604-1'),
(13269,'Gran Kain\'s Large Firework','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2605-1'),
(13270,'Pathfinder\'s Reward - AU Karm','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13271,'Pathfinder\'s Reward - AR Karm','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13272,'Pathfinder\'s Reward - AE Karm','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13273,'Hunting Helper Exchange Coupon - 5 hours','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13274,'Hunting Helper Exchange Coupon - 7 days','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13275,'Hunting Helper Exchange Coupon 3-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13276,'Hunting Helper Exchange Coupon 1-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13277,'Energy Star Stone','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13278,'High Quality Energy Star Stone','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13279,'Feather of Blessing 1-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13280,'Agathion of Love 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13281,'Pumpkin Transformation Stick 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13282,'Kat the Cat Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13283,'Feline Queen Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13284,'Monster Eye Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13285,'Brown Bear Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13286,'Fungus Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13287,'Skull Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13288,'Ornithomimus Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13289,'Feline King Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13290,'Kai the Cat Hat 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13291,'OX Stick 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13292,'Rock-Paper-Scissors Stick 7-Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13297,'Extra Entrance Pass - Kamaloka (Hall of the Abyss) (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13298,'Extra Entrance Pass - Near Kamaloka (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13299,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss) (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13300,'Feather of Blessing (Event)','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13301,'My Teleport Spellbook (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13302,'My Teleport Scroll (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13303,'White Weasel Hunting Helper Necklace (Event)','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13304,'Fairy Princess Hunting Helper Necklace (Event)','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13305,'Wild Beast Fighter Hunting Helper Necklace (Event)','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13306,'Fox Shaman Hunting Helper Necklace (Event)','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13307,'Color Name (Event)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13341,'My Teleport Spellbook 1-Book Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13342,'My Teleport Scroll 30-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13343,'Feather of Blessing 3-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13344,'Agathion of Love 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13345,'Halloween Gift Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13346,'Kamaloka Entrance Pass 3-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13347,'Kat the Cat Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13348,'Feline Queen Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13349,'Monster Eye Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13350,'Brown Bear Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13351,'Fungus Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13352,'Skull Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13353,'Ornithomimus Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13354,'Feline King Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13355,'Kai the Cat Hat 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13356,'OX Stick 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13357,'Rock-Paper-Scissors Stick 30-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13358,'Purple Maned Horse 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13359,'Color Name 3-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13360,'Color Name 1-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13361,'My Teleport Scroll 10-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13362,'Kamaloka (Hall of the Abyss) 15-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13363,'Near Kamaloka 15-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13364,'Kamaloka (Labyrinth of the Abyss) 15-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13365,'Kamaloka (Hall of the Abyss) 5-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13366,'Near Kamaloka 5-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13367,'Kamaloka (Labyrinth of the Abyss) 5-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13368,'Feather of Blessing 1-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13369,'Agathion of Love 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13370,'Pumpkin Transformation Stick 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13371,'Kat the Cat Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13372,'Feline Queen Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13373,'Monster Eye Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13374,'Brown Bear Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13375,'Fungus Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13376,'Skull Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13377,'Ornithomimus Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13378,'Feline King Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13379,'Kai the Cat Hat 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(13380,'OX Stick 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13381,'Rock-Paper-Scissors Stick 7-Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13382,'Gran Kain\'s Gift Box (Event) - 30 day limited period','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13383,'Hunting Helper Exchange Coupon - 5 hours (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13384,'Hunting Helper Exchange Coupon 3-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13385,'Hunting Helper Exchange Coupon 1-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13386,'Blue Crystal of Fantasy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2608-1'),
(13387,'Green Crystal of Fantasy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2608-2'),
(13388,'Red Crystal of Fantasy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2608-3'),
(13395,'Escape - Talking Island Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-1'),
(13396,'Escape - Elven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-2'),
(13397,'Escape - Dark Elven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-3'),
(13398,'Escape - Orc Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-4'),
(13399,'Escape - Dwarven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-5'),
(13400,'Escape - Gludin Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-6'),
(13401,'Escape - Town of Gludio','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-7'),
(13402,'Escape - Town of Dion','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-8'),
(13403,'Escape - Floran Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-9'),
(13404,'Escape - Giran Castle Town','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-10'),
(13405,'Escape - Hardin\'s Academy','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-11'),
(13406,'Escape - Heine','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-12'),
(13407,'Escape - Town of Oren','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-13'),
(13408,'Escape - Ivory Tower','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-14'),
(13409,'Escape - Hunters Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-15'),
(13410,'Escape - Town of Aden','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-16'),
(13411,'Escape - Town of Goddard','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-17'),
(13412,'Escape - Rune Township','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-18'),
(13413,'Escape - Town of Schuttgart','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-19'),
(13414,'Escape - Kamael Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2609-20'),
(13417,'L2day - Letter Y','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13418,'L2day - Letter 5','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13419,'Lineage II Commemorative Mark','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13420,'Multi-colored Honey Rice Cake','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13421,'Honey Wheat Cake','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13422,'Medium Parchment Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13423,'Medium Mineral Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13424,'Large Libation Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13425,'Small Parchment Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13426,'Small Mineral Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13427,'Medium Libation Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13428,'Small Libation Box','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13540,'Master Yogi\'s Scroll: Enchant Weapon','false','scroll',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','EnchantScrolls','2637-1'),
(13541,'Yogi\'s Enchanted Treasure Box','false','none',20,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(13542,'Yogi\'s Enchanted Reward Cube ','false','none',20,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(13548,'Toy Knight Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13549,'Soul Monk Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13550,'Owl Monk Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13551,'Turtle Ascetic Hunting Helper Necklace','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13552,'Spellbook - Flying Final Form','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2789-1'),
(13553,'Spellbook - Aurabird Falcon','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2790-1'),
(13554,'Spellbook - Aurabird Owl','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2791-1'),
(13555,'Combined Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13559,'Airship Summon License','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13569,'Gludio Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13570,'Gludio Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13571,'Gludio Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13572,'Gludio Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13573,'Gludio Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13574,'Gludio Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13575,'Gludio Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13576,'Gludio Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13577,'Gludio Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13578,'Gludio White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13579,'Gludio Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13580,'Gludio Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13581,'Dion Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13582,'Dion Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13583,'Dion Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13584,'Dion Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13585,'Dion Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13586,'Dion Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13587,'Dion Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13588,'Dion Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13589,'Dion Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13590,'Dion White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13591,'Dion Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13592,'Dion Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13593,'Giran Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13594,'Giran Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13595,'Giran Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13596,'Giran Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13597,'Giran Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13598,'Giran Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13599,'Giran Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13600,'Giran Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13601,'Giran Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13602,'Giran White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13603,'Giran Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13604,'Giran Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13605,'Oren Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13606,'Oren Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13607,'Oren Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13608,'Oren Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13609,'Oren Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13610,'Oren Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13611,'Oren Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13612,'Oren Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13613,'Oren Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13614,'Oren White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13615,'Oren Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13616,'Oren Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13617,'Aden Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13618,'Aden Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13619,'Aden Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13620,'Aden Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13621,'Aden Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13622,'Aden Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13623,'Aden Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13624,'Aden Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13625,'Aden Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13626,'Aden White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13627,'Aden Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13628,'Aden Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13629,'Innadril Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13630,'Innadril Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13631,'Innadril Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13632,'Innadril Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13633,'Innadril Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13634,'Innadril Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13635,'Innadril Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13636,'Innadril Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13637,'Innadril Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13638,'Innadril White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13639,'Innadril Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13640,'Innadril Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13641,'Goddard Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13642,'Goddard Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13643,'Goddard Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13644,'Goddard Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13645,'Goddard Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13646,'Goddard Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13647,'Goddard Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13648,'Goddard Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13649,'Goddard Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13650,'Goddard White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13651,'Goddard Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13652,'Goddard Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13653,'Rune Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13654,'Rune Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13655,'Rune Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13656,'Rune Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13657,'Rune Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13658,'Rune Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13659,'Rune Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13660,'Rune Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13661,'Rune Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13662,'Rune White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13663,'Rune Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13664,'Rune Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13665,'Schuttgart Human Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13666,'Schuttgart Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13667,'Schuttgart Dark Elf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13668,'Schuttgart Orc Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13669,'Schuttgart Dwarf Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13670,'Schuttgart Kamael Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13671,'Schuttgart Knight Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13672,'Schuttgart Archer Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13673,'Schuttgart Wizard Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13674,'Schuttgart White Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13675,'Schuttgart Knight Captain Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13676,'Schuttgart Commander Mercenary Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13677,'Gludio Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13678,'Dion Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13679,'Giran Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13680,'Oren Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13681,'Aden Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13682,'Innadril Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13683,'Goddard Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13684,'Rune Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13685,'Schuttgart Disguise Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13686,'Sealed Knight\'s Cloak','false','none',220,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13691,'Mark of Keucereus - Stage 1','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13692,'Mark of Keucereus - Stage 2','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13693,'Gracia Anniversary Coins','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13694,'Gracia Key','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13695,'Gludio Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13696,'Dion Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13697,'Giran Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13698,'Oren Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13699,'Aden Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13700,'Innadril Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13701,'Goddard Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13702,'Rune Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13703,'Schuttgart Supply Box - Magic Pin - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13704,'Gludio Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13705,'Dion Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13706,'Giran Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13707,'Oren Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13708,'Aden Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13709,'Innadril Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13710,'Goddard Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13711,'Rune Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13712,'Schuttgart Supply Box - Magic Pouch - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13713,'Gludio Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13714,'Dion Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13715,'Giran Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13716,'Oren Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13717,'Aden Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13718,'Innadril Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13719,'Goddard Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13720,'Rune Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13721,'Schuttgart Supply Box - Belt - Grade B,C','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13722,'Olympiad Token','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','Recipes',''),
(13723,'Design - High Quality MP Recovery Stone','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13724,'Design - High Quality HP MP Recovery Stone','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13725,'Design - Recovery Stone','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13726,'Design - Energy Star Stone','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13727,'Design - High Quality Energy Star Stone','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13728,'Expert Text - Star Stone Extraction Skill. Level 1','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2840-1'),
(13729,'Expert Text - Star Stone Extraction Skill. Level 2','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13730,'Expert Text - Star Stone Extraction Skill. Level 3','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13731,'Gludio Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-1'),
(13732,'Dion Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-2'),
(13733,'Giran Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-3'),
(13734,'Oren Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-5'),
(13735,'Aden Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-6'),
(13736,'Innadril Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-4'),
(13737,'Goddard Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-7'),
(13738,'Rune Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-8'),
(13739,'Schuttgart Blessed Scroll of Escape','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2649-9'),
(13749,'Emery Piece','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13750,'Warrior\'s Temporary Healing Potion','false','none',180,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13757,'Gludio Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13758,'Dion Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13759,'Giran Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13760,'Oren Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13761,'Aden Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13762,'Innadril Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13763,'Goddard Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13764,'Rune Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13765,'Schuttgart Territory Badge','false','quest',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','false','none',''),
(13766,'Ordinary Mercenary Certificate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13767,'Elite Mercenary Certificate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13768,'Exalted Mercenary Certificate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13769,'Artificial Regeneration Incubator','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13771,'Strong Alkali Type Ointment','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13772,'Life Aid Bandage','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13773,'Scent of Preservation','false','none',80,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13774,'Scent of Exorcism','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13775,'Miracle Cure of Resuscitation','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13776,'Structure Scarab','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13777,'Jewel Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13778,'Mother-of-Pearl Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13779,'Gold-Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13780,'Silver-Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13781,'Bronze-Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13782,'Non-Ornamented Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13783,'Weak-Looking Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13784,'Sad-Looking Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13785,'Poor-Looking Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13786,'Worthless Duel Supplies','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13787,'Bond','false','none',180,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13788,'Land Mine','false','none',180,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13793,'Kratei\'s Cube Name Hiding Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13794,'Transformed Object - Handy\'s Block Checker Transformation Scroll Blue','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13795,'Transformed Object - Handy\'s Block Checker Transformation Scroll Red','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13796,'Nucleus of a Freed Soul','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13797,'Tear of a Freed Soul','false','none',60,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13798,'Portion of a Soul','false','none',60,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13799,'Treasure Sack of the Ancient Giants','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13800,'Frog Transformation Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13801,'Young Child Transformation Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13808,'Elmoreden Holy Water','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13810,'High Priest Orven\'s Letter','false','quest',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13811,'Keucereus\' Introduction - Seed of Infinity','false','quest',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13812,'Keucereus\' Introduction - Seed of Destruction','false','quest',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13813,'Croop\'s Introduction','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13814,'Jacob\'s Necklace','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13815,'Croop\'s Letter Requesting a Memorial Service','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13816,'Deadman\'s Herb','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13817,'Priest Kein\'s Investigation Report','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13818,'Athebalt\'s Introduction','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13819,'Native\'s Gloves','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13820,'Frog King\'s Bead','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13821,'Grandma Tess\' Candy Pouch','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13822,'Guards of the Dawn Identity Card','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13823,'Emperor Shunaiman\'s Contract','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13824,'Ancient Seal Stone of Mammon','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13825,'Grail of Einhasad','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13826,'Blood of the Emperor','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13827,'Iason\'s Introduction','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13828,'Prayer: Emperor\'s Key','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13829,'Mysterious Hand-written Text','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13830,'Tomlan Kamos\' Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13831,'Ol Ariosh\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13832,'Crimson Hatu Otis\' Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13833,'Seer Flouros\' Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13834,'Blade Otis\' Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13835,'Weird Bunei\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13836,'Kaim Abigore\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13837,'Knight Montagnar\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13838,'Venomous Storace\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13839,'Kel Bilette\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13840,'White Allosce\'s Cellular Tissue','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13841,'Fleet Steed Troup\'s Charm','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13844,'Star Stone Extraction Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2630-1'),
(13846,'Seal of Binding','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13847,'Piece of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13848,'Headless Knight\'s Armor','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13849,'Mandragora Root','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13850,'Bloody Axe Black Epaulette','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13851,'Nebulite Orb','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13852,'Inspector Medibal\'s Document','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13853,'Destroyed Darkness Fragment Powder','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13854,'Destroyed Light Fragment Powder','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13855,'Sacred Light Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13856,'Rider\'s Mark','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13857,'Lekon\'s Certificate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13858,'Extracted Coarse Red Star Stone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13859,'Extracted Coarse Blue Star Stone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13860,'Extracted Coarse Green Star Stone','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13861,'Reckless Soul Piece - Water','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13862,'Reckless Soul Piece - Air','false','quest',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13863,'Nucleus of an Incomplete Soul','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13864,'Seal of Tiat','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13865,'Fleet Steed Troup\'s Totem','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13866,'Portion of a Soul','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13867,'Breath of Tiat','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13868,'Yehan Klodekus\' Badge','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13869,'Yehan Klanikus\' Badge','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13870,'Lich Crystal','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13871,'Vulture\'s Golden Feather','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13872,'Swallowed Skull','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13873,'Swallowed Sternum','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13874,'Swallowed Bones','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13875,'Deadman\'s Remains','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13876,'Banshee Queen\'s Eye','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13877,'Drake\'s Flesh','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13878,'Rotten Blood','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13879,'Bait for Drakes','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13880,'Variant Drake Wing Horns','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13893,'Sealed Holy Spirit\'s Cloak','false','none',220,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13898,'Sealed Magic Pin (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13899,'Sealed Magic Pin (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13900,'Sealed Magic Pin (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13901,'Sealed Magic Pin (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13902,'Low-Grade Magic Pin (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13903,'Mid-Grade Magic Pin (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13904,'High-Grade Magic Pin (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13905,'Top-Grade Magic Pin (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13906,'Low-Grade Magic Pin (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13907,'Mid-Grade Magic Pin (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13908,'High-Grade Magic Pin (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13909,'Top-Grade Magic Pin (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13910,'Low-Grade Magic Pin (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13911,'Mid-Grade Magic Pin (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13912,'High-Grade Magic Pin (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13913,'Top-Grade Magic Pin (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13914,'Low-Grade Magic Pin (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13915,'Mid-Grade Magic Pin (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13916,'High-Grade Magic Pin (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13917,'Top-Grade Magic Pin (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13918,'Sealed Magic Pouch (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13919,'Sealed Magic Pouch (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13920,'Sealed Magic Pouch (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13921,'Sealed Magic Pouch (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13922,'Low-Grade Magic Pouch (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13923,'Mid-Grade Magic Pouch (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13924,'High-Grade Magic Pouch (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13925,'Top-Grade Magic Pouch (C-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13926,'Low-Grade Magic Pouch (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13927,'Mid-Grade Magic Pouch (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13928,'High-Grade Magic Pouch (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13929,'Top-Grade Magic Pouch (B-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13930,'Low-Grade Magic Pouch (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13931,'Mid-Grade Magic Pouch (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13932,'High-Grade Magic Pouch (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13933,'Top-Grade Magic Pouch (A-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13934,'Low-Grade Magic Pouch (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13935,'Mid-Grade Magic Pouch (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13936,'High-Grade Magic Pouch (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13937,'Top-Grade Magic Pouch (S-Grade)','false','none',20,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13970,'Spellbook - Star Stone Extraction Skill','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(13988,'S80 Grade Weapon Chest (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','2832-1'),
(13989,'S80 Grade Armor Chest (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','2833-1'),
(13990,'Grade S Weapon Chest (Event) ','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','2834-1'),
(13991,'Grade S Armor Chest (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','2835-1'),
(13992,'Grade S Accessory Chest (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','2836-1'),
(13993,'Design - Crystal of Fire','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13994,'Design - Crystal of Water','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13995,'Design - Crystal of Wind','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13996,'Design - Crystal of Earth','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13997,'Design - Crystal of Darkness','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13998,'Design - Crystal of Sacred','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(13999,'Gludio Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14000,'Dion Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14001,'Giran Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14002,'Oren Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14003,'Aden Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14004,'Innadril Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14005,'Goddard Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14006,'Rune Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14007,'Schuttgart Supply Box - Hair Accessory','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14008,'Accessory Type Life Stone - level 84','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14009,'Extracted Red Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14010,'Extracted Blue Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14011,'Extracted Green Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14012,'Extracted Mid-grade Red Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14013,'Extracted Mid-grade Blue Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14014,'Extracted Mid-grade Green Star Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14015,'Fire Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14016,'Water Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14017,'Wind Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14018,'Earth Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14019,'Darkness Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14020,'Sacred Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14021,'Mid-grade Fire Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14022,'Mid-grade Water Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14023,'Mid-grade Wind Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14024,'Mid-grade Earth Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14025,'Mid-grade Darkness Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14026,'Mid-grade Sacred Energy Compression Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14028,'Design - Stone of Stamina','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14029,'Design - Stone of Mana','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14030,'Design - Stone of Recovery','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14031,'Design - Stone of Destruction','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14032,'Design - Stone of Invincibility','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14033,'Design - Stone of Great Speed','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14034,'Design - Stone of Speed','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14035,'Design - Stone of Concentration','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14036,'Design - Stone of Ease','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14037,'Design - Stone of Abundance','false','none',30,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(14038,'Stone of Stamina','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14039,'High-quality Stone of Stamina','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14040,'Stone of Mana','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14041,'High-quality Stone of Mana','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14042,'Stone of Recovery','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14043,'High-quality Stone of Recovery','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14044,'Stone of Destruction','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14045,'Stone of Invincibility','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14046,'Stone of Great Speed','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14047,'Stone of Speed','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14048,'Stone of Concentration','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14049,'Stone of Ease','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14050,'Stone of Abundance','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14051,'Recovery Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14052,'Vesper Noble Enhance Stone','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14055,'Energy Replenishing Beverage','false','none',80,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14061,'Toy Knight Summon Bracelet','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14062,'Spirit Shaman Summon Bracelet','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14063,'Owl Monk Summon Bracelet','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14064,'Turtle Ascetic Summon Bracelet','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14065,'High Quality Hunting Helper Exchange Coupon - 5 hours','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14068,'Energy Replenishing Beverage (event)','false','none',80,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14074,'High Quality Hunting Helper Exchange Coupon (Event) - 5 hours','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14078,'Weapon-type Enhance Backup Stone (D-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14079,'Weapon-type Enhance Backup Stone (C-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14080,'Weapon-type Enhance Backup Stone (B-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14081,'Weapon-type Enhance Backup Stone (A-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14082,'Weapon-type Enhance Backup Stone (S-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14083,'Armor-type Enhance Backup Stone (D-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14084,'Armor-type Enhance Backup Stone (C-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14085,'Armor-type Enhance Backup Stone (B-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14086,'Armor-type Enhance Backup Stone (A-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14087,'Armor-type Enhance Backup Stone (S-Grade) (event)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14166,'Life Stone - level 84','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14167,'Mid-Grade Life Stone - level 84','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14168,'High-Grade Life Stone - level 84','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14169,'Top-Grade Life Stone - level 84','false','none',2,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14170,'Forgotten Scroll - Seed of Revenge','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2803-1'),
(14171,'Forgotten Scroll - Hell Scream','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2804-1'),
(14172,'Forgotten Scroll - Spirit of Phoenix','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2805-1'),
(14173,'Forgotten Scroll - Eva\'s Will','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2806-1'),
(14174,'Forgotten Scroll - Pain of Shillien','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2807-1'),
(14175,'Forgotten Scroll - Exciting Adventure','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2808-1'),
(14176,'Forgotten Scroll - Wind Riding','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2809-1'),
(14177,'Forgotten Scroll - Ghost Walking','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2810-1'),
(14178,'Forgotten Scroll - Flame Hawk','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2811-1'),
(14179,'Forgotten Scroll - Arrow Rain','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2812-1'),
(14180,'Forgotten Scroll - Ghost Piercing','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2813-1'),
(14181,'Forgotten Scroll - Dread Pool','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2814-1'),
(14182,'Forgotten Scroll - Force of Destruction','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2815-1'),
(14183,'Forgotten Scroll - Demolition Impact','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2816-1'),
(14184,'Forgotten Scroll - Golem Armor','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2817-1'),
(14185,'Forgotten Scroll - Wild Shot','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2818-1'),
(14186,'Forgotten Scroll - Lightning Shock','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2819-1'),
(14187,'Forgotten Scroll - Flame Armor','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2820-1'),
(14188,'Forgotten Scroll - Frost Armor','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2821-1'),
(14189,'Forgotten Scroll - Hurricane Armor','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2822-1'),
(14190,'Forgotten Scroll - Vampiric Mist','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2823-1'),
(14191,'Forgotten Scroll - Meteor','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2824-1'),
(14192,'Forgotten Scroll - Star Fall','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2825-1'),
(14193,'Forgotten Scroll - Sublime Self Sacrifice','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2826-1'),
(14194,'Forgotten Scroll - Blessing of Eva','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2827-1'),
(14195,'Forgotten Scroll - Lord of Vampire','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2828-1'),
(14196,'Forgotten Scroll - Throne Route','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2829-1'),
(14197,'Forgotten Scroll - Seal of Limit','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2830-1'),
(14198,'Forgotten Scroll - Song of Purification','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2652-1'),
(14199,'Forgotten Scroll - Dance of Berserker','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2653-1'),
(14200,'Forgotten Scroll - Summon Imperial Phoenix','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2650-1'),
(14201,'Forgotten Scroll - Maximum Focus Force','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2655-1'),
(14202,'Forgotten Scroll - Maximum Focus Sonic','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2656-1'),
(14203,'Forgotten Scroll - Weapon Blockade','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2831-1'),
(14204,'Forgotten Scroll - Spirit of the Cat','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2667-1'),
(14205,'Forgotten Scroll - Spirit of the Unicorn','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2669-1'),
(14206,'Forgotten Scroll - Spirit of the Phantom','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2668-1'),
(14207,'Forgotten Scroll - Deflect Magic','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2651-1'),
(14208,'Forgotten Scroll - Final Secret','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2654-1'),
(14209,'Forgotten Scroll - Hide','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2657-1'),
(14210,'Forgotten Scroll - Dual Dagger Mastery','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2658-1'),
(14211,'Forgotten Scroll - Seven Arrow','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2659-1'),
(14212,'Forgotten Scroll - Enlightenment - Wizard','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2660-1'),
(14213,'Forgotten Scroll - Enlightenment - Healer','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2661-1'),
(14214,'Forgotten Scroll - Chant of Movement','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2662-1'),
(14215,'Forgotten Scroll - Combat of Paagrio','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2663-1'),
(14216,'Forgotten Scroll - Critical of Paagrio','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2664-1'),
(14217,'Forgotten Scroll - Condition of Paagrio','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2665-1'),
(14218,'Forgotten Scroll - Duel Blow','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2666-1'),
(14219,'Forgotten Scroll - Magician\'s Will','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2780-1'),
(14220,'Forgotten Scroll - Silent Mind','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2781-1'),
(14221,'Forgotten Scroll - Turn Stone','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2782-1'),
(14222,'Forgotten Scroll - Lucky Strike','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2783-1'),
(14223,'Forgotten Scroll - Eye for Eye','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2784-1'),
(14224,'Forgotten Scroll - Curse of Desparion','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2785-1'),
(14225,'Forgotten Scroll - Counter Critical','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2786-1'),
(14226,'Forgotten Scroll - Onslaught of Pa\'agrio','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2787-1'),
(14227,'Forgotten Scroll - Great Fury','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','2788-1'),
(14228,'Sudden Agathion 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14229,'Shiny Agathion 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14230,'Sobbing Agathion 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14231,'Gold Maned Lion Mounting Bracelet 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14232,'Steam Beatle Mounting Bracelet 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14233,'Energy Replenishing Beverage 1-Unit Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14234,'Snow Kung Transformation Stick 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14235,'Scarecrow Jack Transformation Stick 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14236,'Tin Golem Transformation Stick 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14237,'Teddy Boy Agathion 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14238,'Teddy Girl Agathion 30 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14239,'High Quality Hunting Helper Exchange Coupon 2-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14240,'Gold Maned Lion Mounting Bracelet 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14241,'Steam Beatle Mounting Bracelet 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14242,'Energy Replenishing Beverage 1-Unit Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14243,'Snow Kung Transformation Stick 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14244,'Scarecrow Jack Transformation Stick 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14245,'Tin Golem Transformation Stick 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14246,'Teddy Boy Agathion 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14247,'Teddy Girl Agathion 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14248,'High Quality Hunting Helper Exchange Coupon 1-Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14249,'Sudden Agathion 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14250,'Shiny Agathion 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14251,'Sobbing Agathion 30 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14252,'Weapon-type Enhance Backup Stone (D-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14253,'Weapon-type Enhance Backup Stone (C-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14254,'Weapon-type Enhance Backup Stone (B-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14255,'Weapon-type Enhance Backup Stone (A-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14256,'Weapon-type Enhance Backup Stone (S-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14257,'Armor-type Enhance Backup Stone (D-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14258,'Armor-type Enhance Backup Stone (C-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14259,'Armor-type Enhance Backup Stone (B-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14260,'Armor-type Enhance Backup Stone (A-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14261,'Armor-type Enhance Backup Stone (S-Grade Pack) (event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14262,'Snow Kung Transformation Stick 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14263,'Scarecrow Jack Transformation Stick 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14264,'Tin Golem Transformation Stick 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14265,'Teddy Boy Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14266,'Teddy Girl Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14267,'Sudden Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14268,'Shiny Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14269,'Sobbing Agathion 7 Day Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14270,'Snow Kung Transformation Stick 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14271,'Scarecrow Jack Transformation Stick 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14272,'Tin Golem Transformation Stick 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14273,'Teddy Boy Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14274,'Teddy Girl Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14275,'Sudden Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14276,'Shiny Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14277,'Sobbing Agathion 7 Day Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14278,'Weapon-type Enhance Backup Stone (D-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14279,'Weapon-type Enhance Backup Stone (C-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14280,'Weapon-type Enhance Backup Stone (B-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14281,'Weapon-type Enhance Backup Stone (A-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14282,'Weapon-type Enhance Backup Stone (S-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14283,'Armor-type Enhance Backup Stone (D-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14284,'Armor-type Enhance Backup Stone (C-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14285,'Armor-type Enhance Backup Stone (B-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14286,'Armor-type Enhance Backup Stone (A-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14287,'Armor-type Enhance Backup Stone (S-Grade Pack)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14288,'Energy Replenishing Beverage 3-Unit Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14289,'Energy Replenishing Beverage 3-Unit Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14290,'High Quality Hunting Helper Exchange Coupon 2-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14291,'High Quality Hunting Helper Exchange Coupon 1-Sheet Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14292,'Samurai Longsword','false','none',1380,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14293,'Deadman\'s Staff','false','none',1010,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14294,'Ghoul\'s Staff','false','none',1000,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14295,'Demon\'s Staff','false','none',990,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14296,'Crystal Dagger','false','none',1000,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14297,'Great Pata','false','none',1460,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14298,'Eminence Bow','false','none',1720,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14299,'Orcish Poleaxe','false','none',1950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14300,'Yaksa Mace','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14301,'Shamshir*Shamshir','false','none',2330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14302,'Berserker Blade','false','none',1380,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14303,'Crystal Dagger','false','none',1000,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14304,'Ecliptic Sword','false','none',1380,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14305,'Ecliptic Axe','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14306,'Dwarven Hammer','false','none',2010,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14307,'Admiral\'s Estoc','false','none',1380,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14308,'Saber Tooth','false','none',1950,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14309,'Sharpshooter','false','none',1740,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14310,'Sword of Damascus','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14311,'Lance','false','none',1920,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14312,'Deadman\'s Glory','false','none',1600,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14313,'Art of Battle Axe','false','none',1570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14314,'Staff of Evil Spirits','false','none',930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14315,'Demon Dagger','false','none',970,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14316,'Bellion Cestus','false','none',1390,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14317,'Bow of Peril','false','none',1700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14318,'Samurai Long Sword*Samurai Long Sword','false','none',2080,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14319,'Demon Dagger','false','none',970,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14320,'Guardian Sword','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14321,'Wizard\'s Tear','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14322,'Kaim Vanul\'s Bones','false','none',1570,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14323,'Star Buster','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14324,'Colichemarde','false','none',1350,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14325,'Dismantler','false','none',1930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14326,'Hell Hound','false','none',1700,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14327,'Sirra\'s Blade','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14328,'Sword of Ipos','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14329,'Barakiel\'s Axe','false','none',1550,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14330,'Behemoth\'s Tuning Fork','false','none',1890,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14331,'Naga Storm','false','none',930,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14332,'Tiphon\'s Spear','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14333,'Shyeed\'s Bow','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14334,'Sobekk\'s Hurricane','false','none',1330,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14335,'Themis\' Tongue','false','none',820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14336,'Cabrio\'s Hand','false','none',1510,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14337,'Daimon Crystal','false','none',880,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14338,'Tallum Blade*Damascus','false','none',1890,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14339,'Eclair Bijou','false','none',1300,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14340,'Durendal','false','none',1820,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14341,'Screaming Vengeance','false','none',1640,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14342,'Necklace of Binding','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14343,'Nassen\'s Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14344,'Ring of Binding','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14345,'Earring of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14346,'Ring of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14347,'Necklace of Black Ore','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14348,'Majestic Earring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14349,'Majestic Ring','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14350,'Majestic Necklace','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14351,'Gracia Anniversary Coins','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14352,'Sculpture of Doubt ','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14353,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14354,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14355,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14356,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14357,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14358,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14359,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14360,'Sculpture of Doubt','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14361,'Blood Stained Cloth','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14362,'White Cloth','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14530,'Maxwell House Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14531,'Gludio Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14532,'Dion Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14533,'Giran Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14534,'Oren Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14535,'Aden Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14536,'Innadril Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14537,'Goddard Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14538,'Rune Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14539,'Schuttgart Supply Box - Magic Pin - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14540,'Gludio Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14541,'Dion Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14542,'Giran Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14543,'Oren Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14544,'Aden Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14545,'Innadril Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14546,'Goddard Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14547,'Rune Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14548,'Schuttgart Supply Box - Magic Pouch - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14549,'Gludio Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14550,'Dion Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14551,'Giran Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14552,'Oren Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14553,'Aden Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14554,'Innadril Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14555,'Goddard Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14556,'Rune Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14557,'Schuttgart Supply Box - Belt - Grade S,A','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14559,'PC cafe points','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14603,'Sealed Ancient Cloak','false','none',220,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14607,'Mark of Gracia','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14612,'Christmas Red Sock','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14614,'Santa\'s Buff Gift Set','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14615,'Scroll of Christmas Festival - Mage Type','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14616,'Gift from Santa Claus','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14618,'Agathion Seal Bracelet - Rudolph','false','none',150,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14619,'Santa Claus\' Weapon Exchange Ticket','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14620,'Santa Claus\' Weapon Exchange Ticket','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14635,'Low Quality Battle Reward Chest','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14636,'Middle Quality Battle Reward Chest','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14637,'High Quality Battle Reward Chest','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14638,'Best Quality Battle Reward Chest','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14639,'Event - Claymore','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14640,'Event - Bonebreaker','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14641,'Event - Atuba Hammer','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14642,'Event - Ghost Staff','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14643,'Event - Staff of Life','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14644,'Event - Atuba Mace','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14645,'Event - Mithril Dagger','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14646,'Event - Scallop Jamadhr','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14647,'Event - Light Crossbow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14648,'Event - Glaive','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14649,'Event - Elven Long Sword','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14650,'Event - Samurai Longsword','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14651,'Event - Deadman\'s Staff','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14652,'Event - Ghoul\'s Staff','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14653,'Event - Demon\'s Staff','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14654,'Event - Crystal Dagger','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14655,'Event - Great Pata','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14656,'Event - Eminence Bow','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14657,'Event - Orcish Poleaxe','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14658,'Event - Yaksa Mace','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14659,'Event - Berserker Blade','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14660,'Event - Ecliptic Sword','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14661,'Event - Ecliptic Axe','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14662,'Event - Dwarven Hammer','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14663,'Event - Katana*Katana','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14673,'Rudolph\'s Nose','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14676,'Agathion\'s New Year\'s Gift','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14677,'Agathion\'s New Year\'s Gift','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14678,'Saerom\'s Bead - B','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14679,'Saerom\'s Bead - A','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14680,'Saerom\'s Bead - S','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14681,'Saerom\'s Bead - S80','false','none',20,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14682,'Greater Elixir of Life (No-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14683,'Greater Elixir of Life (D-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14684,'Greater Elixir of Life (C-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14685,'Greater Elixir of Life (B-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14686,'Greater Elixir of Life (A-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14687,'Greater Elixir of Life (S-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14688,'Greater Elixir of Mental Strength (No-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14689,'Greater Elixir of Mental Strength (D-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14690,'Greater Elixir of Mental Strength (C-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14691,'Greater Elixir of Mental Strength (B-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14692,'Greater Elixir of Mental Strength (A-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14693,'Greater Elixir of Mental Strength (S-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14694,'Greater Elixir of CP (No Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14695,'Greater Elixir of CP (D-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14696,'Greater Elixir of CP (C-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14697,'Greater Elixir of CP (B-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14698,'Greater Elixir of CP (A-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14699,'Greater Elixir of CP (S-Grade)','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14700,'Greater Healing Potion','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14701,'Greater Quick Healing Potion','false','none',180,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14702,'Agathion Auxiliary Stone: Enchant Weapon (D-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14703,'Agathion Auxiliary Stone: Enchant Weapon (C-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14704,'Agathion Auxiliary Stone: Enchant Weapon (B-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14705,'Agathion Auxiliary Stone: Enchant Weapon (A-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14706,'Agathion Auxiliary Stone: Enchant Weapon (S-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14707,'Agathion Auxiliary Stone: Enchant Armor (D-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14708,'Agathion Auxiliary Stone: Enchant Armor (C-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14709,'Agathion Auxiliary Stone: Enchant Armor (B-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14710,'Agathion Auxiliary Stone: Enchant Armor (A-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14711,'Agathion Auxiliary Stone: Enchant Armor (S-Grade)','false','none',120,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14713,'Greater Elixir Gift Box (No-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14714,'Greater Elixir Gift Box (D-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14715,'Greater Elixir Gift Box (C-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14716,'Greater Elixir Gift Box (B-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14717,'Greater Elixir Gift Box (A-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14718,'Greater Elixir Gift Box (S-Grade)','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14719,'Full Energy Event Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(14720,'Event - Apiga','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14721,'Event - Golden Apiga','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14722,'Event - Cupid\'s Fatigue Recovery Potion','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14723,'Event - Cupid\'s Powerful Fatigue Recovery Potion','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14724,'Event - Milk Cow Summon Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14725,'Event - Head Milk Cow Summon Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14726,'Event - Gloomy Milk Cow Summon Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14727,'Event - Gloomy Head Milk Cow Summon Scroll','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14728,'Event - Orr Cube - 30 day limited period','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14729,'Event - Crystal Cube','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14730,'Event - Golden Orr Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14731,'Event - Silver Orr Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14732,'Event - Copper Orr Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14733,'Event - Black Orr Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14734,'Event - Clear Crystal Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14735,'Event - Purple Crystal Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14736,'Event - Pink Crystal Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14737,'Event - Dark Brown Crystal Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14738,'Event - Black Crystal Cube Fragment','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14739,'Event - Fresh Milk','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14740,'Event - Save the Cow Event Pack','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14741,'Event - Energy Replenishing Herb Tea 5 minutes','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14742,'Event - Energy Replenishing Herb Tea 10 minutes','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14743,'Event - Energy Replenishing Herb Tea 20 minutes','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14744,'Event - Energy Replenishing Herb Tea 30 minutes','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(14745,'Event - Energy Replenishing Herb Tea 60 minutes','false','none',1,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none','');

INSERT INTO `etcitem` VALUES
(20000,'Spicy Kimchee','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20001,'Spicy Kimchee','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20002,'Spicy Kimchee','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20003,'Sweet-and-Sour White Kimchee','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20004,'Energy Ginseng','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20005,'Energy Red Ginseng','false','none',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20025,'My Teleport Spellbook','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20026,'Extra Entrance Pass - Kamaloka (Hall of the Abyss)','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20027,'Extra Entrance Pass - Near Kamaloka','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20028,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss)','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20033,'My Teleport Flag','false','none',5,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20034,'Revita-Pop','false','none',5,'assert','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20035,'Majo Agathion Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20036,'Gold Crown Majo Agathion Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20037,'Black Crown Majo Agathion Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20038,'Majo Agathion 30-Day Pack - Big Head','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20039,'Gold Crown Majo Agathion 30-Day Pack - Resurrection','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20040,'Black Crown Majo Agathion 30-Day Pack - Leave','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20041,'Plaipitak Agathion Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20042,'Plaipitak Agathion 30-Day Pack - Big Head','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20043,'Plaipitak Agathion 30-Day Pack - Resurrection','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20044,'Plaipitak Agathion 30-Day Pack - Leave','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20045,'Horn-Rimmed Glasses Pack - Agility','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20046,'Afro Hair Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20047,'Afro Hair Pack - Big Head,Firework','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20048,'Afro Hair Pack - Wind Walk','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20049,'Uniform Hat Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20050,'Assassin\'s Bamboo Hat Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20051,'Ruthless Tribe Mask Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20052,'Ribbon Hairband Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20053,'Visor Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20054,'My Teleport Spellbook 1-Sheet Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20055,'Extra Entrance Pass - Kamaloka (Hall of the Abyss) 1-Sheet Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20056,'Extra Entrance Pass - Near Kamaloka 1-Sheet Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20057,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss) 1-Sheet Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20058,'Light Purple-Maned Horse Bracelet Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20059,'Light Purple Maned Horse Bracelet 30-Day Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20060,'Kat the Cat Hat Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20061,'Skull Hat Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20062,'My Teleport Flag Pack','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20069,'Baby Panda Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20070,'Bamboo Panda Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20071,'Sexy Panda Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20072,'Agathion of Baby Panda 15 Day Pack - Big Head','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20073,'Bamboo Panda Agathion 15 Day Pack - Resurrection','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20074,'Agathion of Sexy Panda 15 Day Pack - Escape','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20075,'Santa Claus\' Gift - Joy - 4 Hour Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20076,'Santa Claus\' Gift - Enjoyment - 4 Hour Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20077,'Santa Claus\' Gift - Luck - 4 Hour Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20078,'Santa Claus\' Gift - Luck - 4 Hour Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20079,'Good Luck Lucky Bag Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20080,'Lucky Four-leaf Clover Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20081,'Good Luck Lucky Bag','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20082,'Lucky Four-leaf Clover','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20092,'Holiday Spirit Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20093,'Spirit of the Holiday','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20096,'Mysterious Formal Dress - Event Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20097,'Mysterious Formal Dress - Event Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20101,'Santa Claus\' Gift Set','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20102,'Santa Claus\' Gift Set','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20103,'Holiday Scroll: Heavy Armor Fighter - 8 Hour Expiration Period','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20104,'Holiday Scroll: Light Armor Fighter - 8 Hour Expiration Period','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20105,'Holiday Scroll: Healer - 8 Hour Expiration Period','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20106,'Holiday Scroll: Mage - 8 Hour Expiration Period','false','none',120,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20107,'Santa Claus\' Weapon Exchange Ticket - 12 Hour Expiration Period','false','none',1,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20108,'Santa Claus\' Weapon Exchange Ticket - 12 Hour Expiration Period','false','none',1,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20179,'Extra Entrance Pass - Near Kamaloka 5 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20180,'Extra Entrance Pass - Near Kamaloka 10 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20181,'My Teleport Spellbook 5 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20182,'My Teleport Spellbook 10 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20183,'My Teleport Flag 5 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20184,'My Teleport Flag 10 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20185,'Extra Entrance Pass - Kamaloka (Hall of the Abyss) 5 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20186,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss) 5 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20187,'Extra Entrance Pass - Kamaloka (Hall of the Abyss) 10 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20188,'Extra Entrance Pass - Kamaloka (Labyrinth of the Abyss) 10 Sheet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20189,'Premium Valentine Decoration Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20190,'Premium Valentine Decoration - 15 Day Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20191,'Valentine Cake Recipe','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','Recipes',''),
(20192,'Valentine Dark Chocolate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20193,'Valentine White Chocolate','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20194,'Valentine Fresh Cream','false','none',0,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20195,'Simple Valentine Cake','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20196,'Velvety Valentine Cake','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20197,'Delectable Valentine Cake','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20198,'Decadent Valentine Cake','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20199,'Heavenly Valentine Cake - 30 Day Expiration Period','false','none',100,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20210,'Charming Valentine Gift Set','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20211,'Naughty Valentine Gift Set','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20214,'Chocolate Cookie','false','none',5,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20215,'White Maneki Neko Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20216,'Black Maneki Neko Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20217,'Brown Maneki Neko Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20218,'White Maneki Neko Agathion 7-Day Pack - Resurrection','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20219,'Black Maneki Neko Agathion 7-Day Pack - Escape','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20220,'Brown Maneki Neko Agathion 7-Day Pack - Vitality','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20227,'One-Eyed Bat Drove Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20228,'One-Eyed Bat Drove Agathion 7-Day Pack - Resist Unholy','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20229,'One-Eyed Bat Drove Agathion 7-Day Pack - Vitality','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20233,'Pegasus Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20234,'Pegasus Agathion 7-Day Pack - Wind Walk','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20235,'Pegasus Agathion 7-Day Pack - Escape','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20239,'Yellow-Robed Tojigong Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20240,'Blue-Robed Tojigong Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20241,'Green-Robed Tojigong Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20242,'Yellow-Robed Tojigong 7-Day Pack - Greater Heal','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20243,'Blue-Robed Tojigong 7-Day Pack - Reflect Damage','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20244,'Green-Robed Tojigong 7-Day Pack - Mana Regeneration','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20251,'Bugbear Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20254,'Agathion of Love Pack (Event)','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20271,'Baguette Legacy','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20272,'Baguette Herb','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','22029-1'),
(20273,'Cream Puff Herb','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','22030-1'),
(20274,'Cheesecake Herb','false','herb',0,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','ItemSkills','22031-1'),
(20277,'Baguette Legacy - Kamael','false','none',10,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20278,'Gold Afro Hair Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20279,'Pink Afro Hair Pack','false','none',10,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20280,'Red Sumo Wrestler Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20281,'Red Sumo Wrestler Agathion 7-Day Pack - Death Whisper','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20282,'Blue Sumo Wrestler Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20283,'Blue Sumo Wrestler Agathion 7-Day Pack - Wild Magic','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20284,'Great Sumo Match Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20285,'Great Sumo Match Agathion 7-Day Pack - Big Head / Firework','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20286,'Button-Eyed Bear Doll Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20287,'Button-Eyed Bear Doll Agathion 7-Day Pack - Escape','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20288,'Button-Eyed Bear Doll Agathion 7-Day Pack - Resurrection','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20289,'Button-Eyed Bear Doll Agathion 7-Day Pack - Energy','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20290,'God of Fortune Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20291,'God of Fortune Agathion 7-Day Pack - Energy','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20292,'Dryad Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20293,'Wonboso Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20294,'Wonboso Agathion 7-Day Pack - Wind Walk','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20295,'Daewoonso Agathion Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20296,'Daewoonso Agathion 7-Day Pack - New Year\'s Gift','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20314,'Birthday Cake Pack - Energy','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20315,'Goggle Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20316,'Napoleon Hat Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20317,'Horn Hairband Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20318,'Black Gem Mask Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20319,'Plastic Hair Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20320,'Birthday Cake - Energy - 24 Hour Expiration Period','false','none',10,'normal','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(20326,'Beast Soulshot Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20327,'Beast Spiritshot Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20328,'Blessed Beast Spiritshot Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20329,'Beast Soulshot Large Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20330,'Beast Spiritshot Large Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20331,'Blessed Beast Spiritshot Large Pack','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20332,'Beast Soulshot','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','BeastSoulShot','22036-1'),
(20333,'Beast Spiritshot','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','BeastSpiritShot','22037-1'),
(20334,'Blessed Beast Spiritshot','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','BeastSpiritShot','22038-1'),
(20335,'Rune of Experience Points 30% - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22039-1'),
(20336,'Rune of Experience Points 50% - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22039-2'),
(20337,'Rune of Experience Points 30% - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22039-1'),
(20338,'Rune of Experience Points 50% - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22039-2'),
(20339,'Rune of Experience Points 30% - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22039-1'),
(20340,'Rune of Experience Points 50% - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22039-2'),
(20341,'Rune of SP 30% - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22040-1'),
(20342,'Rune of SP 50% - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22040-2'),
(20343,'Rune of SP 30% - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22040-1'),
(20344,'Rune of SP 50% - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22040-2'),
(20345,'Rune of SP 30% - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22040-1'),
(20346,'Rune of SP 50% - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22040-2'),
(20347,'Rune of Crystal level 3 - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22041-1'),
(20348,'Rune of Crystal level 5 - 5 Hour Expiration Period','false','none',120,'normal','paper','none',-1,300,0,0,'false','false','true','false','true','none','22041-2'),
(20349,'Rune of Crystal level 3 - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22041-1'),
(20350,'Rune of Crystal level 5 - 10 Hour Expiration Period','false','none',120,'normal','paper','none',-1,600,0,0,'false','false','true','false','true','none','22041-2'),
(20351,'Rune of Crystal level 3 - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22041-1'),
(20352,'Rune of Crystal level 5 - 7 Day Expiration Period','false','none',120,'normal','paper','none',-1,420,0,0,'false','false','true','false','true','none','22041-2'),
(20353,'High Grade Potion of Will','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22042-1'),
(20354,'Secret medicine of Will - D grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22043-2'),
(20355,'Secret medicine of Will - C grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22043-3'),
(20356,'Secret medicine of Will - B grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22043-4'),
(20357,'Secret medicine of Will - A grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22043-5'),
(20358,'Secret medicine of Will - S grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22043-6'),
(20359,'Secret medicine of Life - D grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22044-2'),
(20360,'Secret medicine of Life - C grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22044-3'),
(20361,'Secret medicine of Life - B grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22044-4'),
(20362,'Secret medicine of Life - A grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22044-5'),
(20363,'Secret medicine of Life - S grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','22044-6'),
(20364,'Omen Beast Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22045-1'),
(20365,'Death Blader Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22046-1'),
(20366,'Grail Apostle Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22047-1'),
(20367,'Unicorn Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22048-1'),
(20368,'Lilim Knight Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22049-1'),
(20369,'Golem Guardian Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22050-1'),
(20370,'Inferno Drake Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22051-1'),
(20371,'Dragon Bomber Transformation Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22052-1'),
(20372,'Escape - Talking Island Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-1'),
(20373,'Escape - Elven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-2'),
(20374,'Escape - Dark Elven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-3'),
(20375,'Escape - Orc Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-4'),
(20376,'Escape - Dwarven Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-5'),
(20377,'Escape - Gludin Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-6'),
(20378,'Escape - Town of Gludio','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-7'),
(20379,'Escape - Town of Dion','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-8'),
(20380,'Escape - Floran Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-9'),
(20381,'Escape - Giran Castle Town','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-10'),
(20382,'Escape - Hardin\'s Academy','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-11'),
(20383,'Escape - Heine','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-12'),
(20384,'Escape - Town of Oren','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-13'),
(20385,'Escape - Ivory Tower','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-14'),
(20386,'Escape - Hunters Village','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-15'),
(20387,'Escape - Town of Aden','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-16'),
(20388,'Escape - Town of Goddard','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-17'),
(20389,'Escape - Rune Township','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-18'),
(20390,'Escape - Town of Schuttgart','false','none',30,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','22053-19'),
(20391,'Potion of Energy Maintenance','false','none',36,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','22054-1'),
(20392,'Potion of Energy Replenishing','false','none',36,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','22055-1'),
(20393,'Sweet Fruit Cocktail','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Potions','22056-1;22057-1;22058-1;22059-1;22060-1;22061-1;22064-1;22065-1'),
(20394,'Fresh Fruit Cocktail','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Potions','22062-1;22063-1;22065-1;22066-1;22067-1;22068-1;22069-1;22070-1'),
(20395,'Steam Beatle Mounting Bracelet Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ExtractableItems',''),
(20397,'Newbie Level-Up Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none',''),
(20398,'Fast Growth Pack','false','none',100,'stackable','paper','none',-1,-1,0,0,'true','true','true','true','true','none',''),
(22000,'Small fortuna box ','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26000-1'),
(22001,'Middle fortuna box','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26001-1'),
(22002,'Large fortuna box','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26002-1'),
(22003,'Small fortuna cube','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26003-1'),
(22004,'Middle fortuna cube','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26004-1'),
(22005,'Large fortuna cube','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26005-1'),
(22006,'Weapon Enchant Scroll - D Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26006-1'),
(22007,'Weapon Enchant Scroll - C Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26007-1'),
(22008,'Weapon Enchant Scroll - B Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26008-1'),
(22009,'Weapon Enchant Scroll - A Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26009-1'),
(22010,'Armor Enchant Scroll - D Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26010-1'),
(22011,'Armor Enchant Scroll - C Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26011-1'),
(22012,'Armor Enchant Scroll - B Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26012-1'),
(22013,'Armor Enchant Scroll - A Grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26013-1'),
(22014,'Ancient Weapon Enchant Crystal - B grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26014-1'),
(22015,'Ancient Weapon Enchant Crystal - A grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26015-1'),
(22016,'Ancient Weapon Enchant Crystal - B grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26016-1'),
(22017,'Ancient Armor Enchant Crystal - B grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26017-1'),
(22018,'Divine Weapon Enchant Crystal - B grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26018-1'),
(22019,'Divine Weapon Enchant Crystal - A grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26019-1'),
(22020,'Divine Armor Enchant Crystal - B grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26020-1'),
(22021,'Divine Armor Enchant Crystal - A grade','false','none',0,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','EnchantScrolls','26021-1'),
(22022,'High grade potion which improves attack speed','false','none',4,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26022-1'),
(22023,'High grade potion which improves moving speed','false','none',4,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26023-1'),
(22024,'Temporary Healing Potion','false','none',36,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26024-1'),
(22025,'Powerful Healing Potion','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26025-1'),
(22026,'High-grade Healing Potion','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26026-1'),
(22027,'Secret medicine of Will - D grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26027-2'),
(22028,'Secret medicine of Will - C grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26027-3'),
(22029,'Secret medicine of Will - B grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26027-4'),
(22030,'Secret medicine of Will - A grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26027-5'),
(22031,'Secret medicine of Will - S grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26027-6'),
(22032,'Secret medicine of Life - D grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26028-2'),
(22033,'Secret medicine of Life - C grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26028-3'),
(22034,'Secret medicine of Life - B grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26028-4'),
(22035,'Secret medicine of Life - A grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26028-5'),
(22036,'Secret medicine of Life - S grade','false','none',5,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','Elixir','26028-6'),
(22037,'Potion of Will','false','none',25,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26029-1'),
(22038,'Healing medicine for Mana','false','none',36,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','none','26030-1'),
(22039,'Wind Walk Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26031-1'),
(22040,'Haste Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26032-1'),
(22041,'Might Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26033-1'),
(22042,'Shield Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26034-1'),
(22043,'Death Whisper Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26035-1'),
(22044,'Guidance Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26036-1'),
(22045,'Empower Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26037-1'),
(22046,'Greater Acumen Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26038-1'),
(22047,'Vampiric Rage Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26039-1'),
(22048,'Bless the Body Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26040-1'),
(22049,'Berserker Spirit Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26041-1'),
(22050,'Magic Barrier Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26042-1'),
(22051,'Bless the Soul Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26043-1'),
(22052,'Clarity Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26044-1'),
(22053,'Wild Magic Scroll','false','none',120,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26045-1'),
(22054,'Rune of Experience Points - 24 Hour Expiration Period','false','none',120,'normal','paper','none',-1,1440,0,0,'false','false','true','false','true','none','26046-1'),
(22055,'Rune of Experience Points - 168 Hour Expiration Period','false','none',120,'normal','paper','none',-1,10080,0,0,'false','false','true','false','true','none','26046-1'),
(22056,'Rune of Experience Points - 336 Hour Expiration Period','false','none',120,'normal','paper','none',-1,20160,0,0,'false','false','true','false','true','none','26046-1'),
(22057,'Rune of Experience Points - 720 Hour Expiration Period','false','none',120,'normal','paper','none',-1,43200,0,0,'false','false','true','false','true','none','26046-1'),
(22058,'Rune of SP - 24 Hour Expiration Period','false','none',120,'normal','paper','none',-1,1440,0,0,'false','false','true','false','true','none','26047-1'),
(22059,'Rune of SP - 168 Hour Expiration Period','false','none',120,'normal','paper','none',-1,10080,0,0,'false','false','true','false','true','none','26047-1'),
(22060,'Rune of SP - 336 Hour Expiration Period','false','none',120,'normal','paper','none',-1,20160,0,0,'false','false','true','false','true','none','26047-1'),
(22061,'Rune of SP - 720 Hour Expiration Period','false','none',120,'normal','paper','none',-1,43200,0,0,'false','false','true','false','true','none','26047-1'),
(22062,'Crystal form Rune - 24 Hour Expiration Period','false','none',120,'normal','paper','none',-1,1440,0,0,'false','false','true','false','true','none','26048-1'),
(22063,'Crystal form Rune - 168 Hour Expiration Period','false','none',120,'normal','paper','none',-1,10080,0,0,'false','false','true','false','true','none','26048-1'),
(22064,'Crystal form Rune - 336 Hour Expiration Period','false','none',120,'normal','paper','none',-1,20160,0,0,'false','false','true','false','true','none','26048-1'),
(22065,'Crystal form Rune - 720 Hour Expiration Period','false','none',120,'normal','paper','none',-1,43200,0,0,'false','false','true','false','true','none','26048-1'),
(22066,'Rune of Feather - 24 Hour Expiration Period','false','none',120,'normal','paper','none',-1,1440,0,0,'false','false','true','false','true','none','26049-1'),
(22067,'Bone Arrow','false','arrow',1,'stackable','paper','d',-1,-1,0,0,'false','false','true','false','true','none',''),
(22068,'Steel Arrow','false','arrow',1,'stackable','paper','c',-1,-1,0,0,'false','false','true','false','true','none',''),
(22069,'Silver Arrow','false','arrow',1,'stackable','paper','b',-1,-1,0,0,'false','false','true','false','true','none',''),
(22070,'Mithril Arrow','false','arrow',1,'stackable','paper','a',-1,-1,0,0,'false','false','true','false','true','none',''),
(22071,'Arrow of Light','false','arrow',1,'stackable','paper','s',-1,-1,0,0,'false','false','true','false','true','none',''),
(22072,'Blessed Spiritshot - D grade','false','shot',1,'stackable','paper','d',-1,-1,0,0,'false','false','true','false','true','BlessedSpiritShot','26050-1'),
(22073,'Blessed Spiritshot - C grade','false','shot',1,'stackable','paper','c',-1,-1,0,0,'false','false','true','false','true','BlessedSpiritShot','26051-1'),
(22074,'Blessed Spiritshot - B grade','false','shot',1,'stackable','paper','b',-1,-1,0,0,'false','false','true','false','true','BlessedSpiritShot','26052-1'),
(22075,'Blessed Spiritshot - A grade','false','shot',1,'stackable','paper','a',-1,-1,0,0,'false','false','true','false','true','BlessedSpiritShot','26053-1'),
(22076,'Blessed Spiritshot - S grade','false','shot',1,'stackable','paper','s',-1,-1,0,0,'false','false','true','false','true','BlessedSpiritShot','26054-1'),
(22077,'Spiritshot - D grade','false','shot',1,'stackable','paper','d',-1,-1,0,0,'false','false','true','false','true','SpiritShot','26055-1'),
(22078,'Spiritshot - C grade','false','shot',1,'stackable','paper','c',-1,-1,0,0,'false','false','true','false','true','SpiritShot','26056-1'),
(22079,'Spiritshot - B grade','false','shot',1,'stackable','paper','b',-1,-1,0,0,'false','false','true','false','true','SpiritShot','26057-1'),
(22080,'Spiritshot - A grade','false','shot',1,'stackable','paper','a',-1,-1,0,0,'false','false','true','false','true','SpiritShot','26058-1'),
(22081,'Spiritshot - S grade','false','shot',1,'stackable','paper','s',-1,-1,0,0,'false','false','true','false','true','SpiritShot','26059-1'),
(22082,'Soulshot - D-Grade','false','shot',1,'stackable','paper','d',-1,-1,0,0,'false','false','true','false','true','SoulShots','26060-1'),
(22083,'Soulshot - C-Grade','false','shot',1,'stackable','paper','c',-1,-1,0,0,'false','false','true','false','true','SoulShots','26061-1'),
(22084,'Soulshot - B grade','false','shot',1,'stackable','paper','b',-1,-1,0,0,'false','false','true','false','true','SoulShots','26062-1'),
(22085,'Soulshot - A-Grade','false','shot',1,'stackable','paper','a',-1,-1,0,0,'false','false','true','false','true','SoulShots','26063-1'),
(22086,'Soulshot - S grade','false','shot',1,'stackable','paper','s',-1,-1,0,0,'false','false','true','false','true','SoulShots','26064-1'),
(22087,'A Scroll Bundle of Fighter','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26065-1'),
(22088,'A Scroll Bundle of Mage','false','none',100,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26066-1'),
(22089,'Bone Quiver','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26067-1'),
(22090,'Steel Quiver','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26067-2'),
(22091,'Silver Quiver','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26067-3'),
(22092,'Mithril Quiver','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26067-4'),
(22093,'Quiver of Light','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26067-5'),
(22094,'Blessed Spiritshot Pack - D grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-1'),
(22095,'Blessed Spiritshot Pack - C grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-2'),
(22096,'Blessed Spiritshot Pack - B grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-3'),
(22097,'Blessed Spiritshot Pack - A grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-4'),
(22098,'Blessed Spiritshot Pack - S grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-5'),
(22099,'Spiritshot Pack - D grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-1'),
(22100,'Spiritshot Pack - C grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-2'),
(22101,'Spiritshot Pack - B grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-3'),
(22102,'Spiritshot Pack - A grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-4'),
(22103,'Spiritshot Pack - S grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-5'),
(22104,'Soulshot Pack - D grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-1'),
(22105,'Soulshot Pack - C grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-2'),
(22106,'Soulshot Pack - B grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-3'),
(22107,'Soulshot Pack - A grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-4'),
(22108,'Soulshot Pack - S grade','false','none',500,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-5'),
(22109,'Blessed Spiritshot Large Pack - D grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-6'),
(22110,'Blessed Spiritshot Large Pack - C grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-7'),
(22111,'Blessed Spiritshot Large Pack - B grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-8'),
(22112,'Blessed Spiritshot Large Pack - A grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-9'),
(22113,'Blessed Spiritshot Large Pack - S grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26068-10'),
(22114,'Spiritshot Large Pack - D grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-6'),
(22115,'Spiritshot Large Pack - C grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-7'),
(22116,'Spiritshot Large Pack - B grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-8'),
(22117,'Spiritshot Large Pack - A grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-9'),
(22118,'Spiritshot Large Pack - S grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26069-10'),
(22119,'Soulshot Large Pack - D grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-6'),
(22120,'Soulshot Large Pack - C grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-7'),
(22121,'Soulshot Large Pack - B grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-8'),
(22122,'Soulshot Large Pack - A grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-9'),
(22123,'Soulshot Large Pack - S grade','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26070-10'),
(22124,'Wrapped daisy hairpin','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-1'),
(22125,'Wrapped forget-me-not hairpin','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-2'),
(22126,'Wrapped outlaw\'s eyepatch','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-3'),
(22127,'Wrapped pirate\'s eyepatch','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-4'),
(22128,'Wrapped Monocle','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-5'),
(22129,'Wrapped Red Mask of Victory','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-6'),
(22130,'Wrapped Red Horn of Victory','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-7'),
(22131,'Wrapped Party Mask','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-8'),
(22132,'Wrapped Red Party Mask','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-9'),
(22133,'Wrapped Cat Ear','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-10'),
(22134,'Wrapped Noblewoman\'s Hairpin','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-11'),
(22135,'Wrapped Raccoon Ear','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-12'),
(22136,'Wrapped Rabbit Ear','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-13'),
(22137,'Wrapped Little Angel\'s Wings','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-14'),
(22138,'Wrapped Fairy\'s Tentacle','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-15'),
(22139,'Wrapped Dandy\'s Chapeau','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-16'),
(22140,'Wrapped Artisan\'s Goggles','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26071-17'),
(22141,'Wrapped Pet Exchange Ticket - Buffalo','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26072-1'),
(22142,'Wrapped Pet Exchange Ticket - Cougar','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26072-2'),
(22143,'Wrapped Pet Exchange Ticket - kookaburra','false','none',1,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26072-3'),
(22144,'Bone Bolt','false','bolt',1,'stackable','paper','d',-1,-1,0,0,'false','false','true','false','true','none',''),
(22145,'Steel Bolt','false','bolt',1,'stackable','paper','c',-1,-1,0,0,'false','false','true','false','true','none',''),
(22146,'Silver Bolt','false','bolt',1,'stackable','paper','b',-1,-1,0,0,'false','false','true','false','true','none',''),
(22147,'Mithril Bolt','false','bolt',1,'stackable','paper','a',-1,-1,0,0,'false','false','true','false','true','none',''),
(22148,'Bolt of Light','false','bolt',1,'stackable','paper','s',-1,-1,0,0,'false','false','true','false','true','none',''),
(22149,'Bone Bolt Container','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26073-1'),
(22150,'Steel Bolt Container','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26073-2'),
(22151,'Silver Bolt Container','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26073-3'),
(22152,'Mithril Bolt Container','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26073-4'),
(22153,'Bolt Container of Light','false','none',1000,'stackable','paper','none',-1,-1,0,0,'false','false','true','false','true','ItemSkills','26073-5');

--
-- L2J-Free Add-ons
--

-- Dark Seed cannot be exchanged or dropped according to client's description.
UPDATE `etcitem` SET `sellable` = 'false', `tradeable` = 'false',`dropable` = 'false' WHERE `item_id` = 10112;

-- Visitor's Mark and Pagan's Mark tradeable
UPDATE `etcitem` SET `tradeable` = 'true' WHERE `item_id` IN (8064,8067);
-- Small fix for quests items
UPDATE `etcitem` SET `item_type` = 'quest' WHERE `item_id` IN (8085,8098);

-- Already added at armors
DELETE FROM `etcitem` WHERE `item_id` = 10607;

-- Lord of the Manor's Certificate
UPDATE `etcitem` SET `price` = 10000 WHERE `item_id` = 6388;

-- Revita Pop not only destroyable
UPDATE `etcitem` SET `consume_type` = 'stackable', `sellable` = 'false', `tradeable` = 'false',`dropable` = 'false', `handler` = 'ItemSkills', `skills_item` = '22006-1' WHERE `item_id` = 20034;

-- Setting Vitality Replenishing Herbs as herb
UPDATE `etcitem` SET `item_type` = 'herb' WHERE `item_id` IN (13028,13029,13030,13031);

-- Bolts stats fix
UPDATE `etcitem` SET `price` = 2 WHERE `item_id` = 9632;
UPDATE `etcitem` SET `material` = 'bone', `crystal_type` = 'd' WHERE `item_id` = 9633;
UPDATE `etcitem` SET `material` = 'fine_steel', `crystal_type` = 'c' WHERE `item_id` = 9634;
UPDATE `etcitem` SET `material` = 'silver', `crystal_type` = 'b', `price` = 7 WHERE `item_id` = 9635;
UPDATE `etcitem` SET `material` = 'mithril', `crystal_type` = 'a', `price` = 8 WHERE `item_id` = 9636;
UPDATE `etcitem` SET `material` = 'adamantaite', `crystal_type` = 's', `price` = 10 WHERE `item_id` = 9637;

-- Moving our Changes to update statements to make syncs easier
UPDATE `etcitem` SET `sellable` = 'true', `dropable` = 'true', `destroyable` = 'true', `tradeable` = 'true', `handler` = 'SummonItems' WHERE `item_id` = 5249;
UPDATE `etcitem` SET `item_type` = 'castle_guard' WHERE `item_id` = 8029;
UPDATE `etcitem` SET `handler` = 'ItemSkills' WHERE `item_id` IN (8056,8192,8273,8274,8275,8379,9698,9699,20272,20273,20274,20335,20336,20337,20338,20339,20340,20341,20342,20343,20344,20345,20346,20347,20348,20349,20350,20351,20352,20391,20392,22000,22001,22002,22003,22004,22005,22038,22054,22055,22056,22057,22058,22059,22060,22061,22062,22063,22064,22065,22066);
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2440-1' WHERE `item_id` = 9599;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2359-1' WHERE `item_id` = 9672;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2358-1' WHERE `item_id` = 9673;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2341-1' WHERE `item_id` = 9702;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2580-1' WHERE `item_id` = 13028;
UPDATE `etcitem` SET `sellable` = 'true', `dropable` = 'true', `destroyable` = 'true', `tradeable` = 'true' where item_id >= 8570 and item_id <= 8575;
-- Temp fix for Sound Crystals 
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2073-1' WHERE `item_id` = 4416;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2073-2' WHERE `item_id` = 7061;

-- Soul crystals lvl 14+
UPDATE `etcitem` SET `item_type` = 'scroll', `material` = 'crystal' WHERE `item_id` IN (9570,9571,9572,10480,10481,10482,13071,13072,13073);
UPDATE `etcitem` SET `skills_item` = '2074-1' WHERE `item_id` = 4677;
UPDATE `etcitem` SET `skills_item` = '2075-1' WHERE `item_id` = 4678;
UPDATE `etcitem` SET `skills_item` = '2076-1' WHERE `item_id` = 4679;
UPDATE `etcitem` SET `handler` = 'ItemSkills' WHERE `item_id` IN (4677,4678,4679);
UPDATE `etcitem` SET `skills_item` = '2499-2' WHERE `item_id` = 10412;
UPDATE `etcitem` SET `consume_type` = 'normal' WHERE `item_id` IN (10480,10481,10482);

-- Emergency Dressing skills
UPDATE `etcitem` SET `skills_item` = '2045-1' WHERE `item_id` = 1834;

-- Seed of Evil
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false' WHERE `item_id` IN (9593,9594,9595,9596,9597,9598);

-- Disguise Scrolls by Spire
UPDATE `etcitem` SET `skills_item` = '2672-1', `handler` = 'ItemSkills' WHERE `item_id` = '13569'; -- Gludio Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2673-1', `handler` = 'ItemSkills' WHERE `item_id` = '13570'; -- Gludio Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2674-1', `handler` = 'ItemSkills' WHERE `item_id` = '13571'; -- Gludio Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2675-1', `handler` = 'ItemSkills' WHERE `item_id` = '13572'; -- Gludio Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2676-1', `handler` = 'ItemSkills' WHERE `item_id` = '13573'; -- Gludio Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2677-1', `handler` = 'ItemSkills' WHERE `item_id` = '13574'; -- Gludio Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2678-1', `handler` = 'ItemSkills' WHERE `item_id` = '13575'; -- Gludio Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2679-1', `handler` = 'ItemSkills' WHERE `item_id` = '13576'; -- Gludio Archer Captain
UPDATE `etcitem` SET `skills_item` = '2680-1', `handler` = 'ItemSkills' WHERE `item_id` = '13577'; -- Gludio Magic Leader
UPDATE `etcitem` SET `skills_item` = '2681-1', `handler` = 'ItemSkills' WHERE `item_id` = '13578'; -- Gludio Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2682-1', `handler` = 'ItemSkills' WHERE `item_id` = '13579'; -- Gludio Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2683-1', `handler` = 'ItemSkills' WHERE `item_id` = '13580'; -- Gludio Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2684-1', `handler` = 'ItemSkills' WHERE `item_id` = '13581'; -- Dion Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2685-1', `handler` = 'ItemSkills' WHERE `item_id` = '13582'; -- Dion Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2686-1', `handler` = 'ItemSkills' WHERE `item_id` = '13583'; -- Dion Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2687-1', `handler` = 'ItemSkills' WHERE `item_id` = '13584'; -- Dion Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2688-1', `handler` = 'ItemSkills' WHERE `item_id` = '13585'; -- Dion Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2689-1', `handler` = 'ItemSkills' WHERE `item_id` = '13586'; -- Dion Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2690-1', `handler` = 'ItemSkills' WHERE `item_id` = '13587'; -- Dion Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2691-1', `handler` = 'ItemSkills' WHERE `item_id` = '13588'; -- Dion Archer Captain
UPDATE `etcitem` SET `skills_item` = '2692-1', `handler` = 'ItemSkills' WHERE `item_id` = '13589'; -- Dion Magic Leader
UPDATE `etcitem` SET `skills_item` = '2693-1', `handler` = 'ItemSkills' WHERE `item_id` = '13590'; -- Dion Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2694-1', `handler` = 'ItemSkills' WHERE `item_id` = '13591'; -- Dion Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2695-1', `handler` = 'ItemSkills' WHERE `item_id` = '13592'; -- Dion Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2696-1', `handler` = 'ItemSkills' WHERE `item_id` = '13593'; -- Giran Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2697-1', `handler` = 'ItemSkills' WHERE `item_id` = '13594'; -- Giran Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2698-1', `handler` = 'ItemSkills' WHERE `item_id` = '13595'; -- Giran Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2699-1', `handler` = 'ItemSkills' WHERE `item_id` = '13596'; -- Giran Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2700-1', `handler` = 'ItemSkills' WHERE `item_id` = '13597'; -- Giran Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2701-1', `handler` = 'ItemSkills' WHERE `item_id` = '13598'; -- Giran Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2702-1', `handler` = 'ItemSkills' WHERE `item_id` = '13599'; -- Giran Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2703-1', `handler` = 'ItemSkills' WHERE `item_id` = '13600'; -- Giran Archer Captain
UPDATE `etcitem` SET `skills_item` = '2704-1', `handler` = 'ItemSkills' WHERE `item_id` = '13601'; -- Giran Magic Leader
UPDATE `etcitem` SET `skills_item` = '2705-1', `handler` = 'ItemSkills' WHERE `item_id` = '13602'; -- Giran Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2706-1', `handler` = 'ItemSkills' WHERE `item_id` = '13603'; -- Giran Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2707-1', `handler` = 'ItemSkills' WHERE `item_id` = '13604'; -- Giran Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2708-1', `handler` = 'ItemSkills' WHERE `item_id` = '13605'; -- Oren Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2709-1', `handler` = 'ItemSkills' WHERE `item_id` = '13606'; -- Oren Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2710-1', `handler` = 'ItemSkills' WHERE `item_id` = '13607'; -- Oren Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2711-1', `handler` = 'ItemSkills' WHERE `item_id` = '13608'; -- Oren Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2712-1', `handler` = 'ItemSkills' WHERE `item_id` = '13609'; -- Oren Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2713-1', `handler` = 'ItemSkills' WHERE `item_id` = '13610'; -- Oren Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2714-1', `handler` = 'ItemSkills' WHERE `item_id` = '13611'; -- Oren Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2715-1', `handler` = 'ItemSkills' WHERE `item_id` = '13612'; -- Oren Archer Captain
UPDATE `etcitem` SET `skills_item` = '2716-1', `handler` = 'ItemSkills' WHERE `item_id` = '13613'; -- Oren Magic Leader
UPDATE `etcitem` SET `skills_item` = '2717-1', `handler` = 'ItemSkills' WHERE `item_id` = '13614'; -- Oren Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2718-1', `handler` = 'ItemSkills' WHERE `item_id` = '13615'; -- Oren Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2719-1', `handler` = 'ItemSkills' WHERE `item_id` = '13616'; -- Oren Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2720-1', `handler` = 'ItemSkills' WHERE `item_id` = '13617'; -- Aden Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2721-1', `handler` = 'ItemSkills' WHERE `item_id` = '13618'; -- Aden Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2722-1', `handler` = 'ItemSkills' WHERE `item_id` = '13619'; -- Aden Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2723-1', `handler` = 'ItemSkills' WHERE `item_id` = '13620'; -- Aden Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2724-1', `handler` = 'ItemSkills' WHERE `item_id` = '13621'; -- Aden Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2725-1', `handler` = 'ItemSkills' WHERE `item_id` = '13622'; -- Aden Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2726-1', `handler` = 'ItemSkills' WHERE `item_id` = '13623'; -- Aden Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2727-1', `handler` = 'ItemSkills' WHERE `item_id` = '13624'; -- Aden Archer Captain
UPDATE `etcitem` SET `skills_item` = '2728-1', `handler` = 'ItemSkills' WHERE `item_id` = '13625'; -- Aden Magic Leader
UPDATE `etcitem` SET `skills_item` = '2729-1', `handler` = 'ItemSkills' WHERE `item_id` = '13626'; -- Aden Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2730-1', `handler` = 'ItemSkills' WHERE `item_id` = '13627'; -- Aden Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2731-1', `handler` = 'ItemSkills' WHERE `item_id` = '13628'; -- Aden Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2732-1', `handler` = 'ItemSkills' WHERE `item_id` = '13629'; -- Innadril Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2733-1', `handler` = 'ItemSkills' WHERE `item_id` = '13630'; -- Innadril Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2734-1', `handler` = 'ItemSkills' WHERE `item_id` = '13631'; -- Innadril Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2735-1', `handler` = 'ItemSkills' WHERE `item_id` = '13632'; -- Innadril Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2736-1', `handler` = 'ItemSkills' WHERE `item_id` = '13633'; -- Innadril Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2737-1', `handler` = 'ItemSkills' WHERE `item_id` = '13634'; -- Innadril Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2738-1', `handler` = 'ItemSkills' WHERE `item_id` = '13635'; -- Innadril Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2739-1', `handler` = 'ItemSkills' WHERE `item_id` = '13636'; -- Innadril Archer Captain
UPDATE `etcitem` SET `skills_item` = '2740-1', `handler` = 'ItemSkills' WHERE `item_id` = '13637'; -- Innadril Magic Leader
UPDATE `etcitem` SET `skills_item` = '2741-1', `handler` = 'ItemSkills' WHERE `item_id` = '13638'; -- Innadril Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2742-1', `handler` = 'ItemSkills' WHERE `item_id` = '13639'; -- Innadril Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2743-1', `handler` = 'ItemSkills' WHERE `item_id` = '13640'; -- Innadril Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2744-1', `handler` = 'ItemSkills' WHERE `item_id` = '13641'; -- Goddard Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2745-1', `handler` = 'ItemSkills' WHERE `item_id` = '13642'; -- Goddard Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2746-1', `handler` = 'ItemSkills' WHERE `item_id` = '13643'; -- Goddard Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2747-1', `handler` = 'ItemSkills' WHERE `item_id` = '13644'; -- Goddard Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2748-1', `handler` = 'ItemSkills' WHERE `item_id` = '13645'; -- Goddard Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2749-1', `handler` = 'ItemSkills' WHERE `item_id` = '13646'; -- Goddard Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2750-1', `handler` = 'ItemSkills' WHERE `item_id` = '13647'; -- Goddard Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2751-1', `handler` = 'ItemSkills' WHERE `item_id` = '13648'; -- Goddard Archer Captain
UPDATE `etcitem` SET `skills_item` = '2752-1', `handler` = 'ItemSkills' WHERE `item_id` = '13649'; -- Goddard Magic Leader
UPDATE `etcitem` SET `skills_item` = '2753-1', `handler` = 'ItemSkills' WHERE `item_id` = '13650'; -- Goddard Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2754-1', `handler` = 'ItemSkills' WHERE `item_id` = '13651'; -- Goddard Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2755-1', `handler` = 'ItemSkills' WHERE `item_id` = '13652'; -- Goddard Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2756-1', `handler` = 'ItemSkills' WHERE `item_id` = '13653'; -- Rune Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2757-1', `handler` = 'ItemSkills' WHERE `item_id` = '13654'; -- Rune Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2758-1', `handler` = 'ItemSkills' WHERE `item_id` = '13655'; -- Rune Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2759-1', `handler` = 'ItemSkills' WHERE `item_id` = '13656'; -- Rune Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2760-1', `handler` = 'ItemSkills' WHERE `item_id` = '13657'; -- Rune Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2761-1', `handler` = 'ItemSkills' WHERE `item_id` = '13658'; -- Rune Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2762-1', `handler` = 'ItemSkills' WHERE `item_id` = '13659'; -- Rune Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2763-1', `handler` = 'ItemSkills' WHERE `item_id` = '13660'; -- Rune Archer Captain
UPDATE `etcitem` SET `skills_item` = '2764-1', `handler` = 'ItemSkills' WHERE `item_id` = '13661'; -- Rune Magic Leader
UPDATE `etcitem` SET `skills_item` = '2765-1', `handler` = 'ItemSkills' WHERE `item_id` = '13662'; -- Rune Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2766-1', `handler` = 'ItemSkills' WHERE `item_id` = '13663'; -- Rune Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2767-1', `handler` = 'ItemSkills' WHERE `item_id` = '13664'; -- Rune Fortress Captain
UPDATE `etcitem` SET `skills_item` = '2768-1', `handler` = 'ItemSkills' WHERE `item_id` = '13665'; -- Schuttgart Human Mercenary
UPDATE `etcitem` SET `skills_item` = '2769-1', `handler` = 'ItemSkills' WHERE `item_id` = '13666'; -- Schuttgart Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2770-1', `handler` = 'ItemSkills' WHERE `item_id` = '13667'; -- Schuttgart Dark Elf Mercenary
UPDATE `etcitem` SET `skills_item` = '2771-1', `handler` = 'ItemSkills' WHERE `item_id` = '13668'; -- Schuttgart Orc Mercenary
UPDATE `etcitem` SET `skills_item` = '2772-1', `handler` = 'ItemSkills' WHERE `item_id` = '13669'; -- Schuttgart Dwarf Mercenary
UPDATE `etcitem` SET `skills_item` = '2773-1', `handler` = 'ItemSkills' WHERE `item_id` = '13670'; -- Schuttgart Kamael Mercenary
UPDATE `etcitem` SET `skills_item` = '2774-1', `handler` = 'ItemSkills' WHERE `item_id` = '13671'; -- Schuttgart Royal Guard Captain
UPDATE `etcitem` SET `skills_item` = '2775-1', `handler` = 'ItemSkills' WHERE `item_id` = '13672'; -- Schuttgart Archer Captain
UPDATE `etcitem` SET `skills_item` = '2776-1', `handler` = 'ItemSkills' WHERE `item_id` = '13673'; -- Schuttgart Magic Leader
UPDATE `etcitem` SET `skills_item` = '2777-1', `handler` = 'ItemSkills' WHERE `item_id` = '13674'; -- Schuttgart Kamael Guard Captain
UPDATE `etcitem` SET `skills_item` = '2778-1', `handler` = 'ItemSkills' WHERE `item_id` = '13675'; -- Schuttgart Knight of Dawn
UPDATE `etcitem` SET `skills_item` = '2779-1', `handler` = 'ItemSkills' WHERE `item_id` = '13676'; -- Schuttgart Fortress Captain
UPDATE `etcitem` SET `item_type` = 'scroll' WHERE `item_id` BETWEEN 13569 AND 13685; -- Disguise Scrolls

-- Water dragon Scale and claws (Psycho) 
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2360-1' WHERE `etcitem`.`item_id` =9700 LIMIT 1 ; 
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2369-1' WHERE `etcitem`.`item_id` =9691 LIMIT 1 ;

-- Birthday cake pack & birthday cake (savormix)
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '22034-1', `sellable` = 'false', `dropable` = 'false', `tradeable`= 'false' WHERE `item_id` = 20314;
UPDATE `etcitem` SET `time` = 1440, `sellable` = 'false', `dropable` = 'false', `tradeable`= 'false', `handler` = 'ItemSkills', `skills_item` = '22035-1' WHERE `item_id` = 20320;

UPDATE `etcitem` SET `skills_item` = '2592-1', `handler` = 'ItemSkills' WHERE `item_id` = '13033'; -- Quick Healing Potion
UPDATE `etcitem` SET `skills_item` = '2403-1', `handler` = 'ItemSkills' WHERE `item_id` = '10166'; -- Spring CP Potion

-- Fix seed price (Psycho)
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10171';
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10172';
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10173';
UPDATE `etcitem` SET `price` = '10' WHERE `item_id` = '10174';
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10197';
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10198';
UPDATE `etcitem` SET `price` = '5' WHERE `item_id` = '10199';
UPDATE `etcitem` SET `price` = '10' WHERE `item_id` = '10200';
UPDATE `etcitem` SET `price` = '20' WHERE `item_id` = '10201';
UPDATE `etcitem` SET `price` = '20' WHERE `item_id` = '10202';

-- Empty bottle of soul (Psycho)
UPDATE `etcitem` SET `handler` = 'Potions' WHERE `item_id` = '10409';

-- Wrapped Vitamin Packs (savormix)
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` IN (13256, 13257, 13384, 13385, 14530);
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13079 AND 13098;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13103 AND 13126;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13225 AND 13233;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13274 AND 13276;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13279 AND 13292;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13341 AND 13381;
UPDATE `etcitem` SET `handler` = 'WrappedPack', `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 14228 AND 14291;
-- Vitamin Items (savormix)
UPDATE `etcitem` SET `handler` = 'ColorName' WHERE `item_id` IN (13021, 13307);
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `destroyable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 12362 AND 12371;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` IN (10649, 12782, 12783, 12800, 13015, 13016, 13027, 13128, 13273, 13382, 13383);
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 12786 AND 12797;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13010 AND 13012;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13021 AND 13026;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13239 AND 13254;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13297 AND 13299;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13300 AND 13302;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13307 AND 13323;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 13325 AND 13340;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 14053 AND 14060;
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` BETWEEN 14065 AND 14103;

-- Cocktails
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '22056-1;22057-1;22058-1;22059-1;22060-1;22061-1;22064-1;22065-1' WHERE `item_id` = 10178;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '22062-1;22063-1;22065-1;22066-1;22067-1;22068-1;22069-1;22070-1' WHERE `item_id` = 10179;

-- Some items aren't in this table... (savormix)
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2856-1' WHERE `item_id` = 14614;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2857-1' WHERE `item_id` = 14615;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2858-1' WHERE `item_id` = 14612;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2883-1' WHERE `item_id` = 14742;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2884-1' WHERE `item_id` = 14743;
UPDATE `etcitem` SET `handler` = 'ItemSkills', `skills_item` = '2894-1' WHERE `item_id` = 14769;

UPDATE `etcitem` SET `item_type` = 'scroll' WHERE `item_id` BETWEEN 13731 AND 13739; -- Blessed Scrolls
UPDATE `etcitem` SET `item_type` = 'scroll' WHERE `item_id` BETWEEN 20364 AND 20371; -- Transformation Scrolls

-- Sealed Knight's cloak (savormix)
UPDATE `etcitem` SET `price` = 28671000 WHERE `item_id` = 13686;

-- Generated from csv
UPDATE `etcitem` SET `handler` = 'ExtractableItems' WHERE `item_id` IN (
55,140,14229,14250,14268,14276,56,141,14230,14251,14269,14277,139,170,14228,14249,14267,14275,13083,
13107,13280,13344,13369,20254,14237,14246,14265,14273,14238,14247,14266,14274,14719,20035,20036,20037,
20038,20039,20040,20041,20042,20043,20044,20069,20072,20070,20073,20071,20074,20215,20216,20217,20218,
20219,20220,20227,20228,20229,20233,20234,20235,20239,20240,20241,20242,20243,20244,20251,20280,20281,
20282,20283,20284,20285,20286,20287,20288,20289,20290,20291,20292,20293,20294,20295,20296,14234,14243,
14262,14270,13084,13108,13281,13370,14235,14244,14263,14271,14236,14245,14264,14272,13082,13106,13279,
13343,13368,20045,20046,20047,20048,20278,20279,20049,20315,20316,20317,20318,20319,20050,20051,20052,
20053,13110,13086,13282,13347,13371,20060,13111,13087,13283,13348,13372,13112,13088,13284,13349,13373,
13089,13113,13285,13350,13374,13090,13114,13286,13351,13375,13091,13115,13287,13352,13376,20061,13092,
13116,13288,13353,13377,13093,13117,13289,13354,13378,13094,13118,13290,13355,13379,13098,13122,13124,
13359,13360,14232,14241,20395,20058,20059,14240,20096,20189,14252,14253,14254,14255,14256,14278,14279,
14280,14281,14282,14257,14258,14259,14260,14261,14283,14284,14285,14286,14287);

-- Supply boxes (Spire)
UPDATE `etcitem` SET `handler` = 'ItemSkills' WHERE `item_id` IN (
13695,13696,13697,13698,13699,13700,13701,13702,13703,13704,13705,13706,13707,13708,13709,13710,13711,
13712,13713,13714,13715,13716,13717,13718,13719,13720,13721);

UPDATE `etcitem` SET `skills_item` = '2921-1' WHERE `item_id` = 13695;
UPDATE `etcitem` SET `skills_item` = '2922-1' WHERE `item_id` = 13696;
UPDATE `etcitem` SET `skills_item` = '2923-1' WHERE `item_id` = 13697;
UPDATE `etcitem` SET `skills_item` = '2924-1' WHERE `item_id` = 13698;
UPDATE `etcitem` SET `skills_item` = '2925-1' WHERE `item_id` = 13699;
UPDATE `etcitem` SET `skills_item` = '2926-1' WHERE `item_id` = 13700;
UPDATE `etcitem` SET `skills_item` = '2927-1' WHERE `item_id` = 13701;
UPDATE `etcitem` SET `skills_item` = '2928-1' WHERE `item_id` = 13702;
UPDATE `etcitem` SET `skills_item` = '2929-1' WHERE `item_id` = 13703;
UPDATE `etcitem` SET `skills_item` = '2930-1' WHERE `item_id` = 13704;
UPDATE `etcitem` SET `skills_item` = '2931-1' WHERE `item_id` = 13705;
UPDATE `etcitem` SET `skills_item` = '2932-1' WHERE `item_id` = 13706;
UPDATE `etcitem` SET `skills_item` = '2933-1' WHERE `item_id` = 13707;
UPDATE `etcitem` SET `skills_item` = '2934-1' WHERE `item_id` = 13708;
UPDATE `etcitem` SET `skills_item` = '2935-1' WHERE `item_id` = 13709;
UPDATE `etcitem` SET `skills_item` = '2936-1' WHERE `item_id` = 13710;
UPDATE `etcitem` SET `skills_item` = '2937-1' WHERE `item_id` = 13711;
UPDATE `etcitem` SET `skills_item` = '2938-1' WHERE `item_id` = 13712;
UPDATE `etcitem` SET `skills_item` = '2939-1' WHERE `item_id` = 13713;
UPDATE `etcitem` SET `skills_item` = '2940-1' WHERE `item_id` = 13714;
UPDATE `etcitem` SET `skills_item` = '2941-1' WHERE `item_id` = 13715;
UPDATE `etcitem` SET `skills_item` = '2942-1' WHERE `item_id` = 13716;
UPDATE `etcitem` SET `skills_item` = '2943-1' WHERE `item_id` = 13717;
UPDATE `etcitem` SET `skills_item` = '2944-1' WHERE `item_id` = 13718;
UPDATE `etcitem` SET `skills_item` = '2945-1' WHERE `item_id` = 13719;
UPDATE `etcitem` SET `skills_item` = '2946-1' WHERE `item_id` = 13720;
UPDATE `etcitem` SET `skills_item` = '2947-1' WHERE `item_id` = 13721;

-- Caravaner\'s Remedy and Certificates
UPDATE `etcitem` SET `dropable` = 'false', `tradeable` = 'false' WHERE `item_id` = '9702';
UPDATE `etcitem` SET `item_type` = 'quest' WHERE `item_id` IN (9850,9851,9852);
UPDATE `etcitem` SET `sellable` = 'false', `dropable` = 'false', `tradeable` = 'false', `depositable` = 'false' WHERE `item_id` IN (9850,9851,9852);

-- Greater Elixir (Spire)
UPDATE `etcitem` SET `handler` = 'Elixir', `item_type` = 'potion', `material` = 'liquid' WHERE `item_id` BETWEEN 14682 AND 14699;
UPDATE `etcitem` SET `crystal_type` = 'none' WHERE `item_id` IN (14682,14688,14694);
UPDATE `etcitem` SET `crystal_type` = 'd' WHERE `item_id` IN (14683,14689,14695);
UPDATE `etcitem` SET `crystal_type` = 'c' WHERE `item_id` IN (14684,14690,14696);
UPDATE `etcitem` SET `crystal_type` = 'b' WHERE `item_id` IN (14685,14691,14697);
UPDATE `etcitem` SET `crystal_type` = 'a' WHERE `item_id` IN (14686,14692,14698);
UPDATE `etcitem` SET `crystal_type` = 's' WHERE `item_id` IN (14687,14693,14699);
UPDATE `etcitem` SET `skills_item` = '2860-1' WHERE `item_id` = 14682;
UPDATE `etcitem` SET `skills_item` = '2860-2' WHERE `item_id` = 14683;
UPDATE `etcitem` SET `skills_item` = '2860-3' WHERE `item_id` = 14684;
UPDATE `etcitem` SET `skills_item` = '2860-4' WHERE `item_id` = 14685;
UPDATE `etcitem` SET `skills_item` = '2860-5' WHERE `item_id` = 14686;
UPDATE `etcitem` SET `skills_item` = '2860-6' WHERE `item_id` = 14687;
UPDATE `etcitem` SET `skills_item` = '2861-1' WHERE `item_id` = 14688;
UPDATE `etcitem` SET `skills_item` = '2861-2' WHERE `item_id` = 14689;
UPDATE `etcitem` SET `skills_item` = '2861-3' WHERE `item_id` = 14690;
UPDATE `etcitem` SET `skills_item` = '2861-4' WHERE `item_id` = 14691;
UPDATE `etcitem` SET `skills_item` = '2861-5' WHERE `item_id` = 14692;
UPDATE `etcitem` SET `skills_item` = '2861-6' WHERE `item_id` = 14693;
UPDATE `etcitem` SET `skills_item` = '2862-1' WHERE `item_id` = 14694;
UPDATE `etcitem` SET `skills_item` = '2862-2' WHERE `item_id` = 14695;
UPDATE `etcitem` SET `skills_item` = '2862-3' WHERE `item_id` = 14696;
UPDATE `etcitem` SET `skills_item` = '2862-4' WHERE `item_id` = 14697;
UPDATE `etcitem` SET `skills_item` = '2862-5' WHERE `item_id` = 14698;
UPDATE `etcitem` SET `skills_item` = '2862-6' WHERE `item_id` = 14699;

-- Book of Secret (Pailaka 1)
UPDATE `etcitem` SET `handler` = 'Book' WHERE `item_id` IN (13130, 13131, 13132, 13133, 13134, 13135, 13136);

-- Various updates (Spire)
UPDATE `etcitem` SET `price` = '167' WHERE `item_id` = '7736';
UPDATE `etcitem` SET `price` = '163' WHERE `item_id` = '7743';
UPDATE `etcitem` SET `price` = '167' WHERE `item_id` = '7745';
UPDATE `etcitem` SET `price` = '198' WHERE `item_id` = '7746';
UPDATE `etcitem` SET `price` = '202' WHERE `item_id` = '7747';
UPDATE `etcitem` SET `price` = '197' WHERE `item_id` = '7748';
UPDATE `etcitem` SET `price` = '210' WHERE `item_id` = '7749';
UPDATE `etcitem` SET `price` = '213' WHERE `item_id` = '7750';
UPDATE `etcitem` SET `price` = '216' WHERE `item_id` = '7751';
UPDATE `etcitem` SET `price` = '218' WHERE `item_id` = '7752';
UPDATE `etcitem` SET `price` = '221' WHERE `item_id` = '7753';
UPDATE `etcitem` SET `price` = '224' WHERE `item_id` = '7754';
UPDATE `etcitem` SET `price` = '226' WHERE `item_id` = '7755';
UPDATE `etcitem` SET `price` = '284' WHERE `item_id` = '7758';
UPDATE `etcitem` SET `price` = '290' WHERE `item_id` = '7759';
UPDATE `etcitem` SET `price` = '297' WHERE `item_id` = '7760';
UPDATE `etcitem` SET `price` = '304' WHERE `item_id` = '7761';
UPDATE `etcitem` SET `price` = '311' WHERE `item_id` = '7762';
UPDATE `etcitem` SET `price` = '318' WHERE `item_id` = '7763';
UPDATE `etcitem` SET `price` = '325' WHERE `item_id` = '7764';
UPDATE `etcitem` SET `price` = '332' WHERE `item_id` = '7765';
UPDATE `etcitem` SET `price` = '388' WHERE `item_id` = '7766';
UPDATE `etcitem` SET `price` = '396' WHERE `item_id` = '7767';
UPDATE `etcitem` SET `price` = '408' WHERE `item_id` = '7768';
UPDATE `etcitem` SET `price` = '420' WHERE `item_id` = '7769';
UPDATE `etcitem` SET `price` = '429' WHERE `item_id` = '7770';
UPDATE `etcitem` SET `price` = '438' WHERE `item_id` = '7771';
UPDATE `etcitem` SET `price` = '447' WHERE `item_id` = '7772';
UPDATE `etcitem` SET `price` = '465' WHERE `item_id` = '7774';
UPDATE `etcitem` SET `price` = '474' WHERE `item_id` = '7775';
UPDATE `etcitem` SET `price` = '545' WHERE `item_id` = '7776';
UPDATE `etcitem` SET `price` = '556' WHERE `item_id` = '7777';
UPDATE `etcitem` SET `price` = '567' WHERE `item_id` = '7778';
UPDATE `etcitem` SET `price` = '579' WHERE `item_id` = '7779';
UPDATE `etcitem` SET `price` = '639' WHERE `item_id` = '7780';
UPDATE `etcitem` SET `price` = '651' WHERE `item_id` = '7781';
UPDATE `etcitem` SET `price` = '663' WHERE `item_id` = '7782';
UPDATE `etcitem` SET `price` = '676' WHERE `item_id` = '7783';
UPDATE `etcitem` SET `price` = '688' WHERE `item_id` = '7784';
UPDATE `etcitem` SET `price` = '701' WHERE `item_id` = '7785';
UPDATE `etcitem` SET `price` = '789' WHERE `item_id` = '7786';
UPDATE `etcitem` SET `price` = '804' WHERE `item_id` = '7787';
UPDATE `etcitem` SET `price` = '858' WHERE `item_id` = '7788';
UPDATE `etcitem` SET `price` = '874' WHERE `item_id` = '7789';
UPDATE `etcitem` SET `price` = '891' WHERE `item_id` = '7790';
UPDATE `etcitem` SET `price` = '907' WHERE `item_id` = '7791';
UPDATE `etcitem` SET `price` = '925' WHERE `item_id` = '7792';
UPDATE `etcitem` SET `price` = '944' WHERE `item_id` = '7793';
UPDATE `etcitem` SET `price` = '962' WHERE `item_id` = '7794';
UPDATE `etcitem` SET `price` = '981' WHERE `item_id` = '7795';
UPDATE `etcitem` SET `price` = '1000' WHERE `item_id` = '7796';
UPDATE `etcitem` SET `price` = '1020' WHERE `item_id` = '7797';
UPDATE `etcitem` SET `price` = '1041' WHERE `item_id` = '7798';
UPDATE `etcitem` SET `price` = '1062' WHERE `item_id` = '7799';
UPDATE `etcitem` SET `price` = '1083' WHERE `item_id` = '7800';
UPDATE `etcitem` SET `price` = '1155' WHERE `item_id` = '7801';
UPDATE `etcitem` SET `price` = '1179' WHERE `item_id` = '7802';
UPDATE `etcitem` SET `price` = '1202' WHERE `item_id` = '7803';
UPDATE `etcitem` SET `price` = '1226' WHERE `item_id` = '7804';
UPDATE `etcitem` SET `price` = '1251' WHERE `item_id` = '7805';
UPDATE `etcitem` SET `price` = '1276' WHERE `item_id` = '7806';
UPDATE `etcitem` SET `price` = '5000' WHERE `item_id` = '8201';
UPDATE `etcitem` SET `item_type` = 'none' WHERE `item_id` = '8202';
UPDATE `etcitem` SET `price` = '28000' WHERE `item_id` = '8303';
UPDATE `etcitem` SET `price` = '28000' WHERE `item_id` = '8304';
UPDATE `etcitem` SET `price` = '86000' WHERE `item_id` = '8319';
UPDATE `etcitem` SET `price` = '262000' WHERE `item_id` = '8323';
UPDATE `etcitem` SET `price` = '262000' WHERE `item_id` = '8324';
UPDATE `etcitem` SET `price` = '138' WHERE `item_id` = '8403';
UPDATE `etcitem` SET `price` = '141' WHERE `item_id` = '8404';
UPDATE `etcitem` SET `price` = '153' WHERE `item_id` = '8405';
UPDATE `etcitem` SET `price` = '167' WHERE `item_id` = '8406';
UPDATE `etcitem` SET `price` = '187' WHERE `item_id` = '8407';
UPDATE `etcitem` SET `price` = '208' WHERE `item_id` = '8408';
UPDATE `etcitem` SET `price` = '225' WHERE `item_id` = '8409';
UPDATE `etcitem` SET `price` = '248' WHERE `item_id` = '8410';
UPDATE `etcitem` SET `price` = '285' WHERE `item_id` = '8412';
UPDATE `etcitem` SET `price` = '295' WHERE `item_id` = '8413';
UPDATE `etcitem` SET `price` = '325' WHERE `item_id` = '8415';
UPDATE `etcitem` SET `price` = '340' WHERE `item_id` = '8416';
UPDATE `etcitem` SET `price` = '355' WHERE `item_id` = '8417';
UPDATE `etcitem` SET `price` = '375' WHERE `item_id` = '8419';
UPDATE `etcitem` SET `price` = '395' WHERE `item_id` = '8421';
UPDATE `etcitem` SET `price` = '400' WHERE `item_id` = '8422';
UPDATE `etcitem` SET `price` = '415' WHERE `item_id` = '8424';
UPDATE `etcitem` SET `price` = '420' WHERE `item_id` = '8426';
UPDATE `etcitem` SET `price` = '425' WHERE `item_id` = '8427';
UPDATE `etcitem` SET `price` = '431' WHERE `item_id` = '8428';
UPDATE `etcitem` SET `price` = '435' WHERE `item_id` = '8429';
UPDATE `etcitem` SET `price` = '447' WHERE `item_id` = '8431';
UPDATE `etcitem` SET `price` = '452' WHERE `item_id` = '8432';
UPDATE `etcitem` SET `price` = '540' WHERE `item_id` = '8433';
UPDATE `etcitem` SET `price` = '553' WHERE `item_id` = '8434';
UPDATE `etcitem` SET `price` = '568' WHERE `item_id` = '8435';
UPDATE `etcitem` SET `price` = '608' WHERE `item_id` = '8438';
UPDATE `etcitem` SET `price` = '663' WHERE `item_id` = '8442';
UPDATE `etcitem` SET `price` = '776' WHERE `item_id` = '8443';
UPDATE `etcitem` SET `price` = '792' WHERE `item_id` = '8444';
UPDATE `etcitem` SET `price` = '816' WHERE `item_id` = '8445';
UPDATE `etcitem` SET `price` = '840' WHERE `item_id` = '8446';
UPDATE `etcitem` SET `price` = '858' WHERE `item_id` = '8447';
UPDATE `etcitem` SET `price` = '875' WHERE `item_id` = '8448';
UPDATE `etcitem` SET `price` = '893' WHERE `item_id` = '8449';
UPDATE `etcitem` SET `price` = '910' WHERE `item_id` = '8450';
UPDATE `etcitem` SET `price` = '930' WHERE `item_id` = '8451';
UPDATE `etcitem` SET `price` = '948' WHERE `item_id` = '8452';
UPDATE `etcitem` SET `price` = '1090' WHERE `item_id` = '8453';
UPDATE `etcitem` SET `price` = '1111' WHERE `item_id` = '8454';
UPDATE `etcitem` SET `price` = '1133' WHERE `item_id` = '8455';
UPDATE `etcitem` SET `price` = '1157' WHERE `item_id` = '8456';
UPDATE `etcitem` SET `price` = '1277' WHERE `item_id` = '8457';
UPDATE `etcitem` SET `price` = '1301' WHERE `item_id` = '8458';
UPDATE `etcitem` SET `price` = '1351' WHERE `item_id` = '8460';
UPDATE `etcitem` SET `price` = '1376' WHERE `item_id` = '8461';
UPDATE `etcitem` SET `price` = '1402' WHERE `item_id` = '8462';
UPDATE `etcitem` SET `price` = '1577' WHERE `item_id` = '8463';
UPDATE `etcitem` SET `price` = '1715' WHERE `item_id` = '8465';
UPDATE `etcitem` SET `price` = '1747' WHERE `item_id` = '8466';
UPDATE `etcitem` SET `price` = '1781' WHERE `item_id` = '8467';
UPDATE `etcitem` SET `price` = '1814' WHERE `item_id` = '8468';
UPDATE `etcitem` SET `price` = '1849' WHERE `item_id` = '8469';
UPDATE `etcitem` SET `price` = '1887' WHERE `item_id` = '8470';
UPDATE `etcitem` SET `price` = '1923' WHERE `item_id` = '8471';
UPDATE `etcitem` SET `price` = '1961' WHERE `item_id` = '8472';
UPDATE `etcitem` SET `price` = '2000' WHERE `item_id` = '8473';
UPDATE `etcitem` SET `price` = '2039' WHERE `item_id` = '8474';
UPDATE `etcitem` SET `price` = '2081' WHERE `item_id` = '8475';
UPDATE `etcitem` SET `price` = '2123' WHERE `item_id` = '8476';
UPDATE `etcitem` SET `price` = '2166' WHERE `item_id` = '8477';
UPDATE `etcitem` SET `price` = '2309' WHERE `item_id` = '8478';
UPDATE `etcitem` SET `price` = '2357' WHERE `item_id` = '8479';
UPDATE `etcitem` SET `price` = '2403' WHERE `item_id` = '8480';
UPDATE `etcitem` SET `price` = '2452' WHERE `item_id` = '8481';
UPDATE `etcitem` SET `price` = '2502' WHERE `item_id` = '8482';
UPDATE `etcitem` SET `price` = '2552' WHERE `item_id` = '8483';
UPDATE `etcitem` SET `price` = '706000' WHERE `item_id` BETWEEN 8690 AND 8701;
UPDATE `etcitem` SET `price` = '706000' WHERE `item_id` BETWEEN 8704 AND 8711;
UPDATE `etcitem` SET `price` = '82400' WHERE `item_id` BETWEEN 8712 AND 8722;
UPDATE `etcitem` SET `item_type` = 'recipe', `price` = '1493000' WHERE `item_id` IN (9967,9968,9969,9970,9971,9972,9973,9974,9975,9976,9977,9978,9979,9980,9981,9982,9983);
UPDATE `etcitem` SET `item_type` = 'recipe', `price` = '243700' WHERE `item_id` IN (9985,9988);
UPDATE `etcitem` SET `item_type` = 'recipe', `price` = '324920' WHERE `item_id` IN (9986,9989);
UPDATE `etcitem` SET `item_type` = 'recipe', `price` = '162460' WHERE `item_id` IN (9987,9990);
UPDATE `etcitem` SET `price` = '2068800' WHERE `item_id` BETWEEN 10373 AND 10396;
